/* NetworkDevice.c generated by valac 0.40.4, the Vala compiler
 * generated from NetworkDevice.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gee.h>
#include <float.h>
#include <math.h>


#define NOISE_TYPE_NETWORK_DEVICE (noise_network_device_get_type ())
#define NOISE_NETWORK_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_NETWORK_DEVICE, NoiseNetworkDevice))
#define NOISE_IS_NETWORK_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_NETWORK_DEVICE))
#define NOISE_NETWORK_DEVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NOISE_TYPE_NETWORK_DEVICE, NoiseNetworkDeviceIface))

typedef struct _NoiseNetworkDevice NoiseNetworkDevice;
typedef struct _NoiseNetworkDeviceIface NoiseNetworkDeviceIface;

#define NOISE_TYPE_MEDIA (noise_media_get_type ())
#define NOISE_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA, NoiseMedia))
#define NOISE_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA, NoiseMediaClass))
#define NOISE_IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA))
#define NOISE_IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA))
#define NOISE_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA, NoiseMediaClass))

typedef struct _NoiseMedia NoiseMedia;
typedef struct _NoiseMediaClass NoiseMediaClass;

#define NOISE_TYPE_PLAYLIST (noise_playlist_get_type ())
#define NOISE_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYLIST, NoisePlaylist))
#define NOISE_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYLIST, NoisePlaylistClass))
#define NOISE_IS_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYLIST))
#define NOISE_IS_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYLIST))
#define NOISE_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYLIST, NoisePlaylistClass))

typedef struct _NoisePlaylist NoisePlaylist;
typedef struct _NoisePlaylistClass NoisePlaylistClass;

#define NOISE_TYPE_SMART_PLAYLIST (noise_smart_playlist_get_type ())
#define NOISE_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SMART_PLAYLIST, NoiseSmartPlaylist))
#define NOISE_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SMART_PLAYLIST, NoiseSmartPlaylistClass))
#define NOISE_IS_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SMART_PLAYLIST))
#define NOISE_IS_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SMART_PLAYLIST))
#define NOISE_SMART_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SMART_PLAYLIST, NoiseSmartPlaylistClass))

typedef struct _NoiseSmartPlaylist NoiseSmartPlaylist;
typedef struct _NoiseSmartPlaylistClass NoiseSmartPlaylistClass;
enum  {
	NOISE_NETWORK_DEVICE_INITIALIZED_SIGNAL,
	NOISE_NETWORK_DEVICE_DEVICE_UNMOUNTED_SIGNAL,
	NOISE_NETWORK_DEVICE_PROGRESS_NOTIFICATION_SIGNAL,
	NOISE_NETWORK_DEVICE_SYNC_FINISHED_SIGNAL,
	NOISE_NETWORK_DEVICE_NUM_SIGNALS
};
static guint noise_network_device_signals[NOISE_NETWORK_DEVICE_NUM_SIGNALS] = {0};

struct _NoiseNetworkDeviceIface {
	GTypeInterface parent_iface;
	gboolean (*start_initialization) (NoiseNetworkDevice* self);
	void (*finish_initialization) (NoiseNetworkDevice* self);
	gchar* (*getContentType) (NoiseNetworkDevice* self);
	gchar* (*getDisplayName) (NoiseNetworkDevice* self);
	void (*setDisplayName) (NoiseNetworkDevice* self, const gchar* name);
	gchar* (*get_fancy_description) (NoiseNetworkDevice* self);
	gchar* (*get_path) (NoiseNetworkDevice* self);
	void (*set_icon) (NoiseNetworkDevice* self, GdkPixbuf* icon);
	GdkPixbuf* (*get_icon) (NoiseNetworkDevice* self);
	void (*unmount) (NoiseNetworkDevice* self);
	void (*get_device_type) (NoiseNetworkDevice* self);
	gboolean (*supports_podcasts) (NoiseNetworkDevice* self);
	gboolean (*supports_audiobooks) (NoiseNetworkDevice* self);
	GeeCollection* (*get_medias) (NoiseNetworkDevice* self);
	GeeCollection* (*get_songs) (NoiseNetworkDevice* self);
	GeeCollection* (*get_podcasts) (NoiseNetworkDevice* self);
	GeeCollection* (*get_audiobooks) (NoiseNetworkDevice* self);
	GeeCollection* (*get_playlists) (NoiseNetworkDevice* self);
	GeeCollection* (*get_smart_playlists) (NoiseNetworkDevice* self);
};



GType noise_media_get_type (void) G_GNUC_CONST;
GType noise_playlist_get_type (void) G_GNUC_CONST;
GType noise_smart_playlist_get_type (void) G_GNUC_CONST;
GType noise_network_device_get_type (void) G_GNUC_CONST;
gboolean noise_network_device_start_initialization (NoiseNetworkDevice* self);
void noise_network_device_finish_initialization (NoiseNetworkDevice* self);
gchar* noise_network_device_getContentType (NoiseNetworkDevice* self);
gchar* noise_network_device_getDisplayName (NoiseNetworkDevice* self);
void noise_network_device_setDisplayName (NoiseNetworkDevice* self,
                                          const gchar* name);
gchar* noise_network_device_get_fancy_description (NoiseNetworkDevice* self);
gchar* noise_network_device_get_path (NoiseNetworkDevice* self);
void noise_network_device_set_icon (NoiseNetworkDevice* self,
                                    GdkPixbuf* icon);
GdkPixbuf* noise_network_device_get_icon (NoiseNetworkDevice* self);
void noise_network_device_unmount (NoiseNetworkDevice* self);
void noise_network_device_get_device_type (NoiseNetworkDevice* self);
gboolean noise_network_device_supports_podcasts (NoiseNetworkDevice* self);
gboolean noise_network_device_supports_audiobooks (NoiseNetworkDevice* self);
GeeCollection* noise_network_device_get_medias (NoiseNetworkDevice* self);
GeeCollection* noise_network_device_get_songs (NoiseNetworkDevice* self);
GeeCollection* noise_network_device_get_podcasts (NoiseNetworkDevice* self);
GeeCollection* noise_network_device_get_audiobooks (NoiseNetworkDevice* self);
GeeCollection* noise_network_device_get_playlists (NoiseNetworkDevice* self);
GeeCollection* noise_network_device_get_smart_playlists (NoiseNetworkDevice* self);
static void g_cclosure_user_marshal_VOID__STRING_DOUBLE (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);


gboolean
noise_network_device_start_initialization (NoiseNetworkDevice* self)
{
#line 35 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	return NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->start_initialization (self);
#line 155 "NetworkDevice.c"
}


void
noise_network_device_finish_initialization (NoiseNetworkDevice* self)
{
#line 36 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_if_fail (self != NULL);
#line 36 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->finish_initialization (self);
#line 166 "NetworkDevice.c"
}


gchar*
noise_network_device_getContentType (NoiseNetworkDevice* self)
{
#line 37 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	return NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->getContentType (self);
#line 177 "NetworkDevice.c"
}


gchar*
noise_network_device_getDisplayName (NoiseNetworkDevice* self)
{
#line 38 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	return NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->getDisplayName (self);
#line 188 "NetworkDevice.c"
}


void
noise_network_device_setDisplayName (NoiseNetworkDevice* self,
                                     const gchar* name)
{
#line 39 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_if_fail (self != NULL);
#line 39 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->setDisplayName (self, name);
#line 200 "NetworkDevice.c"
}


gchar*
noise_network_device_get_fancy_description (NoiseNetworkDevice* self)
{
#line 40 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	return NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->get_fancy_description (self);
#line 211 "NetworkDevice.c"
}


gchar*
noise_network_device_get_path (NoiseNetworkDevice* self)
{
#line 41 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	return NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->get_path (self);
#line 222 "NetworkDevice.c"
}


void
noise_network_device_set_icon (NoiseNetworkDevice* self,
                               GdkPixbuf* icon)
{
#line 42 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_if_fail (self != NULL);
#line 42 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->set_icon (self, icon);
#line 234 "NetworkDevice.c"
}


GdkPixbuf*
noise_network_device_get_icon (NoiseNetworkDevice* self)
{
#line 43 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	return NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->get_icon (self);
#line 245 "NetworkDevice.c"
}


void
noise_network_device_unmount (NoiseNetworkDevice* self)
{
#line 44 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_if_fail (self != NULL);
#line 44 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->unmount (self);
#line 256 "NetworkDevice.c"
}


void
noise_network_device_get_device_type (NoiseNetworkDevice* self)
{
#line 45 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_if_fail (self != NULL);
#line 45 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->get_device_type (self);
#line 267 "NetworkDevice.c"
}


gboolean
noise_network_device_supports_podcasts (NoiseNetworkDevice* self)
{
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	return NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->supports_podcasts (self);
#line 278 "NetworkDevice.c"
}


gboolean
noise_network_device_supports_audiobooks (NoiseNetworkDevice* self)
{
#line 47 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 47 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	return NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->supports_audiobooks (self);
#line 289 "NetworkDevice.c"
}


GeeCollection*
noise_network_device_get_medias (NoiseNetworkDevice* self)
{
#line 48 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	return NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->get_medias (self);
#line 300 "NetworkDevice.c"
}


GeeCollection*
noise_network_device_get_songs (NoiseNetworkDevice* self)
{
#line 49 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	return NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->get_songs (self);
#line 311 "NetworkDevice.c"
}


GeeCollection*
noise_network_device_get_podcasts (NoiseNetworkDevice* self)
{
#line 50 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	return NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->get_podcasts (self);
#line 322 "NetworkDevice.c"
}


GeeCollection*
noise_network_device_get_audiobooks (NoiseNetworkDevice* self)
{
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	return NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->get_audiobooks (self);
#line 333 "NetworkDevice.c"
}


GeeCollection*
noise_network_device_get_playlists (NoiseNetworkDevice* self)
{
#line 52 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	return NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->get_playlists (self);
#line 344 "NetworkDevice.c"
}


GeeCollection*
noise_network_device_get_smart_playlists (NoiseNetworkDevice* self)
{
#line 53 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	return NOISE_NETWORK_DEVICE_GET_INTERFACE (self)->get_smart_playlists (self);
#line 355 "NetworkDevice.c"
}


static void
g_cclosure_user_marshal_VOID__STRING_DOUBLE (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_DOUBLE) (gpointer data1, const char* arg_1, gdouble arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_DOUBLE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	g_return_if_fail (n_param_values == 3);
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
		data1 = closure->data;
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
		data2 = param_values->data[0].v_pointer;
#line 381 "NetworkDevice.c"
	} else {
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
		data1 = param_values->data[0].v_pointer;
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
		data2 = closure->data;
#line 387 "NetworkDevice.c"
	}
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	callback = (GMarshalFunc_VOID__STRING_DOUBLE) (marshal_data ? marshal_data : cc->callback);
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_double (param_values + 2), data2);
#line 393 "NetworkDevice.c"
}


static void
noise_network_device_base_init (NoiseNetworkDeviceIface * iface)
{
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	static gboolean initialized = FALSE;
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
	if (!initialized) {
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
		initialized = TRUE;
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
		noise_network_device_signals[NOISE_NETWORK_DEVICE_INITIALIZED_SIGNAL] = g_signal_new ("initialized", NOISE_TYPE_NETWORK_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
		noise_network_device_signals[NOISE_NETWORK_DEVICE_DEVICE_UNMOUNTED_SIGNAL] = g_signal_new ("device-unmounted", NOISE_TYPE_NETWORK_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
		noise_network_device_signals[NOISE_NETWORK_DEVICE_PROGRESS_NOTIFICATION_SIGNAL] = g_signal_new ("progress-notification", NOISE_TYPE_NETWORK_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_DOUBLE, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_DOUBLE);
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Devices/NetworkDevice.vala"
		noise_network_device_signals[NOISE_NETWORK_DEVICE_SYNC_FINISHED_SIGNAL] = g_signal_new ("sync-finished", NOISE_TYPE_NETWORK_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 414 "NetworkDevice.c"
	}
}


GType
noise_network_device_get_type (void)
{
	static volatile gsize noise_network_device_type_id__volatile = 0;
	if (g_once_init_enter (&noise_network_device_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseNetworkDeviceIface), (GBaseInitFunc) noise_network_device_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType noise_network_device_type_id;
		noise_network_device_type_id = g_type_register_static (G_TYPE_INTERFACE, "NoiseNetworkDevice", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (noise_network_device_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&noise_network_device_type_id__volatile, noise_network_device_type_id);
	}
	return noise_network_device_type_id__volatile;
}



