/* StaticPlaylist.c generated by valac 0.40.4, the Vala compiler
 * generated from StaticPlaylist.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define NOISE_TYPE_PLAYLIST (noise_playlist_get_type ())
#define NOISE_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYLIST, NoisePlaylist))
#define NOISE_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYLIST, NoisePlaylistClass))
#define NOISE_IS_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYLIST))
#define NOISE_IS_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYLIST))
#define NOISE_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYLIST, NoisePlaylistClass))

typedef struct _NoisePlaylist NoisePlaylist;
typedef struct _NoisePlaylistClass NoisePlaylistClass;
typedef struct _NoisePlaylistPrivate NoisePlaylistPrivate;

#define NOISE_TYPE_MEDIA (noise_media_get_type ())
#define NOISE_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA, NoiseMedia))
#define NOISE_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA, NoiseMediaClass))
#define NOISE_IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA))
#define NOISE_IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA))
#define NOISE_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA, NoiseMediaClass))

typedef struct _NoiseMedia NoiseMedia;
typedef struct _NoiseMediaClass NoiseMediaClass;

#define NOISE_TYPE_STATIC_PLAYLIST (noise_static_playlist_get_type ())
#define NOISE_STATIC_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylist))
#define NOISE_STATIC_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylistClass))
#define NOISE_IS_STATIC_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_STATIC_PLAYLIST))
#define NOISE_IS_STATIC_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_STATIC_PLAYLIST))
#define NOISE_STATIC_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylistClass))

typedef struct _NoiseStaticPlaylist NoiseStaticPlaylist;
typedef struct _NoiseStaticPlaylistClass NoiseStaticPlaylistClass;
typedef struct _NoiseStaticPlaylistPrivate NoiseStaticPlaylistPrivate;
enum  {
	NOISE_STATIC_PLAYLIST_0_PROPERTY,
	NOISE_STATIC_PLAYLIST_READ_ONLY_PROPERTY,
	NOISE_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY,
	NOISE_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY,
	NOISE_STATIC_PLAYLIST_NUM_PROPERTIES
};
static GParamSpec* noise_static_playlist_properties[NOISE_STATIC_PLAYLIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _NoisePlaylist {
	GObject parent_instance;
	NoisePlaylistPrivate * priv;
	GIcon* icon;
	gchar* _name;
};

struct _NoisePlaylistClass {
	GObjectClass parent_class;
	void (*add_media) (NoisePlaylist* self, NoiseMedia* to_remove);
	void (*add_medias) (NoisePlaylist* self, GeeCollection* to_add);
	void (*remove_media) (NoisePlaylist* self, NoiseMedia* to_remove);
	void (*remove_medias) (NoisePlaylist* self, GeeCollection* to_remove);
	void (*clear) (NoisePlaylist* self);
	GeeArrayList* (*get_medias) (NoisePlaylist* self);
	void (*set_medias) (NoisePlaylist* self, GeeArrayList* value);
	const gchar* (*get_name) (NoisePlaylist* self);
	void (*set_name) (NoisePlaylist* self, const gchar* value);
};

struct _NoiseStaticPlaylist {
	NoisePlaylist parent_instance;
	NoiseStaticPlaylistPrivate * priv;
};

struct _NoiseStaticPlaylistClass {
	NoisePlaylistClass parent_class;
};

struct _NoiseStaticPlaylistPrivate {
	gboolean _read_only;
	gboolean _show_badge;
	gboolean _allow_duplicate;
};


static gpointer noise_static_playlist_parent_class = NULL;

GType noise_playlist_get_type (void) G_GNUC_CONST;
GType noise_media_get_type (void) G_GNUC_CONST;
GType noise_static_playlist_get_type (void) G_GNUC_CONST;
#define NOISE_STATIC_PLAYLIST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylistPrivate))
NoiseStaticPlaylist* noise_static_playlist_new_with_info (gint rowid,
                                                          const gchar* name);
NoiseStaticPlaylist* noise_static_playlist_construct_with_info (GType object_type,
                                                                gint rowid,
                                                                const gchar* name);
static void noise_static_playlist_real_add_media (NoisePlaylist* base,
                                           NoiseMedia* m);
gboolean noise_static_playlist_get_allow_duplicate (NoiseStaticPlaylist* self);
GeeArrayList* noise_playlist_get_medias (NoisePlaylist* self);
static void noise_static_playlist_real_add_medias (NoisePlaylist* base,
                                            GeeCollection* to_add);
static void noise_static_playlist_real_remove_media (NoisePlaylist* base,
                                              NoiseMedia* to_remove);
static void noise_static_playlist_real_remove_medias (NoisePlaylist* base,
                                               GeeCollection* to_remove);
static void noise_static_playlist_real_clear (NoisePlaylist* base);
NoiseStaticPlaylist* noise_static_playlist_new (void);
NoiseStaticPlaylist* noise_static_playlist_construct (GType object_type);
NoisePlaylist* noise_playlist_construct (GType object_type);
gboolean noise_static_playlist_get_read_only (NoiseStaticPlaylist* self);
void noise_static_playlist_set_read_only (NoiseStaticPlaylist* self,
                                          gboolean value);
gboolean noise_static_playlist_get_show_badge (NoiseStaticPlaylist* self);
void noise_static_playlist_set_show_badge (NoiseStaticPlaylist* self,
                                           gboolean value);
void noise_static_playlist_set_allow_duplicate (NoiseStaticPlaylist* self,
                                                gboolean value);
static GObject * noise_static_playlist_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void noise_static_playlist_finalize (GObject * obj);
static void _vala_noise_static_playlist_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_noise_static_playlist_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);


NoiseStaticPlaylist*
noise_static_playlist_construct_with_info (GType object_type,
                                           gint rowid,
                                           const gchar* name)
{
	NoiseStaticPlaylist * self = NULL;
#line 35 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 36 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	self = (NoiseStaticPlaylist*) g_object_new (object_type, "rowid", rowid, "name", name, NULL);
#line 35 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	return self;
#line 179 "StaticPlaylist.c"
}


NoiseStaticPlaylist*
noise_static_playlist_new_with_info (gint rowid,
                                     const gchar* name)
{
#line 35 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	return noise_static_playlist_construct_with_info (NOISE_TYPE_STATIC_PLAYLIST, rowid, name);
#line 189 "StaticPlaylist.c"
}


static void
noise_static_playlist_real_add_media (NoisePlaylist* base,
                                      NoiseMedia* m)
{
	NoiseStaticPlaylist * self;
	GeeLinkedList* added_media = NULL;
	GeeLinkedList* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
#line 43 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	self = (NoiseStaticPlaylist*) base;
#line 43 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (m != NULL);
#line 44 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 44 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	added_media = _tmp0_;
#line 45 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	_tmp2_ = self->priv->_allow_duplicate;
#line 45 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	if (_tmp2_) {
#line 45 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp1_ = TRUE;
#line 216 "StaticPlaylist.c"
	} else {
		GeeArrayList* _tmp3_;
		GeeArrayList* _tmp4_;
#line 45 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp3_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 45 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp4_ = _tmp3_;
#line 45 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp1_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp4_, m) == FALSE;
#line 226 "StaticPlaylist.c"
	}
#line 45 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	if (_tmp1_) {
#line 230 "StaticPlaylist.c"
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeLinkedList* _tmp7_;
		GeeLinkedList* _tmp8_;
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp5_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp6_ = _tmp5_;
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, m);
#line 47 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp7_ = added_media;
#line 47 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, m);
#line 48 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp8_ = added_media;
#line 48 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		g_signal_emit_by_name ((NoisePlaylist*) self, "media-added", (GeeCollection*) _tmp8_);
#line 249 "StaticPlaylist.c"
	}
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((NoisePlaylist*) self, "updated", NULL);
#line 43 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	_g_object_unref0 (added_media);
#line 255 "StaticPlaylist.c"
}


static void
noise_static_playlist_real_add_medias (NoisePlaylist* base,
                                       GeeCollection* to_add)
{
	NoiseStaticPlaylist * self;
	GeeLinkedList* added_media = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp15_;
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	self = (NoiseStaticPlaylist*) base;
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (to_add != NULL);
#line 55 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 55 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	added_media = _tmp0_;
#line 275 "StaticPlaylist.c"
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp1_;
#line 56 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) to_add);
#line 56 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_m_it = _tmp1_;
#line 56 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		while (TRUE) {
#line 285 "StaticPlaylist.c"
			GeeIterator* _tmp2_;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_;
#line 56 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			_tmp2_ = _m_it;
#line 56 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 56 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				break;
#line 298 "StaticPlaylist.c"
			}
#line 56 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			_tmp3_ = _m_it;
#line 56 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 56 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			m = (NoiseMedia*) _tmp4_;
#line 57 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			_tmp6_ = self->priv->_allow_duplicate;
#line 57 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			if (_tmp6_) {
#line 57 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp5_ = TRUE;
#line 312 "StaticPlaylist.c"
			} else {
				GeeArrayList* _tmp7_;
				GeeArrayList* _tmp8_;
				NoiseMedia* _tmp9_;
#line 57 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp7_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 57 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp8_ = _tmp7_;
#line 57 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp9_ = m;
#line 57 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp5_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp8_, _tmp9_) == FALSE;
#line 325 "StaticPlaylist.c"
			}
#line 57 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			if (_tmp5_) {
#line 329 "StaticPlaylist.c"
				GeeArrayList* _tmp10_;
				GeeArrayList* _tmp11_;
				NoiseMedia* _tmp12_;
				GeeLinkedList* _tmp13_;
				NoiseMedia* _tmp14_;
#line 58 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp10_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 58 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp11_ = _tmp10_;
#line 58 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp12_ = m;
#line 58 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 59 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp13_ = added_media;
#line 59 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp14_ = m;
#line 59 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 349 "StaticPlaylist.c"
			}
#line 56 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			_g_object_unref0 (m);
#line 353 "StaticPlaylist.c"
		}
#line 56 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_g_object_unref0 (_m_it);
#line 357 "StaticPlaylist.c"
	}
#line 63 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((NoisePlaylist*) self, "updated", NULL);
#line 64 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	_tmp15_ = added_media;
#line 64 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((NoisePlaylist*) self, "media-added", (GeeCollection*) _tmp15_);
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	_g_object_unref0 (added_media);
#line 367 "StaticPlaylist.c"
}


static void
noise_static_playlist_real_remove_media (NoisePlaylist* base,
                                         NoiseMedia* to_remove)
{
	NoiseStaticPlaylist * self;
	gboolean _tmp0_ = FALSE;
#line 67 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	self = (NoiseStaticPlaylist*) base;
#line 67 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (to_remove != NULL);
#line 68 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	if (to_remove != NULL) {
#line 383 "StaticPlaylist.c"
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
#line 68 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp1_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 68 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp2_ = _tmp1_;
#line 68 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp0_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp2_, to_remove);
#line 392 "StaticPlaylist.c"
	} else {
#line 68 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp0_ = FALSE;
#line 396 "StaticPlaylist.c"
	}
#line 68 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	if (_tmp0_) {
#line 400 "StaticPlaylist.c"
		GeeLinkedList* removed_media = NULL;
		GeeLinkedList* _tmp3_;
		GeeLinkedList* _tmp4_;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeLinkedList* _tmp7_;
#line 69 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp3_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 69 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		removed_media = _tmp3_;
#line 70 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp4_ = removed_media;
#line 70 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, to_remove);
#line 71 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp5_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 71 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp6_ = _tmp5_;
#line 71 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp6_, to_remove);
#line 72 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp7_ = removed_media;
#line 72 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		g_signal_emit_by_name ((NoisePlaylist*) self, "media-removed", (GeeCollection*) _tmp7_);
#line 68 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_g_object_unref0 (removed_media);
#line 427 "StaticPlaylist.c"
	}
#line 75 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((NoisePlaylist*) self, "updated", NULL);
#line 431 "StaticPlaylist.c"
}


static void
noise_static_playlist_real_remove_medias (NoisePlaylist* base,
                                          GeeCollection* to_remove)
{
	NoiseStaticPlaylist * self;
	GeeLinkedList* removed_media = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp15_;
#line 78 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	self = (NoiseStaticPlaylist*) base;
#line 78 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (to_remove != NULL);
#line 79 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 79 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	removed_media = _tmp0_;
#line 451 "StaticPlaylist.c"
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp1_;
#line 80 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) to_remove);
#line 80 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_m_it = _tmp1_;
#line 80 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		while (TRUE) {
#line 461 "StaticPlaylist.c"
			GeeIterator* _tmp2_;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			gboolean _tmp5_ = FALSE;
			NoiseMedia* _tmp6_;
#line 80 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			_tmp2_ = _m_it;
#line 80 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 80 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				break;
#line 474 "StaticPlaylist.c"
			}
#line 80 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			_tmp3_ = _m_it;
#line 80 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 80 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			m = (NoiseMedia*) _tmp4_;
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			_tmp6_ = m;
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			if (_tmp6_ != NULL) {
#line 486 "StaticPlaylist.c"
				GeeArrayList* _tmp7_;
				GeeArrayList* _tmp8_;
				NoiseMedia* _tmp9_;
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp7_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp8_ = _tmp7_;
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp9_ = m;
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp5_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp8_, _tmp9_);
#line 498 "StaticPlaylist.c"
			} else {
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp5_ = FALSE;
#line 502 "StaticPlaylist.c"
			}
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			if (_tmp5_) {
#line 506 "StaticPlaylist.c"
				GeeLinkedList* _tmp10_;
				NoiseMedia* _tmp11_;
				GeeArrayList* _tmp12_;
				GeeArrayList* _tmp13_;
				NoiseMedia* _tmp14_;
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp10_ = removed_media;
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp11_ = m;
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 83 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp12_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 83 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp13_ = _tmp12_;
#line 83 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				_tmp14_ = m;
#line 83 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
				gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 526 "StaticPlaylist.c"
			}
#line 80 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
			_g_object_unref0 (m);
#line 530 "StaticPlaylist.c"
		}
#line 80 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		_g_object_unref0 (_m_it);
#line 534 "StaticPlaylist.c"
	}
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((NoisePlaylist*) self, "updated", NULL);
#line 88 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	_tmp15_ = removed_media;
#line 88 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((NoisePlaylist*) self, "media-removed", (GeeCollection*) _tmp15_);
#line 78 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	_g_object_unref0 (removed_media);
#line 544 "StaticPlaylist.c"
}


static void
noise_static_playlist_real_clear (NoisePlaylist* base)
{
	NoiseStaticPlaylist * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 91 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	self = (NoiseStaticPlaylist*) base;
#line 92 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 92 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 92 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
#line 93 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((NoisePlaylist*) self, "cleared");
#line 94 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((NoisePlaylist*) self, "updated", NULL);
#line 566 "StaticPlaylist.c"
}


NoiseStaticPlaylist*
noise_static_playlist_construct (GType object_type)
{
	NoiseStaticPlaylist * self = NULL;
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	self = (NoiseStaticPlaylist*) noise_playlist_construct (object_type);
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	return self;
#line 578 "StaticPlaylist.c"
}


NoiseStaticPlaylist*
noise_static_playlist_new (void)
{
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	return noise_static_playlist_construct (NOISE_TYPE_STATIC_PLAYLIST);
#line 587 "StaticPlaylist.c"
}


gboolean
noise_static_playlist_get_read_only (NoiseStaticPlaylist* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 31 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = self->priv->_read_only;
#line 31 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	return result;
#line 604 "StaticPlaylist.c"
}


void
noise_static_playlist_set_read_only (NoiseStaticPlaylist* self,
                                     gboolean value)
{
#line 31 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 31 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	if (noise_static_playlist_get_read_only (self) != value) {
#line 31 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		self->priv->_read_only = value;
#line 31 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_static_playlist_properties[NOISE_STATIC_PLAYLIST_READ_ONLY_PROPERTY]);
#line 620 "StaticPlaylist.c"
	}
}


gboolean
noise_static_playlist_get_show_badge (NoiseStaticPlaylist* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 32 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = self->priv->_show_badge;
#line 32 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	return result;
#line 638 "StaticPlaylist.c"
}


void
noise_static_playlist_set_show_badge (NoiseStaticPlaylist* self,
                                      gboolean value)
{
#line 32 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	if (noise_static_playlist_get_show_badge (self) != value) {
#line 32 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		self->priv->_show_badge = value;
#line 32 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_static_playlist_properties[NOISE_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY]);
#line 654 "StaticPlaylist.c"
	}
}


gboolean
noise_static_playlist_get_allow_duplicate (NoiseStaticPlaylist* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 33 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = self->priv->_allow_duplicate;
#line 33 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	result = _tmp0_;
#line 33 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	return result;
#line 672 "StaticPlaylist.c"
}


void
noise_static_playlist_set_allow_duplicate (NoiseStaticPlaylist* self,
                                           gboolean value)
{
#line 33 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 33 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	if (noise_static_playlist_get_allow_duplicate (self) != value) {
#line 33 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		self->priv->_allow_duplicate = value;
#line 33 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_static_playlist_properties[NOISE_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY]);
#line 688 "StaticPlaylist.c"
	}
}


static GObject *
noise_static_playlist_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseStaticPlaylist * self;
	GThemedIcon* _tmp0_;
#line 39 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	parent_class = G_OBJECT_CLASS (noise_static_playlist_parent_class);
#line 39 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 39 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylist);
#line 40 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("playlist");
#line 40 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	_g_object_unref0 (((NoisePlaylist*) self)->icon);
#line 40 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	((NoisePlaylist*) self)->icon = (GIcon*) _tmp0_;
#line 39 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	return obj;
#line 716 "StaticPlaylist.c"
}


static void
noise_static_playlist_class_init (NoiseStaticPlaylistClass * klass)
{
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	noise_static_playlist_parent_class = g_type_class_peek_parent (klass);
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_type_class_add_private (klass, sizeof (NoiseStaticPlaylistPrivate));
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	((NoisePlaylistClass *) klass)->add_media = (void (*) (NoisePlaylist *, NoiseMedia*)) noise_static_playlist_real_add_media;
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	((NoisePlaylistClass *) klass)->add_medias = (void (*) (NoisePlaylist *, GeeCollection*)) noise_static_playlist_real_add_medias;
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	((NoisePlaylistClass *) klass)->remove_media = (void (*) (NoisePlaylist *, NoiseMedia*)) noise_static_playlist_real_remove_media;
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	((NoisePlaylistClass *) klass)->remove_medias = (void (*) (NoisePlaylist *, GeeCollection*)) noise_static_playlist_real_remove_medias;
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	((NoisePlaylistClass *) klass)->clear = (void (*) (NoisePlaylist *)) noise_static_playlist_real_clear;
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_static_playlist_get_property;
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_static_playlist_set_property;
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_static_playlist_constructor;
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_static_playlist_finalize;
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_STATIC_PLAYLIST_READ_ONLY_PROPERTY, noise_static_playlist_properties[NOISE_STATIC_PLAYLIST_READ_ONLY_PROPERTY] = g_param_spec_boolean ("read-only", "read-only", "read-only", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY, noise_static_playlist_properties[NOISE_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY] = g_param_spec_boolean ("show-badge", "show-badge", "show-badge", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY, noise_static_playlist_properties[NOISE_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY] = g_param_spec_boolean ("allow-duplicate", "allow-duplicate", "allow-duplicate", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 751 "StaticPlaylist.c"
}


static void
noise_static_playlist_instance_init (NoiseStaticPlaylist * self)
{
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	self->priv = NOISE_STATIC_PLAYLIST_GET_PRIVATE (self);
#line 31 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	self->priv->_read_only = FALSE;
#line 32 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	self->priv->_show_badge = FALSE;
#line 33 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	self->priv->_allow_duplicate = FALSE;
#line 766 "StaticPlaylist.c"
}


static void
noise_static_playlist_finalize (GObject * obj)
{
	NoiseStaticPlaylist * self;
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylist);
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	G_OBJECT_CLASS (noise_static_playlist_parent_class)->finalize (obj);
#line 778 "StaticPlaylist.c"
}


GType
noise_static_playlist_get_type (void)
{
	static volatile gsize noise_static_playlist_type_id__volatile = 0;
	if (g_once_init_enter (&noise_static_playlist_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseStaticPlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_static_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseStaticPlaylist), 0, (GInstanceInitFunc) noise_static_playlist_instance_init, NULL };
		GType noise_static_playlist_type_id;
		noise_static_playlist_type_id = g_type_register_static (NOISE_TYPE_PLAYLIST, "NoiseStaticPlaylist", &g_define_type_info, 0);
		g_once_init_leave (&noise_static_playlist_type_id__volatile, noise_static_playlist_type_id);
	}
	return noise_static_playlist_type_id__volatile;
}


static void
_vala_noise_static_playlist_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	NoiseStaticPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylist);
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	switch (property_id) {
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		case NOISE_STATIC_PLAYLIST_READ_ONLY_PROPERTY:
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		g_value_set_boolean (value, noise_static_playlist_get_read_only (self));
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		break;
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		case NOISE_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY:
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		g_value_set_boolean (value, noise_static_playlist_get_show_badge (self));
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		break;
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		case NOISE_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY:
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		g_value_set_boolean (value, noise_static_playlist_get_allow_duplicate (self));
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		break;
#line 824 "StaticPlaylist.c"
		default:
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		break;
#line 830 "StaticPlaylist.c"
	}
}


static void
_vala_noise_static_playlist_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	NoiseStaticPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylist);
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
	switch (property_id) {
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		case NOISE_STATIC_PLAYLIST_READ_ONLY_PROPERTY:
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		noise_static_playlist_set_read_only (self, g_value_get_boolean (value));
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		break;
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		case NOISE_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY:
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		noise_static_playlist_set_show_badge (self, g_value_get_boolean (value));
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		break;
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		case NOISE_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY:
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		noise_static_playlist_set_allow_duplicate (self, g_value_get_boolean (value));
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		break;
#line 863 "StaticPlaylist.c"
		default:
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "/builddir/build/BUILD/music-0.4.2/core/Playlists/StaticPlaylist.vala"
		break;
#line 869 "StaticPlaylist.c"
	}
}



