/* Icon.c generated by valac 0.40.4, the Vala compiler
 * generated from Icon.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define NOISE_TYPE_ICON (noise_icon_get_type ())
#define NOISE_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_ICON, NoiseIcon))
#define NOISE_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_ICON, NoiseIconClass))
#define NOISE_IS_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_ICON))
#define NOISE_IS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_ICON))
#define NOISE_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_ICON, NoiseIconClass))

typedef struct _NoiseIcon NoiseIcon;
typedef struct _NoiseIconClass NoiseIconClass;
typedef struct _NoiseIconPrivate NoiseIconPrivate;
enum  {
	NOISE_ICON_0_PROPERTY,
	NOISE_ICON_NAME_PROPERTY,
	NOISE_ICON_FILE_NAME_PROPERTY,
	NOISE_ICON_GICON_PROPERTY,
	NOISE_ICON_NUM_PROPERTIES
};
static GParamSpec* noise_icon_properties[NOISE_ICON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gtk_icon_info_free0(var) ((var == NULL) ? NULL : (var = (gtk_icon_info_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NoiseIcon {
	GObject parent_instance;
	NoiseIconPrivate * priv;
};

struct _NoiseIconClass {
	GObjectClass parent_class;
};

struct _NoiseIconPrivate {
	gchar* _name;
	gchar* _file_name;
	GIcon* _gicon;
};


static gpointer noise_icon_parent_class = NULL;
static GtkIconTheme* noise_icon__theme;
static GtkIconTheme* noise_icon__theme = NULL;

GType noise_icon_get_type (void) G_GNUC_CONST;
#define NOISE_ICON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_ICON, NoiseIconPrivate))
NoiseIcon* noise_icon_new (const gchar* file_name);
NoiseIcon* noise_icon_construct (GType object_type,
                                 const gchar* file_name);
static void noise_icon_set_file_name (NoiseIcon* self,
                               const gchar* value);
const gchar* noise_icon_get_file_name (NoiseIcon* self);
static void noise_icon_set_gicon (NoiseIcon* self,
                           GIcon* value);
static void noise_icon_set_name (NoiseIcon* self,
                          const gchar* value);
const gchar* noise_icon_get_name (NoiseIcon* self);
GtkIconInfo* noise_icon_get_icon_info (NoiseIcon* self,
                                       gint size);
GtkIconTheme* noise_icon_get_theme (void);
GIcon* noise_icon_get_gicon (NoiseIcon* self);
GFile* noise_icon_get_file (NoiseIcon* self,
                            gint size);
GdkPixbuf* noise_icon_render (NoiseIcon* self,
                              GtkIconSize size,
                              GtkStyleContext* style_context);
GdkPixbuf* noise_icon_render_at_size (NoiseIcon* self,
                                      gint pixel_size,
                                      GtkStyleContext* style_context);
GtkImage* noise_icon_render_image (NoiseIcon* self,
                                   GtkIconSize size);
GtkImage* noise_icon_render_image_at_size (NoiseIcon* self,
                                           gint pixel_size);
#define BUILD_ICON_DIR "/usr/share/noise/icons"
static void noise_icon_finalize (GObject * obj);
static void _vala_noise_icon_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_noise_icon_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);


/**
     * Creates a new icon object.
     *
     * @param file_name A filename pointing to the icon file. If it is an absolute file name,
     * the icon will be loaded from the file it points to; otherwise, it is assumed that the
     * string only specifies the icon name (without filename extension), and it will be loaded from
     * the available icon themes.
     */
NoiseIcon*
noise_icon_construct (GType object_type,
                      const gchar* file_name)
{
	NoiseIcon * self = NULL;
#line 98 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	g_return_val_if_fail (file_name != NULL, NULL);
#line 98 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	self = (NoiseIcon*) g_object_new (object_type, NULL);
#line 99 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	if (g_path_is_absolute (file_name)) {
#line 146 "Icon.c"
		const gchar* _tmp0_;
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFileIcon* _tmp3_;
		GFileIcon* _tmp4_;
#line 100 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		noise_icon_set_file_name (self, file_name);
#line 101 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp0_ = self->priv->_file_name;
#line 101 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp1_ = g_file_new_for_path (_tmp0_);
#line 101 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp2_ = _tmp1_;
#line 101 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp3_ = (GFileIcon*) g_file_icon_new (_tmp2_);
#line 101 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp4_ = _tmp3_;
#line 101 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		noise_icon_set_gicon (self, (GIcon*) _tmp4_);
#line 101 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_g_object_unref0 (_tmp4_);
#line 101 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_g_object_unref0 (_tmp2_);
#line 170 "Icon.c"
	} else {
		const gchar* _tmp5_;
		GThemedIcon* _tmp6_;
		GThemedIcon* _tmp7_;
#line 103 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		noise_icon_set_name (self, file_name);
#line 104 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp5_ = self->priv->_name;
#line 104 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp6_ = (GThemedIcon*) g_themed_icon_new (_tmp5_);
#line 104 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp7_ = _tmp6_;
#line 104 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		noise_icon_set_gicon (self, (GIcon*) _tmp7_);
#line 104 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_g_object_unref0 (_tmp7_);
#line 187 "Icon.c"
	}
#line 98 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	return self;
#line 191 "Icon.c"
}


NoiseIcon*
noise_icon_new (const gchar* file_name)
{
#line 98 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	return noise_icon_construct (NOISE_TYPE_ICON, file_name);
#line 200 "Icon.c"
}


GtkIconInfo*
noise_icon_get_icon_info (NoiseIcon* self,
                          gint size)
{
	GtkIconInfo* result = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
	GIcon* _tmp2_;
	GtkIconInfo* _tmp3_;
#line 109 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 110 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_tmp0_ = noise_icon_get_theme ();
#line 110 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_tmp1_ = _tmp0_;
#line 110 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_tmp2_ = self->priv->_gicon;
#line 110 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_tmp3_ = gtk_icon_theme_lookup_by_gicon (_tmp1_, _tmp2_, size, GTK_ICON_LOOKUP_USE_BUILTIN);
#line 110 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	result = _tmp3_;
#line 110 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	return result;
#line 227 "Icon.c"
}


/**
     * Returns a file representing the icon in the filesystem. If this icon represents a
     * file, it returns a file at a location equivalent to {@link Noise.Icon.file_name}.
     * Otherwise, a file pointing to the image in the icon theme is returned.
     *
     * @param size Icon size to query.
     * @return A {@link GLib.File} representing the icon, or //null// if none is found.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	return self ? g_object_ref (self) : NULL;
#line 244 "Icon.c"
}


GFile*
noise_icon_get_file (NoiseIcon* self,
                     gint size)
{
	GFile* result = NULL;
	GIcon* _tmp0_;
	GtkIconInfo* info = NULL;
	GtkIconInfo* _tmp5_;
	GFile* _tmp6_ = NULL;
	GtkIconInfo* _tmp7_;
#line 121 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 122 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_tmp0_ = self->priv->_gicon;
#line 122 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_file_icon_get_type ())) {
#line 264 "Icon.c"
		GIcon* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp1_ = self->priv->_gicon;
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp2_ = g_file_icon_get_file (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, g_file_icon_get_type ()) ? ((GFileIcon*) _tmp1_) : NULL);
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp3_ = _tmp2_;
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		result = _tmp4_;
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		return result;
#line 281 "Icon.c"
	}
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_tmp5_ = noise_icon_get_icon_info (self, size);
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	info = _tmp5_;
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_tmp7_ = info;
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	if (_tmp7_ != NULL) {
#line 291 "Icon.c"
		GtkIconInfo* _tmp8_;
		const gchar* _tmp9_;
		GFile* _tmp10_;
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp8_ = info;
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp9_ = gtk_icon_info_get_filename (_tmp8_);
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp10_ = g_file_new_for_path (_tmp9_);
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_g_object_unref0 (_tmp6_);
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp6_ = _tmp10_;
#line 305 "Icon.c"
	} else {
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_g_object_unref0 (_tmp6_);
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp6_ = NULL;
#line 311 "Icon.c"
	}
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	result = _tmp6_;
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_gtk_icon_info_free0 (info);
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	return result;
#line 319 "Icon.c"
}


/**
     * Creates a new {@link Gdk.Pixbuf} from the icon at the specified icon size.
     *
     * @param size The pixbuf's icon size.
     * @param style_context The style context used to render the icon, or null to use none.
     * @return a newly-created Gdk.Pixbuf displaying the icon (or a "missing-image" icon)
     * @see Noise.Icon.render_at_size
     */
GdkPixbuf*
noise_icon_render (NoiseIcon* self,
                   GtkIconSize size,
                   GtkStyleContext* style_context)
{
	GdkPixbuf* result = NULL;
	gint width = 0;
	gint height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GdkPixbuf* _tmp2_;
#line 137 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 139 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	gtk_icon_size_lookup (size, &_tmp0_, &_tmp1_);
#line 139 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	width = _tmp0_;
#line 139 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	height = _tmp1_;
#line 140 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_tmp2_ = noise_icon_render_at_size (self, MAX (width, height), style_context);
#line 140 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	result = _tmp2_;
#line 140 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	return result;
#line 356 "Icon.c"
}


/**
     * Creates a new {@link Gdk.Pixbuf} from the icon at the specified pixel size.
     *
     * @param pixel_size The pixbuf's pixel size.
     * @param style_context The style context used to render the icon, or null to use none.
     * @return a newly-created Gdk.Pixbuf displaying the icon (or a "missing-image" icon)
     * @see Noise.Icon.render
     */
GdkPixbuf*
noise_icon_render_at_size (NoiseIcon* self,
                           gint pixel_size,
                           GtkStyleContext* style_context)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* rv = NULL;
	GError * _inner_error_ = NULL;
#line 152 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 153 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	rv = NULL;
#line 380 "Icon.c"
	{
		GtkIconInfo* icon_info = NULL;
		GtkIconInfo* _tmp0_;
		GtkIconInfo* _tmp1_;
		GdkPixbuf* _tmp10_;
#line 156 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp0_ = noise_icon_get_icon_info (self, pixel_size);
#line 156 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		icon_info = _tmp0_;
#line 158 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp1_ = icon_info;
#line 158 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		if (_tmp1_ != NULL) {
#line 159 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
			if (style_context != NULL) {
#line 396 "Icon.c"
				GdkPixbuf* _tmp2_ = NULL;
				GtkIconInfo* _tmp3_;
				GdkPixbuf* _tmp4_;
				GdkPixbuf* _tmp5_;
#line 160 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				_tmp3_ = icon_info;
#line 160 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				_tmp4_ = gtk_icon_info_load_symbolic_for_context (_tmp3_, style_context, NULL, &_inner_error_);
#line 160 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				_tmp2_ = _tmp4_;
#line 160 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 160 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
					_gtk_icon_info_free0 (icon_info);
#line 411 "Icon.c"
					goto __catch21_g_error;
				}
#line 160 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				_tmp5_ = _tmp2_;
#line 160 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				_tmp2_ = NULL;
#line 160 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				_g_object_unref0 (rv);
#line 160 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				rv = _tmp5_;
#line 159 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				_g_object_unref0 (_tmp2_);
#line 424 "Icon.c"
			} else {
				GdkPixbuf* _tmp6_ = NULL;
				GtkIconInfo* _tmp7_;
				GdkPixbuf* _tmp8_;
				GdkPixbuf* _tmp9_;
#line 162 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				_tmp7_ = icon_info;
#line 162 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				_tmp8_ = gtk_icon_info_load_icon (_tmp7_, &_inner_error_);
#line 162 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				_tmp6_ = _tmp8_;
#line 162 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 162 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
					_gtk_icon_info_free0 (icon_info);
#line 440 "Icon.c"
					goto __catch21_g_error;
				}
#line 162 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				_tmp9_ = _tmp6_;
#line 162 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				_tmp6_ = NULL;
#line 162 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				_g_object_unref0 (rv);
#line 162 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				rv = _tmp9_;
#line 159 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				_g_object_unref0 (_tmp6_);
#line 453 "Icon.c"
			}
		}
#line 166 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp10_ = rv;
#line 166 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		if (_tmp10_ == NULL) {
#line 460 "Icon.c"
			const gchar* _tmp11_ = NULL;
			const gchar* _tmp12_;
			GdkPixbuf* _tmp14_ = NULL;
			GtkIconTheme* _tmp15_;
			GtkIconTheme* _tmp16_;
			GdkPixbuf* _tmp17_;
			GdkPixbuf* _tmp18_;
#line 167 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
			_tmp12_ = self->priv->_file_name;
#line 167 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
			_tmp11_ = _tmp12_;
#line 167 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
			if (_tmp11_ == NULL) {
#line 474 "Icon.c"
				const gchar* _tmp13_;
#line 167 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				_tmp13_ = self->priv->_name;
#line 167 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				_tmp11_ = _tmp13_;
#line 480 "Icon.c"
			}
#line 167 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
			g_warning ("Icon.vala:167: Icon not found: %s", _tmp11_);
#line 168 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
			_tmp15_ = noise_icon_get_theme ();
#line 168 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
			_tmp16_ = _tmp15_;
#line 168 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
			_tmp17_ = gtk_icon_theme_load_icon (_tmp16_, "image-missing", pixel_size, GTK_ICON_LOOKUP_GENERIC_FALLBACK, &_inner_error_);
#line 168 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
			_tmp14_ = _tmp17_;
#line 168 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 168 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
				_gtk_icon_info_free0 (icon_info);
#line 496 "Icon.c"
				goto __catch21_g_error;
			}
#line 168 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
			_tmp18_ = _tmp14_;
#line 168 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
			_tmp14_ = NULL;
#line 168 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
			_g_object_unref0 (rv);
#line 168 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
			rv = _tmp18_;
#line 166 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
			_g_object_unref0 (_tmp14_);
#line 509 "Icon.c"
		}
#line 155 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_gtk_icon_info_free0 (icon_info);
#line 513 "Icon.c"
	}
	goto __finally21;
	__catch21_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		GError* _tmp22_;
		const gchar* _tmp23_;
#line 155 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		err = _inner_error_;
#line 155 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_inner_error_ = NULL;
#line 172 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp20_ = self->priv->_file_name;
#line 172 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp19_ = _tmp20_;
#line 172 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		if (_tmp19_ == NULL) {
#line 533 "Icon.c"
			const gchar* _tmp21_;
#line 172 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
			_tmp21_ = self->priv->_name;
#line 172 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
			_tmp19_ = _tmp21_;
#line 539 "Icon.c"
		}
#line 172 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp22_ = err;
#line 172 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp23_ = _tmp22_->message;
#line 172 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		g_warning ("Icon.vala:172: Could not load icon [%s]: %s", _tmp19_, _tmp23_);
#line 155 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_g_error_free0 (err);
#line 549 "Icon.c"
	}
	__finally21:
#line 155 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 155 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_g_object_unref0 (rv);
#line 155 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 155 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		g_clear_error (&_inner_error_);
#line 155 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		return NULL;
#line 562 "Icon.c"
	}
#line 175 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	result = rv;
#line 175 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	return result;
#line 568 "Icon.c"
}


/**
     * Creates a new {@link Gtk.Image} displaying the icon at the specified size.
     *
     * @param size The image's icon size.
     * @return a newly-created Gtk.Image.
     * @see Noise.Icon.render_image_at_size
     */
GtkImage*
noise_icon_render_image (NoiseIcon* self,
                         GtkIconSize size)
{
	GtkImage* result = NULL;
	GtkImage* image = NULL;
	const gchar* _tmp0_;
#line 186 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 188 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_tmp0_ = self->priv->_name;
#line 188 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	if (_tmp0_ != NULL) {
#line 592 "Icon.c"
		const gchar* _tmp1_;
		GtkImage* _tmp2_;
#line 189 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp1_ = self->priv->_name;
#line 189 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp1_, (GtkIconSize) size);
#line 189 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		g_object_ref_sink (_tmp2_);
#line 189 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_g_object_unref0 (image);
#line 189 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		image = _tmp2_;
#line 605 "Icon.c"
	} else {
		GIcon* _tmp3_;
		GtkImage* _tmp4_;
#line 191 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp3_ = self->priv->_gicon;
#line 191 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp4_ = (GtkImage*) gtk_image_new_from_gicon (_tmp3_, (GtkIconSize) size);
#line 191 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		g_object_ref_sink (_tmp4_);
#line 191 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_g_object_unref0 (image);
#line 191 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		image = _tmp4_;
#line 619 "Icon.c"
	}
#line 192 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	result = image;
#line 192 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	return result;
#line 625 "Icon.c"
}


/**
     * Creates a new {@link Gtk.Image} displaying the icon at the specified pixel size.
     *
     * @param pixel_size The image's pixel size.
     * @return a newly-created Gtk.Image.
     * @see Noise.Icon.render_image
     */
GtkImage*
noise_icon_render_image_at_size (NoiseIcon* self,
                                 gint pixel_size)
{
	GtkImage* result = NULL;
	GtkImage* rv = NULL;
	GtkImage* _tmp0_;
#line 203 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 204 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_tmp0_ = noise_icon_render_image (self, GTK_ICON_SIZE_MENU);
#line 204 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	rv = _tmp0_;
#line 205 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	gtk_image_set_pixel_size (rv, pixel_size);
#line 206 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	result = rv;
#line 206 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	return result;
#line 655 "Icon.c"
}


GtkIconTheme*
noise_icon_get_theme (void)
{
	GtkIconTheme* result;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp6_;
#line 59 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_tmp0_ = noise_icon__theme;
#line 59 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	if (_tmp0_ == NULL) {
#line 669 "Icon.c"
		GtkIconTheme* _tmp1_;
		GtkIconTheme* _tmp2_;
		GtkIconTheme* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp1_ = gtk_icon_theme_get_default ();
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_g_object_unref0 (noise_icon__theme);
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		noise_icon__theme = _tmp2_;
#line 65 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp3_ = noise_icon__theme;
#line 65 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp4_ = g_build_filename (BUILD_ICON_DIR, NULL);
#line 65 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp5_ = _tmp4_;
#line 65 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		gtk_icon_theme_append_search_path (_tmp3_, _tmp5_);
#line 65 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_g_free0 (_tmp5_);
#line 693 "Icon.c"
	}
#line 68 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_tmp6_ = noise_icon__theme;
#line 68 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	result = _tmp6_;
#line 68 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	return result;
#line 701 "Icon.c"
}


const gchar*
noise_icon_get_name (NoiseIcon* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 76 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 76 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_tmp0_ = self->priv->_name;
#line 76 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	result = _tmp0_;
#line 76 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	return result;
#line 718 "Icon.c"
}


static void
noise_icon_set_name (NoiseIcon* self,
                     const gchar* value)
{
#line 76 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	g_return_if_fail (self != NULL);
#line 76 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	if (g_strcmp0 (value, noise_icon_get_name (self)) != 0) {
#line 730 "Icon.c"
		gchar* _tmp0_;
#line 76 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp0_ = g_strdup (value);
#line 76 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_g_free0 (self->priv->_name);
#line 76 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		self->priv->_name = _tmp0_;
#line 76 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_icon_properties[NOISE_ICON_NAME_PROPERTY]);
#line 740 "Icon.c"
	}
}


const gchar*
noise_icon_get_file_name (NoiseIcon* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_tmp0_ = self->priv->_file_name;
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	result = _tmp0_;
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	return result;
#line 758 "Icon.c"
}


static void
noise_icon_set_file_name (NoiseIcon* self,
                          const gchar* value)
{
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	g_return_if_fail (self != NULL);
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	if (g_strcmp0 (value, noise_icon_get_file_name (self)) != 0) {
#line 770 "Icon.c"
		gchar* _tmp0_;
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp0_ = g_strdup (value);
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_g_free0 (self->priv->_file_name);
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		self->priv->_file_name = _tmp0_;
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_icon_properties[NOISE_ICON_FILE_NAME_PROPERTY]);
#line 780 "Icon.c"
	}
}


GIcon*
noise_icon_get_gicon (NoiseIcon* self)
{
	GIcon* result;
	GIcon* _tmp0_;
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_tmp0_ = self->priv->_gicon;
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	result = _tmp0_;
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	return result;
#line 798 "Icon.c"
}


static void
noise_icon_set_gicon (NoiseIcon* self,
                      GIcon* value)
{
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	g_return_if_fail (self != NULL);
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	if (noise_icon_get_gicon (self) != value) {
#line 810 "Icon.c"
		GIcon* _tmp0_;
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		_g_object_unref0 (self->priv->_gicon);
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		self->priv->_gicon = _tmp0_;
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_icon_properties[NOISE_ICON_GICON_PROPERTY]);
#line 820 "Icon.c"
	}
}


static void
noise_icon_class_init (NoiseIconClass * klass)
{
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	noise_icon_parent_class = g_type_class_peek_parent (klass);
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	g_type_class_add_private (klass, sizeof (NoiseIconPrivate));
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_icon_get_property;
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_icon_set_property;
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_icon_finalize;
#line 838 "Icon.c"
	/**
	     * The name of the icon, as passed to the constructor. If the icon points to an absolute
	     * file name, this will return null.
	     */
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ICON_NAME_PROPERTY, noise_icon_properties[NOISE_ICON_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 845 "Icon.c"
	/**
	     * The absolute file name of the icon, as passed to the constructor. If the icon points to
	     * an icon name instead, this will return null.
	     */
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ICON_FILE_NAME_PROPERTY, noise_icon_properties[NOISE_ICON_FILE_NAME_PROPERTY] = g_param_spec_string ("file-name", "file-name", "file-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 852 "Icon.c"
	/**
	     * The {@link GLib.Icon} representing the icon.
	     */
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ICON_GICON_PROPERTY, noise_icon_properties[NOISE_ICON_GICON_PROPERTY] = g_param_spec_object ("gicon", "gicon", "gicon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 858 "Icon.c"
}


static void
noise_icon_instance_init (NoiseIcon * self)
{
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	self->priv = NOISE_ICON_GET_PRIVATE (self);
#line 867 "Icon.c"
}


static void
noise_icon_finalize (GObject * obj)
{
	NoiseIcon * self;
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_ICON, NoiseIcon);
#line 76 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_g_free0 (self->priv->_name);
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_g_free0 (self->priv->_file_name);
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	_g_object_unref0 (self->priv->_gicon);
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	G_OBJECT_CLASS (noise_icon_parent_class)->finalize (obj);
#line 885 "Icon.c"
}


/**
 * An Icon Object
 *
 * Icon objects point to icon files or generic icon names. The API provides convenience
 * methods for rendering the icon to a {@link Gdk.Pixbuf} image or {@link Gtk.Image} widgets.
 *
 * When an icon points to an absolute path (e.g. /usr/share/noise/icons/default-cover-art.png),
 * the image is loaded from that specific file and not from any icon theme. Otherwise, the icon
 * is searched in the available icon themes. Please note though that it's not necessary to pass
 * an absolute path in order to get backup icon (i.e. icons shipped along with the application)
 * support, since the application's icon path is also queried when looking up for named icons,
 * which means that shipping a backup icon file and installing it to a sub-directory named "hicolor"
 * is enough for making sure that the icon will always be available/found. For instance:
 *
 * {{{
 * // To provide a fallback, simply install a fallback icon. e.g. ${NOISE_ICON_DIR}/hicolor/starred.svg
 * var icon = new Noise.Icon ("starred");
 *
 * // Supposing the icon was not found in any icon theme, the fallback icon file will be used instead,
 * // so this operation will never fail.
 * icon.render (Gtk.IconSize.MENU);
 * }}}
 *
 * This class is actually a wrapper around {@link GLib.Icon} that allows easy backup-icon management.
 */
GType
noise_icon_get_type (void)
{
	static volatile gsize noise_icon_type_id__volatile = 0;
	if (g_once_init_enter (&noise_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseIcon), 0, (GInstanceInitFunc) noise_icon_instance_init, NULL };
		GType noise_icon_type_id;
		noise_icon_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseIcon", &g_define_type_info, 0);
		g_once_init_leave (&noise_icon_type_id__volatile, noise_icon_type_id);
	}
	return noise_icon_type_id__volatile;
}


static void
_vala_noise_icon_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	NoiseIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_ICON, NoiseIcon);
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	switch (property_id) {
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		case NOISE_ICON_NAME_PROPERTY:
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		g_value_set_string (value, noise_icon_get_name (self));
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		break;
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		case NOISE_ICON_FILE_NAME_PROPERTY:
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		g_value_set_string (value, noise_icon_get_file_name (self));
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		break;
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		case NOISE_ICON_GICON_PROPERTY:
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		g_value_set_object (value, noise_icon_get_gicon (self));
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		break;
#line 956 "Icon.c"
		default:
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		break;
#line 962 "Icon.c"
	}
}


static void
_vala_noise_icon_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	NoiseIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_ICON, NoiseIcon);
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
	switch (property_id) {
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		case NOISE_ICON_NAME_PROPERTY:
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		noise_icon_set_name (self, g_value_get_string (value));
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		break;
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		case NOISE_ICON_FILE_NAME_PROPERTY:
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		noise_icon_set_file_name (self, g_value_get_string (value));
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		break;
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		case NOISE_ICON_GICON_PROPERTY:
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		noise_icon_set_gicon (self, g_value_get_object (value));
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		break;
#line 995 "Icon.c"
		default:
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/Icon.vala"
		break;
#line 1001 "Icon.c"
	}
}



