/* Search.c generated by valac 0.40.4, the Vala compiler
 * generated from Search.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define NOISE_TYPE_MEDIA (noise_media_get_type ())
#define NOISE_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA, NoiseMedia))
#define NOISE_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA, NoiseMediaClass))
#define NOISE_IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA))
#define NOISE_IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA))
#define NOISE_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA, NoiseMediaClass))

typedef struct _NoiseMedia NoiseMedia;
typedef struct _NoiseMediaClass NoiseMediaClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



GType noise_media_get_type (void) G_GNUC_CONST;
void noise_search_search_in_media_list (GeeCollection* to_search,
                                        GeeCollection* * results,
                                        const gchar* album_artist,
                                        const gchar* album,
                                        const gchar* genre,
                                        const gchar* grouping,
                                        const gchar* composer,
                                        gint year,
                                        gint rating,
                                        GCancellable* cancellable);
gboolean noise_utils_is_cancelled (GCancellable* cancellable);
gboolean noise_search_match_fields_to_media (NoiseMedia* media,
                                             const gchar* album_artist,
                                             const gchar* album,
                                             const gchar* genre,
                                             const gchar* grouping,
                                             const gchar* composer,
                                             gint year,
                                             gint rating);
guint noise_media_get_rating (NoiseMedia* self);
guint noise_media_get_year (NoiseMedia* self);
gboolean noise_string_is_empty (const gchar* text,
                                gboolean check_white_space);
gchar* noise_media_get_display_genre (NoiseMedia* self);
gchar* noise_media_get_display_album_artist (NoiseMedia* self,
                                             gboolean use_artist_fallback);
gchar* noise_media_get_display_album (NoiseMedia* self);
const gchar* noise_media_get_grouping (NoiseMedia* self);
gchar* noise_media_get_display_composer (NoiseMedia* self);
gchar* noise_search_get_valid_search_string (const gchar* s);
gchar* noise_string_canonicalize_for_search (const gchar* str);
guint* noise_search_get_rating_from_string (const gchar* rating_string);
static gboolean _uint_equal (const guint * s1,
                      const guint * s2);
static guint* _uint_dup (guint* self);
gboolean noise_search_match_string_to_media (NoiseMedia* m,
                                             const gchar* search);
gchar* noise_media_get_display_title (NoiseMedia* self);
const gchar* noise_media_get_album (NoiseMedia* self);
const gchar* noise_media_get_artist (NoiseMedia* self);
const gchar* noise_media_get_album_artist (NoiseMedia* self);
const gchar* noise_media_get_genre (NoiseMedia* self);
const gchar* noise_media_get_composer (NoiseMedia* self);
const gchar* noise_media_get_comment (NoiseMedia* self);
const gchar* noise_media_get_lyrics (NoiseMedia* self);


/**
     * Linear exact-string-matching search method.
     *
     * To mean "ALL", pass an empty string (i.e.: "") for string parameters; and
     * -1 for integer parameters.
     *
     * Please note that this method compares against the values returned by
     * Media.get_display_*(), and not the real fields. This means that a value
     * like 'Unknown' will have a matching media even if the actual field is empty.
     *
     *
     * Used by the column browser. Fields compared must match those *displayed* by the browser.
     *
     * /!\ Modify carefully.
     */
void
noise_search_search_in_media_list (GeeCollection* to_search,
                                   GeeCollection* * results,
                                   const gchar* album_artist,
                                   const gchar* album,
                                   const gchar* genre,
                                   const gchar* grouping,
                                   const gchar* composer,
                                   gint year,
                                   gint rating,
                                   GCancellable* cancellable)
{
	GeeCollection* _vala_results = NULL;
	GeeTreeSet* _tmp0_;
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	g_return_if_fail (to_search != NULL);
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	g_return_if_fail (album_artist != NULL);
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	g_return_if_fail (album != NULL);
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	g_return_if_fail (genre != NULL);
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	g_return_if_fail (grouping != NULL);
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	g_return_if_fail (composer != NULL);
#line 57 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	_tmp0_ = gee_tree_set_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 57 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	_g_object_unref0 (_vala_results);
#line 57 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	_vala_results = (GeeCollection*) _tmp0_;
#line 155 "Search.c"
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp1_;
#line 59 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) to_search);
#line 59 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_media_it = _tmp1_;
#line 59 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		while (TRUE) {
#line 165 "Search.c"
			GeeIterator* _tmp2_;
			NoiseMedia* media = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			NoiseMedia* _tmp5_;
#line 59 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp2_ = _media_it;
#line 59 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 59 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
				break;
#line 177 "Search.c"
			}
#line 59 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp3_ = _media_it;
#line 59 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 59 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			media = (NoiseMedia*) _tmp4_;
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			if (noise_utils_is_cancelled (cancellable)) {
#line 61 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
				_g_object_unref0 (media);
#line 61 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
				break;
#line 191 "Search.c"
			}
#line 63 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp5_ = media;
#line 63 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			if (noise_search_match_fields_to_media (_tmp5_, album_artist, album, genre, grouping, composer, year, rating)) {
#line 197 "Search.c"
				GeeCollection* _tmp6_;
				NoiseMedia* _tmp7_;
#line 64 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
				_tmp6_ = _vala_results;
#line 64 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
				_tmp7_ = media;
#line 64 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
				gee_collection_add (_tmp6_, _tmp7_);
#line 206 "Search.c"
			}
#line 59 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_g_object_unref0 (media);
#line 210 "Search.c"
		}
#line 59 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_g_object_unref0 (_media_it);
#line 214 "Search.c"
	}
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (results) {
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		*results = _vala_results;
#line 220 "Search.c"
	} else {
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_g_object_unref0 (_vala_results);
#line 224 "Search.c"
	}
}


/**
     * Used by the column browser. Fields compared must match those *displayed* by the browser.
     *
     * /!\ Modify carefully.
     */
inline gboolean
noise_search_match_fields_to_media (NoiseMedia* media,
                                    const gchar* album_artist,
                                    const gchar* album,
                                    const gchar* genre,
                                    const gchar* grouping,
                                    const gchar* composer,
                                    gint year,
                                    gint rating)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	g_return_val_if_fail (media != NULL, FALSE);
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	g_return_val_if_fail (album_artist != NULL, FALSE);
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	g_return_val_if_fail (album != NULL, FALSE);
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	g_return_val_if_fail (genre != NULL, FALSE);
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	g_return_val_if_fail (grouping != NULL, FALSE);
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	g_return_val_if_fail (composer != NULL, FALSE);
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (rating == -1) {
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp6_ = TRUE;
#line 268 "Search.c"
	} else {
		guint _tmp7_;
		guint _tmp8_;
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp7_ = noise_media_get_rating (media);
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp8_ = _tmp7_;
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp6_ = _tmp8_ == ((guint) rating);
#line 278 "Search.c"
	}
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (_tmp6_) {
#line 282 "Search.c"
		gboolean _tmp9_ = FALSE;
#line 83 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		if (year == -1) {
#line 83 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp9_ = TRUE;
#line 288 "Search.c"
		} else {
			guint _tmp10_;
			guint _tmp11_;
#line 83 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp10_ = noise_media_get_year (media);
#line 83 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp11_ = _tmp10_;
#line 83 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp9_ = _tmp11_ == ((guint) year);
#line 298 "Search.c"
		}
#line 83 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp5_ = _tmp9_;
#line 302 "Search.c"
	} else {
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp5_ = FALSE;
#line 306 "Search.c"
	}
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (_tmp5_) {
#line 310 "Search.c"
		gboolean _tmp12_ = FALSE;
#line 84 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		if (noise_string_is_empty (genre, FALSE)) {
#line 84 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp12_ = TRUE;
#line 316 "Search.c"
		} else {
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 84 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp13_ = noise_media_get_display_genre (media);
#line 84 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp14_ = _tmp13_;
#line 84 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp12_ = g_strcmp0 (_tmp14_, genre) == 0;
#line 84 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_g_free0 (_tmp14_);
#line 328 "Search.c"
		}
#line 84 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp4_ = _tmp12_;
#line 332 "Search.c"
	} else {
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp4_ = FALSE;
#line 336 "Search.c"
	}
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (_tmp4_) {
#line 340 "Search.c"
		gboolean _tmp15_ = FALSE;
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		if (noise_string_is_empty (album_artist, FALSE)) {
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp15_ = TRUE;
#line 346 "Search.c"
		} else {
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp16_ = noise_media_get_display_album_artist (media, TRUE);
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp17_ = _tmp16_;
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp15_ = g_strcmp0 (_tmp17_, album_artist) == 0;
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_g_free0 (_tmp17_);
#line 358 "Search.c"
		}
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp3_ = _tmp15_;
#line 362 "Search.c"
	} else {
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp3_ = FALSE;
#line 366 "Search.c"
	}
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (_tmp3_) {
#line 370 "Search.c"
		gboolean _tmp18_ = FALSE;
#line 86 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		if (noise_string_is_empty (album, FALSE)) {
#line 86 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp18_ = TRUE;
#line 376 "Search.c"
		} else {
			gchar* _tmp19_;
			gchar* _tmp20_;
#line 86 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp19_ = noise_media_get_display_album (media);
#line 86 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp20_ = _tmp19_;
#line 86 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp18_ = g_strcmp0 (_tmp20_, album) == 0;
#line 86 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_g_free0 (_tmp20_);
#line 388 "Search.c"
		}
#line 86 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp2_ = _tmp18_;
#line 392 "Search.c"
	} else {
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp2_ = FALSE;
#line 396 "Search.c"
	}
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (_tmp2_) {
#line 400 "Search.c"
		gboolean _tmp21_ = FALSE;
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		if (noise_string_is_empty (grouping, FALSE)) {
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp21_ = TRUE;
#line 406 "Search.c"
		} else {
			const gchar* _tmp22_;
			const gchar* _tmp23_;
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp22_ = noise_media_get_grouping (media);
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp23_ = _tmp22_;
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp21_ = g_strcmp0 (_tmp23_, grouping) == 0;
#line 416 "Search.c"
		}
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp1_ = _tmp21_;
#line 420 "Search.c"
	} else {
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp1_ = FALSE;
#line 424 "Search.c"
	}
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (_tmp1_) {
#line 428 "Search.c"
		gboolean _tmp24_ = FALSE;
#line 88 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		if (noise_string_is_empty (composer, FALSE)) {
#line 88 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp24_ = TRUE;
#line 434 "Search.c"
		} else {
			gchar* _tmp25_;
			gchar* _tmp26_;
#line 88 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp25_ = noise_media_get_display_composer (media);
#line 88 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp26_ = _tmp25_;
#line 88 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp24_ = g_strcmp0 (_tmp26_, composer) == 0;
#line 88 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_g_free0 (_tmp26_);
#line 446 "Search.c"
		}
#line 88 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp0_ = _tmp24_;
#line 450 "Search.c"
	} else {
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp0_ = FALSE;
#line 454 "Search.c"
	}
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	result = _tmp0_;
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	return result;
#line 460 "Search.c"
}


inline gchar*
noise_search_get_valid_search_string (const gchar* s)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 91 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 92 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	_tmp0_ = noise_string_canonicalize_for_search (s);
#line 92 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	result = _tmp0_;
#line 92 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	return result;
#line 477 "Search.c"
}


/**
     * Parses a rating from stars. e.g. "***" => 3
     * Returns -1 if rating_string doesn't represent a valid rating.
     *
     * This method ''never'' returns zero. It simply doesn't make sense to
     * return a rating of zero for any given empty string.
     *
     * Samples of valid strings:
     *   "*"
     *   "****"
     * Samples of invalid strings:
     *   ""
     *   "  "
     *   "**a"
     */
static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gunichar _tmp0_;
#line 1143 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1144 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1145 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = _vala_c;
#line 1145 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_ != ((gunichar) 0)) {
#line 512 "Search.c"
		gchar* _tmp1_;
#line 1146 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1146 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*index = (gint) (_tmp1_ - ((gchar*) self));
#line 1147 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = TRUE;
#line 1147 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (c) {
#line 1147 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 524 "Search.c"
		}
#line 1147 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 528 "Search.c"
	} else {
#line 1149 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = FALSE;
#line 1149 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (c) {
#line 1149 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 536 "Search.c"
		}
#line 1149 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 540 "Search.c"
	}
#line 1143 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (c) {
#line 1143 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*c = _vala_c;
#line 546 "Search.c"
	}
}


static gboolean
_uint_equal (const guint * s1,
             const guint * s2)
{
#line 119 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (s1 == s2) {
#line 119 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		return TRUE;
#line 559 "Search.c"
	}
#line 119 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (s1 == NULL) {
#line 119 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		return FALSE;
#line 565 "Search.c"
	}
#line 119 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (s2 == NULL) {
#line 119 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		return FALSE;
#line 571 "Search.c"
	}
#line 119 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	return (*s1) == (*s2);
#line 575 "Search.c"
}


static guint*
_uint_dup (guint* self)
{
	guint* dup;
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	dup = g_new0 (guint, 1);
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	memcpy (dup, self, sizeof (guint));
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	return dup;
#line 589 "Search.c"
}


static gpointer
__uint_dup0 (gpointer self)
{
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	return self ? _uint_dup (self) : NULL;
#line 598 "Search.c"
}


inline guint*
noise_search_get_rating_from_string (const gchar* rating_string)
{
	guint* result = NULL;
	gint i = 0;
	gunichar c = 0U;
	guint rating = 0U;
	guint _tmp7_;
	guint* _tmp10_;
	guint* _tmp11_;
	guint _tmp12_;
	guint* _tmp13_;
	guint _tmp14_;
#line 110 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	g_return_val_if_fail (rating_string != NULL, NULL);
#line 113 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	i = 0;
#line 619 "Search.c"
	{
		gboolean _tmp0_ = FALSE;
#line 117 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		rating = (guint) 0;
#line 117 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp0_ = TRUE;
#line 117 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		while (TRUE) {
#line 628 "Search.c"
			gunichar _tmp2_ = 0U;
			gboolean _tmp3_;
			gunichar _tmp4_;
#line 117 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			if (!_tmp0_) {
#line 634 "Search.c"
				guint _tmp1_;
#line 117 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
				_tmp1_ = rating;
#line 117 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
				rating = _tmp1_ + 1;
#line 640 "Search.c"
			}
#line 117 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp0_ = FALSE;
#line 117 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp3_ = string_get_next_char (rating_string, &i, &_tmp2_);
#line 117 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			c = _tmp2_;
#line 117 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			if (!_tmp3_) {
#line 117 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
				break;
#line 652 "Search.c"
			}
#line 118 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			_tmp4_ = c;
#line 118 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
			if (_tmp4_ != ((gunichar) '*')) {
#line 658 "Search.c"
				guint* _tmp5_;
				guint _tmp6_;
#line 119 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
				result = NULL;
#line 119 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
				_tmp5_ = result;
#line 119 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
				_tmp6_ = (guint) 0;
#line 119 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
				_vala_warn_if_fail (_uint_equal (_tmp5_, &_tmp6_) != TRUE, "result != 0");
#line 119 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
				return result;
#line 671 "Search.c"
			}
		}
	}
#line 122 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	_tmp7_ = rating;
#line 122 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (_tmp7_ == ((guint) 0)) {
#line 679 "Search.c"
		guint* _tmp8_;
		guint _tmp9_;
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		result = NULL;
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp8_ = result;
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp9_ = (guint) 0;
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_vala_warn_if_fail (_uint_equal (_tmp8_, &_tmp9_) != TRUE, "result != 0");
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		return result;
#line 692 "Search.c"
	}
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	_tmp10_ = __uint_dup0 (&rating);
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	result = _tmp10_;
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	_tmp11_ = result;
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	_tmp12_ = (guint) 0;
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	_vala_warn_if_fail (_uint_equal (_tmp11_, &_tmp12_) != TRUE, "result != 0");
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	return result;
#line 706 "Search.c"
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1417 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1417 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 726 "Search.c"
}


inline gboolean
noise_search_match_string_to_media (NoiseMedia* m,
                                    const gchar* search)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	guint _tmp9_;
	guint _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gboolean _tmp13_;
#line 128 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	g_return_val_if_fail (m != NULL, FALSE);
#line 128 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	g_return_val_if_fail (search != NULL, FALSE);
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	_tmp9_ = noise_media_get_year (m);
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	_tmp10_ = _tmp9_;
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	_tmp11_ = g_strdup_printf ("%u", _tmp10_);
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	_tmp12_ = _tmp11_;
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	_tmp13_ = g_strcmp0 (search, _tmp12_) == 0;
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	_g_free0 (_tmp12_);
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (_tmp13_) {
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp8_ = TRUE;
#line 769 "Search.c"
	} else {
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 130 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp14_ = noise_media_get_display_title (m);
#line 130 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp15_ = _tmp14_;
#line 130 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp16_ = noise_search_get_valid_search_string (_tmp15_);
#line 130 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp17_ = _tmp16_;
#line 130 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp8_ = string_contains (_tmp17_, search);
#line 130 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_g_free0 (_tmp17_);
#line 130 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_g_free0 (_tmp15_);
#line 789 "Search.c"
	}
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (_tmp8_) {
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp7_ = TRUE;
#line 795 "Search.c"
	} else {
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 131 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp18_ = noise_media_get_album (m);
#line 131 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp19_ = _tmp18_;
#line 131 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp20_ = noise_search_get_valid_search_string (_tmp19_);
#line 131 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp21_ = _tmp20_;
#line 131 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp7_ = string_contains (_tmp21_, search);
#line 131 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_g_free0 (_tmp21_);
#line 813 "Search.c"
	}
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (_tmp7_) {
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp6_ = TRUE;
#line 819 "Search.c"
	} else {
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
#line 132 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp22_ = noise_media_get_artist (m);
#line 132 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp23_ = _tmp22_;
#line 132 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp24_ = noise_search_get_valid_search_string (_tmp23_);
#line 132 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp25_ = _tmp24_;
#line 132 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp6_ = string_contains (_tmp25_, search);
#line 132 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_g_free0 (_tmp25_);
#line 837 "Search.c"
	}
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (_tmp6_) {
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp5_ = TRUE;
#line 843 "Search.c"
	} else {
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 133 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp26_ = noise_media_get_album_artist (m);
#line 133 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp27_ = _tmp26_;
#line 133 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp28_ = noise_search_get_valid_search_string (_tmp27_);
#line 133 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp29_ = _tmp28_;
#line 133 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp5_ = string_contains (_tmp29_, search);
#line 133 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_g_free0 (_tmp29_);
#line 861 "Search.c"
	}
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (_tmp5_) {
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp4_ = TRUE;
#line 867 "Search.c"
	} else {
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
#line 134 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp30_ = noise_media_get_genre (m);
#line 134 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp31_ = _tmp30_;
#line 134 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp32_ = noise_search_get_valid_search_string (_tmp31_);
#line 134 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp33_ = _tmp32_;
#line 134 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp4_ = string_contains (_tmp33_, search);
#line 134 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_g_free0 (_tmp33_);
#line 885 "Search.c"
	}
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (_tmp4_) {
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp3_ = TRUE;
#line 891 "Search.c"
	} else {
		const gchar* _tmp34_;
		const gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
#line 135 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp34_ = noise_media_get_composer (m);
#line 135 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp35_ = _tmp34_;
#line 135 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp36_ = noise_search_get_valid_search_string (_tmp35_);
#line 135 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp37_ = _tmp36_;
#line 135 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp3_ = string_contains (_tmp37_, search);
#line 135 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_g_free0 (_tmp37_);
#line 909 "Search.c"
	}
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (_tmp3_) {
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp2_ = TRUE;
#line 915 "Search.c"
	} else {
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
#line 136 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp38_ = noise_media_get_grouping (m);
#line 136 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp39_ = _tmp38_;
#line 136 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp40_ = noise_search_get_valid_search_string (_tmp39_);
#line 136 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp41_ = _tmp40_;
#line 136 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp2_ = string_contains (_tmp41_, search);
#line 136 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_g_free0 (_tmp41_);
#line 933 "Search.c"
	}
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (_tmp2_) {
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp1_ = TRUE;
#line 939 "Search.c"
	} else {
		const gchar* _tmp42_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
#line 137 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp42_ = noise_media_get_comment (m);
#line 137 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp43_ = _tmp42_;
#line 137 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp44_ = noise_search_get_valid_search_string (_tmp43_);
#line 137 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp45_ = _tmp44_;
#line 137 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp1_ = string_contains (_tmp45_, search);
#line 137 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_g_free0 (_tmp45_);
#line 957 "Search.c"
	}
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	if (_tmp1_) {
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp0_ = TRUE;
#line 963 "Search.c"
	} else {
		const gchar* _tmp46_;
		const gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
#line 138 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp46_ = noise_media_get_lyrics (m);
#line 138 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp47_ = _tmp46_;
#line 138 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp48_ = noise_search_get_valid_search_string (_tmp47_);
#line 138 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp49_ = _tmp48_;
#line 138 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_tmp0_ = string_contains (_tmp49_, search);
#line 138 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
		_g_free0 (_tmp49_);
#line 981 "Search.c"
	}
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	result = _tmp0_;
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Utils/Search.vala"
	return result;
#line 987 "Search.c"
}



