/* String.c generated by valac 0.40.4, the Vala compiler
 * generated from String.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



gboolean noise_string_is_empty (const gchar* text,
                                gboolean check_white_space);
gboolean noise_string_is_white_space (const gchar* text);
gint noise_string_compare (const gchar* a,
                           const gchar* b);
gchar* noise_string_canonicalize_for_search (const gchar* str);
gunichar noise_string_strip_char (gunichar ch);
gchar* noise_string_to_title_case (const gchar* text);
gchar* noise_string_locale_to_utf8 (const gchar* string_locale);
void noise_string_base_search_method (const gchar* search,
                                      guint* parsed_rating,
                                      gchar* * parsed_search_string);
guint* noise_search_get_rating_from_string (const gchar* rating_string);
gchar* noise_search_get_valid_search_string (const gchar* s);
guint64 noise_string_uint_from_string (const gchar* str);


inline gboolean
noise_string_is_empty (const gchar* text,
                       gboolean check_white_space)
{
	gboolean result = FALSE;
#line 32 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	if (text != NULL) {
#line 69 "String.c"
		gboolean _tmp0_ = FALSE;
#line 33 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		if (check_white_space) {
#line 33 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
			_tmp0_ = noise_string_is_white_space (text);
#line 75 "String.c"
		} else {
#line 33 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
			_tmp0_ = g_strcmp0 (text, "") == 0;
#line 79 "String.c"
		}
#line 33 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		result = _tmp0_;
#line 33 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		return result;
#line 85 "String.c"
	}
#line 34 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	result = TRUE;
#line 34 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	return result;
#line 91 "String.c"
}


/**
     * Compares two strings encoded in UTF-8. Used extensively in the views for sorting.
     *
     * It takes into account the current locale's sorting rules and is faster
     * than normal string comparison.
     *
     * /!\ DON'T USE THIS METHOD WITH STRINGS NOT ENCODED IN UTF-8.
     *
     * @param a first string.
     * @param b second string.
     * @return 0 if a == b, a positive number if a > b, or a negative number if a < b.
     */
inline gint
noise_string_compare (const gchar* a,
                      const gchar* b)
{
	gint result = 0;
	gchar* _tmp0_ = NULL;
	gchar* _tmp3_ = NULL;
	GCompareFunc _tmp6_;
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	if (a != NULL) {
#line 117 "String.c"
		gchar* _tmp1_;
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_tmp1_ = g_utf8_collate_key (a, (gssize) -1);
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_g_free0 (_tmp0_);
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_tmp0_ = _tmp1_;
#line 125 "String.c"
	} else {
		gchar* _tmp2_;
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_tmp2_ = g_strdup ((const gchar*) NULL);
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_g_free0 (_tmp0_);
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_tmp0_ = _tmp2_;
#line 134 "String.c"
	}
#line 52 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	if (b != NULL) {
#line 138 "String.c"
		gchar* _tmp4_;
#line 52 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_tmp4_ = g_utf8_collate_key (b, (gssize) -1);
#line 52 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_g_free0 (_tmp3_);
#line 52 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_tmp3_ = _tmp4_;
#line 146 "String.c"
	} else {
		gchar* _tmp5_;
#line 52 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_tmp5_ = g_strdup ((const gchar*) NULL);
#line 52 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_g_free0 (_tmp3_);
#line 52 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_tmp3_ = _tmp5_;
#line 155 "String.c"
	}
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp6_ = g_strcmp0;
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	result = _tmp6_ (_tmp0_, _tmp3_);
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_g_free0 (_tmp3_);
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_g_free0 (_tmp0_);
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	return result;
#line 167 "String.c"
}


/**
     * Checks whether a string contains only whitespace.
     *
     * @return //true// if text consists enterely of white space.
     */
static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1248 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _result_;
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 197 "String.c"
}


inline gboolean
noise_string_is_white_space (const gchar* text)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 61 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp0_ = string_strip (text);
#line 61 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp1_ = _tmp0_;
#line 61 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp2_ = strlen (_tmp1_);
#line 61 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp3_ = _tmp2_;
#line 61 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp4_ = _tmp3_ == 0;
#line 61 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_g_free0 (_tmp1_);
#line 61 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	result = _tmp4_;
#line 61 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	return result;
#line 228 "String.c"
}


/**
     * Removes irrelevant and meaningless characters from a string. Useful for search operations.
     * (Taken from gnome-contacts' contacts-utils.vala)
     */
static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gunichar _tmp0_;
#line 1143 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1144 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1145 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = _vala_c;
#line 1145 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_ != ((gunichar) 0)) {
#line 252 "String.c"
		gchar* _tmp1_;
#line 1146 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1146 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*index = (gint) (_tmp1_ - ((gchar*) self));
#line 1147 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = TRUE;
#line 1147 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (c) {
#line 1147 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 264 "String.c"
		}
#line 1147 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 268 "String.c"
	} else {
#line 1149 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = FALSE;
#line 1149 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (c) {
#line 1149 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 276 "String.c"
		}
#line 1149 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 280 "String.c"
	}
#line 1143 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (c) {
#line 1143 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*c = _vala_c;
#line 286 "String.c"
	}
}


inline gchar*
noise_string_canonicalize_for_search (const gchar* str)
{
	gchar* result = NULL;
	gunichar* buf = NULL;
	gunichar* _tmp0_;
	gint buf_length1;
	gint _buf_size_;
	GString* res = NULL;
	GString* _tmp1_;
	gunichar c = 0U;
	GString* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
#line 68 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 69 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp0_ = g_new0 (gunichar, G_UNICHAR_MAX_DECOMPOSITION_LENGTH);
#line 69 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	buf = _tmp0_;
#line 69 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	buf_length1 = G_UNICHAR_MAX_DECOMPOSITION_LENGTH;
#line 69 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_buf_size_ = buf_length1;
#line 70 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp1_ = g_string_new ("");
#line 70 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	res = _tmp1_;
#line 319 "String.c"
	{
		gint i = 0;
#line 74 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		i = 0;
#line 324 "String.c"
		{
			gboolean _tmp2_ = FALSE;
#line 74 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
			_tmp2_ = TRUE;
#line 74 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
			while (TRUE) {
#line 331 "String.c"
				gunichar _tmp3_ = 0U;
				gboolean _tmp4_;
				gunichar sc = 0U;
				gunichar _tmp5_;
				gunichar _tmp6_;
#line 74 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				if (!_tmp2_) {
#line 339 "String.c"
				}
#line 74 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				_tmp2_ = FALSE;
#line 74 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				_tmp4_ = string_get_next_char (str, &i, &_tmp3_);
#line 74 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				c = _tmp3_;
#line 74 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				if (!_tmp4_) {
#line 74 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					break;
#line 351 "String.c"
				}
#line 75 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				_tmp5_ = c;
#line 75 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				sc = noise_string_strip_char (_tmp5_);
#line 77 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				_tmp6_ = sc;
#line 77 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				if (_tmp6_ != ((gunichar) 0)) {
#line 361 "String.c"
					gsize size = 0UL;
					gunichar _tmp7_;
					gunichar* _tmp8_;
					gint _tmp8__length1;
					gsize _tmp9_;
#line 78 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					_tmp7_ = sc;
#line 78 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					_tmp8_ = buf;
#line 78 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					_tmp8__length1 = buf_length1;
#line 78 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					size = g_unichar_fully_decompose (_tmp7_, FALSE, _tmp8_, _tmp8__length1);
#line 80 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					_tmp9_ = size;
#line 80 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					if (_tmp9_ > ((gsize) 0)) {
#line 379 "String.c"
						GString* _tmp10_;
						gunichar* _tmp11_;
						gint _tmp11__length1;
						gunichar _tmp12_;
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
						_tmp10_ = res;
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
						_tmp11_ = buf;
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
						_tmp11__length1 = buf_length1;
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
						_tmp12_ = _tmp11_[0];
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
						g_string_append_unichar (_tmp10_, _tmp12_);
#line 394 "String.c"
					}
				}
			}
		}
	}
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp13_ = res;
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp14_ = _tmp13_->str;
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	result = _tmp15_;
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_g_string_free0 (res);
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	buf = (g_free (buf), NULL);
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	return result;
#line 414 "String.c"
}


inline gunichar
noise_string_strip_char (gunichar ch)
{
	gunichar result = 0U;
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	switch (g_unichar_type (ch)) {
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		case G_UNICODE_CONTROL:
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		case G_UNICODE_FORMAT:
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		case G_UNICODE_UNASSIGNED:
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		case G_UNICODE_NON_SPACING_MARK:
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		case G_UNICODE_COMBINING_MARK:
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		case G_UNICODE_ENCLOSING_MARK:
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		case G_UNICODE_LINE_SEPARATOR:
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		case G_UNICODE_SPACE_SEPARATOR:
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		case G_UNICODE_PARAGRAPH_SEPARATOR:
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		case G_UNICODE_DASH_PUNCTUATION:
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		case G_UNICODE_OPEN_PUNCTUATION:
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		case G_UNICODE_OTHER_PUNCTUATION:
#line 448 "String.c"
		{
#line 102 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
			result = (gunichar) 0;
#line 102 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
			return result;
#line 454 "String.c"
		}
		default:
		{
#line 104 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
			result = g_unichar_tolower (ch);
#line 104 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
			return result;
#line 462 "String.c"
		}
	}
}


/**
     * Capitalizes the initial letters of a UTF-8 string (Title Case).
     *
     * The implementation is guaranteed to be efficient.
     *
     * For example:
     * "This is an input string" => "This Is An Input String"
     * "example string/text"     => "Example String/Text" 
     */
inline gchar*
noise_string_to_title_case (const gchar* text)
{
	gchar* result = NULL;
	gboolean capitalize_next = FALSE;
	GString* _result_ = NULL;
	GString* _tmp0_;
	gunichar c = 0U;
	GString* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
#line 117 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 118 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	capitalize_next = TRUE;
#line 120 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp0_ = g_string_new ("");
#line 120 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_result_ = _tmp0_;
#line 496 "String.c"
	{
		gint i = 0;
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		i = 0;
#line 501 "String.c"
		{
			gboolean _tmp1_ = FALSE;
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
			_tmp1_ = TRUE;
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
			while (TRUE) {
#line 508 "String.c"
				gunichar _tmp2_ = 0U;
				gboolean _tmp3_;
				gboolean _tmp4_;
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				if (!_tmp1_) {
#line 514 "String.c"
				}
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				_tmp1_ = FALSE;
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				_tmp3_ = string_get_next_char (text, &i, &_tmp2_);
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				c = _tmp2_;
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				if (!_tmp3_) {
#line 123 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					break;
#line 526 "String.c"
				}
#line 124 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				_tmp4_ = capitalize_next;
#line 124 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				if (_tmp4_) {
#line 532 "String.c"
					GString* _tmp5_;
					gunichar _tmp6_;
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					_tmp5_ = _result_;
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					_tmp6_ = c;
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					g_string_append_unichar (_tmp5_, g_unichar_totitle (_tmp6_));
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					capitalize_next = FALSE;
#line 543 "String.c"
				} else {
					GString* _tmp7_;
					gunichar _tmp8_;
					gboolean _tmp9_ = FALSE;
					gunichar _tmp10_;
#line 128 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					_tmp7_ = _result_;
#line 128 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					_tmp8_ = c;
#line 128 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					g_string_append_unichar (_tmp7_, g_unichar_tolower (_tmp8_));
#line 131 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					_tmp10_ = c;
#line 131 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					if (g_unichar_isspace (_tmp10_)) {
#line 131 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
						_tmp9_ = TRUE;
#line 561 "String.c"
					} else {
						gunichar _tmp11_;
#line 131 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
						_tmp11_ = c;
#line 131 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
						_tmp9_ = g_unichar_iscntrl (_tmp11_);
#line 568 "String.c"
					}
#line 131 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					capitalize_next = _tmp9_;
#line 572 "String.c"
				}
			}
		}
	}
#line 135 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp12_ = _result_;
#line 135 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp13_ = _tmp12_->str;
#line 135 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 135 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	result = _tmp14_;
#line 135 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_g_string_free0 (_result_);
#line 135 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	return result;
#line 589 "String.c"
}


/**
     * Converts a string encoded in the native operating system encoding to UTF-8.
     *
     * @param string_locale String in locale encoding.
     * @return String encoded in UTF-8, or //null// if the string could not be converted.
     */
gchar*
noise_string_locale_to_utf8 (const gchar* string_locale)
{
	gchar* result = NULL;
	GError* _error_ = NULL;
	gsize bytes_read = 0UL;
	gsize bytes_written = 0UL;
	gchar* string_utf8 = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gsize _tmp2_ = 0UL;
	gsize _tmp3_ = 0UL;
	GError* _tmp4_ = NULL;
	gchar* _tmp5_;
	GError* _tmp6_;
#line 144 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	g_return_val_if_fail (string_locale != NULL, NULL);
#line 147 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp0_ = strlen (string_locale);
#line 147 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp1_ = _tmp0_;
#line 147 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp5_ = g_locale_to_utf8 (string_locale, (gssize) _tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
#line 147 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	bytes_read = _tmp2_;
#line 147 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	bytes_written = _tmp3_;
#line 147 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_g_error_free0 (_error_);
#line 147 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_error_ = _tmp4_;
#line 147 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	string_utf8 = _tmp5_;
#line 151 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp6_ = _error_;
#line 151 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	if (_tmp6_ != NULL) {
#line 152 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_g_free0 (string_utf8);
#line 152 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		string_utf8 = NULL;
#line 640 "String.c"
	}
#line 154 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	result = string_utf8;
#line 154 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_g_error_free0 (_error_);
#line 154 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	return result;
#line 648 "String.c"
}


/**
     * Base method used for searches. It does a previous parsing on the search string.
     *
     * If the output value of parsed_rating is greater than 0, then the view should
     * only display the media with that rating in the search results, and ignore
     * the value of parsed_search_string.
     *
     * @param search Non-parsed version of the search string.
     * @param parsed_rating location where the parsed rating it stored, or -1 if the
     * string didn't represent a valid rating.
     * @param parsed_search_string location where the canonicalized version of the
     * search string is stored. Should be passed to the methods in Noise.Search.
     */
void
noise_string_base_search_method (const gchar* search,
                                 guint* parsed_rating,
                                 gchar* * parsed_search_string)
{
	guint _vala_parsed_rating = 0U;
	gchar* _vala_parsed_search_string = NULL;
	guint* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	guint* _tmp2_;
	guint* _tmp3_;
	guint* _tmp4_;
	gchar* _tmp6_;
#line 170 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	g_return_if_fail (search != NULL);
#line 173 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp0_ = string_strip (search);
#line 173 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp1_ = _tmp0_;
#line 173 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp2_ = noise_search_get_rating_from_string (_tmp1_);
#line 173 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp3_ = _tmp2_;
#line 173 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_g_free0 (_tmp1_);
#line 173 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_result_ = _tmp3_;
#line 175 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp4_ = _result_;
#line 175 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	if (_tmp4_ != NULL) {
#line 697 "String.c"
		guint _tmp5_;
#line 176 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_tmp5_ = _vala_parsed_rating;
#line 176 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_vala_parsed_rating = CLAMP (_tmp5_, (guint) 1, (guint) 5);
#line 703 "String.c"
	} else {
#line 178 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_vala_parsed_rating = (guint) 0;
#line 707 "String.c"
	}
#line 181 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp6_ = noise_search_get_valid_search_string (search);
#line 181 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_g_free0 (_vala_parsed_search_string);
#line 181 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_vala_parsed_search_string = _tmp6_;
#line 170 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_g_free0 (_result_);
#line 170 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	if (parsed_rating) {
#line 170 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		*parsed_rating = _vala_parsed_rating;
#line 721 "String.c"
	}
#line 170 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	if (parsed_search_string) {
#line 170 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		*parsed_search_string = _vala_parsed_search_string;
#line 727 "String.c"
	} else {
#line 170 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_g_free0 (_vala_parsed_search_string);
#line 731 "String.c"
	}
}


/**
     * A method for extracting integers from strings.
     *
     * The method does its best to extract a number from a string by cleaning up
     * non-numeric characters before parsing the string with uint64.parse(). The
     * purpose of this method is to provide a safe way of extracting numbers
     * from strings without making everything crash when passing a weird localized
     * string that would normally lead uint64.parse, int64.parse or int.parse
     * to a segmentation fault. This happens due to encoding incompatibilities:
     * Remember that the standard C library doesn't know how to deal with variable-
     * length UTF-8 characters!
     *
     * If no number is found in the string, zero is returned.
     *
     * Examples:
     * "a23oe ew2" => 232
     " "32 text"   => 32
     * "ins1 32"   => 132
     * "a word"    => 0
     *
     * @param str string known to contain a valid integer
     * @return Result of parsing the string.
     */
static guint64
uint64_parse (const gchar* str)
{
	guint64 result = 0ULL;
	guint64 _tmp0_;
#line 747 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 748 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_ascii_strtoull (str, NULL, (guint) 0);
#line 748 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp0_;
#line 748 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 772 "String.c"
}


inline guint64
noise_string_uint_from_string (const gchar* str)
{
	guint64 result = 0ULL;
#line 209 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	static const gushort MAX_DIGITS = (gushort) 18;
#line 782 "String.c"
	gushort ndigits = 0U;
	GString* _result_ = NULL;
	GString* _tmp0_;
	gunichar c = 0U;
	guint64 _tmp10_ = 0ULL;
	gushort _tmp11_;
#line 207 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 210 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	ndigits = (gushort) 0;
#line 212 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp0_ = g_string_new ("");
#line 212 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_result_ = _tmp0_;
#line 797 "String.c"
	{
		gint i = 0;
#line 215 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		i = 0;
#line 802 "String.c"
		{
			gboolean _tmp1_ = FALSE;
#line 215 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
			_tmp1_ = TRUE;
#line 215 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
			while (TRUE) {
#line 809 "String.c"
				gboolean _tmp2_ = FALSE;
				gunichar _tmp3_ = 0U;
				gboolean _tmp4_;
				gunichar _tmp6_;
#line 215 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				if (!_tmp1_) {
#line 816 "String.c"
				}
#line 215 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				_tmp1_ = FALSE;
#line 215 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				_tmp4_ = string_get_next_char (str, &i, &_tmp3_);
#line 215 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				c = _tmp3_;
#line 215 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				if (_tmp4_) {
#line 826 "String.c"
					gushort _tmp5_;
#line 215 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					_tmp5_ = ndigits;
#line 215 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					_tmp2_ = _tmp5_ < MAX_DIGITS;
#line 832 "String.c"
				} else {
#line 215 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					_tmp2_ = FALSE;
#line 836 "String.c"
				}
#line 215 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				if (!_tmp2_) {
#line 215 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					break;
#line 842 "String.c"
				}
#line 216 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				_tmp6_ = c;
#line 216 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
				if (g_unichar_isdigit (_tmp6_)) {
#line 848 "String.c"
					GString* _tmp7_;
					gunichar _tmp8_;
					gushort _tmp9_;
#line 217 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					_tmp7_ = _result_;
#line 217 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					_tmp8_ = c;
#line 217 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					g_string_append_unichar (_tmp7_, _tmp8_);
#line 218 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					_tmp9_ = ndigits;
#line 218 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
					ndigits = _tmp9_ + 1;
#line 862 "String.c"
				}
			}
		}
	}
#line 222 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_tmp11_ = ndigits;
#line 222 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	if (((gint) _tmp11_) == 0) {
#line 222 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_tmp10_ = (guint64) 0;
#line 873 "String.c"
	} else {
		GString* _tmp12_;
		const gchar* _tmp13_;
#line 222 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_tmp12_ = _result_;
#line 222 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_tmp13_ = _tmp12_->str;
#line 222 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
		_tmp10_ = uint64_parse (_tmp13_);
#line 883 "String.c"
	}
#line 222 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	result = _tmp10_;
#line 222 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	_g_string_free0 (_result_);
#line 222 "/builddir/build/BUILD/music-0.4.2/core/Utils/String.vala"
	return result;
#line 891 "String.c"
}



