/* TimeUtils.c generated by valac 0.40.4, the Vala compiler
 * generated from TimeUtils.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <time.h>

#define _g_free0(var) (var = (g_free (var), NULL))



#define NOISE_TIME_UTILS_NANO_INV ((guint64) 1000000000)
#define NOISE_TIME_UTILS_MILI_INV ((guint64) 1000)
#define NOISE_TIME_UTILS_SECONDS_PER_MINUTE ((guint) 60)
#define NOISE_TIME_UTILS_SECONDS_PER_HOUR (60 * NOISE_TIME_UTILS_SECONDS_PER_MINUTE)
#define NOISE_TIME_UTILS_SECONDS_PER_DAY (24 * NOISE_TIME_UTILS_SECONDS_PER_HOUR)
gchar* noise_time_utils_time_string_from_seconds (guint given_seconds);
gchar* noise_time_utils_time_string_from_miliseconds (guint64 miliseconds);
gchar* noise_time_utils_time_string_from_nanoseconds (guint64 nanoseconds);
gchar* noise_time_utils_pretty_length (guint seconds);
gchar* noise_time_utils_pretty_length_from_ms (guint64 mseconds);
gchar* noise_time_utils_pretty_length_from_ns (guint64 nseconds);
gchar* noise_time_utils_pretty_timestamp_from_time (struct tm* dt);
gchar* noise_time_utils_pretty_timestamp_from_uint (guint time);
guint noise_time_utils_nanoseconds_to_miliseconds (guint64 nanoseconds);
guint64 noise_time_utils_miliseconds_to_nanoseconds (guint miliseconds);


/**
     * Receives the number of seconds and returns a string with format:
     * "%i days, %i hours and %i minutes", "%i seconds", "%i minutes and %i seconds",
     * or similar.
     */
inline gchar*
noise_time_utils_time_string_from_seconds (guint given_seconds)
{
	gchar* result = NULL;
	guint days = 0U;
	guint hours = 0U;
	guint _tmp0_;
	guint minutes = 0U;
	guint _tmp1_;
	guint _tmp2_;
	guint seconds = 0U;
	guint _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	gchar* days_string = NULL;
	gchar* _tmp9_;
	gchar* hours_string = NULL;
	gchar* _tmp10_;
	gchar* minutes_string = NULL;
	gchar* _tmp11_;
	gchar* seconds_string = NULL;
	gchar* _tmp12_;
	guint _tmp23_;
	guint _tmp27_;
	guint _tmp31_;
	gchar* rv = NULL;
	gchar* _tmp35_;
	guint _tmp36_;
#line 43 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	days = given_seconds / 86400;
#line 44 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp0_ = days;
#line 44 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	hours = (given_seconds - (_tmp0_ * 86400)) / 3600;
#line 45 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp1_ = days;
#line 45 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp2_ = hours;
#line 45 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	minutes = ((given_seconds - (_tmp1_ * 86400)) - (_tmp2_ * 3600)) / 60;
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp3_ = days;
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp4_ = hours;
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp5_ = minutes;
#line 46 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	seconds = ((given_seconds - (_tmp3_ * 86400)) - (_tmp4_ * 3600)) - (_tmp5_ * 60);
#line 48 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	if (given_seconds < NOISE_TIME_UTILS_SECONDS_PER_MINUTE) {
#line 117 "TimeUtils.c"
		guint _tmp6_;
		guint _tmp7_;
		gchar* _tmp8_;
#line 49 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp6_ = seconds;
#line 49 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp7_ = seconds;
#line 49 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp8_ = g_strdup_printf (ngettext ("%u second", "%u seconds", (gulong) _tmp6_), _tmp7_);
#line 49 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		result = _tmp8_;
#line 49 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		return result;
#line 131 "TimeUtils.c"
	}
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp9_ = g_strdup ("");
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	days_string = _tmp9_;
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp10_ = g_strdup ("");
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	hours_string = _tmp10_;
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp11_ = g_strdup ("");
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	minutes_string = _tmp11_;
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp12_ = g_strdup ("");
#line 51 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	seconds_string = _tmp12_;
#line 54 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	if (given_seconds < NOISE_TIME_UTILS_SECONDS_PER_HOUR) {
#line 151 "TimeUtils.c"
		guint _tmp13_;
		guint _tmp14_;
		gchar* _tmp15_;
		guint _tmp16_;
#line 55 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp13_ = minutes;
#line 55 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp14_ = minutes;
#line 55 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp15_ = g_strdup_printf (ngettext ("%u minute", "%u minutes", (gulong) _tmp13_), _tmp14_);
#line 55 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_g_free0 (minutes_string);
#line 55 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		minutes_string = _tmp15_;
#line 57 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp16_ = seconds;
#line 57 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		if (_tmp16_ > ((guint) 0)) {
#line 170 "TimeUtils.c"
			guint _tmp17_;
			guint _tmp18_;
			gchar* _tmp19_;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
#line 58 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_tmp17_ = seconds;
#line 58 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_tmp18_ = seconds;
#line 58 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_tmp19_ = g_strdup_printf (ngettext ("%u second", "%u seconds", (gulong) _tmp17_), _tmp18_);
#line 58 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_g_free0 (seconds_string);
#line 58 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			seconds_string = _tmp19_;
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_tmp20_ = minutes_string;
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_tmp21_ = seconds_string;
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_tmp22_ = g_strdup_printf (C_ ("minutes and seconds", "%s and %s"), _tmp20_, _tmp21_);
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			result = _tmp22_;
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_g_free0 (seconds_string);
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_g_free0 (minutes_string);
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_g_free0 (hours_string);
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_g_free0 (days_string);
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			return result;
#line 205 "TimeUtils.c"
		}
#line 63 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		result = minutes_string;
#line 63 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_g_free0 (seconds_string);
#line 63 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_g_free0 (hours_string);
#line 63 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_g_free0 (days_string);
#line 63 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		return result;
#line 217 "TimeUtils.c"
	}
#line 66 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp23_ = days;
#line 66 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	if (_tmp23_ > ((guint) 0)) {
#line 223 "TimeUtils.c"
		guint _tmp24_;
		guint _tmp25_;
		gchar* _tmp26_;
#line 67 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp24_ = days;
#line 67 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp25_ = days;
#line 67 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp26_ = g_strdup_printf (ngettext ("%u day", "%u days", (gulong) _tmp24_), _tmp25_);
#line 67 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_g_free0 (days_string);
#line 67 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		days_string = _tmp26_;
#line 237 "TimeUtils.c"
	}
#line 69 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp27_ = hours;
#line 69 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	if (_tmp27_ > ((guint) 0)) {
#line 243 "TimeUtils.c"
		guint _tmp28_;
		guint _tmp29_;
		gchar* _tmp30_;
#line 70 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp28_ = hours;
#line 70 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp29_ = hours;
#line 70 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp30_ = g_strdup_printf (ngettext ("%u hour", "%u hours", (gulong) _tmp28_), _tmp29_);
#line 70 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_g_free0 (hours_string);
#line 70 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		hours_string = _tmp30_;
#line 257 "TimeUtils.c"
	}
#line 72 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp31_ = minutes;
#line 72 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	if (_tmp31_ > ((guint) 0)) {
#line 263 "TimeUtils.c"
		guint _tmp32_;
		guint _tmp33_;
		gchar* _tmp34_;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp32_ = minutes;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp33_ = minutes;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp34_ = g_strdup_printf (ngettext ("%u minute", "%u minutes", (gulong) _tmp32_), _tmp33_);
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_g_free0 (minutes_string);
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		minutes_string = _tmp34_;
#line 277 "TimeUtils.c"
	}
#line 75 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp35_ = g_strdup ("");
#line 75 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	rv = _tmp35_;
#line 77 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp36_ = days;
#line 77 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	if (_tmp36_ > ((guint) 0)) {
#line 287 "TimeUtils.c"
		guint _tmp37_;
#line 78 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp37_ = hours;
#line 78 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		if (_tmp37_ > ((guint) 0)) {
#line 293 "TimeUtils.c"
			guint _tmp38_;
#line 79 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_tmp38_ = minutes;
#line 79 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			if (_tmp38_ > ((guint) 0)) {
#line 299 "TimeUtils.c"
				const gchar* _tmp39_;
				const gchar* _tmp40_;
				const gchar* _tmp41_;
				gchar* _tmp42_;
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_tmp39_ = days_string;
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_tmp40_ = hours_string;
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_tmp41_ = minutes_string;
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_tmp42_ = g_strdup_printf (C_ ("days, hours and minutes", "%s, %s and %s"), _tmp39_, _tmp40_, _tmp41_);
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_g_free0 (rv);
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				rv = _tmp42_;
#line 316 "TimeUtils.c"
			} else {
				const gchar* _tmp43_;
				const gchar* _tmp44_;
				gchar* _tmp45_;
#line 84 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_tmp43_ = days_string;
#line 84 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_tmp44_ = hours_string;
#line 84 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_tmp45_ = g_strdup_printf (C_ ("days and hours", "%s and %s"), _tmp43_, _tmp44_);
#line 84 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_g_free0 (rv);
#line 84 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				rv = _tmp45_;
#line 331 "TimeUtils.c"
			}
		} else {
			guint _tmp46_;
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_tmp46_ = minutes;
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			if (_tmp46_ > ((guint) 0)) {
#line 339 "TimeUtils.c"
				const gchar* _tmp47_;
				const gchar* _tmp48_;
				gchar* _tmp49_;
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_tmp47_ = days_string;
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_tmp48_ = minutes_string;
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_tmp49_ = g_strdup_printf (C_ ("days and minutes", "%s and %s"), _tmp47_, _tmp48_);
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_g_free0 (rv);
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				rv = _tmp49_;
#line 353 "TimeUtils.c"
			} else {
				const gchar* _tmp50_;
				gchar* _tmp51_;
#line 91 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_tmp50_ = days_string;
#line 91 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_tmp51_ = g_strdup (_tmp50_);
#line 91 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_g_free0 (rv);
#line 91 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				rv = _tmp51_;
#line 365 "TimeUtils.c"
			}
		}
	} else {
		guint _tmp52_;
#line 95 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp52_ = hours;
#line 95 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		if (_tmp52_ > ((guint) 0)) {
#line 374 "TimeUtils.c"
			guint _tmp53_;
#line 96 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_tmp53_ = minutes;
#line 96 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			if (_tmp53_ > ((guint) 0)) {
#line 380 "TimeUtils.c"
				const gchar* _tmp54_;
				const gchar* _tmp55_;
				gchar* _tmp56_;
#line 98 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_tmp54_ = hours_string;
#line 98 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_tmp55_ = minutes_string;
#line 98 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_tmp56_ = g_strdup_printf (C_ ("hours and minutes", "%s and %s"), _tmp54_, _tmp55_);
#line 98 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_g_free0 (rv);
#line 98 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				rv = _tmp56_;
#line 394 "TimeUtils.c"
			} else {
				const gchar* _tmp57_;
				gchar* _tmp58_;
#line 100 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_tmp57_ = hours_string;
#line 100 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_tmp58_ = g_strdup (_tmp57_);
#line 100 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				_g_free0 (rv);
#line 100 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
				rv = _tmp58_;
#line 406 "TimeUtils.c"
			}
		} else {
			const gchar* _tmp59_;
			gchar* _tmp60_;
			const gchar* _tmp61_;
#line 104 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_tmp59_ = minutes_string;
#line 104 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_tmp60_ = g_strdup (_tmp59_);
#line 104 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_g_free0 (rv);
#line 104 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			rv = _tmp60_;
#line 105 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			_tmp61_ = rv;
#line 105 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
			g_warning ("TimeUtils.vala:105: Minutes string '%s'. Should not be reached", _tmp61_);
#line 424 "TimeUtils.c"
		}
	}
#line 109 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	result = rv;
#line 109 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_g_free0 (seconds_string);
#line 109 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_g_free0 (minutes_string);
#line 109 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_g_free0 (hours_string);
#line 109 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_g_free0 (days_string);
#line 109 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	return result;
#line 439 "TimeUtils.c"
}


inline gchar*
noise_time_utils_time_string_from_miliseconds (guint64 miliseconds)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 113 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp0_ = noise_time_utils_time_string_from_seconds ((guint) (miliseconds / NOISE_TIME_UTILS_MILI_INV));
#line 113 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	result = _tmp0_;
#line 113 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	return result;
#line 454 "TimeUtils.c"
}


inline gchar*
noise_time_utils_time_string_from_nanoseconds (guint64 nanoseconds)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 117 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp0_ = noise_time_utils_time_string_from_seconds ((guint) (nanoseconds / NOISE_TIME_UTILS_NANO_INV));
#line 117 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	result = _tmp0_;
#line 117 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	return result;
#line 469 "TimeUtils.c"
}


/**
     * Receives the number of seconds and returns a string with format MM:SS
     */
inline gchar*
noise_time_utils_pretty_length (guint seconds)
{
	gchar* result = NULL;
	guint hours = 0U;
	guint _tmp3_;
	guint minutes = 0U;
	guint _tmp4_;
	guint _tmp5_;
	guint _tmp6_;
	gchar* _tmp7_;
#line 124 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	if (seconds < NOISE_TIME_UTILS_SECONDS_PER_HOUR) {
#line 489 "TimeUtils.c"
		guint minutes = 0U;
		guint _tmp0_;
		guint _tmp1_;
		gchar* _tmp2_;
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		minutes = seconds / 60;
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp0_ = minutes;
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		seconds = seconds - (_tmp0_ * 60);
#line 127 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp1_ = minutes;
#line 127 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		_tmp2_ = g_strdup_printf ("%u:%02u", _tmp1_, seconds);
#line 127 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		result = _tmp2_;
#line 127 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
		return result;
#line 508 "TimeUtils.c"
	}
#line 130 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	hours = seconds / 3600;
#line 131 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp3_ = hours;
#line 131 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	seconds = seconds - (_tmp3_ * 3600);
#line 132 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	minutes = seconds / 60;
#line 133 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp4_ = minutes;
#line 133 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	seconds = seconds - (_tmp4_ * 60);
#line 134 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp5_ = hours;
#line 134 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp6_ = minutes;
#line 134 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp7_ = g_strdup_printf ("%u:%02u:%02u", _tmp5_, _tmp6_, seconds);
#line 134 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	result = _tmp7_;
#line 134 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	return result;
#line 532 "TimeUtils.c"
}


/**
     * Receives the number of miliseconds and returns a string with format MM:SS
     */
inline gchar*
noise_time_utils_pretty_length_from_ms (guint64 mseconds)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 141 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp0_ = noise_time_utils_pretty_length ((guint) (mseconds / NOISE_TIME_UTILS_MILI_INV));
#line 141 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	result = _tmp0_;
#line 141 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	return result;
#line 550 "TimeUtils.c"
}


/**
     * Receives the number of nanoseconds and returns a string with format MM:SS
     */
inline gchar*
noise_time_utils_pretty_length_from_ns (guint64 nseconds)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 148 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp0_ = noise_time_utils_pretty_length ((guint) (nseconds / NOISE_TIME_UTILS_NANO_INV));
#line 148 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	result = _tmp0_;
#line 148 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	return result;
#line 568 "TimeUtils.c"
}


/**
     * Returns a formatted date and time string.
     */
static gchar*
g_time_format (struct tm *self,
               const gchar* format)
{
	gchar* result = NULL;
	gchar* buffer = NULL;
	gchar* _tmp0_;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	gchar* _tmp2_;
	gint _tmp2__length1;
	gchar* _tmp3_;
#line 2874 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (format != NULL, NULL);
#line 2875 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 64);
#line 2875 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	buffer = _tmp0_;
#line 2875 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	buffer_length1 = 64;
#line 2875 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_buffer_size_ = buffer_length1;
#line 2876 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = buffer;
#line 2876 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1__length1 = buffer_length1;
#line 2876 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	strftime (_tmp1_, _tmp1__length1, format, &(*self));
#line 2877 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp2_ = buffer;
#line 2877 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp2__length1 = buffer_length1;
#line 2877 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp3_ = g_strdup ((const gchar*) _tmp2_);
#line 2877 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp3_;
#line 2877 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	buffer = (g_free (buffer), NULL);
#line 2877 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 617 "TimeUtils.c"
}


inline gchar*
noise_time_utils_pretty_timestamp_from_time (struct tm* dt)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 154 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	g_return_val_if_fail (dt != NULL, NULL);
#line 157 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp0_ = g_time_format (dt, _ ("%m/%e/%Y %l:%M %p"));
#line 157 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	result = _tmp0_;
#line 157 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	return result;
#line 634 "TimeUtils.c"
}


static void
g_time_local (time_t time,
              struct tm* result)
{
	struct tm _result_ = {0};
	struct tm _tmp0_ = {0};
#line 2866 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	localtime_r (&time, &_tmp0_);
#line 2866 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 2867 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	*result = _result_;
#line 2867 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return;
#line 652 "TimeUtils.c"
}


inline gchar*
noise_time_utils_pretty_timestamp_from_uint (guint time)
{
	gchar* result = NULL;
	struct tm dt = {0};
	struct tm _tmp0_ = {0};
	struct tm _tmp1_;
	gchar* _tmp2_;
#line 161 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	g_time_local ((time_t) time, &_tmp0_);
#line 161 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	dt = _tmp0_;
#line 162 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp1_ = dt;
#line 162 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	_tmp2_ = noise_time_utils_pretty_timestamp_from_time (&_tmp1_);
#line 162 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	result = _tmp2_;
#line 162 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	return result;
#line 676 "TimeUtils.c"
}


/**
     * Convert from nanoseconds (10E-9) to miliseconds (10E-3);
     *
     * This is used extensively because {@link Noise.Media} stores
     * miliseconds, while GStreamer uses nanoseconds.
     *
     * The method does its best to avoid losing precision.
     */
inline guint
noise_time_utils_nanoseconds_to_miliseconds (guint64 nanoseconds)
{
	guint result = 0U;
#line 174 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	result = (guint) ((nanoseconds * NOISE_TIME_UTILS_MILI_INV) / NOISE_TIME_UTILS_NANO_INV);
#line 174 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	return result;
#line 696 "TimeUtils.c"
}


inline guint64
noise_time_utils_miliseconds_to_nanoseconds (guint miliseconds)
{
	guint64 result = 0ULL;
#line 178 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	result = (((guint64) miliseconds) * NOISE_TIME_UTILS_NANO_INV) / NOISE_TIME_UTILS_MILI_INV;
#line 178 "/builddir/build/BUILD/music-0.4.2/core/Utils/TimeUtils.vala"
	return result;
#line 708 "TimeUtils.c"
}



