/* AlbumImage.c generated by valac 0.40.4, the Vala compiler
 * generated from AlbumImage.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define NOISE_WIDGETS_TYPE_ALBUM_IMAGE (noise_widgets_album_image_get_type ())
#define NOISE_WIDGETS_ALBUM_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_WIDGETS_TYPE_ALBUM_IMAGE, NoiseWidgetsAlbumImage))
#define NOISE_WIDGETS_ALBUM_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_WIDGETS_TYPE_ALBUM_IMAGE, NoiseWidgetsAlbumImageClass))
#define NOISE_WIDGETS_IS_ALBUM_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_WIDGETS_TYPE_ALBUM_IMAGE))
#define NOISE_WIDGETS_IS_ALBUM_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_WIDGETS_TYPE_ALBUM_IMAGE))
#define NOISE_WIDGETS_ALBUM_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_WIDGETS_TYPE_ALBUM_IMAGE, NoiseWidgetsAlbumImageClass))

typedef struct _NoiseWidgetsAlbumImage NoiseWidgetsAlbumImage;
typedef struct _NoiseWidgetsAlbumImageClass NoiseWidgetsAlbumImageClass;
typedef struct _NoiseWidgetsAlbumImagePrivate NoiseWidgetsAlbumImagePrivate;
enum  {
	NOISE_WIDGETS_ALBUM_IMAGE_0_PROPERTY,
	NOISE_WIDGETS_ALBUM_IMAGE_NUM_PROPERTIES
};
static GParamSpec* noise_widgets_album_image_properties[NOISE_WIDGETS_ALBUM_IMAGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gtk_icon_info_free0(var) ((var == NULL) ? NULL : (var = (gtk_icon_info_free (var), NULL)))

struct _NoiseWidgetsAlbumImage {
	GtkImage parent_instance;
	NoiseWidgetsAlbumImagePrivate * priv;
};

struct _NoiseWidgetsAlbumImageClass {
	GtkImageClass parent_class;
};

struct _NoiseWidgetsAlbumImagePrivate {
	GdkPixbuf* internal_pixbuf;
	gint scale;
};


static gpointer noise_widgets_album_image_parent_class = NULL;

GType noise_widgets_album_image_get_type (void) G_GNUC_CONST;
#define NOISE_WIDGETS_ALBUM_IMAGE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_WIDGETS_TYPE_ALBUM_IMAGE, NoiseWidgetsAlbumImagePrivate))
#define NOISE_WIDGETS_ALBUM_IMAGE_STYLESHEET "\n" \
"        .album {\n" \
"            background-clip: padding-box;\n" \
"            border: 3px solid transparent;\n" \
"            box-shadow: 0 1px 3px alpha (#000, 0.12),\n" \
"                        0 1px 2px alpha (#000, 0.24);\n" \
"            margin: 12px;\n" \
"            transition: all 600ms ease-in-out;\n" \
"        }\n" \
"\n" \
"        .album:focused {\n" \
"            border-color: @colorAccent;\n" \
"            border-radius: 3px;\n" \
"        }\n" \
"\n" \
"        .album:hover {\n" \
"            box-shadow: 0 3px 6px alpha (#000, 0.16),\n" \
"                        0 3px 6px alpha (#000, 0.23);\n" \
"        }\n" \
"    "
static gboolean noise_widgets_album_image_real_draw (GtkWidget* base,
                                              cairo_t* cr);
static void noise_widgets_album_image_render_pixbuf (NoiseWidgetsAlbumImage* self);
static void noise_widgets_album_image_real_get_preferred_width (GtkWidget* base,
                                                         gint* minimum_width,
                                                         gint* natural_width);
static void noise_widgets_album_image_real_get_preferred_height (GtkWidget* base,
                                                          gint* minimum_height,
                                                          gint* natural_height);
void noise_widgets_album_image_apply_album_style (GtkWidget* widget);
NoiseWidgetsAlbumImage* noise_widgets_album_image_new (void);
NoiseWidgetsAlbumImage* noise_widgets_album_image_construct (GType object_type);
static GObject * noise_widgets_album_image_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static void noise_widgets_album_image_finalize (GObject * obj);


static gboolean
noise_widgets_album_image_real_draw (GtkWidget* base,
                                     cairo_t* cr)
{
	NoiseWidgetsAlbumImage * self;
	gboolean result = FALSE;
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp0_;
	GtkStateFlags state = 0;
	GtkBorder border = {0};
	GtkBorder _tmp1_ = {0};
	gint width = 0;
	gint height = 0;
	gint x = 0;
	GdkPixbuf* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint y = 0;
	GdkPixbuf* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GdkPixbuf* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GdkPixbuf* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	GdkPixbuf* _tmp14_;
	GtkBorder _tmp15_;
	gint16 _tmp16_;
	GtkBorder _tmp17_;
	gint16 _tmp18_;
	GdkPixbuf* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	GtkBorder _tmp22_;
	gint16 _tmp23_;
	GtkBorder _tmp24_;
	gint16 _tmp25_;
	GdkPixbuf* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	GtkBorder _tmp29_;
	gint16 _tmp30_;
	GtkBorder _tmp31_;
	gint16 _tmp32_;
#line 61 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	self = (NoiseWidgetsAlbumImage*) base;
#line 61 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 62 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 62 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	ctx = _tmp0_;
#line 63 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	state = gtk_style_context_get_state (ctx);
#line 64 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	gtk_style_context_get_border (ctx, state, &_tmp1_);
#line 64 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	border = _tmp1_;
#line 65 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 66 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 67 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp2_ = self->priv->internal_pixbuf;
#line 67 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp3_ = gdk_pixbuf_get_width (_tmp2_);
#line 67 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp4_ = _tmp3_;
#line 67 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	x = (width - _tmp4_) / 2;
#line 68 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp5_ = self->priv->internal_pixbuf;
#line 68 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp6_ = gdk_pixbuf_get_height (_tmp5_);
#line 68 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp7_ = _tmp6_;
#line 68 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	y = (height - _tmp7_) / 2;
#line 69 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp8_ = self->priv->internal_pixbuf;
#line 69 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp9_ = gdk_pixbuf_get_width (_tmp8_);
#line 69 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp10_ = _tmp9_;
#line 69 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp11_ = self->priv->internal_pixbuf;
#line 69 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp12_ = gdk_pixbuf_get_height (_tmp11_);
#line 69 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp13_ = _tmp12_;
#line 69 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	gtk_render_background (ctx, cr, (gdouble) x, (gdouble) y, (gdouble) _tmp10_, (gdouble) _tmp13_);
#line 70 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	noise_widgets_album_image_render_pixbuf (self);
#line 71 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp14_ = self->priv->internal_pixbuf;
#line 71 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	gtk_render_icon (ctx, cr, _tmp14_, (gdouble) x, (gdouble) y);
#line 72 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	cairo_fill_preserve (cr);
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp15_ = border;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp16_ = _tmp15_.left;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp17_ = border;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp18_ = _tmp17_.top;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp19_ = self->priv->internal_pixbuf;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp20_ = gdk_pixbuf_get_width (_tmp19_);
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp21_ = _tmp20_;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp22_ = border;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp23_ = _tmp22_.left;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp24_ = border;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp25_ = _tmp24_.right;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp26_ = self->priv->internal_pixbuf;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp27_ = gdk_pixbuf_get_height (_tmp26_);
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp28_ = _tmp27_;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp29_ = border;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp30_ = _tmp29_.top;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp31_ = border;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp32_ = _tmp31_.bottom;
#line 73 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	gtk_render_frame (ctx, cr, (gdouble) (x - _tmp16_), (gdouble) (y - _tmp18_), (gdouble) ((_tmp21_ + _tmp23_) + _tmp25_), (gdouble) ((_tmp28_ + _tmp30_) + _tmp32_));
#line 74 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	result = FALSE;
#line 74 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	return result;
#line 246 "AlbumImage.c"
}


static void
noise_widgets_album_image_real_get_preferred_width (GtkWidget* base,
                                                    gint* minimum_width,
                                                    gint* natural_width)
{
	NoiseWidgetsAlbumImage * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp0_;
	GtkStateFlags state = 0;
	GtkBorder margin = {0};
	GtkBorder _tmp1_ = {0};
	GtkBorder border = {0};
	GtkBorder _tmp2_ = {0};
	GtkBorder padding = {0};
	GtkBorder _tmp3_ = {0};
	GdkPixbuf* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GtkBorder _tmp8_;
	gint16 _tmp9_;
	GtkBorder _tmp10_;
	gint16 _tmp11_;
	gint _tmp12_;
	GtkBorder _tmp13_;
	gint16 _tmp14_;
	GtkBorder _tmp15_;
	gint16 _tmp16_;
	gint _tmp17_;
	GtkBorder _tmp18_;
	gint16 _tmp19_;
	GtkBorder _tmp20_;
	gint16 _tmp21_;
	GdkPixbuf* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	GtkBorder _tmp26_;
	gint16 _tmp27_;
	GtkBorder _tmp28_;
	gint16 _tmp29_;
	gint _tmp30_;
	GtkBorder _tmp31_;
	gint16 _tmp32_;
	GtkBorder _tmp33_;
	gint16 _tmp34_;
	gint _tmp35_;
	GtkBorder _tmp36_;
	gint16 _tmp37_;
	GtkBorder _tmp38_;
	gint16 _tmp39_;
#line 77 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	self = (NoiseWidgetsAlbumImage*) base;
#line 78 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 78 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	ctx = _tmp0_;
#line 79 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	state = gtk_style_context_get_state (ctx);
#line 80 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	gtk_style_context_get_margin (ctx, state, &_tmp1_);
#line 80 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	margin = _tmp1_;
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	gtk_style_context_get_border (ctx, state, &_tmp2_);
#line 81 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	border = _tmp2_;
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	gtk_style_context_get_padding (ctx, state, &_tmp3_);
#line 82 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	padding = _tmp3_;
#line 83 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	noise_widgets_album_image_render_pixbuf (self);
#line 84 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp4_ = self->priv->internal_pixbuf;
#line 84 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp5_ = gdk_pixbuf_get_width (_tmp4_);
#line 84 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp6_ = _tmp5_;
#line 84 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_vala_minimum_width = _tmp6_;
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp7_ = _vala_minimum_width;
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp8_ = margin;
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp9_ = _tmp8_.left;
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp10_ = margin;
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp11_ = _tmp10_.right;
#line 85 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_vala_minimum_width = _tmp7_ + (_tmp9_ + _tmp11_);
#line 86 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp12_ = _vala_minimum_width;
#line 86 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp13_ = border;
#line 86 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp14_ = _tmp13_.left;
#line 86 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp15_ = border;
#line 86 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp16_ = _tmp15_.right;
#line 86 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_vala_minimum_width = _tmp12_ + (_tmp14_ + _tmp16_);
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp17_ = _vala_minimum_width;
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp18_ = padding;
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp19_ = _tmp18_.left;
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp20_ = padding;
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp21_ = _tmp20_.right;
#line 87 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_vala_minimum_width = _tmp17_ + (_tmp19_ + _tmp21_);
#line 88 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp22_ = self->priv->internal_pixbuf;
#line 88 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp23_ = gdk_pixbuf_get_width (_tmp22_);
#line 88 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp24_ = _tmp23_;
#line 88 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_vala_natural_width = _tmp24_;
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp25_ = _vala_natural_width;
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp26_ = margin;
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp27_ = _tmp26_.left;
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp28_ = margin;
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp29_ = _tmp28_.right;
#line 89 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_vala_natural_width = _tmp25_ + (_tmp27_ + _tmp29_);
#line 90 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp30_ = _vala_natural_width;
#line 90 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp31_ = border;
#line 90 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp32_ = _tmp31_.left;
#line 90 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp33_ = border;
#line 90 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp34_ = _tmp33_.right;
#line 90 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_vala_natural_width = _tmp30_ + (_tmp32_ + _tmp34_);
#line 91 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp35_ = _vala_natural_width;
#line 91 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp36_ = padding;
#line 91 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp37_ = _tmp36_.left;
#line 91 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp38_ = padding;
#line 91 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp39_ = _tmp38_.right;
#line 91 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_vala_natural_width = _tmp35_ + (_tmp37_ + _tmp39_);
#line 77 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	if (minimum_width) {
#line 77 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		*minimum_width = _vala_minimum_width;
#line 417 "AlbumImage.c"
	}
#line 77 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	if (natural_width) {
#line 77 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		*natural_width = _vala_natural_width;
#line 423 "AlbumImage.c"
	}
}


static void
noise_widgets_album_image_real_get_preferred_height (GtkWidget* base,
                                                     gint* minimum_height,
                                                     gint* natural_height)
{
	NoiseWidgetsAlbumImage * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp0_;
	GtkStateFlags state = 0;
	GtkBorder margin = {0};
	GtkBorder _tmp1_ = {0};
	GtkBorder border = {0};
	GtkBorder _tmp2_ = {0};
	GtkBorder padding = {0};
	GtkBorder _tmp3_ = {0};
	GdkPixbuf* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GtkBorder _tmp8_;
	gint16 _tmp9_;
	GtkBorder _tmp10_;
	gint16 _tmp11_;
	gint _tmp12_;
	GtkBorder _tmp13_;
	gint16 _tmp14_;
	GtkBorder _tmp15_;
	gint16 _tmp16_;
	gint _tmp17_;
	GtkBorder _tmp18_;
	gint16 _tmp19_;
	GtkBorder _tmp20_;
	gint16 _tmp21_;
	gint _tmp22_;
#line 94 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	self = (NoiseWidgetsAlbumImage*) base;
#line 95 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 95 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	ctx = _tmp0_;
#line 96 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	state = gtk_style_context_get_state (ctx);
#line 97 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	gtk_style_context_get_margin (ctx, state, &_tmp1_);
#line 97 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	margin = _tmp1_;
#line 98 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	gtk_style_context_get_border (ctx, state, &_tmp2_);
#line 98 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	border = _tmp2_;
#line 99 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	gtk_style_context_get_padding (ctx, state, &_tmp3_);
#line 99 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	padding = _tmp3_;
#line 100 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	noise_widgets_album_image_render_pixbuf (self);
#line 101 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp4_ = self->priv->internal_pixbuf;
#line 101 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp5_ = gdk_pixbuf_get_height (_tmp4_);
#line 101 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp6_ = _tmp5_;
#line 101 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_vala_minimum_height = _tmp6_;
#line 102 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp7_ = _vala_minimum_height;
#line 102 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp8_ = margin;
#line 102 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp9_ = _tmp8_.top;
#line 102 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp10_ = margin;
#line 102 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp11_ = _tmp10_.bottom;
#line 102 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_vala_minimum_height = _tmp7_ + (_tmp9_ + _tmp11_);
#line 103 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp12_ = _vala_minimum_height;
#line 103 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp13_ = border;
#line 103 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp14_ = _tmp13_.top;
#line 103 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp15_ = border;
#line 103 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp16_ = _tmp15_.bottom;
#line 103 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_vala_minimum_height = _tmp12_ + (_tmp14_ + _tmp16_);
#line 104 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp17_ = _vala_minimum_height;
#line 104 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp18_ = padding;
#line 104 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp19_ = _tmp18_.top;
#line 104 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp20_ = padding;
#line 104 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp21_ = _tmp20_.bottom;
#line 104 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_vala_minimum_height = _tmp17_ + (_tmp19_ + _tmp21_);
#line 105 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp22_ = _vala_minimum_height;
#line 105 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_vala_natural_height = _tmp22_;
#line 94 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	if (minimum_height) {
#line 94 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		*minimum_height = _vala_minimum_height;
#line 538 "AlbumImage.c"
	}
#line 94 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	if (natural_height) {
#line 94 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		*natural_height = _vala_natural_height;
#line 544 "AlbumImage.c"
	}
}


static guint8*
string_get_data (const gchar* self,
                 int* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
#line 1442 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1443 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	res = (guint8*) self;
#line 1443 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	res_length1 = -1;
#line 1443 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1444 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1444 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1444 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1444 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp2_ = res_length1;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp3_ = res;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp3__length1 = res_length1;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp4__length1 = _tmp3__length1;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (result_length1) {
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 592 "AlbumImage.c"
	}
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 598 "AlbumImage.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 112 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	return self ? g_object_ref (self) : NULL;
#line 607 "AlbumImage.c"
}


void
noise_widgets_album_image_apply_album_style (GtkWidget* widget)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GError * _inner_error_ = NULL;
#line 108 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	g_return_if_fail (widget != NULL);
#line 109 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 109 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	provider = _tmp0_;
#line 623 "AlbumImage.c"
	{
		guint8* _tmp1_;
		gint _tmp1__length1;
		guint8* _tmp2_;
		gint _tmp2__length1;
		GtkStyleContext* context = NULL;
		GtkStyleContext* _tmp3_;
		GtkStyleContext* _tmp4_;
		GtkStyleContext* _tmp5_;
#line 111 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp1_ = string_get_data (NOISE_WIDGETS_ALBUM_IMAGE_STYLESHEET, &_tmp1__length1);
#line 111 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp2_ = _tmp1_;
#line 111 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp2__length1 = _tmp1__length1;
#line 111 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		gtk_css_provider_load_from_data (provider, _tmp2_, (gssize) _tmp2__length1, &_inner_error_);
#line 111 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 643 "AlbumImage.c"
			goto __catch22_g_error;
		}
#line 112 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp3_ = gtk_widget_get_style_context (widget);
#line 112 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 112 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		context = _tmp4_;
#line 113 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp5_ = context;
#line 113 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		gtk_style_context_add_provider (_tmp5_, (GtkStyleProvider*) provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 110 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_g_object_unref0 (context);
#line 658 "AlbumImage.c"
	}
	goto __finally22;
	__catch22_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 110 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		e = _inner_error_;
#line 110 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_inner_error_ = NULL;
#line 115 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp6_ = e;
#line 115 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp7_ = _tmp6_->message;
#line 115 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		g_critical ("AlbumImage.vala:115: %s", _tmp7_);
#line 110 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_g_error_free0 (e);
#line 678 "AlbumImage.c"
	}
	__finally22:
#line 110 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 110 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_g_object_unref0 (provider);
#line 110 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 110 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		g_clear_error (&_inner_error_);
#line 110 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		return;
#line 691 "AlbumImage.c"
	}
#line 108 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_g_object_unref0 (provider);
#line 695 "AlbumImage.c"
}


static void
noise_widgets_album_image_render_pixbuf (NoiseWidgetsAlbumImage* self)
{
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	GdkPixbuf* _tmp5_;
	gboolean _tmp6_;
	GtkStyleContext* _tmp9_;
	GtkIconInfo* icon_info = NULL;
	GtkIconTheme* _tmp10_;
	GIcon* _tmp11_;
	GIcon* _tmp12_;
	GIcon* _tmp13_;
	gint _tmp14_;
	GtkIconInfo* _tmp15_;
	GtkIconInfo* _tmp16_;
	GError * _inner_error_ = NULL;
#line 119 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	g_return_if_fail (self != NULL);
#line 120 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 120 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 120 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	ctx = _tmp1_;
#line 121 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	g_object_get ((GtkImage*) self, "pixbuf", &_tmp3_, NULL);
#line 121 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp4_ = _tmp3_;
#line 121 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp5_ = _tmp4_;
#line 121 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp6_ = _tmp5_ != NULL;
#line 121 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_g_object_unref0 (_tmp5_);
#line 121 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	if (_tmp6_) {
#line 740 "AlbumImage.c"
		gint _tmp7_;
		GtkStyleContext* _tmp8_;
#line 121 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp7_ = self->priv->scale;
#line 121 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp8_ = ctx;
#line 121 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp2_ = _tmp7_ == gtk_style_context_get_scale (_tmp8_);
#line 749 "AlbumImage.c"
	} else {
#line 121 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp2_ = FALSE;
#line 753 "AlbumImage.c"
	}
#line 121 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	if (_tmp2_) {
#line 122 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_g_object_unref0 (ctx);
#line 122 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		return;
#line 761 "AlbumImage.c"
	}
#line 124 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp9_ = ctx;
#line 124 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	self->priv->scale = gtk_style_context_get_scale (_tmp9_);
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp10_ = gtk_icon_theme_get_default ();
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	g_object_get ((GtkImage*) self, "gicon", &_tmp11_, NULL);
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp12_ = _tmp11_;
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp13_ = _tmp12_;
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp14_ = self->priv->scale;
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp15_ = gtk_icon_theme_lookup_by_gicon_for_scale (_tmp10_, _tmp13_, 128, _tmp14_, GTK_ICON_LOOKUP_GENERIC_FALLBACK);
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp16_ = _tmp15_;
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_g_object_unref0 (_tmp13_);
#line 125 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	icon_info = _tmp16_;
#line 785 "AlbumImage.c"
	{
		GdkPixbuf* _tmp17_ = NULL;
		GtkIconInfo* _tmp18_;
		GdkPixbuf* _tmp19_;
		GdkPixbuf* _tmp20_;
#line 127 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp18_ = icon_info;
#line 127 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp19_ = gtk_icon_info_load_icon (_tmp18_, &_inner_error_);
#line 127 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp17_ = _tmp19_;
#line 127 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 799 "AlbumImage.c"
			goto __catch23_g_error;
		}
#line 127 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp20_ = _tmp17_;
#line 127 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp17_ = NULL;
#line 127 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_g_object_unref0 (self->priv->internal_pixbuf);
#line 127 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		self->priv->internal_pixbuf = _tmp20_;
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_g_object_unref0 (_tmp17_);
#line 812 "AlbumImage.c"
	}
	goto __finally23;
	__catch23_g_error:
	{
		GError* e = NULL;
		GError* _tmp21_;
		const gchar* _tmp22_;
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		e = _inner_error_;
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_inner_error_ = NULL;
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp21_ = e;
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_tmp22_ = _tmp21_->message;
#line 129 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		g_critical ("AlbumImage.vala:129: %s", _tmp22_);
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_g_error_free0 (e);
#line 832 "AlbumImage.c"
	}
	__finally23:
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_gtk_icon_info_free0 (icon_info);
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		_g_object_unref0 (ctx);
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		g_clear_error (&_inner_error_);
#line 126 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
		return;
#line 847 "AlbumImage.c"
	}
#line 119 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_gtk_icon_info_free0 (icon_info);
#line 119 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_g_object_unref0 (ctx);
#line 853 "AlbumImage.c"
}


NoiseWidgetsAlbumImage*
noise_widgets_album_image_construct (GType object_type)
{
	NoiseWidgetsAlbumImage * self = NULL;
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	self = (NoiseWidgetsAlbumImage*) g_object_new (object_type, NULL);
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	return self;
#line 865 "AlbumImage.c"
}


NoiseWidgetsAlbumImage*
noise_widgets_album_image_new (void)
{
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	return noise_widgets_album_image_construct (NOISE_WIDGETS_TYPE_ALBUM_IMAGE);
#line 874 "AlbumImage.c"
}


static GObject *
noise_widgets_album_image_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseWidgetsAlbumImage * self;
	GtkStyleContext* _tmp0_;
#line 55 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	parent_class = G_OBJECT_CLASS (noise_widgets_album_image_parent_class);
#line 55 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 55 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_WIDGETS_TYPE_ALBUM_IMAGE, NoiseWidgetsAlbumImage);
#line 56 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 56 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	gtk_style_context_add_class (_tmp0_, "album");
#line 57 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	gtk_image_set_pixel_size ((GtkImage*) self, 128);
#line 58 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	noise_widgets_album_image_apply_album_style ((GtkWidget*) self);
#line 55 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	return obj;
#line 903 "AlbumImage.c"
}


static void
noise_widgets_album_image_class_init (NoiseWidgetsAlbumImageClass * klass)
{
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	noise_widgets_album_image_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	g_type_class_add_private (klass, sizeof (NoiseWidgetsAlbumImagePrivate));
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget *, cairo_t*)) noise_widgets_album_image_real_draw;
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget *, gint*, gint*)) noise_widgets_album_image_real_get_preferred_width;
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget *, gint*, gint*)) noise_widgets_album_image_real_get_preferred_height;
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_widgets_album_image_constructor;
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_widgets_album_image_finalize;
#line 924 "AlbumImage.c"
}


static void
noise_widgets_album_image_instance_init (NoiseWidgetsAlbumImage * self)
{
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	self->priv = NOISE_WIDGETS_ALBUM_IMAGE_GET_PRIVATE (self);
#line 53 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	self->priv->scale = 1;
#line 935 "AlbumImage.c"
}


static void
noise_widgets_album_image_finalize (GObject * obj)
{
	NoiseWidgetsAlbumImage * self;
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_WIDGETS_TYPE_ALBUM_IMAGE, NoiseWidgetsAlbumImage);
#line 52 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	_g_object_unref0 (self->priv->internal_pixbuf);
#line 29 "/builddir/build/BUILD/music-0.4.2/core/Widgets/AlbumImage.vala"
	G_OBJECT_CLASS (noise_widgets_album_image_parent_class)->finalize (obj);
#line 949 "AlbumImage.c"
}


GType
noise_widgets_album_image_get_type (void)
{
	static volatile gsize noise_widgets_album_image_type_id__volatile = 0;
	if (g_once_init_enter (&noise_widgets_album_image_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseWidgetsAlbumImageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_widgets_album_image_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseWidgetsAlbumImage), 0, (GInstanceInitFunc) noise_widgets_album_image_instance_init, NULL };
		GType noise_widgets_album_image_type_id;
		noise_widgets_album_image_type_id = g_type_register_static (gtk_image_get_type (), "NoiseWidgetsAlbumImage", &g_define_type_info, 0);
		g_once_init_leave (&noise_widgets_album_image_type_id__volatile, noise_widgets_album_image_type_id);
	}
	return noise_widgets_album_image_type_id__volatile;
}



