/* CDRomDeviceManager.c generated by valac 0.40.4, the Vala compiler
 * generated from CDRomDeviceManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include <noise-core.h>
#include <stdlib.h>
#include <string.h>


#define NOISE_PLUGINS_TYPE_CD_ROM_DEVICE_MANAGER (noise_plugins_cd_rom_device_manager_get_type ())
#define NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE_MANAGER, NoisePluginsCDRomDeviceManager))
#define NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE_MANAGER, NoisePluginsCDRomDeviceManagerClass))
#define NOISE_PLUGINS_IS_CD_ROM_DEVICE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE_MANAGER))
#define NOISE_PLUGINS_IS_CD_ROM_DEVICE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE_MANAGER))
#define NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE_MANAGER, NoisePluginsCDRomDeviceManagerClass))

typedef struct _NoisePluginsCDRomDeviceManager NoisePluginsCDRomDeviceManager;
typedef struct _NoisePluginsCDRomDeviceManagerClass NoisePluginsCDRomDeviceManagerClass;
typedef struct _NoisePluginsCDRomDeviceManagerPrivate NoisePluginsCDRomDeviceManagerPrivate;

#define NOISE_PLUGINS_TYPE_CD_ROM_DEVICE (noise_plugins_cd_rom_device_get_type ())
#define NOISE_PLUGINS_CD_ROM_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE, NoisePluginsCDRomDevice))
#define NOISE_PLUGINS_CD_ROM_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE, NoisePluginsCDRomDeviceClass))
#define NOISE_PLUGINS_IS_CD_ROM_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE))
#define NOISE_PLUGINS_IS_CD_ROM_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE))
#define NOISE_PLUGINS_CD_ROM_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE, NoisePluginsCDRomDeviceClass))

typedef struct _NoisePluginsCDRomDevice NoisePluginsCDRomDevice;
typedef struct _NoisePluginsCDRomDeviceClass NoisePluginsCDRomDeviceClass;
enum  {
	NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_0_PROPERTY,
	NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* noise_plugins_cd_rom_device_manager_properties[NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NoisePluginsCDRomDeviceManager {
	GObject parent_instance;
	NoisePluginsCDRomDeviceManagerPrivate * priv;
};

struct _NoisePluginsCDRomDeviceManagerClass {
	GObjectClass parent_class;
	void (*mount_added) (NoisePluginsCDRomDeviceManager* self, GMount* mount);
	void (*mount_changed) (NoisePluginsCDRomDeviceManager* self, GMount* mount);
	void (*mount_pre_unmount) (NoisePluginsCDRomDeviceManager* self, GMount* mount);
	void (*mount_removed) (NoisePluginsCDRomDeviceManager* self, GMount* mount);
};

struct _NoisePluginsCDRomDeviceManagerPrivate {
	GeeArrayList* devices;
};


static gpointer noise_plugins_cd_rom_device_manager_parent_class = NULL;
static GType noise_plugins_cd_rom_device_manager_type_id = 0;

GType noise_plugins_cd_rom_device_manager_get_type (void) G_GNUC_CONST;
GType noise_plugins_cd_rom_device_get_type (void) G_GNUC_CONST;
#define NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE_MANAGER, NoisePluginsCDRomDeviceManagerPrivate))
NoisePluginsCDRomDeviceManager* noise_plugins_cd_rom_device_manager_new (void);
NoisePluginsCDRomDeviceManager* noise_plugins_cd_rom_device_manager_construct (GType object_type);
void noise_plugins_cd_rom_device_manager_mount_added (NoisePluginsCDRomDeviceManager* self,
                                                      GMount* mount);
static void _noise_plugins_cd_rom_device_manager_mount_added_noise_device_manager_mount_added (NoiseDeviceManager* _sender,
                                                                                        GMount* mount,
                                                                                        gpointer self);
void noise_plugins_cd_rom_device_manager_mount_removed (NoisePluginsCDRomDeviceManager* self,
                                                        GMount* mount);
static void _noise_plugins_cd_rom_device_manager_mount_removed_noise_device_manager_mount_removed (NoiseDeviceManager* _sender,
                                                                                            GMount* mount,
                                                                                            gpointer self);
void noise_plugins_cd_rom_device_manager_remove_all (NoisePluginsCDRomDeviceManager* self);
static void noise_plugins_cd_rom_device_manager_real_mount_added (NoisePluginsCDRomDeviceManager* self,
                                                           GMount* mount);
NoisePluginsCDRomDevice* noise_plugins_cd_rom_device_new (GMount* mount);
NoisePluginsCDRomDevice* noise_plugins_cd_rom_device_construct (GType object_type,
                                                                GMount* mount);
static void ____lambda9_ (NoisePluginsCDRomDeviceManager* self,
                   NoiseDevice* d);
static void _____lambda9__noise_device_initialized (NoiseDevice* _sender,
                                             NoiseDevice* d,
                                             gpointer self);
void noise_plugins_cd_rom_device_manager_mount_changed (NoisePluginsCDRomDeviceManager* self,
                                                        GMount* mount);
static void noise_plugins_cd_rom_device_manager_real_mount_changed (NoisePluginsCDRomDeviceManager* self,
                                                             GMount* mount);
void noise_plugins_cd_rom_device_manager_mount_pre_unmount (NoisePluginsCDRomDeviceManager* self,
                                                            GMount* mount);
static void noise_plugins_cd_rom_device_manager_real_mount_pre_unmount (NoisePluginsCDRomDeviceManager* self,
                                                                 GMount* mount);
static void noise_plugins_cd_rom_device_manager_real_mount_removed (NoisePluginsCDRomDeviceManager* self,
                                                             GMount* mount);
static void noise_plugins_cd_rom_device_manager_finalize (GObject * obj);


static void
_noise_plugins_cd_rom_device_manager_mount_added_noise_device_manager_mount_added (NoiseDeviceManager* _sender,
                                                                                   GMount* mount,
                                                                                   gpointer self)
{
#line 36 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	noise_plugins_cd_rom_device_manager_mount_added ((NoisePluginsCDRomDeviceManager*) self, mount);
#line 138 "CDRomDeviceManager.c"
}


static void
_noise_plugins_cd_rom_device_manager_mount_removed_noise_device_manager_mount_removed (NoiseDeviceManager* _sender,
                                                                                       GMount* mount,
                                                                                       gpointer self)
{
#line 37 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	noise_plugins_cd_rom_device_manager_mount_removed ((NoisePluginsCDRomDeviceManager*) self, mount);
#line 149 "CDRomDeviceManager.c"
}


NoisePluginsCDRomDeviceManager*
noise_plugins_cd_rom_device_manager_construct (GType object_type)
{
	NoisePluginsCDRomDeviceManager * self = NULL;
	GeeArrayList* _tmp0_;
	NoiseDeviceManager* device_manager = NULL;
	NoiseDeviceManager* _tmp1_;
	NoiseDeviceManager* _tmp2_;
	NoiseDeviceManager* _tmp3_;
#line 32 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	self = (NoisePluginsCDRomDeviceManager*) g_object_new (object_type, NULL);
#line 33 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_tmp0_ = gee_array_list_new (NOISE_PLUGINS_TYPE_CD_ROM_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 33 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_g_object_unref0 (self->priv->devices);
#line 33 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	self->priv->devices = _tmp0_;
#line 35 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_tmp1_ = noise_device_manager_get_default ();
#line 35 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	device_manager = _tmp1_;
#line 36 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_tmp2_ = device_manager;
#line 36 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	g_signal_connect_object (_tmp2_, "mount-added", (GCallback) _noise_plugins_cd_rom_device_manager_mount_added_noise_device_manager_mount_added, self, 0);
#line 37 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_tmp3_ = device_manager;
#line 37 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	g_signal_connect_object (_tmp3_, "mount-removed", (GCallback) _noise_plugins_cd_rom_device_manager_mount_removed_noise_device_manager_mount_removed, self, 0);
#line 182 "CDRomDeviceManager.c"
	{
		GeeIterator* _mount_it = NULL;
		NoiseDeviceManager* _tmp4_;
		GeeCollection* _tmp5_;
		GeeCollection* _tmp6_;
		GeeIterator* _tmp7_;
		GeeIterator* _tmp8_;
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp4_ = device_manager;
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp5_ = noise_device_manager_get_available_mounts (_tmp4_);
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp6_ = _tmp5_;
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp8_ = _tmp7_;
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_g_object_unref0 (_tmp6_);
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_mount_it = _tmp8_;
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		while (TRUE) {
#line 206 "CDRomDeviceManager.c"
			GeeIterator* _tmp9_;
			GMount* mount = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			GMount* _tmp12_;
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp9_ = _mount_it;
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			if (!gee_iterator_next (_tmp9_)) {
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
				break;
#line 218 "CDRomDeviceManager.c"
			}
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp10_ = _mount_it;
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			mount = (GMount*) _tmp11_;
#line 39 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp12_ = mount;
#line 39 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			noise_plugins_cd_rom_device_manager_mount_added (self, _tmp12_);
#line 230 "CDRomDeviceManager.c"
		}
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_g_object_unref0 (_mount_it);
#line 234 "CDRomDeviceManager.c"
	}
#line 32 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_g_object_unref0 (device_manager);
#line 32 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	return self;
#line 240 "CDRomDeviceManager.c"
}


NoisePluginsCDRomDeviceManager*
noise_plugins_cd_rom_device_manager_new (void)
{
#line 32 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	return noise_plugins_cd_rom_device_manager_construct (NOISE_PLUGINS_TYPE_CD_ROM_DEVICE_MANAGER);
#line 249 "CDRomDeviceManager.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 258 "CDRomDeviceManager.c"
}


void
noise_plugins_cd_rom_device_manager_remove_all (NoisePluginsCDRomDeviceManager* self)
{
	NoiseDeviceManager* device_manager = NULL;
	NoiseDeviceManager* _tmp0_;
	GeeArrayList* _tmp14_;
#line 43 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 44 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_tmp0_ = noise_device_manager_get_default ();
#line 44 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	device_manager = _tmp0_;
#line 274 "CDRomDeviceManager.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
		gint _dev_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _dev_index = 0;
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp1_ = self->priv->devices;
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_dev_list = _tmp2_;
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp3_ = _dev_list;
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp5_ = _tmp4_;
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_dev_size = _tmp5_;
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_dev_index = -1;
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		while (TRUE) {
#line 302 "CDRomDeviceManager.c"
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			NoisePluginsCDRomDevice* dev = NULL;
			GeeArrayList* _tmp9_;
			gint _tmp10_;
			gpointer _tmp11_;
			NoiseDeviceManager* _tmp12_;
			NoisePluginsCDRomDevice* _tmp13_;
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp6_ = _dev_index;
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_dev_index = _tmp6_ + 1;
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp7_ = _dev_index;
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp8_ = _dev_size;
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
				break;
#line 324 "CDRomDeviceManager.c"
			}
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp9_ = _dev_list;
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp10_ = _dev_index;
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			dev = (NoisePluginsCDRomDevice*) _tmp11_;
#line 46 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp12_ = device_manager;
#line 46 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp13_ = dev;
#line 46 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			g_signal_emit_by_name (_tmp12_, "device-removed", G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, NOISE_TYPE_DEVICE, NoiseDevice));
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_g_object_unref0 (dev);
#line 342 "CDRomDeviceManager.c"
		}
#line 45 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_g_object_unref0 (_dev_list);
#line 346 "CDRomDeviceManager.c"
	}
#line 49 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_tmp14_ = gee_array_list_new (NOISE_PLUGINS_TYPE_CD_ROM_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 49 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_g_object_unref0 (self->priv->devices);
#line 49 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	self->priv->devices = _tmp14_;
#line 43 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_g_object_unref0 (device_manager);
#line 356 "CDRomDeviceManager.c"
}


static void
____lambda9_ (NoisePluginsCDRomDeviceManager* self,
              NoiseDevice* d)
{
	NoiseDeviceManager* _tmp0_;
	NoiseDeviceManager* _tmp1_;
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	g_return_if_fail (d != NULL);
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_tmp0_ = noise_device_manager_get_default ();
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_tmp1_ = _tmp0_;
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	noise_device_manager_device_initialized (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (d, NOISE_TYPE_DEVICE, NoiseDevice));
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_g_object_unref0 (_tmp1_);
#line 376 "CDRomDeviceManager.c"
}


static void
_____lambda9__noise_device_initialized (NoiseDevice* _sender,
                                        NoiseDevice* d,
                                        gpointer self)
{
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	____lambda9_ ((NoisePluginsCDRomDeviceManager*) self, d);
#line 387 "CDRomDeviceManager.c"
}


static void
noise_plugins_cd_rom_device_manager_real_mount_added (NoisePluginsCDRomDeviceManager* self,
                                                      GMount* mount)
{
	gboolean _tmp19_ = FALSE;
	GFile* _tmp20_;
	GFile* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gboolean _tmp24_;
#line 52 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	g_return_if_fail (mount != NULL);
#line 403 "CDRomDeviceManager.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _dev_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _dev_index = 0;
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp0_ = self->priv->devices;
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_dev_list = _tmp1_;
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp2_ = _dev_list;
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp4_ = _tmp3_;
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_dev_size = _tmp4_;
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_dev_index = -1;
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		while (TRUE) {
#line 431 "CDRomDeviceManager.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			NoisePluginsCDRomDevice* dev = NULL;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			NoisePluginsCDRomDevice* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			GFile* _tmp14_;
			GFile* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gboolean _tmp18_;
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp5_ = _dev_index;
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_dev_index = _tmp5_ + 1;
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp6_ = _dev_index;
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp7_ = _dev_size;
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
				break;
#line 459 "CDRomDeviceManager.c"
			}
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp8_ = _dev_list;
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp9_ = _dev_index;
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			dev = (NoisePluginsCDRomDevice*) _tmp10_;
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp11_ = dev;
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp12_ = noise_device_get_uri ((NoiseDevice*) _tmp11_);
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp13_ = _tmp12_;
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp14_ = g_mount_get_default_location (mount);
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp15_ = _tmp14_;
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp16_ = g_file_get_uri (_tmp15_);
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp17_ = _tmp16_;
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp18_ = g_strcmp0 (_tmp13_, _tmp17_) == 0;
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_g_free0 (_tmp17_);
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_g_object_unref0 (_tmp15_);
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_g_free0 (_tmp13_);
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			if (_tmp18_) {
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
				_g_object_unref0 (dev);
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
				_g_object_unref0 (_dev_list);
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
				return;
#line 499 "CDRomDeviceManager.c"
			}
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_g_object_unref0 (dev);
#line 503 "CDRomDeviceManager.c"
		}
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_g_object_unref0 (_dev_list);
#line 507 "CDRomDeviceManager.c"
	}
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_tmp20_ = g_mount_get_default_location (mount);
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_tmp21_ = _tmp20_;
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_tmp22_ = g_file_get_uri (_tmp21_);
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_tmp23_ = _tmp22_;
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_tmp24_ = g_str_has_prefix (_tmp23_, "cdda://");
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_g_free0 (_tmp23_);
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_g_object_unref0 (_tmp21_);
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	if (_tmp24_) {
#line 525 "CDRomDeviceManager.c"
		GVolume* _tmp25_;
		GVolume* _tmp26_;
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp25_ = g_mount_get_volume (mount);
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp26_ = _tmp25_;
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp19_ = _tmp26_ != NULL;
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_g_object_unref0 (_tmp26_);
#line 536 "CDRomDeviceManager.c"
	} else {
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp19_ = FALSE;
#line 540 "CDRomDeviceManager.c"
	}
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	if (_tmp19_) {
#line 544 "CDRomDeviceManager.c"
		NoisePluginsCDRomDevice* added = NULL;
		NoisePluginsCDRomDevice* _tmp27_;
		NoisePluginsCDRomDevice* _tmp28_;
		GeeArrayList* _tmp29_;
		NoisePluginsCDRomDevice* _tmp30_;
		NoisePluginsCDRomDevice* _tmp31_;
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp27_ = noise_plugins_cd_rom_device_new (mount);
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		added = _tmp27_;
#line 60 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp28_ = added;
#line 60 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		noise_device_set_mount ((NoiseDevice*) _tmp28_, mount);
#line 61 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp29_ = self->priv->devices;
#line 61 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp30_ = added;
#line 61 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, _tmp30_);
#line 63 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp31_ = added;
#line 63 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		if (noise_device_start_initialization ((NoiseDevice*) _tmp31_)) {
#line 569 "CDRomDeviceManager.c"
			NoisePluginsCDRomDevice* _tmp32_;
			NoisePluginsCDRomDevice* _tmp33_;
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp32_ = added;
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			noise_device_finish_initialization ((NoiseDevice*) _tmp32_);
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp33_ = added;
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			g_signal_connect_object ((NoiseDevice*) _tmp33_, "initialized", (GCallback) _____lambda9__noise_device_initialized, self, 0);
#line 580 "CDRomDeviceManager.c"
		} else {
			NoisePluginsCDRomDevice* _tmp34_;
			GMount* _tmp35_;
			GMount* _tmp36_;
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp34_ = added;
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp35_ = noise_device_get_mount ((NoiseDevice*) _tmp34_);
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp36_ = _tmp35_;
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			noise_plugins_cd_rom_device_manager_mount_removed (self, _tmp36_);
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_g_object_unref0 (_tmp36_);
#line 595 "CDRomDeviceManager.c"
		}
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_g_object_unref0 (added);
#line 599 "CDRomDeviceManager.c"
	} else {
		GFile* _tmp37_;
		GFile* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
#line 72 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp37_ = g_mount_get_default_location (mount);
#line 72 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp38_ = _tmp37_;
#line 72 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp39_ = g_file_get_parse_name (_tmp38_);
#line 72 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp40_ = _tmp39_;
#line 72 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		g_debug ("CDRomDeviceManager.vala:72: Found device at %s is not an Audio CD. Not" \
" using it", _tmp40_);
#line 72 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_g_free0 (_tmp40_);
#line 72 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_g_object_unref0 (_tmp38_);
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		return;
#line 621 "CDRomDeviceManager.c"
	}
}


void
noise_plugins_cd_rom_device_manager_mount_added (NoisePluginsCDRomDeviceManager* self,
                                                 GMount* mount)
{
#line 52 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 52 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_GET_CLASS (self)->mount_added (self, mount);
#line 634 "CDRomDeviceManager.c"
}


static void
noise_plugins_cd_rom_device_manager_real_mount_changed (NoisePluginsCDRomDeviceManager* self,
                                                        GMount* mount)
{
#line 77 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	g_return_if_fail (mount != NULL);
#line 644 "CDRomDeviceManager.c"
}


void
noise_plugins_cd_rom_device_manager_mount_changed (NoisePluginsCDRomDeviceManager* self,
                                                   GMount* mount)
{
#line 77 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 77 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_GET_CLASS (self)->mount_changed (self, mount);
#line 656 "CDRomDeviceManager.c"
}


static void
noise_plugins_cd_rom_device_manager_real_mount_pre_unmount (NoisePluginsCDRomDeviceManager* self,
                                                            GMount* mount)
{
#line 81 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	g_return_if_fail (mount != NULL);
#line 666 "CDRomDeviceManager.c"
}


void
noise_plugins_cd_rom_device_manager_mount_pre_unmount (NoisePluginsCDRomDeviceManager* self,
                                                       GMount* mount)
{
#line 81 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 81 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_GET_CLASS (self)->mount_pre_unmount (self, mount);
#line 678 "CDRomDeviceManager.c"
}


static void
noise_plugins_cd_rom_device_manager_real_mount_removed (NoisePluginsCDRomDeviceManager* self,
                                                        GMount* mount)
{
	NoiseDeviceManager* device_manager = NULL;
	NoiseDeviceManager* _tmp0_;
#line 85 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	g_return_if_fail (mount != NULL);
#line 86 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_tmp0_ = noise_device_manager_get_default ();
#line 86 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	device_manager = _tmp0_;
#line 694 "CDRomDeviceManager.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
		gint _dev_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _dev_index = 0;
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp1_ = self->priv->devices;
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_dev_list = _tmp2_;
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp3_ = _dev_list;
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_tmp5_ = _tmp4_;
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_dev_size = _tmp5_;
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_dev_index = -1;
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		while (TRUE) {
#line 722 "CDRomDeviceManager.c"
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			NoisePluginsCDRomDevice* dev = NULL;
			GeeArrayList* _tmp9_;
			gint _tmp10_;
			gpointer _tmp11_;
			NoisePluginsCDRomDevice* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			GFile* _tmp15_;
			GFile* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gboolean _tmp19_;
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp6_ = _dev_index;
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_dev_index = _tmp6_ + 1;
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp7_ = _dev_index;
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp8_ = _dev_size;
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
				break;
#line 750 "CDRomDeviceManager.c"
			}
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp9_ = _dev_list;
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp10_ = _dev_index;
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			dev = (NoisePluginsCDRomDevice*) _tmp11_;
#line 88 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp12_ = dev;
#line 88 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp13_ = noise_device_get_uri ((NoiseDevice*) _tmp12_);
#line 88 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp14_ = _tmp13_;
#line 88 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp15_ = g_mount_get_default_location (mount);
#line 88 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp16_ = _tmp15_;
#line 88 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp17_ = g_file_get_uri (_tmp16_);
#line 88 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp18_ = _tmp17_;
#line 88 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_tmp19_ = g_strcmp0 (_tmp14_, _tmp18_) == 0;
#line 88 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_g_free0 (_tmp18_);
#line 88 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_g_object_unref0 (_tmp16_);
#line 88 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_g_free0 (_tmp14_);
#line 88 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			if (_tmp19_) {
#line 784 "CDRomDeviceManager.c"
				NoiseDeviceManager* _tmp20_;
				NoisePluginsCDRomDevice* _tmp21_;
				GeeArrayList* _tmp22_;
				NoisePluginsCDRomDevice* _tmp23_;
#line 89 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
				_tmp20_ = device_manager;
#line 89 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
				_tmp21_ = dev;
#line 89 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
				g_signal_emit_by_name (_tmp20_, "device-removed", G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, NOISE_TYPE_DEVICE, NoiseDevice));
#line 92 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
				_tmp22_ = self->priv->devices;
#line 92 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
				_tmp23_ = dev;
#line 92 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
				gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp22_, _tmp23_);
#line 94 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
				_g_object_unref0 (dev);
#line 94 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
				_g_object_unref0 (_dev_list);
#line 94 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
				_g_object_unref0 (device_manager);
#line 94 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
				return;
#line 809 "CDRomDeviceManager.c"
			}
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
			_g_object_unref0 (dev);
#line 813 "CDRomDeviceManager.c"
		}
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
		_g_object_unref0 (_dev_list);
#line 817 "CDRomDeviceManager.c"
	}
#line 85 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_g_object_unref0 (device_manager);
#line 821 "CDRomDeviceManager.c"
}


void
noise_plugins_cd_rom_device_manager_mount_removed (NoisePluginsCDRomDeviceManager* self,
                                                   GMount* mount)
{
#line 85 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 85 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_GET_CLASS (self)->mount_removed (self, mount);
#line 833 "CDRomDeviceManager.c"
}


static void
noise_plugins_cd_rom_device_manager_class_init (NoisePluginsCDRomDeviceManagerClass * klass)
{
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	noise_plugins_cd_rom_device_manager_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	g_type_class_add_private (klass, sizeof (NoisePluginsCDRomDeviceManagerPrivate));
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	((NoisePluginsCDRomDeviceManagerClass *) klass)->mount_added = (void (*) (NoisePluginsCDRomDeviceManager *, GMount*)) noise_plugins_cd_rom_device_manager_real_mount_added;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	((NoisePluginsCDRomDeviceManagerClass *) klass)->mount_changed = (void (*) (NoisePluginsCDRomDeviceManager *, GMount*)) noise_plugins_cd_rom_device_manager_real_mount_changed;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	((NoisePluginsCDRomDeviceManagerClass *) klass)->mount_pre_unmount = (void (*) (NoisePluginsCDRomDeviceManager *, GMount*)) noise_plugins_cd_rom_device_manager_real_mount_pre_unmount;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	((NoisePluginsCDRomDeviceManagerClass *) klass)->mount_removed = (void (*) (NoisePluginsCDRomDeviceManager *, GMount*)) noise_plugins_cd_rom_device_manager_real_mount_removed;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_plugins_cd_rom_device_manager_finalize;
#line 854 "CDRomDeviceManager.c"
}


static void
noise_plugins_cd_rom_device_manager_instance_init (NoisePluginsCDRomDeviceManager * self)
{
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	self->priv = NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_GET_PRIVATE (self);
#line 863 "CDRomDeviceManager.c"
}


static void
noise_plugins_cd_rom_device_manager_finalize (GObject * obj)
{
	NoisePluginsCDRomDeviceManager * self;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_PLUGINS_TYPE_CD_ROM_DEVICE_MANAGER, NoisePluginsCDRomDeviceManager);
#line 30 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	_g_object_unref0 (self->priv->devices);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRomDeviceManager.vala"
	G_OBJECT_CLASS (noise_plugins_cd_rom_device_manager_parent_class)->finalize (obj);
#line 877 "CDRomDeviceManager.c"
}


GType
noise_plugins_cd_rom_device_manager_get_type (void)
{
	return noise_plugins_cd_rom_device_manager_type_id;
}


GType
noise_plugins_cd_rom_device_manager_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NoisePluginsCDRomDeviceManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_plugins_cd_rom_device_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePluginsCDRomDeviceManager), 0, (GInstanceInitFunc) noise_plugins_cd_rom_device_manager_instance_init, NULL };
	noise_plugins_cd_rom_device_manager_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "NoisePluginsCDRomDeviceManager", &g_define_type_info, 0);
	return noise_plugins_cd_rom_device_manager_type_id;
}



