/* FileNotFoundDialog.c generated by valac 0.40.4, the Vala compiler
 * generated from FileNotFoundDialog.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <noise-core.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>


#define NOISE_TYPE_FILE_NOT_FOUND_DIALOG (noise_file_not_found_dialog_get_type ())
#define NOISE_FILE_NOT_FOUND_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_FILE_NOT_FOUND_DIALOG, NoiseFileNotFoundDialog))
#define NOISE_FILE_NOT_FOUND_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_FILE_NOT_FOUND_DIALOG, NoiseFileNotFoundDialogClass))
#define NOISE_IS_FILE_NOT_FOUND_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_FILE_NOT_FOUND_DIALOG))
#define NOISE_IS_FILE_NOT_FOUND_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_FILE_NOT_FOUND_DIALOG))
#define NOISE_FILE_NOT_FOUND_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_FILE_NOT_FOUND_DIALOG, NoiseFileNotFoundDialogClass))

typedef struct _NoiseFileNotFoundDialog NoiseFileNotFoundDialog;
typedef struct _NoiseFileNotFoundDialogClass NoiseFileNotFoundDialogClass;
typedef struct _NoiseFileNotFoundDialogPrivate NoiseFileNotFoundDialogPrivate;
enum  {
	NOISE_FILE_NOT_FOUND_DIALOG_0_PROPERTY,
	NOISE_FILE_NOT_FOUND_DIALOG_NUM_PROPERTIES
};
static GParamSpec* noise_file_not_found_dialog_properties[NOISE_FILE_NOT_FOUND_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define NOISE_TYPE_LOCAL_LIBRARY (noise_local_library_get_type ())
#define NOISE_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibrary))
#define NOISE_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibraryClass))
#define NOISE_IS_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LOCAL_LIBRARY))
#define NOISE_IS_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LOCAL_LIBRARY))
#define NOISE_LOCAL_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibraryClass))

typedef struct _NoiseLocalLibrary NoiseLocalLibrary;
typedef struct _NoiseLocalLibraryClass NoiseLocalLibraryClass;

struct _NoiseFileNotFoundDialog {
	GtkDialog parent_instance;
	NoiseFileNotFoundDialogPrivate * priv;
};

struct _NoiseFileNotFoundDialogClass {
	GtkDialogClass parent_class;
};

struct _NoiseFileNotFoundDialogPrivate {
	GeeLinkedList* media_list;
	GtkButton* rescanLibrary;
};


static gpointer noise_file_not_found_dialog_parent_class = NULL;

GType noise_file_not_found_dialog_get_type (void) G_GNUC_CONST;
#define NOISE_FILE_NOT_FOUND_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_FILE_NOT_FOUND_DIALOG, NoiseFileNotFoundDialogPrivate))
NoiseFileNotFoundDialog* noise_file_not_found_dialog_new (GeeCollection* _media_list);
NoiseFileNotFoundDialog* noise_file_not_found_dialog_construct (GType object_type,
                                                                GeeCollection* _media_list);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
static void __lambda50_ (NoiseFileNotFoundDialog* self,
                  gint response_id);
static void noise_file_not_found_dialog_rescan_library_clicked (NoiseFileNotFoundDialog* self);
static void noise_file_not_found_dialog_remove_media_clicked (NoiseFileNotFoundDialog* self);
static void noise_file_not_found_dialog_locate_media_clicked (NoiseFileNotFoundDialog* self);
static void ___lambda50__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void noise_file_not_found_dialog_file_operations_started (NoiseFileNotFoundDialog* self);
static void _noise_file_not_found_dialog_file_operations_started_noise_library_file_operations_started (NoiseLibrary* _sender,
                                                                                                 gpointer self);
static void noise_file_not_found_dialog_file_operations_done (NoiseFileNotFoundDialog* self);
static void _noise_file_not_found_dialog_file_operations_done_noise_library_file_operations_done (NoiseLibrary* _sender,
                                                                                           gpointer self);
GType noise_local_library_get_type (void) G_GNUC_CONST;
void noise_local_library_rescan_music_folder (NoiseLocalLibrary* self);
static void noise_file_not_found_dialog_finalize (GObject * obj);


static gpointer
_g_object_ref0 (gpointer self)
{
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 134 "FileNotFoundDialog.c"
}


static void
__lambda50_ (NoiseFileNotFoundDialog* self,
             gint response_id)
{
#line 89 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	switch (response_id) {
#line 89 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		case 1:
#line 146 "FileNotFoundDialog.c"
		{
#line 91 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			noise_file_not_found_dialog_rescan_library_clicked (self);
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			break;
#line 152 "FileNotFoundDialog.c"
		}
#line 89 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		case 2:
#line 156 "FileNotFoundDialog.c"
		{
#line 94 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			noise_file_not_found_dialog_remove_media_clicked (self);
#line 95 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			break;
#line 162 "FileNotFoundDialog.c"
		}
#line 89 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		case 3:
#line 166 "FileNotFoundDialog.c"
		{
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			noise_file_not_found_dialog_locate_media_clicked (self);
#line 98 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			break;
#line 172 "FileNotFoundDialog.c"
		}
#line 89 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		case GTK_RESPONSE_CLOSE:
#line 176 "FileNotFoundDialog.c"
		{
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			gtk_widget_destroy ((GtkWidget*) self);
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			break;
#line 182 "FileNotFoundDialog.c"
		}
		default:
#line 89 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		break;
#line 187 "FileNotFoundDialog.c"
	}
}


static void
___lambda50__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 88 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	__lambda50_ ((NoiseFileNotFoundDialog*) self, response_id);
#line 199 "FileNotFoundDialog.c"
}


static void
_noise_file_not_found_dialog_file_operations_started_noise_library_file_operations_started (NoiseLibrary* _sender,
                                                                                            gpointer self)
{
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	noise_file_not_found_dialog_file_operations_started ((NoiseFileNotFoundDialog*) self);
#line 209 "FileNotFoundDialog.c"
}


static void
_noise_file_not_found_dialog_file_operations_done_noise_library_file_operations_done (NoiseLibrary* _sender,
                                                                                      gpointer self)
{
#line 106 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	noise_file_not_found_dialog_file_operations_done ((NoiseFileNotFoundDialog*) self);
#line 219 "FileNotFoundDialog.c"
}


NoiseFileNotFoundDialog*
noise_file_not_found_dialog_construct (GType object_type,
                                       GeeCollection* _media_list)
{
	NoiseFileNotFoundDialog * self = NULL;
	GeeLinkedList* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	GtkBox* content = NULL;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	GtkImage* warning = NULL;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	gchar* title_string = NULL;
	gchar* _tmp7_;
	gchar* body_string = NULL;
	gchar* _tmp8_;
	GeeLinkedList* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	GtkLabel* info = NULL;
	const gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	const gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	GtkLabel* _tmp41_;
	GtkLabel* _tmp42_;
	GtkButton* _tmp43_;
	NoiseLibrariesManager* _tmp44_;
	NoiseLibrary* _tmp45_;
	GtkGrid* layout = NULL;
	GtkGrid* _tmp46_;
	GtkImage* _tmp47_;
	GtkBox* _tmp48_;
	NoiseLibrariesManager* _tmp49_;
	NoiseLibrary* _tmp50_;
	NoiseLibrariesManager* _tmp51_;
	NoiseLibrary* _tmp52_;
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	g_return_val_if_fail (_media_list != NULL, NULL);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	self = (NoiseFileNotFoundDialog*) g_object_new (object_type, NULL);
#line 36 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp0_ = self->priv->media_list;
#line 36 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gee_collection_add_all ((GeeCollection*) _tmp0_, _media_list);
#line 38 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 39 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp1_ = noise_app_get_main_window ();
#line 39 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp2_ = _tmp1_;
#line 39 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_window_set_transient_for ((GtkWindow*) self, (GtkWindow*) _tmp2_);
#line 40 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_window_set_destroy_with_parent ((GtkWindow*) self, TRUE);
#line 41 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_container_set_border_width ((GtkContainer*) self, (guint) 6);
#line 42 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 43 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp3_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, gtk_box_get_type ()) ? ((GtkBox*) _tmp3_) : NULL);
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	content = _tmp4_;
#line 48 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("dialog-warning", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 48 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	g_object_ref_sink (_tmp5_);
#line 48 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	warning = _tmp5_;
#line 49 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp6_ = warning;
#line 49 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	g_object_set ((GtkMisc*) _tmp6_, "yalign", (gfloat) 0, NULL);
#line 51 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp7_ = g_strdup (_ ("File not found"));
#line 51 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	title_string = _tmp7_;
#line 52 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp8_ = g_strdup ("");
#line 52 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	body_string = _tmp8_;
#line 54 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp9_ = self->priv->media_list;
#line 54 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
#line 54 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp11_ = _tmp10_;
#line 54 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	if (_tmp11_ == 1) {
#line 326 "FileNotFoundDialog.c"
		NoiseMedia* s = NULL;
		GeeLinkedList* _tmp12_;
		gpointer _tmp13_;
		NoiseMedia* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		NoiseMedia* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp12_ = self->priv->media_list;
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, 0);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		s = (NoiseMedia*) _tmp13_;
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp14_ = s;
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp15_ = noise_media_get_title (_tmp14_);
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp16_ = _tmp15_;
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp17_ = g_markup_escape_text (_tmp16_, (gssize) -1);
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp18_ = _tmp17_;
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp19_ = s;
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp20_ = noise_media_get_artist (_tmp19_);
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp21_ = _tmp20_;
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp22_ = g_markup_escape_text (_tmp21_, (gssize) -1);
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp23_ = _tmp22_;
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp24_ = g_strdup_printf (_ ("The music file for <b>%s</b> by <b>%s</b> could not be found."), _tmp18_, _tmp23_);
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_g_free0 (body_string);
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		body_string = _tmp24_;
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_g_free0 (_tmp23_);
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_g_free0 (_tmp18_);
#line 54 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_g_object_unref0 (s);
#line 379 "FileNotFoundDialog.c"
	} else {
		GeeLinkedList* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		gchar* _tmp28_;
#line 60 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp25_ = self->priv->media_list;
#line 60 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp26_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp25_);
#line 60 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp27_ = _tmp26_;
#line 60 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp28_ = g_strdup_printf (_ ("%i music files could not be found?"), _tmp27_);
#line 60 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_g_free0 (body_string);
#line 60 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		body_string = _tmp28_;
#line 397 "FileNotFoundDialog.c"
	}
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp29_ = title_string;
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp30_ = g_markup_escape_text (_tmp29_, (gssize) -1);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp31_ = _tmp30_;
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp32_ = g_strdup_printf ("<span weight=\"bold\" size=\"larger\">%s</span>", _tmp31_);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp33_ = _tmp32_;
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp34_ = g_strconcat (_tmp33_, "\n\n", NULL);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp35_ = _tmp34_;
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp36_ = body_string;
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp37_ = g_strdup_printf ("%s", _tmp36_);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp38_ = _tmp37_;
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp39_ = g_strconcat (_tmp35_, _tmp38_, NULL);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp40_ = _tmp39_;
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp41_ = (GtkLabel*) gtk_label_new (_tmp40_);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	g_object_ref_sink (_tmp41_);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp42_ = _tmp41_;
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_free0 (_tmp40_);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_free0 (_tmp38_);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_free0 (_tmp35_);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_free0 (_tmp33_);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_free0 (_tmp31_);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	info = _tmp42_;
#line 67 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) info, GTK_ALIGN_START);
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_label_set_selectable (info, TRUE);
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_label_set_use_markup (info, TRUE);
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp43_ = self->priv->rescanLibrary;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp44_ = noise_libraries_manager;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp45_ = _tmp44_->local_library;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp43_, !noise_library_doing_file_operations (_tmp45_));
#line 73 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp46_ = (GtkGrid*) gtk_grid_new ();
#line 73 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	g_object_ref_sink (_tmp46_);
#line 73 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	layout = _tmp46_;
#line 74 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_grid_set_column_spacing (layout, (guint) 12);
#line 75 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_widget_set_margin_right ((GtkWidget*) layout, 6);
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) layout, 24);
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_widget_set_margin_left ((GtkWidget*) layout, 6);
#line 78 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp47_ = warning;
#line 78 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_container_add ((GtkContainer*) layout, (GtkWidget*) _tmp47_);
#line 79 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_container_add ((GtkContainer*) layout, (GtkWidget*) info);
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp48_ = content;
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp48_, (GtkWidget*) layout);
#line 83 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_dialog_add_button ((GtkDialog*) self, _ ("Rescan Library"), 1);
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_dialog_add_button ((GtkDialog*) self, _ ("Remove Song"), 2);
#line 85 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_dialog_add_button ((GtkDialog*) self, _ ("Cancel"), (gint) GTK_RESPONSE_CLOSE);
#line 86 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_dialog_add_button ((GtkDialog*) self, _ ("Find Song"), 3);
#line 88 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) ___lambda50__gtk_dialog_response, self, 0);
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp49_ = noise_libraries_manager;
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp50_ = _tmp49_->local_library;
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	g_signal_connect_object (_tmp50_, "file-operations-started", (GCallback) _noise_file_not_found_dialog_file_operations_started_noise_library_file_operations_started, self, 0);
#line 106 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp51_ = noise_libraries_manager;
#line 106 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp52_ = _tmp51_->local_library;
#line 106 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	g_signal_connect_object (_tmp52_, "file-operations-done", (GCallback) _noise_file_not_found_dialog_file_operations_done_noise_library_file_operations_done, self, 0);
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (layout);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (info);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_free0 (body_string);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_free0 (title_string);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (warning);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (content);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	return self;
#line 517 "FileNotFoundDialog.c"
}


NoiseFileNotFoundDialog*
noise_file_not_found_dialog_new (GeeCollection* _media_list)
{
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	return noise_file_not_found_dialog_construct (NOISE_TYPE_FILE_NOT_FOUND_DIALOG, _media_list);
#line 526 "FileNotFoundDialog.c"
}


static void
noise_file_not_found_dialog_remove_media_clicked (NoiseFileNotFoundDialog* self)
{
	NoiseLibrariesManager* _tmp0_;
	NoiseLibrary* _tmp1_;
	GeeLinkedList* _tmp2_;
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	g_return_if_fail (self != NULL);
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp0_ = noise_libraries_manager;
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp1_ = _tmp0_->local_library;
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp2_ = self->priv->media_list;
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	noise_library_remove_medias (_tmp1_, (GeeCollection*) _tmp2_, FALSE);
#line 114 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 548 "FileNotFoundDialog.c"
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1417 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1417 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 568 "FileNotFoundDialog.c"
}


static void
noise_file_not_found_dialog_locate_media_clicked (NoiseFileNotFoundDialog* self)
{
	NoiseMedia* m = NULL;
	GeeLinkedList* _tmp0_;
	gpointer _tmp1_;
	gint64 media_id = 0LL;
	NoiseMedia* _tmp2_;
	gint64 _tmp3_;
	gint64 _tmp4_;
	gchar* file = NULL;
	gchar* _tmp5_;
	GtkFileChooserDialog* file_chooser = NULL;
	GtkFileChooserDialog* _tmp6_;
	GFile* invalid_file = NULL;
	NoiseLibrariesManager* _tmp7_;
	NoiseLibrary* _tmp8_;
	gint64 _tmp9_;
	NoiseMedia* _tmp10_;
	NoiseMedia* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GFile* _tmp15_;
	GFile* _tmp16_;
	gchar* music_folder = NULL;
	NoiseSettingsMain* _tmp17_;
	NoiseSettingsMain* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GFile* _tmp23_;
	GFile* _tmp24_;
	GFile* _tmp25_;
	gboolean _tmp26_;
	GtkFileChooserDialog* _tmp64_;
	GtkFileChooserDialog* _tmp67_;
	gboolean _tmp68_ = FALSE;
	const gchar* _tmp69_;
#line 117 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	g_return_if_fail (self != NULL);
#line 118 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp0_ = self->priv->media_list;
#line 118 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
#line 118 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	m = (NoiseMedia*) _tmp1_;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp2_ = m;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp3_ = noise_media_get_rowid (_tmp2_);
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp4_ = _tmp3_;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	media_id = _tmp4_;
#line 121 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp5_ = g_strdup ("");
#line 121 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	file = _tmp5_;
#line 122 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp6_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (_ ("Choose Music Folder"), (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_OPEN, _ ("Cancel"), GTK_RESPONSE_CANCEL, _ ("Open"), GTK_RESPONSE_ACCEPT, NULL);
#line 122 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	g_object_ref_sink (_tmp6_);
#line 122 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	file_chooser = _tmp6_;
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp7_ = noise_libraries_manager;
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp8_ = _tmp7_->local_library;
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp9_ = media_id;
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp10_ = noise_library_media_from_id (_tmp8_, _tmp9_);
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp11_ = _tmp10_;
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp12_ = noise_media_get_uri (_tmp11_);
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp13_ = _tmp12_;
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp14_ = _tmp13_;
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp15_ = g_file_new_for_uri (_tmp14_);
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp16_ = _tmp15_;
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_free0 (_tmp14_);
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (_tmp11_);
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	invalid_file = _tmp16_;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp17_ = noise_settings_main_get_default ();
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp18_ = _tmp17_;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp19_ = noise_settings_main_get_music_folder (_tmp18_);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp20_ = _tmp19_;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp21_ = g_strdup (_tmp20_);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp22_ = _tmp21_;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (_tmp18_);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	music_folder = _tmp22_;
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp23_ = invalid_file;
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp24_ = g_file_get_parent (_tmp23_);
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp25_ = _tmp24_;
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp26_ = g_file_query_exists (_tmp25_, NULL);
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (_tmp25_);
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	if (_tmp26_) {
#line 692 "FileNotFoundDialog.c"
		GtkFileChooserDialog* _tmp27_;
		GFile* _tmp28_;
		GFile* _tmp29_;
		GFile* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp27_ = file_chooser;
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp28_ = invalid_file;
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp29_ = g_file_get_parent (_tmp28_);
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp30_ = _tmp29_;
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp31_ = g_file_get_path (_tmp30_);
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp32_ = _tmp31_;
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp27_, _tmp32_);
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_g_free0 (_tmp32_);
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_g_object_unref0 (_tmp30_);
#line 717 "FileNotFoundDialog.c"
	} else {
		gboolean _tmp33_ = FALSE;
		GFile* _tmp34_;
		GFile* _tmp35_;
		GFile* _tmp36_;
		GFile* _tmp37_;
		GFile* _tmp38_;
		gboolean _tmp39_;
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp34_ = invalid_file;
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp35_ = g_file_get_parent (_tmp34_);
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp36_ = _tmp35_;
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp37_ = g_file_get_parent (_tmp36_);
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp38_ = _tmp37_;
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp39_ = g_file_query_exists (_tmp38_, NULL);
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_g_object_unref0 (_tmp38_);
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_g_object_unref0 (_tmp36_);
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		if (_tmp39_) {
#line 744 "FileNotFoundDialog.c"
			GFile* _tmp40_;
			GFile* _tmp41_;
			GFile* _tmp42_;
			GFile* _tmp43_;
			GFile* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
			const gchar* _tmp47_;
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp40_ = invalid_file;
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp41_ = g_file_get_parent (_tmp40_);
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp42_ = _tmp41_;
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp43_ = g_file_get_parent (_tmp42_);
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp44_ = _tmp43_;
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp45_ = g_file_get_path (_tmp44_);
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp46_ = _tmp45_;
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp47_ = music_folder;
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp33_ = string_contains (_tmp46_, _tmp47_);
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_g_free0 (_tmp46_);
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_g_object_unref0 (_tmp44_);
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_g_object_unref0 (_tmp42_);
#line 777 "FileNotFoundDialog.c"
		} else {
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp33_ = FALSE;
#line 781 "FileNotFoundDialog.c"
		}
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		if (_tmp33_) {
#line 785 "FileNotFoundDialog.c"
			GtkFileChooserDialog* _tmp48_;
			GFile* _tmp49_;
			GFile* _tmp50_;
			GFile* _tmp51_;
			GFile* _tmp52_;
			GFile* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp48_ = file_chooser;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp49_ = invalid_file;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp50_ = g_file_get_parent (_tmp49_);
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp51_ = _tmp50_;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp52_ = g_file_get_parent (_tmp51_);
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp53_ = _tmp52_;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp54_ = g_file_get_path (_tmp53_);
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp55_ = _tmp54_;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp48_, _tmp55_);
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_g_free0 (_tmp55_);
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_g_object_unref0 (_tmp53_);
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_g_object_unref0 (_tmp51_);
#line 818 "FileNotFoundDialog.c"
		} else {
			const gchar* _tmp56_;
			GFile* _tmp57_;
			GFile* _tmp58_;
			gboolean _tmp59_;
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp56_ = music_folder;
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp57_ = g_file_new_for_path (_tmp56_);
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp58_ = _tmp57_;
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_tmp59_ = g_file_query_exists (_tmp58_, NULL);
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			_g_object_unref0 (_tmp58_);
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
			if (_tmp59_) {
#line 836 "FileNotFoundDialog.c"
				GtkFileChooserDialog* _tmp60_;
				const gchar* _tmp61_;
#line 138 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
				_tmp60_ = file_chooser;
#line 138 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
				_tmp61_ = music_folder;
#line 138 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
				gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp60_, _tmp61_);
#line 845 "FileNotFoundDialog.c"
			} else {
				GtkFileChooserDialog* _tmp62_;
				const gchar* _tmp63_;
#line 140 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
				_tmp62_ = file_chooser;
#line 140 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
				_tmp63_ = g_get_home_dir ();
#line 140 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
				gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp62_, _tmp63_);
#line 855 "FileNotFoundDialog.c"
			}
		}
	}
#line 143 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp64_ = file_chooser;
#line 143 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	if (gtk_dialog_run ((GtkDialog*) _tmp64_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 863 "FileNotFoundDialog.c"
		GtkFileChooserDialog* _tmp65_;
		gchar* _tmp66_;
#line 144 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp65_ = file_chooser;
#line 144 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp66_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp65_);
#line 144 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_g_free0 (file);
#line 144 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		file = _tmp66_;
#line 874 "FileNotFoundDialog.c"
	}
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp67_ = file_chooser;
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp67_);
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp69_ = file;
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	if (g_strcmp0 (_tmp69_, "") != 0) {
#line 884 "FileNotFoundDialog.c"
		const gchar* _tmp70_;
		GFile* _tmp71_;
		GFile* _tmp72_;
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp70_ = file;
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp71_ = g_file_new_for_path (_tmp70_);
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp72_ = _tmp71_;
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp68_ = g_file_query_exists (_tmp72_, NULL);
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_g_object_unref0 (_tmp72_);
#line 898 "FileNotFoundDialog.c"
	} else {
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp68_ = FALSE;
#line 902 "FileNotFoundDialog.c"
	}
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	if (_tmp68_) {
#line 906 "FileNotFoundDialog.c"
		NoiseMedia* _tmp73_;
		const gchar* _tmp74_;
		GFile* _tmp75_;
		GFile* _tmp76_;
		gchar* _tmp77_;
		gchar* _tmp78_;
		NoiseMedia* _tmp79_;
		NoiseMedia* _tmp80_;
		NoiseLibrariesManager* _tmp81_;
		NoiseLibrary* _tmp82_;
		NoiseMedia* _tmp83_;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp73_ = m;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp74_ = file;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp75_ = g_file_new_for_path (_tmp74_);
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp76_ = _tmp75_;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp77_ = g_file_get_uri (_tmp76_);
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp78_ = _tmp77_;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		noise_media_set_uri (_tmp73_, _tmp78_);
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_g_free0 (_tmp78_);
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_g_object_unref0 (_tmp76_);
#line 151 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp79_ = m;
#line 151 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		noise_media_set_location_unknown (_tmp79_, FALSE);
#line 152 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp80_ = m;
#line 152 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		noise_media_set_unique_status_image (_tmp80_, NULL);
#line 155 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp81_ = noise_libraries_manager;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp82_ = _tmp81_->local_library;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		_tmp83_ = m;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		noise_library_update_media (_tmp82_, _tmp83_, FALSE, FALSE);
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
		gtk_widget_destroy ((GtkWidget*) self);
#line 954 "FileNotFoundDialog.c"
	}
#line 117 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_free0 (music_folder);
#line 117 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (invalid_file);
#line 117 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (file_chooser);
#line 117 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_free0 (file);
#line 117 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (m);
#line 966 "FileNotFoundDialog.c"
}


static void
noise_file_not_found_dialog_rescan_library_clicked (NoiseFileNotFoundDialog* self)
{
	NoiseLibrariesManager* _tmp0_;
	NoiseLibrary* _tmp1_;
#line 161 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	g_return_if_fail (self != NULL);
#line 162 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp0_ = noise_libraries_manager;
#line 162 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp1_ = _tmp0_->local_library;
#line 162 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	noise_local_library_rescan_music_folder (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibrary));
#line 164 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 985 "FileNotFoundDialog.c"
}


static void
noise_file_not_found_dialog_file_operations_done (NoiseFileNotFoundDialog* self)
{
	GtkButton* _tmp0_;
#line 167 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	g_return_if_fail (self != NULL);
#line 168 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp0_ = self->priv->rescanLibrary;
#line 168 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
#line 999 "FileNotFoundDialog.c"
}


static void
noise_file_not_found_dialog_file_operations_started (NoiseFileNotFoundDialog* self)
{
	GtkButton* _tmp0_;
#line 171 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	g_return_if_fail (self != NULL);
#line 172 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp0_ = self->priv->rescanLibrary;
#line 172 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
#line 1013 "FileNotFoundDialog.c"
}


static void
noise_file_not_found_dialog_class_init (NoiseFileNotFoundDialogClass * klass)
{
#line 30 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	noise_file_not_found_dialog_parent_class = g_type_class_peek_parent (klass);
#line 30 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	g_type_class_add_private (klass, sizeof (NoiseFileNotFoundDialogPrivate));
#line 30 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_file_not_found_dialog_finalize;
#line 1026 "FileNotFoundDialog.c"
}


static void
noise_file_not_found_dialog_instance_init (NoiseFileNotFoundDialog * self)
{
	GeeLinkedList* _tmp0_;
#line 30 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	self->priv = NOISE_FILE_NOT_FOUND_DIALOG_GET_PRIVATE (self);
#line 31 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 31 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	self->priv->media_list = _tmp0_;
#line 1040 "FileNotFoundDialog.c"
}


static void
noise_file_not_found_dialog_finalize (GObject * obj)
{
	NoiseFileNotFoundDialog * self;
#line 30 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_FILE_NOT_FOUND_DIALOG, NoiseFileNotFoundDialog);
#line 31 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (self->priv->media_list);
#line 33 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (self->priv->rescanLibrary);
#line 30 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/FileNotFoundDialog.vala"
	G_OBJECT_CLASS (noise_file_not_found_dialog_parent_class)->finalize (obj);
#line 1056 "FileNotFoundDialog.c"
}


GType
noise_file_not_found_dialog_get_type (void)
{
	static volatile gsize noise_file_not_found_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&noise_file_not_found_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseFileNotFoundDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_file_not_found_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseFileNotFoundDialog), 0, (GInstanceInitFunc) noise_file_not_found_dialog_instance_init, NULL };
		GType noise_file_not_found_dialog_type_id;
		noise_file_not_found_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "NoiseFileNotFoundDialog", &g_define_type_info, 0);
		g_once_init_leave (&noise_file_not_found_dialog_type_id__volatile, noise_file_not_found_dialog_type_id);
	}
	return noise_file_not_found_dialog_type_id__volatile;
}



