/* TransferFromDeviceDialog.c generated by valac 0.40.4, the Vala compiler
 * generated from TransferFromDeviceDialog.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */
/* Merely a place holder for multiple pieces of information regarding
 * the current media playing. Mostly here because of dependence. */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <noise-core.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>


#define NOISE_TYPE_TRANSFER_FROM_DEVICE_DIALOG (noise_transfer_from_device_dialog_get_type ())
#define NOISE_TRANSFER_FROM_DEVICE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_TRANSFER_FROM_DEVICE_DIALOG, NoiseTransferFromDeviceDialog))
#define NOISE_TRANSFER_FROM_DEVICE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_TRANSFER_FROM_DEVICE_DIALOG, NoiseTransferFromDeviceDialogClass))
#define NOISE_IS_TRANSFER_FROM_DEVICE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_TRANSFER_FROM_DEVICE_DIALOG))
#define NOISE_IS_TRANSFER_FROM_DEVICE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_TRANSFER_FROM_DEVICE_DIALOG))
#define NOISE_TRANSFER_FROM_DEVICE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_TRANSFER_FROM_DEVICE_DIALOG, NoiseTransferFromDeviceDialogClass))

typedef struct _NoiseTransferFromDeviceDialog NoiseTransferFromDeviceDialog;
typedef struct _NoiseTransferFromDeviceDialogClass NoiseTransferFromDeviceDialogClass;
typedef struct _NoiseTransferFromDeviceDialogPrivate NoiseTransferFromDeviceDialogPrivate;
enum  {
	NOISE_TRANSFER_FROM_DEVICE_DIALOG_0_PROPERTY,
	NOISE_TRANSFER_FROM_DEVICE_DIALOG_NUM_PROPERTIES
};
static GParamSpec* noise_transfer_from_device_dialog_properties[NOISE_TRANSFER_FROM_DEVICE_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block30Data Block30Data;

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

struct _NoiseTransferFromDeviceDialog {
	GtkWindow parent_instance;
	NoiseTransferFromDeviceDialogPrivate * priv;
};

struct _NoiseTransferFromDeviceDialogClass {
	GtkWindowClass parent_class;
	void (*transferAllToggled) (NoiseTransferFromDeviceDialog* self);
	void (*transferClick) (NoiseTransferFromDeviceDialog* self);
	void (*cancelClick) (NoiseTransferFromDeviceDialog* self);
};

struct _NoiseTransferFromDeviceDialogPrivate {
	GeeTreeSet* medias;
	NoiseDevice* d;
	GtkBox* content;
	GtkBox* padding;
	GtkCheckButton* transferAll;
	GtkScrolledWindow* mediasScroll;
	GtkTreeView* mediasView;
	GtkListStore* mediasModel;
	GtkButton* transfer;
	GtkMenu* viewMenu;
	GtkMenuItem* selectItem;
	GtkMenuItem* selectAlbum;
	GtkMenuItem* selectArtist;
	GeeTreeSet* to_transfer;
};

struct _Block30Data {
	int _ref_count_;
	NoiseTransferFromDeviceDialog* self;
	GtkExpander* exp;
};


static gpointer noise_transfer_from_device_dialog_parent_class = NULL;

GType noise_transfer_from_device_dialog_get_type (void) G_GNUC_CONST;
#define NOISE_TRANSFER_FROM_DEVICE_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_TRANSFER_FROM_DEVICE_DIALOG, NoiseTransferFromDeviceDialogPrivate))
NoiseTransferFromDeviceDialog* noise_transfer_from_device_dialog_new (NoiseDevice* d,
                                                                      GeeCollection* _medias);
NoiseTransferFromDeviceDialog* noise_transfer_from_device_dialog_construct (GType object_type,
                                                                            NoiseDevice* d,
                                                                            GeeCollection* _medias);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
static void __lambda125_ (NoiseTransferFromDeviceDialog* self,
                   GtkCellRendererToggle* toggle,
                   const gchar* path);
gboolean noise_transfer_from_device_dialog_updateTransferSensetivity (NoiseTransferFromDeviceDialog* self,
                                                                      GtkTreeModel* model,
                                                                      GtkTreePath* path,
                                                                      GtkTreeIter* iter);
static gboolean _noise_transfer_from_device_dialog_updateTransferSensetivity_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                                                   GtkTreePath* path,
                                                                                                   GtkTreeIter* iter,
                                                                                                   gpointer self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void ___lambda125__gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender,
                                                     const gchar* path,
                                                     gpointer self);
gint noise_transfer_from_device_dialog_mediaCompareFunc (NoiseMedia* a,
                                                         NoiseMedia* b);
static gint _noise_transfer_from_device_dialog_mediaCompareFunc_gcompare_data_func (gconstpointer a,
                                                                             gconstpointer b,
                                                                             gpointer self);
void noise_transfer_from_device_dialog_transferClick (NoiseTransferFromDeviceDialog* self);
static void _noise_transfer_from_device_dialog_transferClick_gtk_button_clicked (GtkButton* _sender,
                                                                          gpointer self);
void noise_transfer_from_device_dialog_transferAllToggled (NoiseTransferFromDeviceDialog* self);
static void _noise_transfer_from_device_dialog_transferAllToggled_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                                      gpointer self);
static void __lambda126_ (NoiseTransferFromDeviceDialog* self);
static void ___lambda126__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void __lambda127_ (Block30Data* _data30_);
static void ___lambda127__gtk_expander_activate (GtkExpander* _sender,
                                          gpointer self);
GtkAlignment* noise_transfer_from_device_dialog_wrap_alignment (GtkWidget* widget,
                                                                gint top,
                                                                gint right,
                                                                gint bottom,
                                                                gint left);
gboolean noise_transfer_from_device_dialog_selectAll (NoiseTransferFromDeviceDialog* self,
                                                      GtkTreeModel* model,
                                                      GtkTreePath* path,
                                                      GtkTreeIter* iter);
gboolean noise_transfer_from_device_dialog_unselectAll (NoiseTransferFromDeviceDialog* self,
                                                        GtkTreeModel* model,
                                                        GtkTreePath* path,
                                                        GtkTreeIter* iter);
static void noise_transfer_from_device_dialog_real_transferAllToggled (NoiseTransferFromDeviceDialog* self);
static gboolean _noise_transfer_from_device_dialog_selectAll_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                                   GtkTreePath* path,
                                                                                   GtkTreeIter* iter,
                                                                                   gpointer self);
static gboolean _noise_transfer_from_device_dialog_unselectAll_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                                     GtkTreePath* path,
                                                                                     GtkTreeIter* iter,
                                                                                     gpointer self);
gboolean noise_transfer_from_device_dialog_createTransferList (NoiseTransferFromDeviceDialog* self,
                                                               GtkTreeModel* model,
                                                               GtkTreePath* path,
                                                               GtkTreeIter* iter);
static void noise_transfer_from_device_dialog_real_transferClick (NoiseTransferFromDeviceDialog* self);
static gboolean _noise_transfer_from_device_dialog_createTransferList_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                                            GtkTreePath* path,
                                                                                            GtkTreeIter* iter,
                                                                                            gpointer self);
void noise_transfer_from_device_dialog_cancelClick (NoiseTransferFromDeviceDialog* self);
static void noise_transfer_from_device_dialog_real_cancelClick (NoiseTransferFromDeviceDialog* self);
static void noise_transfer_from_device_dialog_finalize (GObject * obj);


static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_atomic_int_inc (&_data30_->_ref_count_);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	return _data30_;
#line 201 "TransferFromDeviceDialog.c"
}


static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
#line 212 "TransferFromDeviceDialog.c"
		NoiseTransferFromDeviceDialog* self;
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		self = _data30_->self;
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_g_object_unref0 (_data30_->exp);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_g_object_unref0 (self);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		g_slice_free (Block30Data, _data30_);
#line 222 "TransferFromDeviceDialog.c"
	}
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 232 "TransferFromDeviceDialog.c"
}


static gboolean
_noise_transfer_from_device_dialog_updateTransferSensetivity_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                                          GtkTreePath* path,
                                                                                          GtkTreeIter* iter,
                                                                                          gpointer self)
{
	gboolean result;
	result = noise_transfer_from_device_dialog_updateTransferSensetivity ((NoiseTransferFromDeviceDialog*) self, model, path, iter);
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	return result;
#line 246 "TransferFromDeviceDialog.c"
}


static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 255 "TransferFromDeviceDialog.c"
}


static void
__lambda125_ (NoiseTransferFromDeviceDialog* self,
              GtkCellRendererToggle* toggle,
              const gchar* path)
{
	GtkTreePath* tree_path = NULL;
	GtkTreePath* _tmp0_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	GtkListStore* _tmp3_;
	GtkTreeIter _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GtkButton* _tmp7_;
	GtkListStore* _tmp8_;
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_if_fail (toggle != NULL);
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_if_fail (path != NULL);
#line 109 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp0_ = gtk_tree_path_new_from_string (path);
#line 109 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	tree_path = _tmp0_;
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp1_ = self->priv->mediasModel;
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp1_, &_tmp2_, tree_path);
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	iter = _tmp2_;
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp3_ = self->priv->mediasModel;
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp4_ = iter;
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp5_ = gtk_cell_renderer_toggle_get_active (toggle);
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp6_ = _tmp5_;
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_list_store_set (_tmp3_, &_tmp4_, 0, !_tmp6_, -1);
#line 114 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp7_ = self->priv->transfer;
#line 114 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp8_ = self->priv->mediasModel;
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_model_foreach ((GtkTreeModel*) _tmp8_, _noise_transfer_from_device_dialog_updateTransferSensetivity_gtk_tree_model_foreach_func, self);
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	__vala_GtkTreePath_free0 (tree_path);
#line 309 "TransferFromDeviceDialog.c"
}


static void
___lambda125__gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender,
                                                const gchar* path,
                                                gpointer self)
{
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	__lambda125_ ((NoiseTransferFromDeviceDialog*) self, _sender, path);
#line 320 "TransferFromDeviceDialog.c"
}


static gint
_noise_transfer_from_device_dialog_mediaCompareFunc_gcompare_data_func (gconstpointer a,
                                                                        gconstpointer b,
                                                                        gpointer self)
{
	gint result;
	result = noise_transfer_from_device_dialog_mediaCompareFunc ((NoiseMedia*) a, (NoiseMedia*) b);
#line 151 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	return result;
#line 333 "TransferFromDeviceDialog.c"
}


static void
_noise_transfer_from_device_dialog_transferClick_gtk_button_clicked (GtkButton* _sender,
                                                                     gpointer self)
{
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	noise_transfer_from_device_dialog_transferClick ((NoiseTransferFromDeviceDialog*) self);
#line 343 "TransferFromDeviceDialog.c"
}


static void
_noise_transfer_from_device_dialog_transferAllToggled_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                                 gpointer self)
{
#line 199 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	noise_transfer_from_device_dialog_transferAllToggled ((NoiseTransferFromDeviceDialog*) self);
#line 353 "TransferFromDeviceDialog.c"
}


static void
__lambda126_ (NoiseTransferFromDeviceDialog* self)
{
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 362 "TransferFromDeviceDialog.c"
}


static void
___lambda126__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	__lambda126_ ((NoiseTransferFromDeviceDialog*) self);
#line 372 "TransferFromDeviceDialog.c"
}


static void
__lambda127_ (Block30Data* _data30_)
{
	NoiseTransferFromDeviceDialog* self;
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self = _data30_->self;
#line 203 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	if (gtk_expander_get_expanded (_data30_->exp)) {
#line 204 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		gtk_window_set_resizable ((GtkWindow*) self, TRUE);
#line 205 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		gtk_widget_set_size_request ((GtkWidget*) self, 550, 180);
#line 206 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		gtk_window_resize ((GtkWindow*) self, 475, 180);
#line 207 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 392 "TransferFromDeviceDialog.c"
	} else {
#line 210 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		gtk_widget_set_size_request ((GtkWidget*) self, 550, 500);
#line 396 "TransferFromDeviceDialog.c"
	}
}


static void
___lambda127__gtk_expander_activate (GtkExpander* _sender,
                                     gpointer self)
{
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	__lambda127_ (self);
#line 407 "TransferFromDeviceDialog.c"
}


NoiseTransferFromDeviceDialog*
noise_transfer_from_device_dialog_construct (GType object_type,
                                             NoiseDevice* d,
                                             GeeCollection* _medias)
{
	NoiseTransferFromDeviceDialog * self = NULL;
	Block30Data* _data30_;
	GeeTreeSet* _tmp0_;
	NoiseDevice* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	NoiseLibraryWindow* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkImage* warning = NULL;
	GtkImage* _tmp6_;
	GtkLabel* title = NULL;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* info = NULL;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkCheckButton* _tmp19_;
	GtkScrolledWindow* _tmp20_;
	GtkTreeView* _tmp21_;
	GtkListStore* _tmp22_;
	GtkTreeView* _tmp23_;
	GtkListStore* _tmp24_;
	GtkButton* _tmp25_;
	GtkButton* cancel = NULL;
	GtkButton* _tmp26_;
	GtkLabel* _tmp27_;
	gchar* title_text = NULL;
	gchar* _tmp28_;
	GeeTreeSet* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	gchar* MARKUP_TEMPLATE = NULL;
	gchar* _tmp46_;
	gchar* title_string = NULL;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	GtkLabel* _tmp53_;
	const gchar* _tmp54_;
	GtkLabel* _tmp55_;
	GtkLabel* _tmp56_;
	GtkCellRendererToggle* toggle = NULL;
	GtkCellRendererToggle* _tmp57_;
	GtkCellRendererToggle* _tmp58_;
	GtkTreeViewColumn* column = NULL;
	GtkTreeViewColumn* _tmp59_;
	GtkTreeViewColumn* _tmp60_;
	GtkTreeViewColumn* _tmp61_;
	GtkCellRendererToggle* _tmp62_;
	GtkTreeViewColumn* _tmp63_;
	GtkCellRendererToggle* _tmp64_;
	GtkTreeView* _tmp65_;
	GtkTreeViewColumn* _tmp66_;
	GtkTreeView* _tmp67_;
	GtkCellRendererText* _tmp68_;
	GtkCellRendererText* _tmp69_;
	GtkTreeView* _tmp70_;
	GtkCellRendererText* _tmp71_;
	GtkCellRendererText* _tmp72_;
	GtkTreeView* _tmp73_;
	GtkCellRendererText* _tmp74_;
	GtkCellRendererText* _tmp75_;
	GtkTreeView* _tmp76_;
	GtkCellRendererText* _tmp77_;
	GtkCellRendererText* _tmp78_;
	GtkTreeView* _tmp79_;
	GtkTreeView* _tmp95_;
	GtkTreeViewColumn* _tmp96_;
	GtkTreeView* _tmp97_;
	GtkTreeViewColumn* _tmp98_;
	GtkTreeView* _tmp99_;
	GtkTreeViewColumn* _tmp100_;
	GtkTreeView* _tmp101_;
	GtkTreeViewColumn* _tmp102_;
	GtkTreeView* _tmp103_;
	GtkTreeViewColumn* _tmp104_;
	GtkTreeView* _tmp105_;
	GtkTreeViewColumn* _tmp106_;
	GeeLinkedList* medias_sorted = NULL;
	GeeLinkedList* _tmp107_;
	GeeLinkedList* _tmp115_;
	GtkScrolledWindow* _tmp143_;
	GtkTreeView* _tmp144_;
	GtkScrolledWindow* _tmp145_;
	GtkButton* _tmp146_;
	GtkBox* information = NULL;
	GtkBox* _tmp147_;
	GtkBox* information_text = NULL;
	GtkBox* _tmp148_;
	GtkImage* _tmp149_;
	GtkLabel* _tmp150_;
	GtkLabel* _tmp151_;
	GtkBox* listBox = NULL;
	GtkBox* _tmp152_;
	GtkScrolledWindow* _tmp153_;
	GtkExpander* _tmp154_;
	GtkButtonBox* bottomButtons = NULL;
	GtkButtonBox* _tmp155_;
	GtkButton* _tmp156_;
	GtkButton* _tmp157_;
	GtkBox* _tmp158_;
	GtkBox* _tmp159_;
	GtkCheckButton* _tmp160_;
	GtkWidget* _tmp161_;
	GtkWidget* _tmp162_;
	GtkBox* _tmp163_;
	GtkWidget* _tmp164_;
	GtkWidget* _tmp165_;
	GtkBox* _tmp166_;
	GtkBox* _tmp167_;
	GtkBox* _tmp168_;
	GtkMenu* _tmp169_;
	GtkMenuItem* _tmp170_;
	GtkMenuItem* _tmp171_;
	GtkMenuItem* _tmp172_;
	GtkButton* _tmp173_;
	GtkCheckButton* _tmp174_;
	GtkButton* _tmp175_;
	GtkBox* _tmp176_;
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (d != NULL, NULL);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (_medias != NULL, NULL);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_data30_ = g_slice_new0 (Block30Data);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_data30_->_ref_count_ = 1;
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self = (NoiseTransferFromDeviceDialog*) g_object_new (object_type, NULL);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_data30_->self = g_object_ref (self);
#line 56 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp0_ = self->priv->medias;
#line 56 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gee_collection_add_all ((GeeCollection*) _tmp0_, _medias);
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp1_ = _g_object_ref0 (d);
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->d);
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self->priv->d = _tmp1_;
#line 59 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_window_set_title ((GtkWindow*) self, _ ("Import from Device"));
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_window_set_type_hint ((GtkWindow*) self, GDK_WINDOW_TYPE_HINT_DIALOG);
#line 64 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp2_ = noise_app_get_main_window ();
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp3_ = _tmp2_;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_window_set_transient_for ((GtkWindow*) self, (GtkWindow*) _tmp3_);
#line 66 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_window_set_destroy_with_parent ((GtkWindow*) self, TRUE);
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_window_set_default_size ((GtkWindow*) self, 550, -1);
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 10);
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp4_);
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->content);
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self->priv->content = _tmp4_;
#line 72 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 20);
#line 72 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp5_);
#line 72 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->padding);
#line 72 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self->priv->padding = _tmp5_;
#line 75 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp6_ = (GtkImage*) gtk_image_new_from_stock ("dialog-question", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 75 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp6_);
#line 75 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	warning = _tmp6_;
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp7_ = noise_device_getDisplayName (d);
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp8_ = _tmp7_;
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp9_ = g_strdup_printf (_ ("Import media from %s"), _tmp8_);
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp10_ = _tmp9_;
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp11_ = (GtkLabel*) gtk_label_new (_tmp10_);
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp11_);
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp12_ = _tmp11_;
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_free0 (_tmp10_);
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_free0 (_tmp8_);
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	title = _tmp12_;
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp13_ = noise_device_getDisplayName (d);
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp14_ = _tmp13_;
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp15_ = g_strdup_printf (_ ("The following files were found on %s, but are not in your library. Che" \
"ck all the files you would like to import."), _tmp14_);
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp16_ = _tmp15_;
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp17_ = (GtkLabel*) gtk_label_new (_tmp16_);
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp17_);
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp18_ = _tmp17_;
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_free0 (_tmp16_);
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_free0 (_tmp14_);
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	info = _tmp18_;
#line 78 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp19_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Import all media"));
#line 78 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp19_);
#line 78 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->transferAll);
#line 78 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self->priv->transferAll = _tmp19_;
#line 79 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp20_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 79 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp20_);
#line 79 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->mediasScroll);
#line 79 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self->priv->mediasScroll = _tmp20_;
#line 80 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp21_ = (GtkTreeView*) gtk_tree_view_new ();
#line 80 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp21_);
#line 80 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->mediasView);
#line 80 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self->priv->mediasView = _tmp21_;
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp22_ = gtk_list_store_new (5, G_TYPE_BOOLEAN, G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, -1);
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->mediasModel);
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self->priv->mediasModel = _tmp22_;
#line 82 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp23_ = self->priv->mediasView;
#line 82 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp24_ = self->priv->mediasModel;
#line 82 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_view_set_model (_tmp23_, (GtkTreeModel*) _tmp24_);
#line 83 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp25_ = (GtkButton*) gtk_button_new_with_label (_ ("Import"));
#line 83 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp25_);
#line 83 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->transfer);
#line 83 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self->priv->transfer = _tmp25_;
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp26_ = (GtkButton*) gtk_button_new_with_label (_ ("Don't Import"));
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp26_);
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	cancel = _tmp26_;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp27_ = title;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp27_, GTK_ALIGN_START);
#line 90 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp28_ = g_strdup ("");
#line 90 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	title_text = _tmp28_;
#line 91 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp29_ = self->priv->medias;
#line 91 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp30_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp29_);
#line 91 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp31_ = _tmp30_;
#line 91 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	if (_tmp31_ > 1) {
#line 714 "TransferFromDeviceDialog.c"
		GeeTreeSet* _tmp32_;
		gint _tmp33_;
		gint _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp32_ = self->priv->medias;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp33_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp32_);
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp34_ = _tmp33_;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp35_ = noise_device_getDisplayName (d);
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp36_ = _tmp35_;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp37_ = g_strdup_printf (_ ("Import %i items from %s"), _tmp34_, _tmp36_);
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_g_free0 (title_text);
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		title_text = _tmp37_;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_g_free0 (_tmp36_);
#line 739 "TransferFromDeviceDialog.c"
	} else {
		NoiseMedia* m = NULL;
		GeeTreeSet* _tmp38_;
		gpointer _tmp39_;
		NoiseMedia* _tmp40_;
		const gchar* _tmp41_;
		const gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
#line 95 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp38_ = self->priv->medias;
#line 95 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp39_ = gee_abstract_sorted_set_first ((GeeAbstractSortedSet*) _tmp38_);
#line 95 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		m = (NoiseMedia*) _tmp39_;
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp40_ = m;
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp41_ = noise_media_get_title (_tmp40_);
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp42_ = _tmp41_;
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp43_ = noise_device_getDisplayName (d);
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp44_ = _tmp43_;
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp45_ = g_strdup_printf (_ ("Import %s from %s"), _tmp42_, _tmp44_);
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_g_free0 (title_text);
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		title_text = _tmp45_;
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_g_free0 (_tmp44_);
#line 91 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_g_object_unref0 (m);
#line 776 "TransferFromDeviceDialog.c"
	}
#line 99 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp46_ = g_strdup ("<span weight=\"bold\" size=\"larger\">%s</span>");
#line 99 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	MARKUP_TEMPLATE = _tmp46_;
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp47_ = MARKUP_TEMPLATE;
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp48_ = title_text;
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp49_ = g_markup_escape_text (_tmp48_, (gssize) -1);
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp50_ = _tmp49_;
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp51_ = g_strdup_printf (_tmp47_, _tmp50_);
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp52_ = _tmp51_;
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_free0 (_tmp50_);
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	title_string = _tmp52_;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp53_ = title;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp54_ = title_string;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_label_set_markup (_tmp53_, _tmp54_);
#line 103 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp55_ = info;
#line 103 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp55_, GTK_ALIGN_START);
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp56_ = info;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_label_set_line_wrap (_tmp56_, TRUE);
#line 107 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp57_ = (GtkCellRendererToggle*) gtk_cell_renderer_toggle_new ();
#line 107 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp57_);
#line 107 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	toggle = _tmp57_;
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp58_ = toggle;
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_signal_connect_object (_tmp58_, "toggled", (GCallback) ___lambda125__gtk_cell_renderer_toggle_toggled, self, 0);
#line 118 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp59_ = gtk_tree_view_column_new ();
#line 118 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp59_);
#line 118 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	column = _tmp59_;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp60_ = column;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_view_column_set_title (_tmp60_, "");
#line 120 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp61_ = column;
#line 120 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp62_ = toggle;
#line 120 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp61_, (GtkCellRenderer*) _tmp62_, FALSE);
#line 121 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp63_ = column;
#line 121 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp64_ = toggle;
#line 121 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp63_, (GtkCellRenderer*) _tmp64_, "active", 0);
#line 122 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp65_ = self->priv->mediasView;
#line 122 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp66_ = column;
#line 122 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_view_append_column (_tmp65_, _tmp66_);
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp67_ = self->priv->mediasView;
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp68_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp68_);
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp69_ = _tmp68_;
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp67_, -1, _ ("ID"), (GtkCellRenderer*) _tmp69_, "text", 1, NULL, NULL);
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (_tmp69_);
#line 125 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp70_ = self->priv->mediasView;
#line 125 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp71_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 125 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp71_);
#line 125 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp72_ = _tmp71_;
#line 125 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp70_, -1, _ ("Title"), (GtkCellRenderer*) _tmp72_, "text", 2, NULL, NULL);
#line 125 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (_tmp72_);
#line 126 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp73_ = self->priv->mediasView;
#line 126 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp74_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 126 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp74_);
#line 126 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp75_ = _tmp74_;
#line 126 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp73_, -1, _ ("Artist"), (GtkCellRenderer*) _tmp75_, "text", 3, NULL, NULL);
#line 126 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (_tmp75_);
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp76_ = self->priv->mediasView;
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp77_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp77_);
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp78_ = _tmp77_;
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp76_, -1, _ ("Album"), (GtkCellRenderer*) _tmp78_, "text", 4, NULL, NULL);
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (_tmp78_);
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp79_ = self->priv->mediasView;
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_view_set_headers_visible (_tmp79_, TRUE);
#line 902 "TransferFromDeviceDialog.c"
	{
		gint i = 0;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		i = 0;
#line 907 "TransferFromDeviceDialog.c"
		{
			gboolean _tmp80_ = FALSE;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp80_ = TRUE;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			while (TRUE) {
#line 914 "TransferFromDeviceDialog.c"
				gint _tmp82_;
				GtkTreeView* _tmp83_;
				gint _tmp84_;
				GtkTreeViewColumn* _tmp85_;
				GtkTreeView* _tmp86_;
				gint _tmp87_;
				GtkTreeViewColumn* _tmp88_;
				GtkTreeView* _tmp89_;
				gint _tmp90_;
				GtkTreeViewColumn* _tmp91_;
				GtkTreeView* _tmp92_;
				gint _tmp93_;
				GtkTreeViewColumn* _tmp94_;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				if (!_tmp80_) {
#line 930 "TransferFromDeviceDialog.c"
					gint _tmp81_;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
					_tmp81_ = i;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
					i = _tmp81_ + 1;
#line 936 "TransferFromDeviceDialog.c"
				}
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				_tmp80_ = FALSE;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				_tmp82_ = i;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				if (!(_tmp82_ < 5)) {
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
					break;
#line 946 "TransferFromDeviceDialog.c"
				}
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				_tmp83_ = self->priv->mediasView;
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				_tmp84_ = i;
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				_tmp85_ = gtk_tree_view_get_column (_tmp83_, _tmp84_);
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				gtk_tree_view_column_set_sizing (_tmp85_, GTK_TREE_VIEW_COLUMN_FIXED);
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				_tmp86_ = self->priv->mediasView;
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				_tmp87_ = i;
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				_tmp88_ = gtk_tree_view_get_column (_tmp86_, _tmp87_);
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				gtk_tree_view_column_set_resizable (_tmp88_, TRUE);
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				_tmp89_ = self->priv->mediasView;
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				_tmp90_ = i;
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				_tmp91_ = gtk_tree_view_get_column (_tmp89_, _tmp90_);
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				gtk_tree_view_column_set_reorderable (_tmp91_, FALSE);
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				_tmp92_ = self->priv->mediasView;
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				_tmp93_ = i;
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				_tmp94_ = gtk_tree_view_get_column (_tmp92_, _tmp93_);
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				gtk_tree_view_column_set_clickable (_tmp94_, FALSE);
#line 980 "TransferFromDeviceDialog.c"
			}
		}
	}
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp95_ = self->priv->mediasView;
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp96_ = gtk_tree_view_get_column (_tmp95_, 1);
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_view_column_set_visible (_tmp96_, FALSE);
#line 139 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp97_ = self->priv->mediasView;
#line 139 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp98_ = gtk_tree_view_get_column (_tmp97_, 0);
#line 139 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_view_column_set_fixed_width (_tmp98_, 25);
#line 140 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp99_ = self->priv->mediasView;
#line 140 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp100_ = gtk_tree_view_get_column (_tmp99_, 1);
#line 140 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_view_column_set_fixed_width (_tmp100_, 10);
#line 141 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp101_ = self->priv->mediasView;
#line 141 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp102_ = gtk_tree_view_get_column (_tmp101_, 2);
#line 141 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_view_column_set_fixed_width (_tmp102_, 300);
#line 142 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp103_ = self->priv->mediasView;
#line 142 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp104_ = gtk_tree_view_get_column (_tmp103_, 3);
#line 142 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_view_column_set_fixed_width (_tmp104_, 125);
#line 143 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp105_ = self->priv->mediasView;
#line 143 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp106_ = gtk_tree_view_get_column (_tmp105_, 4);
#line 143 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_view_column_set_fixed_width (_tmp106_, 125);
#line 148 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp107_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 148 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	medias_sorted = _tmp107_;
#line 1024 "TransferFromDeviceDialog.c"
	{
		GeeIterator* _m_it = NULL;
		GeeTreeSet* _tmp108_;
		GeeIterator* _tmp109_;
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp108_ = self->priv->medias;
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp109_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp108_);
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_m_it = _tmp109_;
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		while (TRUE) {
#line 1037 "TransferFromDeviceDialog.c"
			GeeIterator* _tmp110_;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp111_;
			gpointer _tmp112_;
			GeeLinkedList* _tmp113_;
			NoiseMedia* _tmp114_;
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp110_ = _m_it;
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			if (!gee_iterator_next (_tmp110_)) {
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				break;
#line 1050 "TransferFromDeviceDialog.c"
			}
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp111_ = _m_it;
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp112_ = gee_iterator_get (_tmp111_);
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			m = (NoiseMedia*) _tmp112_;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp113_ = medias_sorted;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp114_ = m;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp113_, _tmp114_);
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_g_object_unref0 (m);
#line 1066 "TransferFromDeviceDialog.c"
		}
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_g_object_unref0 (_m_it);
#line 1070 "TransferFromDeviceDialog.c"
	}
#line 151 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp115_ = medias_sorted;
#line 151 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gee_list_sort ((GeeList*) _tmp115_, _noise_transfer_from_device_dialog_mediaCompareFunc_gcompare_data_func, NULL, NULL);
#line 1076 "TransferFromDeviceDialog.c"
	{
		GeeLinkedList* _s_list = NULL;
		GeeLinkedList* _tmp116_;
		GeeLinkedList* _tmp117_;
		gint _s_size = 0;
		GeeLinkedList* _tmp118_;
		gint _tmp119_;
		gint _tmp120_;
		gint _s_index = 0;
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp116_ = medias_sorted;
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp117_ = _g_object_ref0 (_tmp116_);
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_s_list = _tmp117_;
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp118_ = _s_list;
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp119_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp118_);
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp120_ = _tmp119_;
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_s_size = _tmp120_;
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_s_index = -1;
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		while (TRUE) {
#line 1104 "TransferFromDeviceDialog.c"
			gint _tmp121_;
			gint _tmp122_;
			gint _tmp123_;
			NoiseMedia* s = NULL;
			GeeLinkedList* _tmp124_;
			gint _tmp125_;
			gpointer _tmp126_;
			GtkTreeIter item = {0};
			GtkListStore* _tmp127_;
			GtkTreeIter _tmp128_ = {0};
			GtkListStore* _tmp129_;
			GtkTreeIter _tmp130_;
			NoiseMedia* _tmp131_;
			gint64 _tmp132_;
			gint64 _tmp133_;
			NoiseMedia* _tmp134_;
			const gchar* _tmp135_;
			const gchar* _tmp136_;
			NoiseMedia* _tmp137_;
			const gchar* _tmp138_;
			const gchar* _tmp139_;
			NoiseMedia* _tmp140_;
			const gchar* _tmp141_;
			const gchar* _tmp142_;
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp121_ = _s_index;
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_s_index = _tmp121_ + 1;
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp122_ = _s_index;
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp123_ = _s_size;
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			if (!(_tmp122_ < _tmp123_)) {
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				break;
#line 1141 "TransferFromDeviceDialog.c"
			}
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp124_ = _s_list;
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp125_ = _s_index;
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp126_ = gee_abstract_list_get ((GeeAbstractList*) _tmp124_, _tmp125_);
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			s = (NoiseMedia*) _tmp126_;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp127_ = self->priv->mediasModel;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			gtk_list_store_append (_tmp127_, &_tmp128_);
#line 155 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			item = _tmp128_;
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp129_ = self->priv->mediasModel;
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp130_ = item;
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp131_ = s;
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp132_ = noise_media_get_rowid (_tmp131_);
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp133_ = _tmp132_;
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp134_ = s;
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp135_ = noise_media_get_title (_tmp134_);
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp136_ = _tmp135_;
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp137_ = s;
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp138_ = noise_media_get_artist (_tmp137_);
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp139_ = _tmp138_;
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp140_ = s;
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp141_ = noise_media_get_album (_tmp140_);
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp142_ = _tmp141_;
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			gtk_list_store_set (_tmp129_, &_tmp130_, 0, FALSE, 1, _tmp133_, 2, _tmp136_, 3, _tmp139_, 4, _tmp142_, -1);
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_g_object_unref0 (s);
#line 1189 "TransferFromDeviceDialog.c"
		}
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_g_object_unref0 (_s_list);
#line 1193 "TransferFromDeviceDialog.c"
	}
#line 160 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp143_ = self->priv->mediasScroll;
#line 160 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp144_ = self->priv->mediasView;
#line 160 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp143_, (GtkWidget*) _tmp144_);
#line 161 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp145_ = self->priv->mediasScroll;
#line 161 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_scrolled_window_set_policy (_tmp145_, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 163 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp146_ = self->priv->transfer;
#line 163 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp146_, FALSE);
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp147_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp147_);
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	information = _tmp147_;
#line 167 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp148_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 167 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp148_);
#line 167 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	information_text = _tmp148_;
#line 168 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp149_ = warning;
#line 168 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_box_pack_start (information, (GtkWidget*) _tmp149_, FALSE, FALSE, (guint) 10);
#line 169 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp150_ = title;
#line 169 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_box_pack_start (information_text, (GtkWidget*) _tmp150_, FALSE, TRUE, (guint) 10);
#line 170 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp151_ = info;
#line 170 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_box_pack_start (information_text, (GtkWidget*) _tmp151_, FALSE, TRUE, (guint) 0);
#line 171 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_box_pack_start (information, (GtkWidget*) information_text, TRUE, TRUE, (guint) 10);
#line 173 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp152_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 173 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp152_);
#line 173 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	listBox = _tmp152_;
#line 174 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp153_ = self->priv->mediasScroll;
#line 174 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_box_pack_start (listBox, (GtkWidget*) _tmp153_, TRUE, TRUE, (guint) 5);
#line 176 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp154_ = (GtkExpander*) gtk_expander_new (_ ("Select individual media to import:"));
#line 176 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp154_);
#line 176 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_data30_->exp = _tmp154_;
#line 177 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_container_add ((GtkContainer*) _data30_->exp, (GtkWidget*) listBox);
#line 178 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_expander_set_expanded (_data30_->exp, FALSE);
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp155_ = (GtkButtonBox*) gtk_button_box_new (GTK_ORIENTATION_HORIZONTAL);
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp155_);
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	bottomButtons = _tmp155_;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_button_box_set_layout (bottomButtons, GTK_BUTTONBOX_END);
#line 182 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp156_ = cancel;
#line 182 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_box_pack_end ((GtkBox*) bottomButtons, (GtkWidget*) _tmp156_, FALSE, FALSE, (guint) 10);
#line 183 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp157_ = self->priv->transfer;
#line 183 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_box_pack_end ((GtkBox*) bottomButtons, (GtkWidget*) _tmp157_, FALSE, FALSE, (guint) 0);
#line 184 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_box_set_spacing ((GtkBox*) bottomButtons, 10);
#line 186 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp158_ = self->priv->content;
#line 186 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_box_pack_start (_tmp158_, (GtkWidget*) information, FALSE, TRUE, (guint) 0);
#line 187 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp159_ = self->priv->content;
#line 187 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp160_ = self->priv->transferAll;
#line 187 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp161_ = noise_ui_wrap_alignment ((GtkWidget*) _tmp160_, 5, 0, 0, 75);
#line 187 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp162_ = _tmp161_;
#line 187 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_box_pack_start (_tmp159_, _tmp162_, FALSE, TRUE, (guint) 0);
#line 187 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (_tmp162_);
#line 188 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp163_ = self->priv->content;
#line 188 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp164_ = noise_ui_wrap_alignment ((GtkWidget*) _data30_->exp, 0, 0, 0, 75);
#line 188 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp165_ = _tmp164_;
#line 188 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_box_pack_start (_tmp163_, _tmp165_, TRUE, TRUE, (guint) 0);
#line 188 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (_tmp165_);
#line 189 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp166_ = self->priv->content;
#line 189 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_box_pack_start (_tmp166_, (GtkWidget*) bottomButtons, FALSE, TRUE, (guint) 10);
#line 191 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp167_ = self->priv->padding;
#line 191 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp168_ = self->priv->content;
#line 191 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_box_pack_start (_tmp167_, (GtkWidget*) _tmp168_, TRUE, TRUE, (guint) 10);
#line 193 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp169_ = (GtkMenu*) gtk_menu_new ();
#line 193 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp169_);
#line 193 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->viewMenu);
#line 193 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self->priv->viewMenu = _tmp169_;
#line 194 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp170_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Check Item"));
#line 194 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp170_);
#line 194 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->selectItem);
#line 194 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self->priv->selectItem = _tmp170_;
#line 195 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp171_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Check Album"));
#line 195 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp171_);
#line 195 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->selectAlbum);
#line 195 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self->priv->selectAlbum = _tmp171_;
#line 196 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp172_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Check Artist"));
#line 196 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp172_);
#line 196 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->selectArtist);
#line 196 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self->priv->selectArtist = _tmp172_;
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp173_ = self->priv->transfer;
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_signal_connect_object (_tmp173_, "clicked", (GCallback) _noise_transfer_from_device_dialog_transferClick_gtk_button_clicked, self, 0);
#line 199 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp174_ = self->priv->transferAll;
#line 199 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_signal_connect_object ((GtkToggleButton*) _tmp174_, "toggled", (GCallback) _noise_transfer_from_device_dialog_transferAllToggled_gtk_toggle_button_toggled, self, 0);
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp175_ = cancel;
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_signal_connect_object (_tmp175_, "clicked", (GCallback) ___lambda126__gtk_button_clicked, self, 0);
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_signal_connect_data (_data30_->exp, "activate", (GCallback) ___lambda127__gtk_expander_activate, block30_data_ref (_data30_), (GClosureNotify) block30_data_unref, 0);
#line 213 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp176_ = self->priv->padding;
#line 213 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp176_);
#line 214 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (bottomButtons);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (listBox);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (information_text);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (information);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (medias_sorted);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (column);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (toggle);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_free0 (title_string);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_free0 (MARKUP_TEMPLATE);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_free0 (title_text);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (cancel);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (info);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (title);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (warning);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	block30_data_unref (_data30_);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_data30_ = NULL;
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	return self;
#line 1395 "TransferFromDeviceDialog.c"
}


NoiseTransferFromDeviceDialog*
noise_transfer_from_device_dialog_new (NoiseDevice* d,
                                       GeeCollection* _medias)
{
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	return noise_transfer_from_device_dialog_construct (NOISE_TYPE_TRANSFER_FROM_DEVICE_DIALOG, d, _medias);
#line 1405 "TransferFromDeviceDialog.c"
}


gint
noise_transfer_from_device_dialog_mediaCompareFunc (NoiseMedia* a,
                                                    NoiseMedia* b)
{
	gint result = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp0_ = noise_media_get_artist (a);
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp1_ = _tmp0_;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp2_ = noise_media_get_artist (b);
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp3_ = _tmp2_;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	if (g_strcmp0 (_tmp1_, _tmp3_) == 0) {
#line 1432 "TransferFromDeviceDialog.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp4_ = noise_media_get_album (a);
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp5_ = _tmp4_;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp6_ = noise_media_get_album (b);
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp7_ = _tmp6_;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		if (g_strcmp0 (_tmp5_, _tmp7_) == 0) {
#line 1447 "TransferFromDeviceDialog.c"
			guint _tmp8_;
			guint _tmp9_;
			guint _tmp10_;
			guint _tmp11_;
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp8_ = noise_media_get_track (a);
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp9_ = _tmp8_;
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp10_ = noise_media_get_track (b);
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp11_ = _tmp10_;
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			result = ((gint) _tmp9_) - ((gint) _tmp11_);
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			return result;
#line 1464 "TransferFromDeviceDialog.c"
		} else {
			gint _tmp12_ = 0;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
#line 222 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp13_ = noise_media_get_album (a);
#line 222 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp14_ = _tmp13_;
#line 222 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp15_ = noise_media_get_album (b);
#line 222 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp16_ = _tmp15_;
#line 222 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			if (g_strcmp0 (_tmp14_, _tmp16_) > 0) {
#line 222 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				_tmp12_ = 1;
#line 1483 "TransferFromDeviceDialog.c"
			} else {
#line 222 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
				_tmp12_ = -1;
#line 1487 "TransferFromDeviceDialog.c"
			}
#line 222 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			result = _tmp12_;
#line 222 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			return result;
#line 1493 "TransferFromDeviceDialog.c"
		}
	} else {
		gint _tmp17_ = 0;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
#line 226 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp18_ = noise_media_get_artist (a);
#line 226 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp19_ = _tmp18_;
#line 226 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp20_ = noise_media_get_artist (b);
#line 226 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp21_ = _tmp20_;
#line 226 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		if (g_strcmp0 (_tmp19_, _tmp21_) > 0) {
#line 226 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp17_ = 1;
#line 1513 "TransferFromDeviceDialog.c"
		} else {
#line 226 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
			_tmp17_ = -1;
#line 1517 "TransferFromDeviceDialog.c"
		}
#line 226 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		result = _tmp17_;
#line 226 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		return result;
#line 1523 "TransferFromDeviceDialog.c"
	}
}


GtkAlignment*
noise_transfer_from_device_dialog_wrap_alignment (GtkWidget* widget,
                                                  gint top,
                                                  gint right,
                                                  gint bottom,
                                                  gint left)
{
	GtkAlignment* result = NULL;
	GtkAlignment* alignment = NULL;
	GtkAlignment* _tmp0_;
#line 229 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 230 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp0_ = (GtkAlignment*) gtk_alignment_new (0.0f, 0.0f, 1.0f, 1.0f);
#line 230 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_ref_sink (_tmp0_);
#line 230 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	alignment = _tmp0_;
#line 231 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_set (alignment, "top-padding", (guint) top, NULL);
#line 232 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_set (alignment, "right-padding", (guint) right, NULL);
#line 233 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_set (alignment, "bottom-padding", (guint) bottom, NULL);
#line 234 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_object_set (alignment, "left-padding", (guint) left, NULL);
#line 236 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_container_add ((GtkContainer*) alignment, widget);
#line 237 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	result = alignment;
#line 237 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	return result;
#line 1560 "TransferFromDeviceDialog.c"
}


gboolean
noise_transfer_from_device_dialog_updateTransferSensetivity (NoiseTransferFromDeviceDialog* self,
                                                             GtkTreeModel* model,
                                                             GtkTreePath* path,
                                                             GtkTreeIter* iter)
{
	gboolean result = FALSE;
	gboolean sel = FALSE;
	GtkTreeIter _tmp0_;
	gboolean _tmp1_;
#line 240 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 240 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 240 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 240 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 241 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	sel = FALSE;
#line 242 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp0_ = *iter;
#line 242 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_model_get (model, &_tmp0_, 0, &sel, -1);
#line 244 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp1_ = sel;
#line 244 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	if (_tmp1_) {
#line 1592 "TransferFromDeviceDialog.c"
		GtkButton* _tmp2_;
#line 245 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp2_ = self->priv->transfer;
#line 245 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, TRUE);
#line 246 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		result = TRUE;
#line 246 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		return result;
#line 1602 "TransferFromDeviceDialog.c"
	}
#line 249 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	result = FALSE;
#line 249 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	return result;
#line 1608 "TransferFromDeviceDialog.c"
}


gboolean
noise_transfer_from_device_dialog_selectAll (NoiseTransferFromDeviceDialog* self,
                                             GtkTreeModel* model,
                                             GtkTreePath* path,
                                             GtkTreeIter* iter)
{
	gboolean result = FALSE;
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
#line 252 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 252 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 252 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 252 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 253 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp0_ = self->priv->mediasModel;
#line 253 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp1_ = *iter;
#line 253 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_list_store_set (_tmp0_, &_tmp1_, 0, TRUE, -1);
#line 255 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	result = FALSE;
#line 255 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	return result;
#line 1639 "TransferFromDeviceDialog.c"
}


gboolean
noise_transfer_from_device_dialog_unselectAll (NoiseTransferFromDeviceDialog* self,
                                               GtkTreeModel* model,
                                               GtkTreePath* path,
                                               GtkTreeIter* iter)
{
	gboolean result = FALSE;
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
#line 258 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 258 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 258 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 258 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 259 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp0_ = self->priv->mediasModel;
#line 259 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp1_ = *iter;
#line 259 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_list_store_set (_tmp0_, &_tmp1_, 0, FALSE, -1);
#line 261 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	result = FALSE;
#line 261 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	return result;
#line 1670 "TransferFromDeviceDialog.c"
}


static gboolean
_noise_transfer_from_device_dialog_selectAll_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                          GtkTreePath* path,
                                                                          GtkTreeIter* iter,
                                                                          gpointer self)
{
	gboolean result;
	result = noise_transfer_from_device_dialog_selectAll ((NoiseTransferFromDeviceDialog*) self, model, path, iter);
#line 266 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	return result;
#line 1684 "TransferFromDeviceDialog.c"
}


static gboolean
_noise_transfer_from_device_dialog_unselectAll_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                            GtkTreePath* path,
                                                                            GtkTreeIter* iter,
                                                                            gpointer self)
{
	gboolean result;
	result = noise_transfer_from_device_dialog_unselectAll ((NoiseTransferFromDeviceDialog*) self, model, path, iter);
#line 270 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	return result;
#line 1698 "TransferFromDeviceDialog.c"
}


static void
noise_transfer_from_device_dialog_real_transferAllToggled (NoiseTransferFromDeviceDialog* self)
{
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp0_ = self->priv->transferAll;
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp2_ = _tmp1_;
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	if (_tmp2_) {
#line 1716 "TransferFromDeviceDialog.c"
		GtkListStore* _tmp3_;
		GtkTreeView* _tmp4_;
		GtkButton* _tmp5_;
#line 266 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp3_ = self->priv->mediasModel;
#line 266 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		gtk_tree_model_foreach ((GtkTreeModel*) _tmp3_, _noise_transfer_from_device_dialog_selectAll_gtk_tree_model_foreach_func, self);
#line 267 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp4_ = self->priv->mediasView;
#line 267 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, FALSE);
#line 268 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp5_ = self->priv->transfer;
#line 268 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, TRUE);
#line 1732 "TransferFromDeviceDialog.c"
	} else {
		GtkListStore* _tmp6_;
		GtkTreeView* _tmp7_;
		GtkButton* _tmp8_;
#line 270 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp6_ = self->priv->mediasModel;
#line 270 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		gtk_tree_model_foreach ((GtkTreeModel*) _tmp6_, _noise_transfer_from_device_dialog_unselectAll_gtk_tree_model_foreach_func, self);
#line 271 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp7_ = self->priv->mediasView;
#line 271 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, TRUE);
#line 272 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp8_ = self->priv->transfer;
#line 272 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
#line 1749 "TransferFromDeviceDialog.c"
	}
}


void
noise_transfer_from_device_dialog_transferAllToggled (NoiseTransferFromDeviceDialog* self)
{
#line 264 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_if_fail (self != NULL);
#line 264 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	NOISE_TRANSFER_FROM_DEVICE_DIALOG_GET_CLASS (self)->transferAllToggled (self);
#line 1761 "TransferFromDeviceDialog.c"
}


gboolean
noise_transfer_from_device_dialog_createTransferList (NoiseTransferFromDeviceDialog* self,
                                                      GtkTreeModel* model,
                                                      GtkTreePath* path,
                                                      GtkTreeIter* iter)
{
	gboolean result = FALSE;
	NoiseMedia* m = NULL;
	gboolean selected = FALSE;
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
	gboolean _tmp2_ = FALSE;
	NoiseMedia* _tmp3_;
#line 276 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 276 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 276 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 276 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 277 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	m = NULL;
#line 278 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	selected = FALSE;
#line 279 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp0_ = self->priv->mediasModel;
#line 279 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp1_ = *iter;
#line 279 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp0_, &_tmp1_, 0, &selected, 1, &m, -1);
#line 281 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp3_ = m;
#line 281 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	if (_tmp3_ != NULL) {
#line 1800 "TransferFromDeviceDialog.c"
		gboolean _tmp4_;
#line 281 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp4_ = selected;
#line 281 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp2_ = _tmp4_;
#line 1806 "TransferFromDeviceDialog.c"
	} else {
#line 281 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp2_ = FALSE;
#line 1810 "TransferFromDeviceDialog.c"
	}
#line 281 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	if (_tmp2_) {
#line 1814 "TransferFromDeviceDialog.c"
		GeeTreeSet* _tmp5_;
		NoiseMedia* _tmp6_;
#line 282 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp5_ = self->priv->to_transfer;
#line 282 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp6_ = m;
#line 282 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp6_);
#line 1823 "TransferFromDeviceDialog.c"
	}
#line 285 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	result = FALSE;
#line 285 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (m);
#line 285 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	return result;
#line 1831 "TransferFromDeviceDialog.c"
}


static gboolean
_noise_transfer_from_device_dialog_createTransferList_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                                   GtkTreePath* path,
                                                                                   GtkTreeIter* iter,
                                                                                   gpointer self)
{
	gboolean result;
	result = noise_transfer_from_device_dialog_createTransferList ((NoiseTransferFromDeviceDialog*) self, model, path, iter);
#line 290 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	return result;
#line 1845 "TransferFromDeviceDialog.c"
}


static void
noise_transfer_from_device_dialog_real_transferClick (NoiseTransferFromDeviceDialog* self)
{
	GeeTreeSet* _tmp0_;
	GtkListStore* _tmp1_;
	NoiseLibrariesManager* _tmp2_;
	NoiseLibrary* _tmp3_;
#line 289 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp0_ = self->priv->to_transfer;
#line 289 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 290 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp1_ = self->priv->mediasModel;
#line 290 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_tree_model_foreach ((GtkTreeModel*) _tmp1_, _noise_transfer_from_device_dialog_createTransferList_gtk_tree_model_foreach_func, self);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp2_ = noise_libraries_manager;
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp3_ = _tmp2_->local_library;
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	if (noise_library_doing_file_operations (_tmp3_)) {
#line 1870 "TransferFromDeviceDialog.c"
		NoiseNotificationManager* _tmp4_;
		NoiseNotificationManager* _tmp5_;
		NoiseDevice* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 293 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp4_ = noise_notification_manager_get_default ();
#line 293 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp5_ = _tmp4_;
#line 293 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp6_ = self->priv->d;
#line 293 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp7_ = noise_device_getDisplayName (_tmp6_);
#line 293 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp8_ = _tmp7_;
#line 293 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp9_ = g_strdup_printf (_ ("Noise is already doing file operations. Please wait until those finish" \
" to import from %s"), _tmp8_);
#line 293 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp10_ = _tmp9_;
#line 293 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		g_signal_emit_by_name (_tmp5_, "show-alert", _ ("Cannot Import"), _tmp10_);
#line 293 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_g_free0 (_tmp10_);
#line 293 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_g_free0 (_tmp8_);
#line 293 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_g_object_unref0 (_tmp5_);
#line 1900 "TransferFromDeviceDialog.c"
	} else {
		NoiseLibrariesManager* _tmp11_;
		GeeTreeSet* _tmp12_;
#line 295 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp11_ = noise_libraries_manager;
#line 295 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		_tmp12_ = self->priv->to_transfer;
#line 295 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		noise_libraries_manager_transfer_to_local_library (_tmp11_, (GeeCollection*) _tmp12_);
#line 296 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
		gtk_widget_destroy ((GtkWidget*) self);
#line 1912 "TransferFromDeviceDialog.c"
	}
}


void
noise_transfer_from_device_dialog_transferClick (NoiseTransferFromDeviceDialog* self)
{
#line 288 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_if_fail (self != NULL);
#line 288 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	NOISE_TRANSFER_FROM_DEVICE_DIALOG_GET_CLASS (self)->transferClick (self);
#line 1924 "TransferFromDeviceDialog.c"
}


static void
noise_transfer_from_device_dialog_real_cancelClick (NoiseTransferFromDeviceDialog* self)
{
#line 301 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 1933 "TransferFromDeviceDialog.c"
}


void
noise_transfer_from_device_dialog_cancelClick (NoiseTransferFromDeviceDialog* self)
{
#line 300 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_return_if_fail (self != NULL);
#line 300 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	NOISE_TRANSFER_FROM_DEVICE_DIALOG_GET_CLASS (self)->cancelClick (self);
#line 1944 "TransferFromDeviceDialog.c"
}


static void
noise_transfer_from_device_dialog_class_init (NoiseTransferFromDeviceDialogClass * klass)
{
#line 34 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	noise_transfer_from_device_dialog_parent_class = g_type_class_peek_parent (klass);
#line 34 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	g_type_class_add_private (klass, sizeof (NoiseTransferFromDeviceDialogPrivate));
#line 34 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	((NoiseTransferFromDeviceDialogClass *) klass)->transferAllToggled = (void (*) (NoiseTransferFromDeviceDialog *)) noise_transfer_from_device_dialog_real_transferAllToggled;
#line 34 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	((NoiseTransferFromDeviceDialogClass *) klass)->transferClick = (void (*) (NoiseTransferFromDeviceDialog *)) noise_transfer_from_device_dialog_real_transferClick;
#line 34 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	((NoiseTransferFromDeviceDialogClass *) klass)->cancelClick = (void (*) (NoiseTransferFromDeviceDialog *)) noise_transfer_from_device_dialog_real_cancelClick;
#line 34 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_transfer_from_device_dialog_finalize;
#line 1963 "TransferFromDeviceDialog.c"
}


static void
noise_transfer_from_device_dialog_instance_init (NoiseTransferFromDeviceDialog * self)
{
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
#line 34 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self->priv = NOISE_TRANSFER_FROM_DEVICE_DIALOG_GET_PRIVATE (self);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp0_ = gee_tree_set_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self->priv->medias = _tmp0_;
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_tmp1_ = gee_tree_set_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self->priv->to_transfer = _tmp1_;
#line 1982 "TransferFromDeviceDialog.c"
}


static void
noise_transfer_from_device_dialog_finalize (GObject * obj)
{
	NoiseTransferFromDeviceDialog * self;
#line 34 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_TRANSFER_FROM_DEVICE_DIALOG, NoiseTransferFromDeviceDialog);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->medias);
#line 36 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->d);
#line 39 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->content);
#line 40 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->padding);
#line 42 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->transferAll);
#line 43 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->mediasScroll);
#line 44 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->mediasView);
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->mediasModel);
#line 46 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->transfer);
#line 48 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->viewMenu);
#line 49 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->selectItem);
#line 50 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->selectAlbum);
#line 51 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->selectArtist);
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	_g_object_unref0 (self->priv->to_transfer);
#line 34 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/TransferFromDeviceDialog.vala"
	G_OBJECT_CLASS (noise_transfer_from_device_dialog_parent_class)->finalize (obj);
#line 2022 "TransferFromDeviceDialog.c"
}


GType
noise_transfer_from_device_dialog_get_type (void)
{
	static volatile gsize noise_transfer_from_device_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&noise_transfer_from_device_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseTransferFromDeviceDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_transfer_from_device_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseTransferFromDeviceDialog), 0, (GInstanceInitFunc) noise_transfer_from_device_dialog_instance_init, NULL };
		GType noise_transfer_from_device_dialog_type_id;
		noise_transfer_from_device_dialog_type_id = g_type_register_static (gtk_window_get_type (), "NoiseTransferFromDeviceDialog", &g_define_type_info, 0);
		g_once_init_leave (&noise_transfer_from_device_dialog_type_id__volatile, noise_transfer_from_device_dialog_type_id);
	}
	return noise_transfer_from_device_dialog_type_id__volatile;
}



