/* Streamer.c generated by valac 0.40.4, the Vala compiler
 * generated from Streamer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */


#include <glib.h>
#include <glib-object.h>
#include <noise-core.h>
#include <gst/gst.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gst/pbutils/pbutils.h>


#define NOISE_TYPE_STREAMER (noise_streamer_get_type ())
#define NOISE_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_STREAMER, NoiseStreamer))
#define NOISE_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_STREAMER, NoiseStreamerClass))
#define NOISE_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_STREAMER))
#define NOISE_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_STREAMER))
#define NOISE_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_STREAMER, NoiseStreamerClass))

typedef struct _NoiseStreamer NoiseStreamer;
typedef struct _NoiseStreamerClass NoiseStreamerClass;
typedef struct _NoiseStreamerPrivate NoiseStreamerPrivate;

#define NOISE_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG (noise_install_gstreamer_plugins_dialog_get_type ())
#define NOISE_INSTALL_GSTREAMER_PLUGINS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG, NoiseInstallGstreamerPluginsDialog))
#define NOISE_INSTALL_GSTREAMER_PLUGINS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG, NoiseInstallGstreamerPluginsDialogClass))
#define NOISE_IS_INSTALL_GSTREAMER_PLUGINS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG))
#define NOISE_IS_INSTALL_GSTREAMER_PLUGINS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG))
#define NOISE_INSTALL_GSTREAMER_PLUGINS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG, NoiseInstallGstreamerPluginsDialogClass))

typedef struct _NoiseInstallGstreamerPluginsDialog NoiseInstallGstreamerPluginsDialog;
typedef struct _NoiseInstallGstreamerPluginsDialogClass NoiseInstallGstreamerPluginsDialogClass;
enum  {
	NOISE_STREAMER_0_PROPERTY,
	NOISE_STREAMER_NUM_PROPERTIES
};
static GParamSpec* noise_streamer_properties[NOISE_STREAMER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NOISE_TYPE_PLAYBACK_MANAGER (noise_playback_manager_get_type ())
#define NOISE_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager))
#define NOISE_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))
#define NOISE_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))

typedef struct _NoisePlaybackManager NoisePlaybackManager;
typedef struct _NoisePlaybackManagerClass NoisePlaybackManagerClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))

struct _NoiseStreamer {
	GObject parent_instance;
	NoiseStreamerPrivate * priv;
	GstElement* cdda;
	gboolean set_resume_pos;
};

struct _NoiseStreamerClass {
	GObjectClass parent_class;
};

struct _NoiseStreamerPrivate {
	NoisePipeline* pipe;
	NoiseInstallGstreamerPluginsDialog* dialog;
};


static gpointer noise_streamer_parent_class = NULL;
static NoisePlaybackIface * noise_streamer_noise_playback_parent_iface = NULL;

GType noise_streamer_get_type (void) G_GNUC_CONST;
GType noise_install_gstreamer_plugins_dialog_get_type (void) G_GNUC_CONST;
#define NOISE_STREAMER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_STREAMER, NoiseStreamerPrivate))
NoiseStreamer* noise_streamer_new (void);
NoiseStreamer* noise_streamer_construct (GType object_type);
static gboolean noise_streamer_bus_callback (NoiseStreamer* self,
                                      GstBus* bus,
                                      GstMessage* message);
static gboolean _noise_streamer_bus_callback_gst_bus_func (GstBus* bus,
                                                    GstMessage* message,
                                                    gpointer self);
static gboolean _noise_playback_update_position_gsource_func (gpointer self);
static GeeCollection* noise_streamer_real_get_supported_uri (NoisePlayback* base);
static gboolean noise_streamer_real_update_position (NoisePlayback* base);
GType noise_playback_manager_get_type (void) G_GNUC_CONST;
NoisePlaybackManager* noise_app_get_player (void);
NoiseMedia* noise_playback_manager_get_current_media (NoisePlaybackManager* self);
static void noise_streamer_real_play (NoisePlayback* base);
static void noise_streamer_real_pause (NoisePlayback* base);
static void noise_streamer_real_set_state (NoisePlayback* base,
                                    GstState s);
static void noise_streamer_real_set_media (NoisePlayback* base,
                                    NoiseMedia* media);
static void noise_streamer_real_set_position (NoisePlayback* base,
                                       gint64 pos);
static gint64 noise_streamer_real_get_position (NoisePlayback* base);
static gint64 noise_streamer_real_get_duration (NoisePlayback* base);
static void noise_streamer_real_set_volume (NoisePlayback* base,
                                     gdouble val);
static gdouble noise_streamer_real_get_volume (NoisePlayback* base);
static void noise_streamer_real_enable_equalizer (NoisePlayback* base);
static void noise_streamer_real_disable_equalizer (NoisePlayback* base);
static void noise_streamer_real_set_equalizer_gain (NoisePlayback* base,
                                             gint index,
                                             gint val);
NoiseInstallGstreamerPluginsDialog* noise_install_gstreamer_plugins_dialog_new (GstMessage* message);
NoiseInstallGstreamerPluginsDialog* noise_install_gstreamer_plugins_dialog_construct (GType object_type,
                                                                                      GstMessage* message);
static void noise_streamer_finalize (GObject * obj);


static gboolean
_noise_streamer_bus_callback_gst_bus_func (GstBus* bus,
                                           GstMessage* message,
                                           gpointer self)
{
	gboolean result;
	result = noise_streamer_bus_callback ((NoiseStreamer*) self, bus, message);
#line 46 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	return result;
#line 158 "Streamer.c"
}


static gboolean
_noise_playback_update_position_gsource_func (gpointer self)
{
	gboolean result;
	result = noise_playback_update_position ((NoisePlayback*) self);
#line 50 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	return result;
#line 169 "Streamer.c"
}


NoiseStreamer*
noise_streamer_construct (GType object_type)
{
	NoiseStreamer * self = NULL;
	NoisePipeline* _tmp0_;
	NoisePipeline* _tmp1_;
	GstBus* _tmp2_;
#line 43 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self = (NoiseStreamer*) g_object_new (object_type, NULL);
#line 44 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp0_ = noise_pipeline_new ();
#line 44 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_g_object_unref0 (self->priv->pipe);
#line 44 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self->priv->pipe = _tmp0_;
#line 46 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp1_ = self->priv->pipe;
#line 46 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp2_ = _tmp1_->bus;
#line 46 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	gst_bus_add_watch_full (_tmp2_, G_PRIORITY_DEFAULT, _noise_streamer_bus_callback_gst_bus_func, g_object_ref (self), g_object_unref);
#line 50 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _noise_playback_update_position_gsource_func, g_object_ref ((NoisePlayback*) self), g_object_unref);
#line 43 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	return self;
#line 198 "Streamer.c"
}


NoiseStreamer*
noise_streamer_new (void)
{
#line 43 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	return noise_streamer_construct (NOISE_TYPE_STREAMER);
#line 207 "Streamer.c"
}


static GeeCollection*
noise_streamer_real_get_supported_uri (NoisePlayback* base)
{
	NoiseStreamer * self;
	GeeCollection* result = NULL;
	GeeLinkedList* uris = NULL;
	GeeLinkedList* _tmp0_;
#line 53 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self = (NoiseStreamer*) base;
#line 54 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 54 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	uris = _tmp0_;
#line 55 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "file://");
#line 56 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "http://");
#line 57 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "smb://");
#line 58 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	result = (GeeCollection*) uris;
#line 58 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	return result;
#line 234 "Streamer.c"
}


static gboolean
noise_streamer_real_update_position (NoisePlayback* base)
{
	NoiseStreamer * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 61 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self = (NoiseStreamer*) base;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp1_ = self->set_resume_pos;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	if (_tmp1_) {
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		_tmp0_ = TRUE;
#line 253 "Streamer.c"
	} else {
		gboolean _tmp2_ = FALSE;
		NoisePlaybackManager* _tmp3_;
		NoisePlaybackManager* _tmp4_;
		NoiseMedia* _tmp5_;
		NoiseMedia* _tmp6_;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		_tmp3_ = noise_app_get_player ();
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		_tmp4_ = _tmp3_;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		_tmp5_ = noise_playback_manager_get_current_media (_tmp4_);
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		_tmp6_ = _tmp5_;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		if (_tmp6_ != NULL) {
#line 270 "Streamer.c"
			NoisePlaybackManager* _tmp7_;
			NoisePlaybackManager* _tmp8_;
			NoiseMedia* _tmp9_;
			NoiseMedia* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp7_ = noise_app_get_player ();
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp8_ = _tmp7_;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp9_ = noise_playback_manager_get_current_media (_tmp8_);
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp10_ = _tmp9_;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp11_ = noise_media_get_resume_pos (_tmp10_);
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp12_ = _tmp11_;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp2_ = noise_playback_get_position ((NoisePlayback*) self) >= (((gint64) (_tmp12_ - 1)) * 1000000000);
#line 291 "Streamer.c"
		} else {
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp2_ = FALSE;
#line 295 "Streamer.c"
		}
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		_tmp0_ = _tmp2_;
#line 299 "Streamer.c"
	}
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	if (_tmp0_) {
#line 63 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		self->set_resume_pos = TRUE;
#line 64 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		g_signal_emit_by_name ((NoisePlayback*) self, "current-position-update", noise_playback_get_position ((NoisePlayback*) self));
#line 307 "Streamer.c"
	} else {
		NoisePlaybackManager* _tmp13_;
		NoisePlaybackManager* _tmp14_;
		NoiseMedia* _tmp15_;
		NoiseMedia* _tmp16_;
#line 66 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		_tmp13_ = noise_app_get_player ();
#line 66 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		_tmp14_ = _tmp13_;
#line 66 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		_tmp15_ = noise_playback_manager_get_current_media (_tmp14_);
#line 66 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		_tmp16_ = _tmp15_;
#line 66 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		if (_tmp16_ != NULL) {
#line 323 "Streamer.c"
			NoisePipeline* _tmp17_;
			GstElement* _tmp18_;
			NoisePlaybackManager* _tmp19_;
			NoisePlaybackManager* _tmp20_;
			NoiseMedia* _tmp21_;
			NoiseMedia* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
#line 67 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp17_ = self->priv->pipe;
#line 67 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp18_ = _tmp17_->playbin;
#line 67 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp19_ = noise_app_get_player ();
#line 67 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp20_ = _tmp19_;
#line 67 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp21_ = noise_playback_manager_get_current_media (_tmp20_);
#line 67 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp22_ = _tmp21_;
#line 67 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp23_ = noise_media_get_resume_pos (_tmp22_);
#line 67 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp24_ = _tmp23_;
#line 67 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			gst_element_seek_simple (_tmp18_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp24_) * 1000000000);
#line 350 "Streamer.c"
		}
	}
#line 70 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	result = TRUE;
#line 70 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	return result;
#line 357 "Streamer.c"
}


static void
noise_streamer_real_play (NoisePlayback* base)
{
	NoiseStreamer * self;
#line 74 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self = (NoiseStreamer*) base;
#line 75 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_PLAYING);
#line 369 "Streamer.c"
}


static void
noise_streamer_real_pause (NoisePlayback* base)
{
	NoiseStreamer * self;
#line 78 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self = (NoiseStreamer*) base;
#line 79 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_PAUSED);
#line 381 "Streamer.c"
}


static void
noise_streamer_real_set_state (NoisePlayback* base,
                               GstState s)
{
	NoiseStreamer * self;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
#line 82 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self = (NoiseStreamer*) base;
#line 83 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp0_ = self->priv->pipe;
#line 83 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 83 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	gst_element_set_state (_tmp1_, s);
#line 400 "Streamer.c"
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 423 "Streamer.c"
	} else {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 427 "Streamer.c"
	}
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 433 "Streamer.c"
	} else {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 437 "Streamer.c"
	}
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 441 "Streamer.c"
		gchar* _tmp2_;
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp2_;
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 449 "Streamer.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		regex = _tmp6_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 477 "Streamer.c"
				goto __catch84_g_regex_error;
			}
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			return NULL;
#line 486 "Streamer.c"
		}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp8_ = regex;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 500 "Streamer.c"
				goto __catch84_g_regex_error;
			}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			return NULL;
#line 511 "Streamer.c"
		}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp10_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 525 "Streamer.c"
	}
	goto __finally84;
	__catch84_g_regex_error:
	{
		GError* e = NULL;
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1429 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 539 "Streamer.c"
	}
	__finally84:
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return NULL;
#line 550 "Streamer.c"
	}
}


static void
noise_streamer_real_set_media (NoisePlayback* base,
                               NoiseMedia* media)
{
	NoiseStreamer * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	NoisePipeline* _tmp3_;
	GstElement* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GValue _tmp9_ = {0};
	NoisePlaybackManager* _tmp10_;
	NoisePlaybackManager* _tmp11_;
	NoiseMedia* _tmp12_;
	NoiseMedia* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	NoisePipeline* _tmp16_;
	GstElement* _tmp17_;
	NoisePlaybackManager* _tmp18_;
	NoisePlaybackManager* _tmp19_;
	NoiseMedia* _tmp20_;
	NoiseMedia* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
#line 86 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self = (NoiseStreamer*) base;
#line 86 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	g_return_if_fail (media != NULL);
#line 87 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_READY);
#line 88 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp0_ = noise_media_get_uri (media);
#line 88 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp1_ = _tmp0_;
#line 88 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp2_ = _tmp1_;
#line 88 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	g_debug ("Streamer.vala:88: set uri to %s\n", _tmp2_);
#line 88 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_g_free0 (_tmp2_);
#line 90 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp3_ = self->priv->pipe;
#line 90 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp4_ = _tmp3_->playbin;
#line 90 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp5_ = noise_media_get_uri (media);
#line 90 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp6_ = _tmp5_;
#line 90 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp7_ = _tmp6_;
#line 90 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp8_ = string_replace (_tmp7_, "#", "%23");
#line 90 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	g_value_init (&_tmp9_, G_TYPE_STRING);
#line 90 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	g_value_take_string (&_tmp9_, _tmp8_);
#line 90 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	g_object_set_property ((GObject*) _tmp4_, "uri", &_tmp9_);
#line 90 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	G_IS_VALUE (&_tmp9_) ? (g_value_unset (&_tmp9_), NULL) : NULL;
#line 90 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_g_free0 (_tmp7_);
#line 92 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_PLAYING);
#line 94 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp10_ = noise_app_get_player ();
#line 94 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp11_ = _tmp10_;
#line 94 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp12_ = noise_playback_manager_get_current_media (_tmp11_);
#line 94 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp13_ = _tmp12_;
#line 94 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp14_ = noise_media_get_resume_pos (_tmp13_);
#line 94 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp15_ = _tmp14_;
#line 94 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	g_debug ("Streamer.vala:94: setURI seeking to %d\n", _tmp15_);
#line 95 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp16_ = self->priv->pipe;
#line 95 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp17_ = _tmp16_->playbin;
#line 95 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp18_ = noise_app_get_player ();
#line 95 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp19_ = _tmp18_;
#line 95 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp20_ = noise_playback_manager_get_current_media (_tmp19_);
#line 95 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp21_ = _tmp20_;
#line 95 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp22_ = noise_media_get_resume_pos (_tmp21_);
#line 95 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp23_ = _tmp22_;
#line 95 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	gst_element_seek_simple (_tmp17_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp23_) * 1000000000);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	noise_playback_play ((NoisePlayback*) self);
#line 658 "Streamer.c"
}


static void
noise_streamer_real_set_position (NoisePlayback* base,
                                  gint64 pos)
{
	NoiseStreamer * self;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
#line 100 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self = (NoiseStreamer*) base;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp0_ = self->priv->pipe;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	gst_element_seek (_tmp1_, 1.0, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, GST_SEEK_TYPE_SET, pos, GST_SEEK_TYPE_NONE, noise_playback_get_duration ((NoisePlayback*) self));
#line 677 "Streamer.c"
}


static gint64
noise_streamer_real_get_position (NoisePlayback* base)
{
	NoiseStreamer * self;
	gint64 result = 0LL;
	gint64 rv = 0LL;
	GstFormat f = 0;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
#line 107 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self = (NoiseStreamer*) base;
#line 108 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	rv = (gint64) 0;
#line 109 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	f = GST_FORMAT_TIME;
#line 111 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp0_ = self->priv->pipe;
#line 111 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 111 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	gst_element_query_position (_tmp1_, f, &_tmp2_);
#line 111 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	rv = _tmp2_;
#line 113 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	result = rv;
#line 113 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	return result;
#line 709 "Streamer.c"
}


static gint64
noise_streamer_real_get_duration (NoisePlayback* base)
{
	NoiseStreamer * self;
	gint64 result = 0LL;
	gint64 rv = 0LL;
	GstFormat f = 0;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self = (NoiseStreamer*) base;
#line 117 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	rv = (gint64) 0;
#line 118 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	f = GST_FORMAT_TIME;
#line 120 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp0_ = self->priv->pipe;
#line 120 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 120 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	gst_element_query_duration (_tmp1_, f, &_tmp2_);
#line 120 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	rv = _tmp2_;
#line 122 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	result = rv;
#line 122 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	return result;
#line 741 "Streamer.c"
}


static void
noise_streamer_real_set_volume (NoisePlayback* base,
                                gdouble val)
{
	NoiseStreamer * self;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	GValue _tmp2_ = {0};
#line 125 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self = (NoiseStreamer*) base;
#line 126 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp0_ = self->priv->pipe;
#line 126 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 126 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	g_value_init (&_tmp2_, G_TYPE_DOUBLE);
#line 126 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	g_value_set_double (&_tmp2_, val);
#line 126 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	g_object_set_property ((GObject*) _tmp1_, "volume", &_tmp2_);
#line 126 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	G_IS_VALUE (&_tmp2_) ? (g_value_unset (&_tmp2_), NULL) : NULL;
#line 767 "Streamer.c"
}


static gdouble
noise_streamer_real_get_volume (NoisePlayback* base)
{
	NoiseStreamer * self;
	gdouble result = 0.0;
	GValue val = {0};
	GValue _tmp0_ = {0};
	NoisePipeline* _tmp1_;
	GstElement* _tmp2_;
	GValue _tmp3_;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self = (NoiseStreamer*) base;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	g_value_init (&_tmp0_, G_TYPE_DOUBLE);
#line 130 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	val = _tmp0_;
#line 131 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp1_ = self->priv->pipe;
#line 131 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp2_ = _tmp1_->playbin;
#line 131 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	g_object_get_property ((GObject*) _tmp2_, "volume", &val);
#line 132 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp3_ = val;
#line 132 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	result = g_value_get_double (&_tmp3_);
#line 132 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 132 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	return result;
#line 801 "Streamer.c"
}


static void
noise_streamer_real_enable_equalizer (NoisePlayback* base)
{
	NoiseStreamer * self;
	NoisePipeline* _tmp0_;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self = (NoiseStreamer*) base;
#line 137 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp0_ = self->priv->pipe;
#line 137 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	noise_pipeline_enableEqualizer (_tmp0_);
#line 816 "Streamer.c"
}


static void
noise_streamer_real_disable_equalizer (NoisePlayback* base)
{
	NoiseStreamer * self;
	NoisePipeline* _tmp0_;
#line 140 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self = (NoiseStreamer*) base;
#line 141 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp0_ = self->priv->pipe;
#line 141 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	noise_pipeline_disableEqualizer (_tmp0_);
#line 831 "Streamer.c"
}


static void
noise_streamer_real_set_equalizer_gain (NoisePlayback* base,
                                        gint index,
                                        gint val)
{
	NoiseStreamer * self;
	NoisePipeline* _tmp0_;
	NoiseEqualizer* _tmp1_;
#line 144 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self = (NoiseStreamer*) base;
#line 145 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp0_ = self->priv->pipe;
#line 145 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp1_ = _tmp0_->eq;
#line 145 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	noise_equalizer_setGain (_tmp1_, index, (gdouble) val);
#line 851 "Streamer.c"
}


static gboolean
noise_streamer_bus_callback (NoiseStreamer* self,
                             GstBus* bus,
                             GstMessage* message)
{
	gboolean result = FALSE;
	GstMessageType _tmp0_;
#line 149 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 149 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	g_return_val_if_fail (bus != NULL, FALSE);
#line 149 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 150 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_tmp0_ = message->type;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	switch (_tmp0_) {
#line 150 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		case GST_MESSAGE_ERROR:
#line 874 "Streamer.c"
		{
			GError* err = NULL;
			gchar* debug = NULL;
			GError* _tmp1_ = NULL;
			gchar* _tmp2_ = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
#line 154 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			gst_message_parse_error (message, &_tmp1_, &_tmp2_);
#line 154 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_g_error_free0 (err);
#line 154 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			err = _tmp1_;
#line 154 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_g_free0 (debug);
#line 154 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			debug = _tmp2_;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp3_ = err;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp4_ = _tmp3_->message;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			g_warning ("Streamer.vala:155: Error: %s\n", _tmp4_);
#line 156 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			g_signal_emit_by_name ((NoisePlayback*) self, "error-occured");
#line 157 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_g_free0 (debug);
#line 157 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_g_error_free0 (err);
#line 157 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			break;
#line 906 "Streamer.c"
		}
#line 150 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		case GST_MESSAGE_ELEMENT:
#line 910 "Streamer.c"
		{
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_ = FALSE;
			GstStructure* _tmp7_;
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp7_ = gst_message_get_structure (message);
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			if (_tmp7_ != NULL) {
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
				_tmp6_ = gst_is_missing_plugin_message (message);
#line 921 "Streamer.c"
			} else {
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
				_tmp6_ = FALSE;
#line 925 "Streamer.c"
			}
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			if (_tmp6_) {
#line 929 "Streamer.c"
				gboolean _tmp8_ = FALSE;
				NoiseInstallGstreamerPluginsDialog* _tmp9_;
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
				_tmp9_ = self->priv->dialog;
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
				if (_tmp9_ == NULL) {
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
					_tmp8_ = TRUE;
#line 938 "Streamer.c"
				} else {
					NoiseInstallGstreamerPluginsDialog* _tmp10_;
					gboolean _tmp11_;
					gboolean _tmp12_;
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
					_tmp10_ = self->priv->dialog;
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
					_tmp11_ = gtk_widget_get_visible ((GtkWidget*) _tmp10_);
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
					_tmp12_ = _tmp11_;
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
					_tmp8_ = !_tmp12_;
#line 951 "Streamer.c"
				}
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
				_tmp5_ = _tmp8_;
#line 955 "Streamer.c"
			} else {
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
				_tmp5_ = FALSE;
#line 959 "Streamer.c"
			}
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			if (_tmp5_) {
#line 963 "Streamer.c"
				NoiseInstallGstreamerPluginsDialog* _tmp13_;
#line 160 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
				_tmp13_ = noise_install_gstreamer_plugins_dialog_new (message);
#line 160 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
				g_object_ref_sink (_tmp13_);
#line 160 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
				_g_object_unref0 (self->priv->dialog);
#line 160 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
				self->priv->dialog = _tmp13_;
#line 973 "Streamer.c"
			}
#line 162 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			break;
#line 977 "Streamer.c"
		}
#line 150 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		case GST_MESSAGE_EOS:
#line 981 "Streamer.c"
		{
#line 164 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			g_signal_emit_by_name ((NoisePlayback*) self, "end-of-stream");
#line 165 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			break;
#line 987 "Streamer.c"
		}
#line 150 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		case GST_MESSAGE_STATE_CHANGED:
#line 991 "Streamer.c"
		{
			GstState oldstate = 0;
			GstState newstate = 0;
			GstState pending = 0;
			GstState _tmp14_ = 0;
			GstState _tmp15_ = 0;
			GstState _tmp16_ = 0;
			GstState _tmp17_;
#line 170 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			gst_message_parse_state_changed (message, &_tmp14_, &_tmp15_, &_tmp16_);
#line 170 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			oldstate = _tmp14_;
#line 170 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			newstate = _tmp15_;
#line 170 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			pending = _tmp16_;
#line 173 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp17_ = newstate;
#line 173 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			if (_tmp17_ != GST_STATE_PLAYING) {
#line 174 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
				break;
#line 1014 "Streamer.c"
			}
#line 177 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			break;
#line 1018 "Streamer.c"
		}
#line 150 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
		case GST_MESSAGE_TAG:
#line 1022 "Streamer.c"
		{
			GstTagList* tag_list = NULL;
			GstTagList* _tmp18_ = NULL;
			GstTagList* _tmp19_;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			gst_message_parse_tag (message, &_tmp18_);
#line 181 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_gst_tag_list_unref0 (tag_list);
#line 181 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			tag_list = _tmp18_;
#line 182 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_tmp19_ = tag_list;
#line 182 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			if (_tmp19_ != NULL) {
#line 1037 "Streamer.c"
				GstTagList* _tmp20_;
#line 183 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
				_tmp20_ = tag_list;
#line 183 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
				if (gst_tag_list_get_tag_size (_tmp20_, GST_TAG_TITLE) > ((guint) 0)) {
#line 1043 "Streamer.c"
					gchar* title = NULL;
					gchar* _tmp21_;
					GstTagList* _tmp22_;
					gchar* _tmp23_ = NULL;
#line 184 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
					_tmp21_ = g_strdup ("");
#line 184 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
					title = _tmp21_;
#line 185 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
					_tmp22_ = tag_list;
#line 185 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
					gst_tag_list_get_string (_tmp22_, GST_TAG_TITLE, &_tmp23_);
#line 185 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
					_g_free0 (title);
#line 185 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
					title = _tmp23_;
#line 183 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
					_g_free0 (title);
#line 1062 "Streamer.c"
				}
			}
#line 188 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			_gst_tag_list_unref0 (tag_list);
#line 188 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			break;
#line 1069 "Streamer.c"
		}
		default:
		{
#line 190 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
			break;
#line 1075 "Streamer.c"
		}
	}
#line 193 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	result = TRUE;
#line 193 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	return result;
#line 1082 "Streamer.c"
}


static void
noise_streamer_class_init (NoiseStreamerClass * klass)
{
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	noise_streamer_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	g_type_class_add_private (klass, sizeof (NoiseStreamerPrivate));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_streamer_finalize;
#line 1095 "Streamer.c"
}


static void
noise_streamer_noise_playback_interface_init (NoisePlaybackIface * iface)
{
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	noise_streamer_noise_playback_parent_iface = g_type_interface_peek_parent (iface);
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	iface->get_supported_uri = (GeeCollection* (*) (NoisePlayback *)) noise_streamer_real_get_supported_uri;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	iface->update_position = (gboolean (*) (NoisePlayback *)) noise_streamer_real_update_position;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	iface->play = (void (*) (NoisePlayback *)) noise_streamer_real_play;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	iface->pause = (void (*) (NoisePlayback *)) noise_streamer_real_pause;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	iface->set_state = (void (*) (NoisePlayback *, GstState)) noise_streamer_real_set_state;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	iface->set_media = (void (*) (NoisePlayback *, NoiseMedia*)) noise_streamer_real_set_media;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	iface->set_position = (void (*) (NoisePlayback *, gint64)) noise_streamer_real_set_position;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	iface->get_position = (gint64 (*) (NoisePlayback *)) noise_streamer_real_get_position;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	iface->get_duration = (gint64 (*) (NoisePlayback *)) noise_streamer_real_get_duration;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	iface->set_volume = (void (*) (NoisePlayback *, gdouble)) noise_streamer_real_set_volume;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	iface->get_volume = (gdouble (*) (NoisePlayback *)) noise_streamer_real_get_volume;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	iface->enable_equalizer = (void (*) (NoisePlayback *)) noise_streamer_real_enable_equalizer;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	iface->disable_equalizer = (void (*) (NoisePlayback *)) noise_streamer_real_disable_equalizer;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	iface->set_equalizer_gain = (void (*) (NoisePlayback *, gint, gint)) noise_streamer_real_set_equalizer_gain;
#line 1132 "Streamer.c"
}


static void
noise_streamer_instance_init (NoiseStreamer * self)
{
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self->priv = NOISE_STREAMER_GET_PRIVATE (self);
#line 1141 "Streamer.c"
}


static void
noise_streamer_finalize (GObject * obj)
{
	NoiseStreamer * self;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_STREAMER, NoiseStreamer);
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_g_object_unref0 (self->priv->pipe);
#line 32 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_g_object_unref0 (self->priv->dialog);
#line 34 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	_g_object_unref0 (self->cdda);
#line 29 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/Streamer.vala"
	G_OBJECT_CLASS (noise_streamer_parent_class)->finalize (obj);
#line 1159 "Streamer.c"
}


GType
noise_streamer_get_type (void)
{
	static volatile gsize noise_streamer_type_id__volatile = 0;
	if (g_once_init_enter (&noise_streamer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseStreamerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_streamer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseStreamer), 0, (GInstanceInitFunc) noise_streamer_instance_init, NULL };
		static const GInterfaceInfo noise_playback_info = { (GInterfaceInitFunc) noise_streamer_noise_playback_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_streamer_type_id;
		noise_streamer_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseStreamer", &g_define_type_info, 0);
		g_type_add_interface_static (noise_streamer_type_id, NOISE_TYPE_PLAYBACK, &noise_playback_info);
		g_once_init_leave (&noise_streamer_type_id__volatile, noise_streamer_type_id);
	}
	return noise_streamer_type_id__volatile;
}



