/* ContentView.c generated by valac 0.40.4, the Vala compiler
 * generated from ContentView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <noise-core.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define NOISE_TYPE_CONTENT_VIEW (noise_content_view_get_type ())
#define NOISE_CONTENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_CONTENT_VIEW, NoiseContentView))
#define NOISE_IS_CONTENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_CONTENT_VIEW))
#define NOISE_CONTENT_VIEW_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NOISE_TYPE_CONTENT_VIEW, NoiseContentViewIface))

typedef struct _NoiseContentView NoiseContentView;
typedef struct _NoiseContentViewIface NoiseContentViewIface;

#define NOISE_VIEW_WRAPPER_TYPE_HINT (noise_view_wrapper_hint_get_type ())
enum  {
	NOISE_CONTENT_VIEW_IMPORT_REQUESTED_SIGNAL,
	NOISE_CONTENT_VIEW_NUM_SIGNALS
};
static guint noise_content_view_signals[NOISE_CONTENT_VIEW_NUM_SIGNALS] = {0};

typedef enum  {
	NOISE_VIEW_WRAPPER_HINT_NONE,
	NOISE_VIEW_WRAPPER_HINT_MUSIC,
	NOISE_VIEW_WRAPPER_HINT_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_CDROM,
	NOISE_VIEW_WRAPPER_HINT_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST
} NoiseViewWrapperHint;

struct _NoiseContentViewIface {
	GTypeInterface parent_iface;
	NoiseViewWrapperHint (*get_hint) (NoiseContentView* self);
	GeeCollection* (*get_media) (NoiseContentView* self);
	GeeCollection* (*get_visible_media) (NoiseContentView* self);
	gchar* (*get_statusbar_text) (NoiseContentView* self);
	void (*refilter) (NoiseContentView* self);
	void (*set_media) (NoiseContentView* self, GeeCollection* new_media);
	void (*add_media) (NoiseContentView* self, GeeCollection* to_add);
	void (*remove_media) (NoiseContentView* self, GeeCollection* to_remove);
	void (*update_media) (NoiseContentView* self, GeeCollection* to_update);
};



GType noise_view_wrapper_hint_get_type (void) G_GNUC_CONST;
GType noise_content_view_get_type (void) G_GNUC_CONST;
NoiseViewWrapperHint noise_content_view_get_hint (NoiseContentView* self);
GeeCollection* noise_content_view_get_media (NoiseContentView* self);
GeeCollection* noise_content_view_get_visible_media (NoiseContentView* self);
gchar* noise_content_view_get_statusbar_text (NoiseContentView* self);
void noise_content_view_refilter (NoiseContentView* self);
void noise_content_view_set_media (NoiseContentView* self,
                                   GeeCollection* new_media);
void noise_content_view_add_media (NoiseContentView* self,
                                   GeeCollection* to_add);
void noise_content_view_remove_media (NoiseContentView* self,
                                      GeeCollection* to_remove);
void noise_content_view_update_media (NoiseContentView* self,
                                      GeeCollection* to_update);
#define NOISE_CONTENT_VIEW_FULL_STATUSBAR_FORMAT NC_ ("Format used on statusbar: $description, $total_duration, $total_file_s" \
"ize", "%s, %s, %s")


NoiseViewWrapperHint
noise_content_view_get_hint (NoiseContentView* self)
{
#line 38 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	return NOISE_CONTENT_VIEW_GET_INTERFACE (self)->get_hint (self);
#line 115 "ContentView.c"
}


/**
     * For some views, get_media() and get_visible_media() return the same contents, since
     * the view doesn't have any kind of built-in filters. For other views, they don't return
     * the same since the view has some kind of internal browsing mechanism (e.g. Miller Columns).
     */
GeeCollection*
noise_content_view_get_media (NoiseContentView* self)
{
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	return NOISE_CONTENT_VIEW_GET_INTERFACE (self)->get_media (self);
#line 131 "ContentView.c"
}


GeeCollection*
noise_content_view_get_visible_media (NoiseContentView* self)
{
#line 46 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	return NOISE_CONTENT_VIEW_GET_INTERFACE (self)->get_visible_media (self);
#line 142 "ContentView.c"
}


/**
     * Text that should be displayed in the statusbar for the view.
     */
gchar*
noise_content_view_get_statusbar_text (NoiseContentView* self)
{
#line 51 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	return NOISE_CONTENT_VIEW_GET_INTERFACE (self)->get_statusbar_text (self);
#line 156 "ContentView.c"
}


/**
     * Requests the view to apply a filter to only show the media matching the
     * search string.
     *
     * @param search Search string; pass null to use the previous search string.
     */
void
noise_content_view_refilter (NoiseContentView* self)
{
#line 59 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	g_return_if_fail (self != NULL);
#line 59 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	NOISE_CONTENT_VIEW_GET_INTERFACE (self)->refilter (self);
#line 173 "ContentView.c"
}


void
noise_content_view_set_media (NoiseContentView* self,
                              GeeCollection* new_media)
{
#line 61 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	g_return_if_fail (self != NULL);
#line 61 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	NOISE_CONTENT_VIEW_GET_INTERFACE (self)->set_media (self, new_media);
#line 185 "ContentView.c"
}


void
noise_content_view_add_media (NoiseContentView* self,
                              GeeCollection* to_add)
{
#line 62 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	g_return_if_fail (self != NULL);
#line 62 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	NOISE_CONTENT_VIEW_GET_INTERFACE (self)->add_media (self, to_add);
#line 197 "ContentView.c"
}


void
noise_content_view_remove_media (NoiseContentView* self,
                                 GeeCollection* to_remove)
{
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	g_return_if_fail (self != NULL);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	NOISE_CONTENT_VIEW_GET_INTERFACE (self)->remove_media (self, to_remove);
#line 209 "ContentView.c"
}


void
noise_content_view_update_media (NoiseContentView* self,
                                 GeeCollection* to_update)
{
#line 64 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	g_return_if_fail (self != NULL);
#line 64 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	NOISE_CONTENT_VIEW_GET_INTERFACE (self)->update_media (self, to_update);
#line 221 "ContentView.c"
}


static void
noise_content_view_base_init (NoiseContentViewIface * iface)
{
#line 30 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	static gboolean initialized = FALSE;
#line 30 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
	if (!initialized) {
#line 30 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
		initialized = TRUE;
#line 234 "ContentView.c"
		/**
		     * Used for device syncing.
		     */
#line 30 "/builddir/build/BUILD/music-0.4.2/src/Views/ContentView.vala"
		noise_content_view_signals[NOISE_CONTENT_VIEW_IMPORT_REQUESTED_SIGNAL] = g_signal_new ("import-requested", NOISE_TYPE_CONTENT_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 240 "ContentView.c"
	}
}


GType
noise_content_view_get_type (void)
{
	static volatile gsize noise_content_view_type_id__volatile = 0;
	if (g_once_init_enter (&noise_content_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseContentViewIface), (GBaseInitFunc) noise_content_view_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType noise_content_view_type_id;
		noise_content_view_type_id = g_type_register_static (G_TYPE_INTERFACE, "NoiseContentView", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (noise_content_view_type_id, gtk_widget_get_type ());
		g_once_init_leave (&noise_content_view_type_id__volatile, noise_content_view_type_id);
	}
	return noise_content_view_type_id__volatile;
}



