/* FastList.c generated by valac 0.40.4, the Vala compiler
 * generated from FastList.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <noise-core.h>
#include <stdlib.h>
#include <string.h>


#define NOISE_TYPE_FAST_VIEW (noise_fast_view_get_type ())
#define NOISE_FAST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_FAST_VIEW, NoiseFastView))
#define NOISE_FAST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_FAST_VIEW, NoiseFastViewClass))
#define NOISE_IS_FAST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_FAST_VIEW))
#define NOISE_IS_FAST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_FAST_VIEW))
#define NOISE_FAST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_FAST_VIEW, NoiseFastViewClass))

typedef struct _NoiseFastView NoiseFastView;
typedef struct _NoiseFastViewClass NoiseFastViewClass;
typedef struct _NoiseFastViewPrivate NoiseFastViewPrivate;

#define NOISE_TYPE_FAST_MODEL (noise_fast_model_get_type ())
#define NOISE_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_FAST_MODEL, NoiseFastModel))
#define NOISE_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_FAST_MODEL, NoiseFastModelClass))
#define NOISE_IS_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_FAST_MODEL))
#define NOISE_IS_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_FAST_MODEL))
#define NOISE_FAST_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_FAST_MODEL, NoiseFastModelClass))

typedef struct _NoiseFastModel NoiseFastModel;
typedef struct _NoiseFastModelClass NoiseFastModelClass;
enum  {
	NOISE_FAST_VIEW_0_PROPERTY,
	NOISE_FAST_VIEW_COLUMNS_PROPERTY,
	NOISE_FAST_VIEW_RESEARCH_NEEDED_PROPERTY,
	NOISE_FAST_VIEW_NUM_PROPERTIES
};
static GParamSpec* noise_fast_view_properties[NOISE_FAST_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NOISE_TYPE_LIST_COLUMN (noise_list_column_get_type ())
enum  {
	NOISE_FAST_VIEW_ROWS_REORDERED_SIGNAL,
	NOISE_FAST_VIEW_NUM_SIGNALS
};
static guint noise_fast_view_signals[NOISE_FAST_VIEW_NUM_SIGNALS] = {0};

struct _NoiseFastView {
	GtkTreeView parent_instance;
	NoiseFastViewPrivate * priv;
	NoiseFastModel* fm;
	GeeArrayList* table;
	GeeArrayList* showing;
	gint sort_column_id;
	GtkSortType sort_direction;
};

struct _NoiseFastViewClass {
	GtkTreeViewClass parent_class;
};

typedef gint (*NoiseFastViewSortCompareFunc) (gint sort_column_id, GtkSortType sort_direction, NoiseMedia* a, NoiseMedia* b, gint index_a, gint index_b, void* user_data);
typedef void (*NoiseFastViewViewSearchFunc) (const gchar* search, GeeArrayList* table, GeeArrayList* showing, void* user_data);
struct _NoiseFastViewPrivate {
	GeeList* _columns;
	gboolean _research_needed;
	NoiseFastViewSortCompareFunc compare_func;
	gpointer compare_func_target;
	NoiseFastViewViewSearchFunc search_func;
	gpointer search_func_target;
};

typedef GValue* (*NoiseFastModelValueReturnFunc) (gint row, gint column, GObject* o, void* user_data);
typedef enum  {
	NOISE_LIST_COLUMN_ICON = 0,
	NOISE_LIST_COLUMN_NUMBER,
	NOISE_LIST_COLUMN_TRACK,
	NOISE_LIST_COLUMN_TITLE,
	NOISE_LIST_COLUMN_LENGTH,
	NOISE_LIST_COLUMN_ARTIST,
	NOISE_LIST_COLUMN_ALBUM,
	NOISE_LIST_COLUMN_ALBUM_ARTIST,
	NOISE_LIST_COLUMN_COMPOSER,
	NOISE_LIST_COLUMN_GENRE,
	NOISE_LIST_COLUMN_YEAR,
	NOISE_LIST_COLUMN_GROUPING,
	NOISE_LIST_COLUMN_BITRATE,
	NOISE_LIST_COLUMN_RATING,
	NOISE_LIST_COLUMN_PLAY_COUNT,
	NOISE_LIST_COLUMN_SKIP_COUNT,
	NOISE_LIST_COLUMN_DATE_ADDED,
	NOISE_LIST_COLUMN_LAST_PLAYED,
	NOISE_LIST_COLUMN_BPM,
	NOISE_LIST_COLUMN_FILE_LOCATION,
	NOISE_LIST_COLUMN_FILE_SIZE,
	NOISE_LIST_COLUMN_N_COLUMNS
} NoiseListColumn;


static gpointer noise_fast_view_parent_class = NULL;

GType noise_fast_view_get_type (void) G_GNUC_CONST;
GType noise_fast_model_get_type (void) G_GNUC_CONST;
#define NOISE_FAST_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_FAST_VIEW, NoiseFastViewPrivate))
#define NOISE_FAST_VIEW_OPTIMAL_COLUMN -2
NoiseFastView* noise_fast_view_new (GeeList* types);
NoiseFastView* noise_fast_view_construct (GType object_type,
                                          GeeList* types);
GeeBidirList* noise_fast_view_get_table (NoiseFastView* self);
GeeBidirList* noise_fast_view_get_visible_table (NoiseFastView* self);
gint noise_fast_view_get_index_from_iter (GtkTreeIter* iter);
NoiseMedia* noise_fast_view_get_object_from_index (NoiseFastView* self,
                                                   gint index);
void noise_fast_view_set_value_func (NoiseFastView* self,
                                     NoiseFastModelValueReturnFunc func,
                                     void* func_target);
void noise_fast_model_set_value_func (NoiseFastModel* self,
                                      NoiseFastModelValueReturnFunc func,
                                      void* func_target);
void noise_fast_view_set_table (NoiseFastView* self,
                                GeeArrayList* table,
                                gboolean do_resort);
void noise_fast_view_resort (NoiseFastView* self);
void noise_fast_view_do_search (NoiseFastView* self,
                                const gchar* search);
void noise_fast_view_set_search_func (NoiseFastView* self,
                                      NoiseFastViewViewSearchFunc func,
                                      void* func_target);
gboolean noise_fast_view_get_research_needed (NoiseFastView* self);
void noise_fast_view_set_research_needed (NoiseFastView* self,
                                          gboolean value);
void noise_fast_model_set_table (NoiseFastModel* self,
                                 GeeArrayList* table);
void noise_fast_model_remove (NoiseFastModel* self,
                              GtkTreeIter* iter);
void noise_fast_model_append (NoiseFastModel* self,
                              GtkTreeIter* iter);
void noise_fast_view_redraw_row (NoiseFastView* self,
                                 gint row_index);
void noise_fast_model_update_row (NoiseFastModel* self,
                                  gint index);
void noise_fast_view_set_sort_column_id (NoiseFastView* self,
                                         gint sort_column_id,
                                         GtkSortType order);
void noise_fast_view_get_sort_column_id (NoiseFastView* self,
                                         gint* sort_column,
                                         GtkSortType* order);
static void noise_fast_view_reorder_requested (NoiseFastView* self,
                                        gint column,
                                        GtkSortType direction);
void noise_fast_view_quicksort (NoiseFastView* self,
                                gint start,
                                gint end);
void noise_fast_view_set_compare_func (NoiseFastView* self,
                                       NoiseFastViewSortCompareFunc func,
                                       void* func_target);
static void noise_fast_view_swap (NoiseFastView* self,
                           gint a,
                           gint b);
GeeList* noise_fast_view_get_columns (NoiseFastView* self);
void noise_fast_view_set_columns (NoiseFastView* self,
                                  GeeList* value);
static GObject * noise_fast_view_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
GType noise_list_column_get_type (void) G_GNUC_CONST;
GeeCollection* noise_list_column_get_all (void);
GType noise_list_column_get_data_type (NoiseListColumn self);
NoiseFastModel* noise_fast_model_new (GeeList* column_types);
NoiseFastModel* noise_fast_model_construct (GType object_type,
                                            GeeList* column_types);
static void _noise_fast_view_reorder_requested_noise_fast_model_reorder_requested (NoiseFastModel* _sender,
                                                                            gint column,
                                                                            GtkSortType direction,
                                                                            gpointer self);
static void noise_fast_view_finalize (GObject * obj);
static void _vala_noise_fast_view_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_noise_fast_view_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);


NoiseFastView*
noise_fast_view_construct (GType object_type,
                           GeeList* types)
{
	NoiseFastView * self = NULL;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_val_if_fail (types != NULL, NULL);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	self = (NoiseFastView*) g_object_new (object_type, "columns", types, NULL);
#line 62 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	return self;
#line 229 "FastList.c"
}


NoiseFastView*
noise_fast_view_new (GeeList* types)
{
#line 62 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	return noise_fast_view_construct (NOISE_TYPE_FAST_VIEW, types);
#line 238 "FastList.c"
}


/** Should not be manipulated by client */
GeeBidirList*
noise_fast_view_get_table (NoiseFastView* self)
{
	GeeBidirList* result = NULL;
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
#line 83 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp0_ = self->table;
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp2_ = _tmp1_;
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	result = _tmp2_;
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	return result;
#line 262 "FastList.c"
}


/** Should not be manipulated by client */
GeeBidirList*
noise_fast_view_get_visible_table (NoiseFastView* self)
{
	GeeBidirList* result = NULL;
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
#line 88 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 89 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp0_ = self->showing;
#line 89 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
#line 89 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp2_ = _tmp1_;
#line 89 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	result = _tmp2_;
#line 89 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	return result;
#line 286 "FastList.c"
}


gint
noise_fast_view_get_index_from_iter (GtkTreeIter* iter)
{
	gint result = 0;
	GtkTreeIter _tmp0_;
	void* _tmp1_;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_val_if_fail (iter != NULL, 0);
#line 93 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp0_ = *iter;
#line 93 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp1_ = _tmp0_.user_data;
#line 93 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	result = (gint) _tmp1_;
#line 93 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	return result;
#line 306 "FastList.c"
}


NoiseMedia*
noise_fast_view_get_object_from_index (NoiseFastView* self,
                                       gint index)
{
	NoiseMedia* result = NULL;
	NoiseMedia* _tmp0_ = NULL;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp1_ = self->showing;
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp3_ = _tmp2_;
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	if (index < _tmp3_) {
#line 329 "FastList.c"
		GeeArrayList* _tmp4_;
		gpointer _tmp5_;
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp4_ = self->showing;
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp4_, index);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_g_object_unref0 (_tmp0_);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp0_ = (NoiseMedia*) _tmp5_;
#line 340 "FastList.c"
	} else {
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_g_object_unref0 (_tmp0_);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp0_ = NULL;
#line 346 "FastList.c"
	}
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	result = _tmp0_;
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	return result;
#line 352 "FastList.c"
}


void
noise_fast_view_set_value_func (NoiseFastView* self,
                                NoiseFastModelValueReturnFunc func,
                                void* func_target)
{
	NoiseFastModel* _tmp0_;
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_if_fail (self != NULL);
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp0_ = self->fm;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	noise_fast_model_set_value_func (_tmp0_, func, func_target);
#line 368 "FastList.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	return self ? g_object_ref (self) : NULL;
#line 377 "FastList.c"
}


void
noise_fast_view_set_table (NoiseFastView* self,
                           GeeArrayList* table,
                           gboolean do_resort)
{
	GeeArrayList* _tmp0_;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_if_fail (self != NULL);
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_if_fail (table != NULL);
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp0_ = _g_object_ref0 (table);
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_g_object_unref0 (self->table);
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	self->table = _tmp0_;
#line 107 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	if (do_resort) {
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		noise_fast_view_resort (self);
#line 401 "FastList.c"
	} else {
#line 110 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		noise_fast_view_do_search (self, NULL);
#line 405 "FastList.c"
	}
}


void
noise_fast_view_set_search_func (NoiseFastView* self,
                                 NoiseFastViewViewSearchFunc func,
                                 void* func_target)
{
#line 114 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_if_fail (self != NULL);
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	self->priv->search_func = func;
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	self->priv->search_func_target = func_target;
#line 421 "FastList.c"
}


void
noise_fast_view_do_search (NoiseFastView* self,
                           const gchar* search)
{
	gboolean _tmp0_ = FALSE;
	NoiseFastViewViewSearchFunc _tmp1_;
	void* _tmp1__target;
	gint old_size = 0;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeArrayList* _tmp6_;
	const gchar* _tmp7_ = NULL;
	NoiseFastViewViewSearchFunc _tmp8_;
	void* _tmp8__target;
	GeeArrayList* _tmp9_;
	GeeArrayList* _tmp10_;
	GeeArrayList* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
#line 118 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_if_fail (self != NULL);
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp1_ = self->priv->search_func;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp1__target = self->priv->search_func_target;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	if (_tmp1_ == NULL) {
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp0_ = TRUE;
#line 456 "FastList.c"
	} else {
		gboolean _tmp2_;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp2_ = self->priv->_research_needed;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp0_ = _tmp2_ == FALSE;
#line 463 "FastList.c"
	}
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	if (_tmp0_) {
#line 120 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		return;
#line 469 "FastList.c"
	}
#line 123 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	noise_fast_view_set_research_needed (self, FALSE);
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp3_ = self->showing;
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp5_ = _tmp4_;
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	old_size = _tmp5_;
#line 126 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp6_ = self->showing;
#line 126 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp6_);
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp7_ = search;
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	if (_tmp7_ == NULL) {
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp7_ = "";
#line 491 "FastList.c"
	}
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp8_ = self->priv->search_func;
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp8__target = self->priv->search_func_target;
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp9_ = self->table;
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp10_ = self->showing;
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp8_ (_tmp7_, _tmp9_, _tmp10_, _tmp8__target);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp11_ = self->showing;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp13_ = _tmp12_;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp14_ = old_size;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	if (_tmp13_ == _tmp14_) {
#line 513 "FastList.c"
		NoiseFastModel* _tmp15_;
		GeeArrayList* _tmp16_;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp15_ = self->fm;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp16_ = self->showing;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		noise_fast_model_set_table (_tmp15_, _tmp16_);
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 524 "FastList.c"
	} else {
		gint _tmp17_;
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp17_ = old_size;
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		if (_tmp17_ == 0) {
#line 531 "FastList.c"
			NoiseFastModel* _tmp18_;
			GeeArrayList* _tmp19_;
			NoiseFastModel* _tmp20_;
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			gtk_tree_view_set_model ((GtkTreeView*) self, NULL);
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp18_ = self->fm;
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp19_ = self->showing;
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			noise_fast_model_set_table (_tmp18_, _tmp19_);
#line 135 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp20_ = self->fm;
#line 135 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp20_);
#line 547 "FastList.c"
		} else {
			gint _tmp21_;
			GeeArrayList* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp21_ = old_size;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp22_ = self->showing;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp24_ = _tmp23_;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			if (_tmp21_ > _tmp24_) {
#line 563 "FastList.c"
				NoiseFastModel* _tmp34_;
				GeeArrayList* _tmp35_;
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				while (TRUE) {
#line 568 "FastList.c"
					NoiseFastModel* _tmp25_;
					GeeArrayList* _tmp26_;
					gint _tmp27_;
					gint _tmp28_;
					GtkTreeIter iter = {0};
					NoiseFastModel* _tmp29_;
					NoiseFastModel* _tmp30_;
					GtkTreeIter _tmp31_ = {0};
					NoiseFastModel* _tmp32_;
					GtkTreeIter _tmp33_;
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
					_tmp25_ = self->fm;
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
					_tmp26_ = self->showing;
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
					_tmp27_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp26_);
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
					_tmp28_ = _tmp27_;
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
					if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp25_, NULL) > _tmp28_)) {
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
						break;
#line 591 "FastList.c"
					}
#line 139 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
					_tmp29_ = self->fm;
#line 139 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
					_tmp30_ = self->fm;
#line 139 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
					gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp29_, &_tmp31_, NULL, gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp30_, NULL) - 1);
#line 139 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
					iter = _tmp31_;
#line 140 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
					_tmp32_ = self->fm;
#line 140 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
					_tmp33_ = iter;
#line 140 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
					noise_fast_model_remove (_tmp32_, &_tmp33_);
#line 607 "FastList.c"
				}
#line 143 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp34_ = self->fm;
#line 143 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp35_ = self->showing;
#line 143 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				noise_fast_model_set_table (_tmp34_, _tmp35_);
#line 144 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				gtk_widget_queue_draw ((GtkWidget*) self);
#line 617 "FastList.c"
			} else {
				GeeArrayList* _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
				gint _tmp39_;
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp36_ = self->showing;
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp37_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp36_);
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp38_ = _tmp37_;
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp39_ = old_size;
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				if (_tmp38_ > _tmp39_) {
#line 633 "FastList.c"
					GtkTreeIter iter = {0};
					NoiseFastModel* _tmp46_;
					GeeArrayList* _tmp47_;
#line 148 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
					while (TRUE) {
#line 639 "FastList.c"
						NoiseFastModel* _tmp40_;
						GeeArrayList* _tmp41_;
						gint _tmp42_;
						gint _tmp43_;
						NoiseFastModel* _tmp44_;
						GtkTreeIter _tmp45_ = {0};
#line 148 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
						_tmp40_ = self->fm;
#line 148 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
						_tmp41_ = self->showing;
#line 148 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
						_tmp42_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp41_);
#line 148 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
						_tmp43_ = _tmp42_;
#line 148 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
						if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp40_, NULL) < _tmp43_)) {
#line 148 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
							break;
#line 658 "FastList.c"
						}
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
						_tmp44_ = self->fm;
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
						noise_fast_model_append (_tmp44_, &_tmp45_);
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
						iter = _tmp45_;
#line 666 "FastList.c"
					}
#line 152 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
					_tmp46_ = self->fm;
#line 152 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
					_tmp47_ = self->showing;
#line 152 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
					noise_fast_model_set_table (_tmp46_, _tmp47_);
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
					gtk_widget_queue_draw ((GtkWidget*) self);
#line 676 "FastList.c"
				}
			}
		}
	}
}


void
noise_fast_view_redraw_row (NoiseFastView* self,
                            gint row_index)
{
	NoiseFastModel* _tmp0_;
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_if_fail (self != NULL);
#line 158 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp0_ = self->fm;
#line 158 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	noise_fast_model_update_row (_tmp0_, row_index);
#line 695 "FastList.c"
}


/** Sorting is done in the treeview, not the model. That way the whole
     * table is sorted and ready to go and we do not need to resort every
     * time we repopulate/search the model
    **/
void
noise_fast_view_set_sort_column_id (NoiseFastView* self,
                                    gint sort_column_id,
                                    GtkSortType order)
{
	NoiseFastModel* _tmp0_;
#line 165 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_if_fail (self != NULL);
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp0_ = self->fm;
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp0_, sort_column_id, order);
#line 715 "FastList.c"
}


void
noise_fast_view_get_sort_column_id (NoiseFastView* self,
                                    gint* sort_column,
                                    GtkSortType* order)
{
	gint _vala_sort_column = 0;
	GtkSortType _vala_order = 0;
	gint _tmp0_;
	GtkSortType _tmp1_;
#line 169 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_if_fail (self != NULL);
#line 170 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp0_ = self->sort_column_id;
#line 170 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_vala_sort_column = _tmp0_;
#line 171 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp1_ = self->sort_direction;
#line 171 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_vala_order = _tmp1_;
#line 169 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	if (sort_column) {
#line 169 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		*sort_column = _vala_sort_column;
#line 742 "FastList.c"
	}
#line 169 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	if (order) {
#line 169 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		*order = _vala_order;
#line 748 "FastList.c"
	}
}


static void
noise_fast_view_reorder_requested (NoiseFastView* self,
                                   gint column,
                                   GtkSortType direction)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 174 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_if_fail (self != NULL);
#line 175 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp1_ = self->sort_column_id;
#line 175 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	if (column == _tmp1_) {
#line 769 "FastList.c"
		GtkSortType _tmp2_;
#line 175 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp2_ = self->sort_direction;
#line 175 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp0_ = direction == _tmp2_;
#line 775 "FastList.c"
	} else {
#line 175 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp0_ = FALSE;
#line 779 "FastList.c"
	}
#line 175 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	if (_tmp0_) {
#line 176 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		return;
#line 785 "FastList.c"
	}
#line 179 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	self->sort_column_id = column;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	self->sort_direction = direction;
#line 182 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp3_ = self->table;
#line 182 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 182 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp5_ = _tmp4_;
#line 182 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	noise_fast_view_quicksort (self, 0, _tmp5_ - 1);
#line 183 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	noise_fast_view_set_research_needed (self, TRUE);
#line 184 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	noise_fast_view_do_search (self, NULL);
#line 187 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_signal_emit (self, noise_fast_view_signals[NOISE_FAST_VIEW_ROWS_REORDERED_SIGNAL], 0);
#line 805 "FastList.c"
}


void
noise_fast_view_resort (NoiseFastView* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 190 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_if_fail (self != NULL);
#line 191 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp0_ = self->table;
#line 191 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 191 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp2_ = _tmp1_;
#line 191 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	noise_fast_view_quicksort (self, 0, _tmp2_ - 1);
#line 193 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	noise_fast_view_set_research_needed (self, TRUE);
#line 194 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	noise_fast_view_do_search (self, NULL);
#line 829 "FastList.c"
}


void
noise_fast_view_set_compare_func (NoiseFastView* self,
                                  NoiseFastViewSortCompareFunc func,
                                  void* func_target)
{
#line 197 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_if_fail (self != NULL);
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	self->priv->compare_func = func;
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	self->priv->compare_func_target = func_target;
#line 844 "FastList.c"
}


static void
noise_fast_view_swap (NoiseFastView* self,
                      gint a,
                      gint b)
{
	NoiseMedia* temp = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gpointer _tmp4_;
	NoiseMedia* _tmp5_;
	GeeArrayList* _tmp6_;
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_if_fail (self != NULL);
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp0_ = self->table;
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, a);
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	temp = (NoiseMedia*) _tmp1_;
#line 203 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp2_ = self->table;
#line 203 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp3_ = self->table;
#line 203 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, b);
#line 203 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp5_ = (NoiseMedia*) _tmp4_;
#line 203 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	gee_abstract_list_set ((GeeAbstractList*) _tmp2_, a, _tmp5_);
#line 203 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_g_object_unref0 (_tmp5_);
#line 204 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp6_ = self->table;
#line 204 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	gee_abstract_list_set ((GeeAbstractList*) _tmp6_, b, temp);
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_g_object_unref0 (temp);
#line 887 "FastList.c"
}


void
noise_fast_view_quicksort (NoiseFastView* self,
                           gint start,
                           gint end)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint pivot_index = 0;
	NoiseMedia* pivot = NULL;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gpointer _tmp5_;
	gint i = 0;
	gint j = 0;
	gint _tmp40_;
	gint _tmp42_;
#line 207 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_if_fail (self != NULL);
#line 208 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp0_ = self->table;
#line 208 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 208 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp2_ = _tmp1_;
#line 208 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	if (_tmp2_ == 0) {
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		return;
#line 920 "FastList.c"
	}
#line 212 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	pivot_index = (start + end) / 2;
#line 213 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp3_ = self->table;
#line 213 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp4_ = pivot_index;
#line 213 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, _tmp4_);
#line 213 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	pivot = (NoiseMedia*) _tmp5_;
#line 214 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	i = start;
#line 215 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	j = end;
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	while (TRUE) {
#line 938 "FastList.c"
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp34_;
		gint _tmp35_;
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp6_ = i;
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp7_ = j;
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		if (!(_tmp6_ <= _tmp7_)) {
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			break;
#line 951 "FastList.c"
		}
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		while (TRUE) {
#line 955 "FastList.c"
			gboolean _tmp8_ = FALSE;
			gint _tmp9_;
			gint _tmp20_;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp9_ = i;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			if (_tmp9_ < end) {
#line 963 "FastList.c"
				NoiseFastViewSortCompareFunc _tmp10_;
				void* _tmp10__target;
				gint _tmp11_;
				GtkSortType _tmp12_;
				GeeArrayList* _tmp13_;
				gint _tmp14_;
				gpointer _tmp15_;
				NoiseMedia* _tmp16_;
				NoiseMedia* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp10_ = self->priv->compare_func;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp10__target = self->priv->compare_func_target;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp11_ = self->sort_column_id;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp12_ = self->sort_direction;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp13_ = self->table;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp14_ = i;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, _tmp14_);
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp16_ = (NoiseMedia*) _tmp15_;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp17_ = pivot;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp18_ = i;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp19_ = pivot_index;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp8_ = _tmp10_ (_tmp11_, _tmp12_, _tmp16_, _tmp17_, _tmp18_, _tmp19_, _tmp10__target) < 0;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_g_object_unref0 (_tmp16_);
#line 1001 "FastList.c"
			} else {
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp8_ = FALSE;
#line 1005 "FastList.c"
			}
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			if (!_tmp8_) {
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				break;
#line 1011 "FastList.c"
			}
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp20_ = i;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			i = _tmp20_ + 1;
#line 1017 "FastList.c"
		}
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		while (TRUE) {
#line 1021 "FastList.c"
			gboolean _tmp21_ = FALSE;
			gint _tmp22_;
			gint _tmp33_;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp22_ = j;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			if (_tmp22_ > start) {
#line 1029 "FastList.c"
				NoiseFastViewSortCompareFunc _tmp23_;
				void* _tmp23__target;
				gint _tmp24_;
				GtkSortType _tmp25_;
				GeeArrayList* _tmp26_;
				gint _tmp27_;
				gpointer _tmp28_;
				NoiseMedia* _tmp29_;
				NoiseMedia* _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp23_ = self->priv->compare_func;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp23__target = self->priv->compare_func_target;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp24_ = self->sort_column_id;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp25_ = self->sort_direction;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp26_ = self->table;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp27_ = j;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp26_, _tmp27_);
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp29_ = (NoiseMedia*) _tmp28_;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp30_ = pivot;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp31_ = j;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp32_ = pivot_index;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp21_ = _tmp23_ (_tmp24_, _tmp25_, _tmp29_, _tmp30_, _tmp31_, _tmp32_, _tmp23__target) > 0;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_g_object_unref0 (_tmp29_);
#line 1067 "FastList.c"
			} else {
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				_tmp21_ = FALSE;
#line 1071 "FastList.c"
			}
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			if (!_tmp21_) {
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				break;
#line 1077 "FastList.c"
			}
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp33_ = j;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			j = _tmp33_ - 1;
#line 1083 "FastList.c"
		}
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp34_ = i;
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp35_ = j;
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		if (_tmp34_ <= _tmp35_) {
#line 1091 "FastList.c"
			gint _tmp36_;
			gint _tmp37_;
			gint _tmp38_;
			gint _tmp39_;
#line 221 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp36_ = i;
#line 221 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp37_ = j;
#line 221 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			noise_fast_view_swap (self, _tmp36_, _tmp37_);
#line 222 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp38_ = i;
#line 222 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			i = _tmp38_ + 1;
#line 222 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp39_ = j;
#line 222 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			j = _tmp39_ - 1;
#line 1110 "FastList.c"
		}
	}
#line 226 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp40_ = j;
#line 226 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	if (start < _tmp40_) {
#line 1117 "FastList.c"
		gint _tmp41_;
#line 227 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp41_ = j;
#line 227 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		noise_fast_view_quicksort (self, start, _tmp41_);
#line 1123 "FastList.c"
	}
#line 229 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp42_ = i;
#line 229 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	if (_tmp42_ < end) {
#line 1129 "FastList.c"
		gint _tmp43_;
#line 230 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp43_ = i;
#line 230 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		noise_fast_view_quicksort (self, _tmp43_, end);
#line 1135 "FastList.c"
	}
#line 207 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_g_object_unref0 (pivot);
#line 1139 "FastList.c"
}


GeeList*
noise_fast_view_get_columns (NoiseFastView* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp0_ = self->priv->_columns;
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	result = _tmp0_;
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	return result;
#line 1156 "FastList.c"
}


void
noise_fast_view_set_columns (NoiseFastView* self,
                             GeeList* value)
{
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_if_fail (self != NULL);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	if (noise_fast_view_get_columns (self) != value) {
#line 1168 "FastList.c"
		GeeList* _tmp0_;
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_g_object_unref0 (self->priv->_columns);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		self->priv->_columns = _tmp0_;
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_fast_view_properties[NOISE_FAST_VIEW_COLUMNS_PROPERTY]);
#line 1178 "FastList.c"
	}
}


gboolean
noise_fast_view_get_research_needed (NoiseFastView* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp0_ = self->priv->_research_needed;
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	result = _tmp0_;
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	return result;
#line 1196 "FastList.c"
}


void
noise_fast_view_set_research_needed (NoiseFastView* self,
                                     gboolean value)
{
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_return_if_fail (self != NULL);
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	if (noise_fast_view_get_research_needed (self) != value) {
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		self->priv->_research_needed = value;
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_fast_view_properties[NOISE_FAST_VIEW_RESEARCH_NEEDED_PROPERTY]);
#line 1212 "FastList.c"
	}
}


static void
_noise_fast_view_reorder_requested_noise_fast_model_reorder_requested (NoiseFastModel* _sender,
                                                                       gint column,
                                                                       GtkSortType direction,
                                                                       gpointer self)
{
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	noise_fast_view_reorder_requested ((NoiseFastView*) self, column, direction);
#line 1225 "FastList.c"
}


static GObject *
noise_fast_view_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseFastView * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeList* _tmp11_;
	NoiseFastModel* _tmp12_;
	NoiseFastModel* _tmp13_;
	GeeArrayList* _tmp14_;
	NoiseFastModel* _tmp15_;
#line 66 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	parent_class = G_OBJECT_CLASS (noise_fast_view_parent_class);
#line 66 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 66 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_FAST_VIEW, NoiseFastView);
#line 67 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_GTYPE, NULL, NULL, NULL, NULL, NULL);
#line 67 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp1_ = _tmp0_;
#line 67 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	noise_fast_view_set_columns (self, (GeeList*) _tmp1_);
#line 67 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_g_object_unref0 (_tmp1_);
#line 1258 "FastList.c"
	{
		GeeIterator* _type_it = NULL;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp2_ = noise_list_column_get_all ();
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp3_ = _tmp2_;
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_tmp5_ = _tmp4_;
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_g_object_unref0 (_tmp3_);
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_type_it = _tmp5_;
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		while (TRUE) {
#line 1279 "FastList.c"
			GeeIterator* _tmp6_;
			NoiseListColumn type = 0;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeList* _tmp9_;
			NoiseListColumn _tmp10_;
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp6_ = _type_it;
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
				break;
#line 1292 "FastList.c"
			}
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp7_ = _type_it;
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			type = (NoiseListColumn) ((gintptr) _tmp8_);
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp9_ = self->priv->_columns;
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			_tmp10_ = type;
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
			gee_collection_add ((GeeCollection*) _tmp9_, (gpointer) ((gintptr) noise_list_column_get_data_type (_tmp10_)));
#line 1306 "FastList.c"
		}
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		_g_object_unref0 (_type_it);
#line 1310 "FastList.c"
	}
#line 72 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp11_ = self->priv->_columns;
#line 72 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp12_ = noise_fast_model_new (_tmp11_);
#line 72 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_g_object_unref0 (self->fm);
#line 72 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	self->fm = _tmp12_;
#line 73 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	self->sort_column_id = NOISE_FAST_VIEW_OPTIMAL_COLUMN;
#line 74 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	self->sort_direction = GTK_SORT_ASCENDING;
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp13_ = self->fm;
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_signal_connect_object (_tmp13_, "reorder-requested", (GCallback) _noise_fast_view_reorder_requested_noise_fast_model_reorder_requested, self, 0);
#line 78 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp14_ = self->table;
#line 78 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	noise_fast_view_set_table (self, _tmp14_, TRUE);
#line 79 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp15_ = self->fm;
#line 79 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp15_);
#line 66 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	return obj;
#line 1338 "FastList.c"
}


static void
noise_fast_view_class_init (NoiseFastViewClass * klass)
{
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	noise_fast_view_parent_class = g_type_class_peek_parent (klass);
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_type_class_add_private (klass, sizeof (NoiseFastViewPrivate));
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_fast_view_get_property;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_fast_view_set_property;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_fast_view_constructor;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_fast_view_finalize;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_FAST_VIEW_COLUMNS_PROPERTY, noise_fast_view_properties[NOISE_FAST_VIEW_COLUMNS_PROPERTY] = g_param_spec_object ("columns", "columns", "columns", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_FAST_VIEW_RESEARCH_NEEDED_PROPERTY, noise_fast_view_properties[NOISE_FAST_VIEW_RESEARCH_NEEDED_PROPERTY] = g_param_spec_boolean ("research-needed", "research-needed", "research-needed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	noise_fast_view_signals[NOISE_FAST_VIEW_ROWS_REORDERED_SIGNAL] = g_signal_new ("rows-reordered", NOISE_TYPE_FAST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1363 "FastList.c"
}


static void
noise_fast_view_instance_init (NoiseFastView * self)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	self->priv = NOISE_FAST_VIEW_GET_PRIVATE (self);
#line 40 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp0_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 40 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	self->table = _tmp0_;
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_tmp1_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	self->showing = _tmp1_;
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	self->priv->_research_needed = FALSE;
#line 1384 "FastList.c"
}


static void
noise_fast_view_finalize (GObject * obj)
{
	NoiseFastView * self;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_FAST_VIEW, NoiseFastView);
#line 34 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_g_object_unref0 (self->fm);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_g_object_unref0 (self->priv->_columns);
#line 40 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_g_object_unref0 (self->table);
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	_g_object_unref0 (self->showing);
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	G_OBJECT_CLASS (noise_fast_view_parent_class)->finalize (obj);
#line 1404 "FastList.c"
}


/**
* A widget display a list of medias.
*/
GType
noise_fast_view_get_type (void)
{
	static volatile gsize noise_fast_view_type_id__volatile = 0;
	if (g_once_init_enter (&noise_fast_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseFastViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_fast_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseFastView), 0, (GInstanceInitFunc) noise_fast_view_instance_init, NULL };
		GType noise_fast_view_type_id;
		noise_fast_view_type_id = g_type_register_static (gtk_tree_view_get_type (), "NoiseFastView", &g_define_type_info, 0);
		g_once_init_leave (&noise_fast_view_type_id__volatile, noise_fast_view_type_id);
	}
	return noise_fast_view_type_id__volatile;
}


static void
_vala_noise_fast_view_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	NoiseFastView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_FAST_VIEW, NoiseFastView);
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	switch (property_id) {
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		case NOISE_FAST_VIEW_COLUMNS_PROPERTY:
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		g_value_set_object (value, noise_fast_view_get_columns (self));
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		break;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		case NOISE_FAST_VIEW_RESEARCH_NEEDED_PROPERTY:
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		g_value_set_boolean (value, noise_fast_view_get_research_needed (self));
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		break;
#line 1447 "FastList.c"
		default:
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		break;
#line 1453 "FastList.c"
	}
}


static void
_vala_noise_fast_view_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	NoiseFastView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_FAST_VIEW, NoiseFastView);
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
	switch (property_id) {
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		case NOISE_FAST_VIEW_COLUMNS_PROPERTY:
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		noise_fast_view_set_columns (self, g_value_get_object (value));
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		break;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		case NOISE_FAST_VIEW_RESEARCH_NEEDED_PROPERTY:
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		noise_fast_view_set_research_needed (self, g_value_get_boolean (value));
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		break;
#line 1480 "FastList.c"
		default:
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/FastList.vala"
		break;
#line 1486 "FastList.c"
	}
}



