/* TileRenderer.c generated by valac 0.40.4, the Vala compiler
 * generated from TileRenderer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <noise-core.h>
#include <pango/pango.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>


#define NOISE_WIDGETS_TYPE_TILE_RENDERER (noise_widgets_tile_renderer_get_type ())
#define NOISE_WIDGETS_TILE_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRenderer))
#define NOISE_WIDGETS_TILE_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRendererClass))
#define NOISE_WIDGETS_IS_TILE_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_WIDGETS_TYPE_TILE_RENDERER))
#define NOISE_WIDGETS_IS_TILE_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_WIDGETS_TYPE_TILE_RENDERER))
#define NOISE_WIDGETS_TILE_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRendererClass))

typedef struct _NoiseWidgetsTileRenderer NoiseWidgetsTileRenderer;
typedef struct _NoiseWidgetsTileRendererClass NoiseWidgetsTileRendererClass;
typedef struct _NoiseWidgetsTileRendererPrivate NoiseWidgetsTileRendererPrivate;
enum  {
	NOISE_WIDGETS_TILE_RENDERER_0_PROPERTY,
	NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY,
	NOISE_WIDGETS_TILE_RENDERER_NUM_PROPERTIES
};
static GParamSpec* noise_widgets_tile_renderer_properties[NOISE_WIDGETS_TILE_RENDERER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gtk_icon_info_free0(var) ((var == NULL) ? NULL : (var = (gtk_icon_info_free (var), NULL)))

struct _NoiseWidgetsTileRenderer {
	GtkCellRenderer parent_instance;
	NoiseWidgetsTileRendererPrivate * priv;
};

struct _NoiseWidgetsTileRendererClass {
	GtkCellRendererClass parent_class;
};

struct _NoiseWidgetsTileRendererPrivate {
	NoiseAlbum* _album;
	PangoLayout* title_text_layout;
	PangoLayout* subtitle_text_layout;
	GtkBorder margin;
	GtkBorder padding;
	GtkBorder border;
	GdkPixbuf* pixbuf;
	GdkPixbuf* fallback_pixbuf;
	gint fallback_pixbuf_scale;
};


static gpointer noise_widgets_tile_renderer_parent_class = NULL;

GType noise_widgets_tile_renderer_get_type (void) G_GNUC_CONST;
#define NOISE_WIDGETS_TILE_RENDERER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRendererPrivate))
NoiseWidgetsTileRenderer* noise_widgets_tile_renderer_new (void);
NoiseWidgetsTileRenderer* noise_widgets_tile_renderer_construct (GType object_type);
static void __lambda37_ (NoiseWidgetsTileRenderer* self);
static void ___lambda37__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void noise_widgets_tile_renderer_real_get_size (GtkCellRenderer* base,
                                                GtkWidget* widget,
                                                GdkRectangle* cell_area,
                                                gint* x_offset,
                                                gint* y_offset,
                                                gint* width,
                                                gint* height);
static GtkSizeRequestMode noise_widgets_tile_renderer_real_get_request_mode (GtkCellRenderer* base);
static void noise_widgets_tile_renderer_real_get_preferred_width (GtkCellRenderer* base,
                                                           GtkWidget* widget,
                                                           gint* minimum_size,
                                                           gint* natural_size);
static void noise_widgets_tile_renderer_update_layout_properties (NoiseWidgetsTileRenderer* self,
                                                           GtkWidget* widget);
static gint noise_widgets_tile_renderer_compute_total_image_width (NoiseWidgetsTileRenderer* self);
static void noise_widgets_tile_renderer_real_get_preferred_height_for_width (GtkCellRenderer* base,
                                                                      GtkWidget* widget,
                                                                      gint width,
                                                                      gint* minimum_height,
                                                                      gint* natural_height);
static gint noise_widgets_tile_renderer_compute_total_image_height (NoiseWidgetsTileRenderer* self);
static void noise_widgets_tile_renderer_real_render (GtkCellRenderer* base,
                                              cairo_t* cr,
                                              GtkWidget* widget,
                                              GdkRectangle* bg_area,
                                              GdkRectangle* cell_area,
                                              GtkCellRendererState flags);
static void noise_widgets_tile_renderer_render_image (NoiseWidgetsTileRenderer* self,
                                               GtkStyleContext* ctx,
                                               cairo_t* cr,
                                               gint* x,
                                               gint* y,
                                               gint width,
                                               GtkCellRendererState flags);
static void noise_widgets_tile_renderer_render_title (NoiseWidgetsTileRenderer* self,
                                               GtkStyleContext* ctx,
                                               cairo_t* cr,
                                               gint x,
                                               gint* y,
                                               gint width);
static void noise_widgets_tile_renderer_render_subtitle (NoiseWidgetsTileRenderer* self,
                                                  GtkStyleContext* ctx,
                                                  cairo_t* cr,
                                                  gint x,
                                                  gint y,
                                                  gint width);
static void noise_widgets_tile_renderer_render_prixbuf (NoiseWidgetsTileRenderer* self,
                                                 GtkStyleContext* ctx);
NoiseAlbum* noise_widgets_tile_renderer_get_album (NoiseWidgetsTileRenderer* self);
void noise_widgets_tile_renderer_set_album (NoiseWidgetsTileRenderer* self,
                                            NoiseAlbum* value);
static void noise_widgets_tile_renderer_finalize (GObject * obj);
static void _vala_noise_widgets_tile_renderer_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_noise_widgets_tile_renderer_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);


static void
__lambda37_ (NoiseWidgetsTileRenderer* self)
{
#line 41 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (self->priv->pixbuf);
#line 41 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->pixbuf = NULL;
#line 167 "TileRenderer.c"
}


static void
___lambda37__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 40 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	__lambda37_ ((NoiseWidgetsTileRenderer*) self);
#line 178 "TileRenderer.c"
}


NoiseWidgetsTileRenderer*
noise_widgets_tile_renderer_construct (GType object_type)
{
	NoiseWidgetsTileRenderer * self = NULL;
#line 39 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	self = (NoiseWidgetsTileRenderer*) g_object_new (object_type, NULL);
#line 40 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_signal_connect_object ((GObject*) self, "notify::album", (GCallback) ___lambda37__g_object_notify, self, 0);
#line 39 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	return self;
#line 192 "TileRenderer.c"
}


NoiseWidgetsTileRenderer*
noise_widgets_tile_renderer_new (void)
{
#line 39 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	return noise_widgets_tile_renderer_construct (NOISE_WIDGETS_TYPE_TILE_RENDERER);
#line 201 "TileRenderer.c"
}


static void
noise_widgets_tile_renderer_real_get_size (GtkCellRenderer* base,
                                           GtkWidget* widget,
                                           GdkRectangle* cell_area,
                                           gint* x_offset,
                                           gint* y_offset,
                                           gint* width,
                                           gint* height)
{
	NoiseWidgetsTileRenderer * self;
	gint _vala_x_offset = 0;
	gint _vala_y_offset = 0;
	gint _vala_width = 0;
	gint _vala_height = 0;
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	self = (NoiseWidgetsTileRenderer*) base;
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (widget != NULL);
#line 49 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_vala_height = 0;
#line 49 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_vala_width = _vala_height;
#line 49 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_vala_y_offset = _vala_width;
#line 49 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_vala_x_offset = _vala_y_offset;
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	if (x_offset) {
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		*x_offset = _vala_x_offset;
#line 235 "TileRenderer.c"
	}
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	if (y_offset) {
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		*y_offset = _vala_y_offset;
#line 241 "TileRenderer.c"
	}
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	if (width) {
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		*width = _vala_width;
#line 247 "TileRenderer.c"
	}
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	if (height) {
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		*height = _vala_height;
#line 253 "TileRenderer.c"
	}
}


static GtkSizeRequestMode
noise_widgets_tile_renderer_real_get_request_mode (GtkCellRenderer* base)
{
	NoiseWidgetsTileRenderer * self;
	GtkSizeRequestMode result = 0;
#line 52 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	self = (NoiseWidgetsTileRenderer*) base;
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	return result;
#line 269 "TileRenderer.c"
}


static void
noise_widgets_tile_renderer_real_get_preferred_width (GtkCellRenderer* base,
                                                      GtkWidget* widget,
                                                      gint* minimum_size,
                                                      gint* natural_size)
{
	NoiseWidgetsTileRenderer * self;
	gint _vala_minimum_size = 0;
	gint _vala_natural_size = 0;
	gint x_padding = 0;
	gint _tmp0_ = 0;
	gint width = 0;
	GtkBorder _tmp1_;
	gint16 _tmp2_;
	GtkBorder _tmp3_;
	gint16 _tmp4_;
	GtkBorder _tmp5_;
	gint16 _tmp6_;
	GtkBorder _tmp7_;
	gint16 _tmp8_;
	GtkBorder _tmp9_;
	gint16 _tmp10_;
	GtkBorder _tmp11_;
	gint16 _tmp12_;
#line 56 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	self = (NoiseWidgetsTileRenderer*) base;
#line 56 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (widget != NULL);
#line 60 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	noise_widgets_tile_renderer_update_layout_properties (self, widget);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_cell_renderer_get_padding ((GtkCellRenderer*) self, &_tmp0_, NULL);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	x_padding = _tmp0_;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp1_ = self->priv->margin;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp2_ = _tmp1_.left;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp3_ = self->priv->margin;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp4_ = _tmp3_.right;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp5_ = self->priv->padding;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp6_ = _tmp5_.left;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp7_ = self->priv->padding;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp8_ = _tmp7_.right;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp9_ = self->priv->border;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp10_ = _tmp9_.left;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp11_ = self->priv->border;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp12_ = _tmp11_.right;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	width = ((((((noise_widgets_tile_renderer_compute_total_image_width (self) + _tmp2_) + _tmp4_) + _tmp6_) + _tmp8_) + _tmp10_) + _tmp12_) + (2 * x_padding);
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_vala_natural_size = width;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_vala_minimum_size = _vala_natural_size;
#line 56 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	if (minimum_size) {
#line 56 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		*minimum_size = _vala_minimum_size;
#line 341 "TileRenderer.c"
	}
#line 56 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	if (natural_size) {
#line 56 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		*natural_size = _vala_natural_size;
#line 347 "TileRenderer.c"
	}
}


static void
noise_widgets_tile_renderer_real_get_preferred_height_for_width (GtkCellRenderer* base,
                                                                 GtkWidget* widget,
                                                                 gint width,
                                                                 gint* minimum_height,
                                                                 gint* natural_height)
{
	NoiseWidgetsTileRenderer * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
	gint y_padding = 0;
	gint _tmp0_ = 0;
	gint subtitle_height = 0;
	gint title_height = 0;
	PangoLayout* _tmp1_;
	gint _tmp2_ = 0;
	PangoLayout* _tmp3_;
	gint _tmp4_ = 0;
	gint height = 0;
	GtkBorder _tmp5_;
	gint16 _tmp6_;
	GtkBorder _tmp7_;
	gint16 _tmp8_;
	GtkBorder _tmp9_;
	gint16 _tmp10_;
	GtkBorder _tmp11_;
	gint16 _tmp12_;
	GtkBorder _tmp13_;
	gint16 _tmp14_;
	GtkBorder _tmp15_;
	gint16 _tmp16_;
#line 74 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	self = (NoiseWidgetsTileRenderer*) base;
#line 74 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (widget != NULL);
#line 78 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	noise_widgets_tile_renderer_update_layout_properties (self, widget);
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_cell_renderer_get_padding ((GtkCellRenderer*) self, NULL, &_tmp0_);
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	y_padding = _tmp0_;
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp1_ = self->priv->title_text_layout;
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_get_pixel_size (_tmp1_, NULL, &_tmp2_);
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	title_height = _tmp2_;
#line 85 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp3_ = self->priv->subtitle_text_layout;
#line 85 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_get_pixel_size (_tmp3_, NULL, &_tmp4_);
#line 85 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	subtitle_height = _tmp4_;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp5_ = self->priv->margin;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp6_ = _tmp5_.top;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp7_ = self->priv->margin;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp8_ = _tmp7_.bottom;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp9_ = self->priv->padding;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp10_ = _tmp9_.top;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp11_ = self->priv->padding;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp12_ = _tmp11_.bottom;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp13_ = self->priv->border;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp14_ = _tmp13_.top;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp15_ = self->priv->border;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp16_ = _tmp15_.bottom;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	height = ((((((((noise_widgets_tile_renderer_compute_total_image_height (self) + title_height) + subtitle_height) + _tmp6_) + (2 * _tmp8_)) + _tmp10_) + _tmp12_) + _tmp14_) + _tmp16_) + (2 * y_padding);
#line 94 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_vala_natural_height = height;
#line 94 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_vala_minimum_height = _vala_natural_height;
#line 74 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	if (minimum_height) {
#line 74 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		*minimum_height = _vala_minimum_height;
#line 439 "TileRenderer.c"
	}
#line 74 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	if (natural_height) {
#line 74 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		*natural_height = _vala_natural_height;
#line 445 "TileRenderer.c"
	}
}


static void
noise_widgets_tile_renderer_real_render (GtkCellRenderer* base,
                                         cairo_t* cr,
                                         GtkWidget* widget,
                                         GdkRectangle* bg_area,
                                         GdkRectangle* cell_area,
                                         GtkCellRendererState flags)
{
	NoiseWidgetsTileRenderer * self;
	GdkRectangle aligned_area = {0};
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_ = {0};
	gint x = 0;
	GdkRectangle _tmp2_;
	gint _tmp3_;
	gint y = 0;
	GdkRectangle _tmp4_;
	gint _tmp5_;
	gint width = 0;
	GdkRectangle _tmp6_;
	gint _tmp7_;
	gint height = 0;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GtkBorder _tmp11_;
	gint16 _tmp12_;
	GtkBorder _tmp13_;
	gint16 _tmp14_;
	GtkBorder _tmp15_;
	gint16 _tmp16_;
	gint _tmp17_;
	GtkBorder _tmp18_;
	gint16 _tmp19_;
	GtkBorder _tmp20_;
	gint16 _tmp21_;
	GtkBorder _tmp22_;
	gint16 _tmp23_;
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp24_;
	gint _tmp25_;
	GtkBorder _tmp26_;
	gint16 _tmp27_;
	GtkBorder _tmp28_;
	gint16 _tmp29_;
	GtkBorder _tmp30_;
	gint16 _tmp31_;
	GtkBorder _tmp32_;
	gint16 _tmp33_;
	GtkBorder _tmp34_;
	gint16 _tmp35_;
	GtkBorder _tmp36_;
	gint16 _tmp37_;
	gint _tmp38_;
	GtkBorder _tmp39_;
	gint16 _tmp40_;
	GtkBorder _tmp41_;
	gint16 _tmp42_;
	GtkBorder _tmp43_;
	gint16 _tmp44_;
	GtkBorder _tmp45_;
	gint16 _tmp46_;
	GtkBorder _tmp47_;
	gint16 _tmp48_;
	GtkBorder _tmp49_;
	gint16 _tmp50_;
	gint _tmp51_;
	gint _tmp52_;
	gint _tmp53_;
	gint _tmp54_;
	gint _tmp55_;
	gint _tmp56_;
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	self = (NoiseWidgetsTileRenderer*) base;
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (widget != NULL);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (bg_area != NULL);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (cell_area != NULL);
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	noise_widgets_tile_renderer_update_layout_properties (self, widget);
#line 102 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp0_ = *cell_area;
#line 102 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_cell_renderer_get_aligned_area ((GtkCellRenderer*) self, widget, flags, &_tmp0_, &_tmp1_);
#line 102 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	aligned_area = _tmp1_;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp2_ = aligned_area;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp3_ = _tmp2_.x;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	x = _tmp3_;
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp4_ = aligned_area;
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp5_ = _tmp4_.y;
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	y = _tmp5_;
#line 106 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp6_ = aligned_area;
#line 106 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp7_ = _tmp6_.width;
#line 106 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	width = _tmp7_;
#line 107 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp8_ = aligned_area;
#line 107 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp9_ = _tmp8_.height;
#line 107 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	height = _tmp9_;
#line 110 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp10_ = x;
#line 110 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp11_ = self->priv->margin;
#line 110 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp12_ = _tmp11_.left;
#line 110 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp13_ = self->priv->border;
#line 110 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp14_ = _tmp13_.left;
#line 110 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp15_ = self->priv->padding;
#line 110 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp16_ = _tmp15_.left;
#line 110 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	x = _tmp10_ + ((_tmp12_ + _tmp14_) + _tmp16_);
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp17_ = y;
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp18_ = self->priv->margin;
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp19_ = _tmp18_.top;
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp20_ = self->priv->border;
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp21_ = _tmp20_.top;
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp22_ = self->priv->padding;
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp23_ = _tmp22_.top;
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	y = _tmp17_ + ((_tmp19_ + _tmp21_) + _tmp23_);
#line 113 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp24_ = gtk_widget_get_style_context (widget);
#line 113 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	ctx = _tmp24_;
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp25_ = width;
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp26_ = self->priv->margin;
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp27_ = _tmp26_.left;
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp28_ = self->priv->margin;
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp29_ = _tmp28_.right;
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp30_ = self->priv->border;
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp31_ = _tmp30_.left;
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp32_ = self->priv->border;
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp33_ = _tmp32_.right;
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp34_ = self->priv->padding;
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp35_ = _tmp34_.left;
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp36_ = self->priv->padding;
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp37_ = _tmp36_.right;
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	width = _tmp25_ - (((((_tmp27_ + _tmp29_) + _tmp31_) + _tmp33_) + _tmp35_) + _tmp37_);
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp38_ = height;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp39_ = self->priv->margin;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp40_ = _tmp39_.top;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp41_ = self->priv->margin;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp42_ = _tmp41_.bottom;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp43_ = self->priv->border;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp44_ = _tmp43_.top;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp45_ = self->priv->border;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp46_ = _tmp45_.bottom;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp47_ = self->priv->padding;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp48_ = _tmp47_.top;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp49_ = self->priv->padding;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp50_ = _tmp49_.bottom;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	height = _tmp38_ - (((((_tmp40_ + _tmp42_) + _tmp44_) + _tmp46_) + _tmp48_) + _tmp50_);
#line 118 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp51_ = width;
#line 118 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	noise_widgets_tile_renderer_render_image (self, ctx, cr, &x, &y, _tmp51_, flags);
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp52_ = x;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp53_ = width;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	noise_widgets_tile_renderer_render_title (self, ctx, cr, _tmp52_, &y, _tmp53_);
#line 120 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp54_ = x;
#line 120 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp55_ = y;
#line 120 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp56_ = width;
#line 120 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	noise_widgets_tile_renderer_render_subtitle (self, ctx, cr, _tmp54_, _tmp55_, _tmp56_);
#line 674 "TileRenderer.c"
}


static void
noise_widgets_tile_renderer_render_image (NoiseWidgetsTileRenderer* self,
                                          GtkStyleContext* ctx,
                                          cairo_t* cr,
                                          gint* x,
                                          gint* y,
                                          gint width,
                                          GtkCellRendererState flags)
{
	gint image_width = 0;
	gint image_height = 0;
	GdkPixbuf* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GdkPixbuf* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GdkPixbuf* _tmp6_;
	GtkBorder _tmp7_;
	gint16 _tmp8_;
	GtkBorder _tmp9_;
	gint16 _tmp10_;
	GdkPixbuf* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	GtkBorder _tmp14_;
	gint16 _tmp15_;
	GtkBorder _tmp16_;
	gint16 _tmp17_;
	GdkPixbuf* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	GtkBorder _tmp21_;
	gint16 _tmp22_;
	GtkBorder _tmp23_;
	gint16 _tmp24_;
	GdkPixbuf* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	GtkBorder _tmp28_;
	gint16 _tmp29_;
#line 123 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (self != NULL);
#line 123 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (ctx != NULL);
#line 123 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 126 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	image_width = noise_widgets_tile_renderer_compute_total_image_width (self);
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	image_height = noise_widgets_tile_renderer_compute_total_image_height (self);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	*x = (*x) + ((width - image_width) / 2);
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_save (ctx);
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_add_class (ctx, "album");
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp0_ = self->priv->pixbuf;
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp1_ = gdk_pixbuf_get_width (_tmp0_);
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp2_ = _tmp1_;
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp3_ = self->priv->pixbuf;
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp4_ = gdk_pixbuf_get_height (_tmp3_);
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp5_ = _tmp4_;
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_render_background (ctx, cr, (gdouble) (*x), (gdouble) (*y), (gdouble) _tmp2_, (gdouble) _tmp5_);
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp6_ = self->priv->pixbuf;
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_render_icon (ctx, cr, _tmp6_, (gdouble) (*x), (gdouble) (*y));
#line 135 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	cairo_fill_preserve (cr);
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp7_ = self->priv->border;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp8_ = _tmp7_.left;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp9_ = self->priv->border;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp10_ = _tmp9_.top;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp11_ = self->priv->pixbuf;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp12_ = gdk_pixbuf_get_width (_tmp11_);
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp13_ = _tmp12_;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp14_ = self->priv->border;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp15_ = _tmp14_.left;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp16_ = self->priv->border;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp17_ = _tmp16_.right;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp18_ = self->priv->pixbuf;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp19_ = gdk_pixbuf_get_height (_tmp18_);
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp20_ = _tmp19_;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp21_ = self->priv->border;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp22_ = _tmp21_.top;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp23_ = self->priv->border;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp24_ = _tmp23_.bottom;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_render_frame (ctx, cr, (gdouble) ((*x) - _tmp8_), (gdouble) ((*y) - _tmp10_), (gdouble) ((_tmp13_ + _tmp15_) + _tmp17_), (gdouble) ((_tmp20_ + _tmp22_) + _tmp24_));
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_restore (ctx);
#line 139 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	*y = (*y) + image_height;
#line 142 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp25_ = self->priv->pixbuf;
#line 142 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp26_ = gdk_pixbuf_get_width (_tmp25_);
#line 142 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp27_ = _tmp26_;
#line 142 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp28_ = self->priv->margin;
#line 142 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp29_ = _tmp28_.left;
#line 142 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	*x = (*x) + (((image_width - _tmp27_) / 2) - _tmp29_);
#line 809 "TileRenderer.c"
}


static void
noise_widgets_tile_renderer_render_title (NoiseWidgetsTileRenderer* self,
                                          GtkStyleContext* ctx,
                                          cairo_t* cr,
                                          gint x,
                                          gint* y,
                                          gint width)
{
	PangoLayout* _tmp0_;
	gint title_height = 0;
	PangoLayout* _tmp1_;
	gint _tmp2_ = 0;
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (self != NULL);
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (ctx != NULL);
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 148 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_save (ctx);
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_add_class (ctx, "h4");
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp0_ = self->priv->title_text_layout;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_render_layout (ctx, cr, (gdouble) x, (gdouble) (*y), _tmp0_);
#line 151 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_restore (ctx);
#line 154 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp1_ = self->priv->title_text_layout;
#line 154 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_get_pixel_size (_tmp1_, NULL, &_tmp2_);
#line 154 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	title_height = _tmp2_;
#line 156 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	*y = (*y) + title_height;
#line 849 "TileRenderer.c"
}


static void
noise_widgets_tile_renderer_render_subtitle (NoiseWidgetsTileRenderer* self,
                                             GtkStyleContext* ctx,
                                             cairo_t* cr,
                                             gint x,
                                             gint y,
                                             gint width)
{
	PangoLayout* _tmp0_;
#line 159 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (self != NULL);
#line 159 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (ctx != NULL);
#line 159 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 162 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp0_ = self->priv->subtitle_text_layout;
#line 162 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_render_layout (ctx, cr, (gdouble) x, (gdouble) y, _tmp0_);
#line 872 "TileRenderer.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	return self ? g_object_ref (self) : NULL;
#line 881 "TileRenderer.c"
}


static void
noise_widgets_tile_renderer_update_layout_properties (NoiseWidgetsTileRenderer* self,
                                                      GtkWidget* widget)
{
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStateFlags state = 0;
	GtkStyleContext* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkStateFlags _tmp7_;
	GtkBorder _tmp8_ = {0};
	GtkStyleContext* _tmp9_;
	GtkStateFlags _tmp10_;
	GtkBorder _tmp11_ = {0};
	GtkStyleContext* _tmp12_;
	GtkStateFlags _tmp13_;
	GtkBorder _tmp14_ = {0};
	GtkStyleContext* _tmp15_;
	NoiseAlbum* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	PangoLayout* _tmp19_;
	PangoFontDescription* font_description = NULL;
	GtkStyleContext* _tmp20_;
	GtkStateFlags _tmp21_;
	PangoLayout* _tmp22_;
	PangoFontDescription* _tmp23_;
	PangoLayout* _tmp24_;
	PangoLayout* _tmp25_;
	gint _tmp26_ = 0;
	GdkPixbuf* _tmp27_;
	gint text_width = 0;
	PangoLayout* _tmp31_;
	GtkStyleContext* _tmp32_;
	GtkStyleContext* _tmp33_;
	NoiseAlbum* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	PangoLayout* _tmp37_;
	GtkStyleContext* _tmp38_;
	GtkStateFlags _tmp39_;
	PangoLayout* _tmp40_;
	PangoFontDescription* _tmp41_;
	PangoLayout* _tmp42_;
	PangoLayout* _tmp43_;
	PangoLayout* _tmp44_;
	GtkStyleContext* _tmp45_;
#line 165 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (self != NULL);
#line 165 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (widget != NULL);
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp0_ = gtk_widget_get_style_context (widget);
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	ctx = _tmp1_;
#line 167 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp2_ = ctx;
#line 167 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	noise_widgets_tile_renderer_render_prixbuf (self, _tmp2_);
#line 168 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp3_ = ctx;
#line 168 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	state = gtk_style_context_get_state (_tmp3_);
#line 170 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp4_ = ctx;
#line 170 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_save (_tmp4_);
#line 171 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp5_ = ctx;
#line 171 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_add_class (_tmp5_, "album");
#line 172 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp6_ = ctx;
#line 172 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp7_ = state;
#line 172 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_get_margin (_tmp6_, _tmp7_, &_tmp8_);
#line 172 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->margin = _tmp8_;
#line 173 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp9_ = ctx;
#line 173 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp10_ = state;
#line 173 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_get_padding (_tmp9_, _tmp10_, &_tmp11_);
#line 173 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->padding = _tmp11_;
#line 174 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp12_ = ctx;
#line 174 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp13_ = state;
#line 174 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_get_border (_tmp12_, _tmp13_, &_tmp14_);
#line 174 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->border = _tmp14_;
#line 175 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp15_ = ctx;
#line 175 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_restore (_tmp15_);
#line 177 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp16_ = self->priv->_album;
#line 177 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp17_ = noise_album_get_display_artist (_tmp16_);
#line 177 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp18_ = _tmp17_;
#line 177 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp19_ = gtk_widget_create_pango_layout (widget, _tmp18_);
#line 177 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (self->priv->subtitle_text_layout);
#line 177 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->subtitle_text_layout = _tmp19_;
#line 177 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_free0 (_tmp18_);
#line 179 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp20_ = ctx;
#line 179 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp21_ = state;
#line 179 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_get (_tmp20_, _tmp21_, GTK_STYLE_PROPERTY_FONT, &font_description, NULL);
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp22_ = self->priv->subtitle_text_layout;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp23_ = font_description;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_set_font_description (_tmp22_, _tmp23_);
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp24_ = self->priv->subtitle_text_layout;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_set_ellipsize (_tmp24_, PANGO_ELLIPSIZE_END);
#line 182 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp25_ = self->priv->subtitle_text_layout;
#line 182 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_set_alignment (_tmp25_, PANGO_ALIGN_LEFT);
#line 183 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp27_ = self->priv->pixbuf;
#line 183 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	if (_tmp27_ != NULL) {
#line 1028 "TileRenderer.c"
		GdkPixbuf* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
#line 183 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp28_ = self->priv->pixbuf;
#line 183 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp29_ = gdk_pixbuf_get_width (_tmp28_);
#line 183 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp30_ = _tmp29_;
#line 183 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp26_ = _tmp30_ * PANGO_SCALE;
#line 1040 "TileRenderer.c"
	} else {
#line 183 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp26_ = 0;
#line 1044 "TileRenderer.c"
	}
#line 183 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	text_width = _tmp26_;
#line 184 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp31_ = self->priv->subtitle_text_layout;
#line 184 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_set_width (_tmp31_, text_width);
#line 186 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp32_ = ctx;
#line 186 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_save (_tmp32_);
#line 187 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp33_ = ctx;
#line 187 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_add_class (_tmp33_, "h4");
#line 188 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp34_ = self->priv->_album;
#line 188 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp35_ = noise_album_get_display_name (_tmp34_);
#line 188 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp36_ = _tmp35_;
#line 188 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp37_ = gtk_widget_create_pango_layout (widget, _tmp36_);
#line 188 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (self->priv->title_text_layout);
#line 188 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->title_text_layout = _tmp37_;
#line 188 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_free0 (_tmp36_);
#line 189 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp38_ = ctx;
#line 189 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp39_ = state;
#line 189 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_get (_tmp38_, _tmp39_, GTK_STYLE_PROPERTY_FONT, &font_description, NULL);
#line 190 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp40_ = self->priv->title_text_layout;
#line 190 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp41_ = font_description;
#line 190 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_set_font_description (_tmp40_, _tmp41_);
#line 191 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp42_ = self->priv->title_text_layout;
#line 191 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_set_width (_tmp42_, text_width);
#line 192 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp43_ = self->priv->title_text_layout;
#line 192 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_set_ellipsize (_tmp43_, PANGO_ELLIPSIZE_END);
#line 193 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp44_ = self->priv->title_text_layout;
#line 193 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_set_alignment (_tmp44_, PANGO_ALIGN_LEFT);
#line 194 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp45_ = ctx;
#line 194 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_restore (_tmp45_);
#line 165 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (ctx);
#line 1104 "TileRenderer.c"
}


static gint
noise_widgets_tile_renderer_compute_total_image_width (NoiseWidgetsTileRenderer* self)
{
	gint result = 0;
	gint _tmp0_ = 0;
	GdkPixbuf* _tmp1_;
#line 197 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp1_ = self->priv->pixbuf;
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	if (_tmp1_ != NULL) {
#line 1120 "TileRenderer.c"
		GdkPixbuf* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		GtkBorder _tmp5_;
		gint16 _tmp6_;
		GtkBorder _tmp7_;
		gint16 _tmp8_;
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp2_ = self->priv->pixbuf;
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp3_ = gdk_pixbuf_get_width (_tmp2_);
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp4_ = _tmp3_;
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp5_ = self->priv->margin;
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp6_ = _tmp5_.left;
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp7_ = self->priv->margin;
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp8_ = _tmp7_.right;
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp0_ = (_tmp4_ + _tmp6_) + _tmp8_;
#line 1144 "TileRenderer.c"
	} else {
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp0_ = 0;
#line 1148 "TileRenderer.c"
	}
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	result = _tmp0_;
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	return result;
#line 1154 "TileRenderer.c"
}


static gint
noise_widgets_tile_renderer_compute_total_image_height (NoiseWidgetsTileRenderer* self)
{
	gint result = 0;
	gint _tmp0_ = 0;
	GdkPixbuf* _tmp1_;
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp1_ = self->priv->pixbuf;
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	if (_tmp1_ != NULL) {
#line 1170 "TileRenderer.c"
		GdkPixbuf* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		GtkBorder _tmp5_;
		gint16 _tmp6_;
		GtkBorder _tmp7_;
		gint16 _tmp8_;
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp2_ = self->priv->pixbuf;
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp3_ = gdk_pixbuf_get_height (_tmp2_);
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp4_ = _tmp3_;
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp5_ = self->priv->margin;
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp6_ = _tmp5_.top;
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp7_ = self->priv->margin;
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp8_ = _tmp7_.bottom;
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp0_ = (_tmp4_ + _tmp6_) + _tmp8_;
#line 1194 "TileRenderer.c"
	} else {
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp0_ = 0;
#line 1198 "TileRenderer.c"
	}
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	result = _tmp0_;
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	return result;
#line 1204 "TileRenderer.c"
}


static void
noise_widgets_tile_renderer_render_prixbuf (NoiseWidgetsTileRenderer* self,
                                            GtkStyleContext* ctx)
{
	gint scale = 0;
	gboolean _tmp0_ = FALSE;
	GdkPixbuf* _tmp1_;
	NoiseAlbum* _tmp16_;
	gint _tmp17_;
	GdkPixbuf* _tmp18_;
	GdkPixbuf* _tmp19_;
	GError * _inner_error_ = NULL;
#line 205 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (self != NULL);
#line 205 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (ctx != NULL);
#line 206 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	scale = gtk_style_context_get_scale (ctx);
#line 207 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp1_ = self->priv->fallback_pixbuf;
#line 207 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	if (_tmp1_ == NULL) {
#line 207 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp0_ = TRUE;
#line 1232 "TileRenderer.c"
	} else {
		gint _tmp2_;
		gint _tmp3_;
#line 207 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp2_ = self->priv->fallback_pixbuf_scale;
#line 207 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp3_ = scale;
#line 207 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp0_ = _tmp2_ != _tmp3_;
#line 1242 "TileRenderer.c"
	}
#line 207 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	if (_tmp0_) {
#line 1246 "TileRenderer.c"
		GtkIconInfo* icon_info = NULL;
		GtkIconTheme* _tmp4_;
		GThemedIcon* _tmp5_;
		GThemedIcon* _tmp6_;
		gint _tmp7_;
		GtkIconInfo* _tmp8_;
		GtkIconInfo* _tmp9_;
#line 208 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp4_ = gtk_icon_theme_get_default ();
#line 208 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp5_ = (GThemedIcon*) g_themed_icon_new ("albumart");
#line 208 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp6_ = _tmp5_;
#line 208 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp7_ = scale;
#line 208 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp8_ = gtk_icon_theme_lookup_by_gicon_for_scale (_tmp4_, (GIcon*) _tmp6_, 128, _tmp7_, GTK_ICON_LOOKUP_GENERIC_FALLBACK);
#line 208 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp9_ = _tmp8_;
#line 208 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_g_object_unref0 (_tmp6_);
#line 208 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		icon_info = _tmp9_;
#line 1270 "TileRenderer.c"
		{
			GdkPixbuf* _tmp10_ = NULL;
			GtkIconInfo* _tmp11_;
			GdkPixbuf* _tmp12_;
			GdkPixbuf* _tmp13_;
#line 210 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			_tmp11_ = icon_info;
#line 210 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			_tmp12_ = gtk_icon_info_load_icon (_tmp11_, &_inner_error_);
#line 210 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			_tmp10_ = _tmp12_;
#line 210 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1284 "TileRenderer.c"
				goto __catch70_g_error;
			}
#line 210 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			_tmp13_ = _tmp10_;
#line 210 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			_tmp10_ = NULL;
#line 210 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			_g_object_unref0 (self->priv->fallback_pixbuf);
#line 210 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			self->priv->fallback_pixbuf = _tmp13_;
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			_g_object_unref0 (_tmp10_);
#line 1297 "TileRenderer.c"
		}
		goto __finally70;
		__catch70_g_error:
		{
			GError* e = NULL;
			GError* _tmp14_;
			const gchar* _tmp15_;
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			e = _inner_error_;
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			_inner_error_ = NULL;
#line 212 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			_tmp14_ = e;
#line 212 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			_tmp15_ = _tmp14_->message;
#line 212 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			g_critical ("TileRenderer.vala:212: %s", _tmp15_);
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			_g_error_free0 (e);
#line 1317 "TileRenderer.c"
		}
		__finally70:
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			_gtk_icon_info_free0 (icon_info);
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			g_clear_error (&_inner_error_);
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
			return;
#line 1330 "TileRenderer.c"
		}
#line 207 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_gtk_icon_info_free0 (icon_info);
#line 1334 "TileRenderer.c"
	}
#line 216 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp16_ = self->priv->_album;
#line 216 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp17_ = scale;
#line 216 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp18_ = noise_album_get_cached_cover_pixbuf (_tmp16_, _tmp17_);
#line 216 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (self->priv->pixbuf);
#line 216 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->pixbuf = _tmp18_;
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp19_ = self->priv->pixbuf;
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	if (_tmp19_ == NULL) {
#line 1350 "TileRenderer.c"
		GdkPixbuf* _tmp20_;
		GdkPixbuf* _tmp21_;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp20_ = self->priv->fallback_pixbuf;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_g_object_unref0 (self->priv->pixbuf);
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		self->priv->pixbuf = _tmp21_;
#line 1361 "TileRenderer.c"
	}
}


NoiseAlbum*
noise_widgets_tile_renderer_get_album (NoiseWidgetsTileRenderer* self)
{
	NoiseAlbum* result;
	NoiseAlbum* _tmp0_;
#line 28 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp0_ = self->priv->_album;
#line 28 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	result = _tmp0_;
#line 28 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	return result;
#line 1379 "TileRenderer.c"
}


void
noise_widgets_tile_renderer_set_album (NoiseWidgetsTileRenderer* self,
                                       NoiseAlbum* value)
{
#line 28 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (self != NULL);
#line 28 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	if (noise_widgets_tile_renderer_get_album (self) != value) {
#line 1391 "TileRenderer.c"
		NoiseAlbum* _tmp0_;
#line 28 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 28 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		_g_object_unref0 (self->priv->_album);
#line 28 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		self->priv->_album = _tmp0_;
#line 28 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_widgets_tile_renderer_properties[NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY]);
#line 1401 "TileRenderer.c"
	}
}


static void
noise_widgets_tile_renderer_class_init (NoiseWidgetsTileRendererClass * klass)
{
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	noise_widgets_tile_renderer_parent_class = g_type_class_peek_parent (klass);
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_type_class_add_private (klass, sizeof (NoiseWidgetsTileRendererPrivate));
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	((GtkCellRendererClass *) klass)->get_size = (void (*) (GtkCellRenderer *, GtkWidget*, GdkRectangle*, gint*, gint*, gint*, gint*)) noise_widgets_tile_renderer_real_get_size;
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	((GtkCellRendererClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkCellRenderer *)) noise_widgets_tile_renderer_real_get_request_mode;
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	((GtkCellRendererClass *) klass)->get_preferred_width = (void (*) (GtkCellRenderer *, GtkWidget*, gint*, gint*)) noise_widgets_tile_renderer_real_get_preferred_width;
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	((GtkCellRendererClass *) klass)->get_preferred_height_for_width = (void (*) (GtkCellRenderer *, GtkWidget*, gint, gint*, gint*)) noise_widgets_tile_renderer_real_get_preferred_height_for_width;
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	((GtkCellRendererClass *) klass)->render = (void (*) (GtkCellRenderer *, cairo_t*, GtkWidget*, GdkRectangle*, GdkRectangle*, GtkCellRendererState)) noise_widgets_tile_renderer_real_render;
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_widgets_tile_renderer_get_property;
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_widgets_tile_renderer_set_property;
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_widgets_tile_renderer_finalize;
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY, noise_widgets_tile_renderer_properties[NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY] = g_param_spec_object ("album", "album", "album", NOISE_TYPE_ALBUM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1431 "TileRenderer.c"
}


static void
noise_widgets_tile_renderer_instance_init (NoiseWidgetsTileRenderer * self)
{
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv = NOISE_WIDGETS_TILE_RENDERER_GET_PRIVATE (self);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->fallback_pixbuf_scale = 1;
#line 1442 "TileRenderer.c"
}


static void
noise_widgets_tile_renderer_finalize (GObject * obj)
{
	NoiseWidgetsTileRenderer * self;
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRenderer);
#line 28 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (self->priv->_album);
#line 30 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (self->priv->title_text_layout);
#line 31 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (self->priv->subtitle_text_layout);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (self->priv->pixbuf);
#line 36 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (self->priv->fallback_pixbuf);
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	G_OBJECT_CLASS (noise_widgets_tile_renderer_parent_class)->finalize (obj);
#line 1464 "TileRenderer.c"
}


GType
noise_widgets_tile_renderer_get_type (void)
{
	static volatile gsize noise_widgets_tile_renderer_type_id__volatile = 0;
	if (g_once_init_enter (&noise_widgets_tile_renderer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseWidgetsTileRendererClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_widgets_tile_renderer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseWidgetsTileRenderer), 0, (GInstanceInitFunc) noise_widgets_tile_renderer_instance_init, NULL };
		GType noise_widgets_tile_renderer_type_id;
		noise_widgets_tile_renderer_type_id = g_type_register_static (gtk_cell_renderer_get_type (), "NoiseWidgetsTileRenderer", &g_define_type_info, 0);
		g_once_init_leave (&noise_widgets_tile_renderer_type_id__volatile, noise_widgets_tile_renderer_type_id);
	}
	return noise_widgets_tile_renderer_type_id__volatile;
}


static void
_vala_noise_widgets_tile_renderer_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	NoiseWidgetsTileRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRenderer);
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	switch (property_id) {
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		case NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY:
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		g_value_set_object (value, noise_widgets_tile_renderer_get_album (self));
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		break;
#line 1498 "TileRenderer.c"
		default:
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		break;
#line 1504 "TileRenderer.c"
	}
}


static void
_vala_noise_widgets_tile_renderer_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	NoiseWidgetsTileRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRenderer);
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
	switch (property_id) {
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		case NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY:
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		noise_widgets_tile_renderer_set_album (self, g_value_get_object (value));
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		break;
#line 1525 "TileRenderer.c"
		default:
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/FastView/TileView/TileRenderer.vala"
		break;
#line 1531 "TileRenderer.c"
	}
}



