/* AudioPlayerLibrary.c generated by valac 0.40.4, the Vala compiler
 * generated from AudioPlayerLibrary.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <noise-core.h>
#include <noise.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY (noise_plugins_audio_player_library_get_type ())
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibrary))
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibraryClass))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY))
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibraryClass))

typedef struct _NoisePluginsAudioPlayerLibrary NoisePluginsAudioPlayerLibrary;
typedef struct _NoisePluginsAudioPlayerLibraryClass NoisePluginsAudioPlayerLibraryClass;
typedef struct _NoisePluginsAudioPlayerLibraryPrivate NoisePluginsAudioPlayerLibraryPrivate;

#define NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE (noise_plugins_audio_player_device_get_type ())
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDevice))
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDeviceClass))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE))
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDeviceClass))

typedef struct _NoisePluginsAudioPlayerDevice NoisePluginsAudioPlayerDevice;
typedef struct _NoisePluginsAudioPlayerDeviceClass NoisePluginsAudioPlayerDeviceClass;
enum  {
	NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_0_PROPERTY,
	NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_NUM_PROPERTIES
};
static GParamSpec* noise_plugins_audio_player_library_properties[NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block1Data Block1Data;

struct _NoisePluginsAudioPlayerLibrary {
	NoiseLibrary parent_instance;
	NoisePluginsAudioPlayerLibraryPrivate * priv;
	gint medias_rowid;
	gint playlists_rowid;
	gint smartplaylists_rowid;
	NoiseGStreamerTagger* tagger;
};

struct _NoisePluginsAudioPlayerLibraryClass {
	NoiseLibraryClass parent_class;
};

struct _NoisePluginsAudioPlayerLibraryPrivate {
	NoisePluginsAudioPlayerDevice* device;
	GeeLinkedList* medias;
	GRecMutex __lock_medias;
	GeeLinkedList* searched_medias;
	GRecMutex __lock_searched_medias;
	GeeLinkedList* playlists;
	gboolean operation_cancelled;
	gboolean is_doing_file_operations;
	gboolean queue_is_finished;
	GeeLinkedList* imported_files;
	gboolean is_initialized;
};

struct _Block1Data {
	int _ref_count_;
	NoisePluginsAudioPlayerLibrary* self;
	NoiseStaticPlaylist* p;
};


static gpointer noise_plugins_audio_player_library_parent_class = NULL;
static GType noise_plugins_audio_player_library_type_id = 0;

GType noise_plugins_audio_player_library_get_type (void) G_GNUC_CONST;
GType noise_plugins_audio_player_device_get_type (void) G_GNUC_CONST;
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibraryPrivate))
NoisePluginsAudioPlayerLibrary* noise_plugins_audio_player_library_new (NoisePluginsAudioPlayerDevice* device);
NoisePluginsAudioPlayerLibrary* noise_plugins_audio_player_library_construct (GType object_type,
                                                                              NoisePluginsAudioPlayerDevice* device);
static void noise_plugins_audio_player_library_media_imported_from_tagger (NoisePluginsAudioPlayerLibrary* self,
                                                                    NoiseMedia* m);
static void _noise_plugins_audio_player_library_media_imported_from_tagger_noise_gstreamer_tagger_media_imported (NoiseGStreamerTagger* _sender,
                                                                                                           NoiseMedia* m,
                                                                                                           gpointer self);
static void noise_plugins_audio_player_library_import_error (NoisePluginsAudioPlayerLibrary* self,
                                                      const gchar* file);
static void _noise_plugins_audio_player_library_import_error_noise_gstreamer_tagger_import_error (NoiseGStreamerTagger* _sender,
                                                                                           const gchar* file_uri,
                                                                                           GError* _error_,
                                                                                           gpointer self);
void noise_plugins_audio_player_library_queue_finished (NoisePluginsAudioPlayerLibrary* self);
static void _noise_plugins_audio_player_library_queue_finished_noise_gstreamer_tagger_queue_finished (NoiseGStreamerTagger* _sender,
                                                                                               gpointer self);
static void __lambda4_ (NoisePluginsAudioPlayerLibrary* self);
static void ___lambda4__noise_notification_manager_progress_canceled (NoiseNotificationManager* _sender,
                                                               gpointer self);
static void noise_plugins_audio_player_library_real_initialize_library (NoiseLibrary* base);
static void noise_plugins_audio_player_library_real_add_files_to_library (NoiseLibrary* base,
                                                                   GeeCollection* files);
static GeeCollection* noise_plugins_audio_player_library_real_get_medias (NoiseLibrary* base);
static GeeCollection* noise_plugins_audio_player_library_real_get_playlists (NoiseLibrary* base);
static GeeCollection* noise_plugins_audio_player_library_real_get_smart_playlists (NoiseLibrary* base);
static void noise_plugins_audio_player_library_real_search_medias (NoiseLibrary* base,
                                                            const gchar* search);
static GeeCollection* noise_plugins_audio_player_library_real_get_search_result (NoiseLibrary* base);
static void noise_plugins_audio_player_library_real_add_media (NoiseLibrary* base,
                                                        NoiseMedia* m);
gchar* noise_plugins_audio_player_device_get_music_folder (NoisePluginsAudioPlayerDevice* self);
static void noise_plugins_audio_player_library_real_add_medias (NoiseLibrary* base,
                                                         GeeCollection* list);
static gboolean _noise_libraries_manager_do_progress_notification_with_timeout_gsource_func (gpointer self);
static NoiseMedia* noise_plugins_audio_player_library_real_media_from_id (NoiseLibrary* base,
                                                                   gint64 id);
static GeeCollection* noise_plugins_audio_player_library_real_medias_from_ids (NoiseLibrary* base,
                                                                        GeeCollection* ids);
static GeeCollection* noise_plugins_audio_player_library_real_medias_from_uris (NoiseLibrary* base,
                                                                         GeeCollection* uris);
static NoiseMedia* noise_plugins_audio_player_library_real_find_media (NoiseLibrary* base,
                                                                NoiseMedia* to_find);
static NoiseMedia* noise_plugins_audio_player_library_real_media_from_file (NoiseLibrary* base,
                                                                     GFile* file);
static NoiseMedia* noise_plugins_audio_player_library_real_media_from_uri (NoiseLibrary* base,
                                                                    const gchar* uri);
static void noise_plugins_audio_player_library_real_update_media (NoiseLibrary* base,
                                                           NoiseMedia* s,
                                                           gboolean updateMeta,
                                                           gboolean record_time);
static void noise_plugins_audio_player_library_real_update_medias (NoiseLibrary* base,
                                                            GeeCollection* updates,
                                                            gboolean updateMeta,
                                                            gboolean record_time);
static void noise_plugins_audio_player_library_real_remove_media (NoiseLibrary* base,
                                                           NoiseMedia* m,
                                                           gboolean trash);
static void noise_plugins_audio_player_library_real_remove_medias (NoiseLibrary* base,
                                                            GeeCollection* list,
                                                            gboolean trash);
static gboolean noise_plugins_audio_player_library_real_support_smart_playlists (NoiseLibrary* base);
static void noise_plugins_audio_player_library_real_add_smart_playlist (NoiseLibrary* base,
                                                                 NoiseSmartPlaylist* p);
static void noise_plugins_audio_player_library_real_remove_smart_playlist (NoiseLibrary* base,
                                                                    gint64 id);
static NoiseSmartPlaylist* noise_plugins_audio_player_library_real_smart_playlist_from_id (NoiseLibrary* base,
                                                                                    gint64 id);
static NoiseSmartPlaylist* noise_plugins_audio_player_library_real_smart_playlist_from_name (NoiseLibrary* base,
                                                                                      const gchar* name);
static gboolean noise_plugins_audio_player_library_real_support_playlists (NoiseLibrary* base);
static void noise_plugins_audio_player_library_real_add_playlist (NoiseLibrary* base,
                                                           NoiseStaticPlaylist* p);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void noise_plugins_audio_player_library_keep_playlist_synchronized (NoisePluginsAudioPlayerLibrary* self,
                                                                    NoiseStaticPlaylist* p);
static void __lambda5_ (Block1Data* _data1_);
static void ___lambda5__noise_playlist_media_added (NoisePlaylist* _sender,
                                             GeeCollection* media,
                                             gpointer self);
static void __lambda6_ (Block1Data* _data1_);
static void ___lambda6__noise_playlist_media_removed (NoisePlaylist* _sender,
                                               GeeCollection* media,
                                               gpointer self);
static void __lambda7_ (Block1Data* _data1_,
                 const gchar* old_name);
static void noise_plugins_audio_player_library_remove_playlist_from_name (NoisePluginsAudioPlayerLibrary* self,
                                                                   const gchar* name);
static void ___lambda7__noise_playlist_updated (NoisePlaylist* _sender,
                                         const gchar* old_name,
                                         gpointer self);
static void noise_plugins_audio_player_library_real_remove_playlist (NoiseLibrary* base,
                                                              gint64 id);
static NoiseStaticPlaylist* noise_plugins_audio_player_library_real_playlist_from_id (NoiseLibrary* base,
                                                                               gint64 id);
static NoiseStaticPlaylist* noise_plugins_audio_player_library_real_playlist_from_name (NoiseLibrary* base,
                                                                                 const gchar* name);
static gboolean noise_plugins_audio_player_library_real_start_file_operations (NoiseLibrary* base,
                                                                        const gchar* message);
static gboolean noise_plugins_audio_player_library_real_doing_file_operations (NoiseLibrary* base);
static void noise_plugins_audio_player_library_real_finish_file_operations (NoiseLibrary* base);
static void noise_plugins_audio_player_library_finalize (GObject * obj);


static gpointer
_g_object_ref0 (gpointer self)
{
#line 47 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return self ? g_object_ref (self) : NULL;
#line 228 "AudioPlayerLibrary.c"
}


static void
_noise_plugins_audio_player_library_media_imported_from_tagger_noise_gstreamer_tagger_media_imported (NoiseGStreamerTagger* _sender,
                                                                                                      NoiseMedia* m,
                                                                                                      gpointer self)
{
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	noise_plugins_audio_player_library_media_imported_from_tagger ((NoisePluginsAudioPlayerLibrary*) self, m);
#line 239 "AudioPlayerLibrary.c"
}


static void
_noise_plugins_audio_player_library_import_error_noise_gstreamer_tagger_import_error (NoiseGStreamerTagger* _sender,
                                                                                      const gchar* file_uri,
                                                                                      GError* _error_,
                                                                                      gpointer self)
{
#line 56 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	noise_plugins_audio_player_library_import_error ((NoisePluginsAudioPlayerLibrary*) self, file_uri);
#line 251 "AudioPlayerLibrary.c"
}


static void
_noise_plugins_audio_player_library_queue_finished_noise_gstreamer_tagger_queue_finished (NoiseGStreamerTagger* _sender,
                                                                                          gpointer self)
{
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	noise_plugins_audio_player_library_queue_finished ((NoisePluginsAudioPlayerLibrary*) self);
#line 261 "AudioPlayerLibrary.c"
}


static void
__lambda4_ (NoisePluginsAudioPlayerLibrary* self)
{
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->operation_cancelled = TRUE;
#line 270 "AudioPlayerLibrary.c"
}


static void
___lambda4__noise_notification_manager_progress_canceled (NoiseNotificationManager* _sender,
                                                          gpointer self)
{
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	__lambda4_ ((NoisePluginsAudioPlayerLibrary*) self);
#line 280 "AudioPlayerLibrary.c"
}


NoisePluginsAudioPlayerLibrary*
noise_plugins_audio_player_library_construct (GType object_type,
                                              NoisePluginsAudioPlayerDevice* device)
{
	NoisePluginsAudioPlayerLibrary * self = NULL;
	NoisePluginsAudioPlayerDevice* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp2_;
	GeeLinkedList* _tmp3_;
	GeeLinkedList* _tmp4_;
	NoiseGStreamerTagger* _tmp5_;
	NoiseGStreamerTagger* _tmp6_;
	NoiseGStreamerTagger* _tmp7_;
	NoiseGStreamerTagger* _tmp8_;
	NoiseNotificationManager* _tmp9_;
	NoiseNotificationManager* _tmp10_;
#line 46 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 46 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) noise_library_construct (object_type);
#line 47 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = _g_object_ref0 (device);
#line 47 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->device);
#line 47 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->device = _tmp0_;
#line 48 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 48 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->medias);
#line 48 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->medias = _tmp1_;
#line 49 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 49 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->searched_medias);
#line 49 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->searched_medias = _tmp2_;
#line 50 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = gee_linked_list_new (NOISE_TYPE_STATIC_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 50 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->playlists);
#line 50 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->playlists = _tmp3_;
#line 51 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 51 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->imported_files);
#line 51 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->imported_files = _tmp4_;
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp5_ = noise_gstreamer_tagger_new (NULL);
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->tagger);
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->tagger = _tmp5_;
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp6_ = self->tagger;
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_connect_object (_tmp6_, "media-imported", (GCallback) _noise_plugins_audio_player_library_media_imported_from_tagger_noise_gstreamer_tagger_media_imported, self, 0);
#line 56 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp7_ = self->tagger;
#line 56 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_connect_object (_tmp7_, "import-error", (GCallback) _noise_plugins_audio_player_library_import_error_noise_gstreamer_tagger_import_error, self, 0);
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp8_ = self->tagger;
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_connect_object (_tmp8_, "queue-finished", (GCallback) _noise_plugins_audio_player_library_queue_finished_noise_gstreamer_tagger_queue_finished, self, 0);
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp9_ = noise_notification_manager_get_default ();
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp10_ = _tmp9_;
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_connect_object (_tmp10_, "progress-canceled", (GCallback) ___lambda4__noise_notification_manager_progress_canceled, self, 0);
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (_tmp10_);
#line 46 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return self;
#line 362 "AudioPlayerLibrary.c"
}


NoisePluginsAudioPlayerLibrary*
noise_plugins_audio_player_library_new (NoisePluginsAudioPlayerDevice* device)
{
#line 46 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return noise_plugins_audio_player_library_construct (NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, device);
#line 371 "AudioPlayerLibrary.c"
}


static void
noise_plugins_audio_player_library_media_imported_from_tagger (NoisePluginsAudioPlayerLibrary* self,
                                                               NoiseMedia* m)
{
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_;
#line 61 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (self != NULL);
#line 61 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (m != NULL);
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	noise_media_set_isTemporary (m, TRUE);
#line 63 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = self->priv->medias;
#line 63 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, m);
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = self->medias_rowid;
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	noise_media_set_rowid (m, (gint64) _tmp1_);
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = self->medias_rowid;
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->medias_rowid = _tmp2_ + 1;
#line 66 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = self->priv->queue_is_finished;
#line 66 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp3_) {
#line 67 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_signal_emit_by_name ((NoiseLibrary*) self, "file-operations-done");
#line 407 "AudioPlayerLibrary.c"
	}
}


static void
noise_plugins_audio_player_library_import_error (NoisePluginsAudioPlayerLibrary* self,
                                                 const gchar* file)
{
#line 70 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (self != NULL);
#line 70 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (file != NULL);
#line 420 "AudioPlayerLibrary.c"
}


void
noise_plugins_audio_player_library_queue_finished (NoisePluginsAudioPlayerLibrary* self)
{
	NoiseLibrariesManager* _tmp0_;
	gboolean _tmp1_;
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (self != NULL);
#line 74 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->queue_is_finished = TRUE;
#line 75 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = noise_libraries_manager;
#line 75 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_->progress = (gdouble) 1;
#line 76 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = self->priv->is_initialized;
#line 76 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp1_ == FALSE) {
#line 441 "AudioPlayerLibrary.c"
		NoisePluginsAudioPlayerDevice* _tmp2_;
		NoisePluginsAudioPlayerDevice* _tmp3_;
#line 77 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		self->priv->is_initialized = TRUE;
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp2_ = self->priv->device;
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp3_ = self->priv->device;
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_signal_emit_by_name ((NoiseDevice*) _tmp2_, "initialized", (NoiseDevice*) _tmp3_);
#line 79 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		noise_library_search_medias ((NoiseLibrary*) self, "");
#line 454 "AudioPlayerLibrary.c"
	}
}


static void
noise_plugins_audio_player_library_real_initialize_library (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
#line 83 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 465 "AudioPlayerLibrary.c"
}


static void
noise_plugins_audio_player_library_real_add_files_to_library (NoiseLibrary* base,
                                                              GeeCollection* files)
{
	NoisePluginsAudioPlayerLibrary * self;
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 87 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (files != NULL);
#line 478 "AudioPlayerLibrary.c"
}


static GeeCollection*
noise_plugins_audio_player_library_real_get_medias (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
	GeeCollection* result = NULL;
	GeeLinkedList* _tmp0_;
	GeeCollection* _tmp1_;
#line 91 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 92 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = self->priv->medias;
#line 92 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = _g_object_ref0 ((GeeCollection*) _tmp0_);
#line 92 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = _tmp1_;
#line 92 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 499 "AudioPlayerLibrary.c"
}


static GeeCollection*
noise_plugins_audio_player_library_real_get_playlists (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
	GeeCollection* result = NULL;
	GeeLinkedList* _tmp0_;
	GeeCollection* _tmp1_;
#line 94 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 95 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = self->priv->playlists;
#line 95 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = _g_object_ref0 ((GeeCollection*) _tmp0_);
#line 95 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = _tmp1_;
#line 95 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 520 "AudioPlayerLibrary.c"
}


static GeeCollection*
noise_plugins_audio_player_library_real_get_smart_playlists (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
	GeeCollection* result = NULL;
	GeeLinkedList* _tmp0_;
#line 97 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 98 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_SMART_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 98 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = (GeeCollection*) _tmp0_;
#line 98 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 538 "AudioPlayerLibrary.c"
}


static void
noise_plugins_audio_player_library_real_search_medias (NoiseLibrary* base,
                                                       const gchar* search)
{
	NoisePluginsAudioPlayerLibrary * self;
	GError * _inner_error_ = NULL;
#line 101 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 101 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (search != NULL);
#line 552 "AudioPlayerLibrary.c"
	{
		GeeLinkedList* _tmp0_;
#line 102 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp0_ = self->priv->searched_medias;
#line 102 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_searched_medias);
#line 559 "AudioPlayerLibrary.c"
		{
			GeeLinkedList* _tmp1_;
			gboolean _tmp2_ = FALSE;
			guint parsed_rating = 0U;
			gchar* parsed_search_string = NULL;
			guint _tmp6_ = 0U;
			gchar* _tmp7_ = NULL;
			gboolean rating_search = FALSE;
			guint _tmp8_;
#line 103 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp1_ = self->priv->searched_medias;
#line 103 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
#line 104 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			if (g_strcmp0 (search, "") == 0) {
#line 104 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp2_ = TRUE;
#line 577 "AudioPlayerLibrary.c"
			} else {
#line 104 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp2_ = search == NULL;
#line 581 "AudioPlayerLibrary.c"
			}
#line 104 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			if (_tmp2_) {
#line 585 "AudioPlayerLibrary.c"
				GeeLinkedList* _tmp3_;
				GeeLinkedList* _tmp4_;
#line 105 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp3_ = self->priv->searched_medias;
#line 105 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp4_ = self->priv->medias;
#line 105 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				gee_collection_add_all ((GeeCollection*) _tmp3_, (GeeCollection*) _tmp4_);
#line 106 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				g_signal_emit_by_name ((NoiseLibrary*) self, "search-finished");
#line 596 "AudioPlayerLibrary.c"
				{
					GeeLinkedList* _tmp5_;
#line 102 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp5_ = self->priv->searched_medias;
#line 102 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					g_rec_mutex_unlock (&self->priv->__lock_searched_medias);
#line 603 "AudioPlayerLibrary.c"
				}
#line 107 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				return;
#line 607 "AudioPlayerLibrary.c"
			}
#line 112 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			noise_string_base_search_method (search, &_tmp6_, &_tmp7_);
#line 112 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			parsed_rating = _tmp6_;
#line 112 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_free0 (parsed_search_string);
#line 112 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			parsed_search_string = _tmp7_;
#line 113 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp8_ = parsed_rating;
#line 113 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			rating_search = _tmp8_ > ((guint) 0);
#line 621 "AudioPlayerLibrary.c"
			{
				GeeLinkedList* _tmp9_;
#line 115 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp9_ = self->priv->medias;
#line 115 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				g_rec_mutex_lock (&self->priv->__lock_medias);
#line 628 "AudioPlayerLibrary.c"
				{
					{
						GeeLinkedList* _m_list = NULL;
						GeeLinkedList* _tmp10_;
						GeeLinkedList* _tmp11_;
						gint _m_size = 0;
						GeeLinkedList* _tmp12_;
						gint _tmp13_;
						gint _tmp14_;
						gint _m_index = 0;
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp10_ = self->priv->medias;
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp11_ = _g_object_ref0 (_tmp10_);
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_m_list = _tmp11_;
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp12_ = _m_list;
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp14_ = _tmp13_;
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_m_size = _tmp14_;
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_m_index = -1;
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						while (TRUE) {
#line 657 "AudioPlayerLibrary.c"
							gint _tmp15_;
							gint _tmp16_;
							gint _tmp17_;
							NoiseMedia* m = NULL;
							GeeLinkedList* _tmp18_;
							gint _tmp19_;
							gpointer _tmp20_;
							gboolean _tmp21_;
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_tmp15_ = _m_index;
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_m_index = _tmp15_ + 1;
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_tmp16_ = _m_index;
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_tmp17_ = _m_size;
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							if (!(_tmp16_ < _tmp17_)) {
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
								break;
#line 678 "AudioPlayerLibrary.c"
							}
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_tmp18_ = _m_list;
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_tmp19_ = _m_index;
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, _tmp19_);
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							m = (NoiseMedia*) _tmp20_;
#line 117 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_tmp21_ = rating_search;
#line 117 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							if (_tmp21_) {
#line 692 "AudioPlayerLibrary.c"
								NoiseMedia* _tmp22_;
								guint _tmp23_;
								guint _tmp24_;
								guint _tmp25_;
#line 118 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
								_tmp22_ = m;
#line 118 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
								_tmp23_ = noise_media_get_rating (_tmp22_);
#line 118 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
								_tmp24_ = _tmp23_;
#line 118 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
								_tmp25_ = parsed_rating;
#line 118 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
								if (_tmp24_ == _tmp25_) {
#line 707 "AudioPlayerLibrary.c"
									GeeLinkedList* _tmp26_;
									NoiseMedia* _tmp27_;
#line 119 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
									_tmp26_ = self->priv->searched_medias;
#line 119 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
									_tmp27_ = m;
#line 119 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, _tmp27_);
#line 716 "AudioPlayerLibrary.c"
								}
							} else {
								NoiseMedia* _tmp28_;
								const gchar* _tmp29_;
#line 120 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
								_tmp28_ = m;
#line 120 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
								_tmp29_ = parsed_search_string;
#line 120 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
								if (noise_search_match_string_to_media (_tmp28_, _tmp29_)) {
#line 727 "AudioPlayerLibrary.c"
									GeeLinkedList* _tmp30_;
									NoiseMedia* _tmp31_;
#line 121 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
									_tmp30_ = self->priv->searched_medias;
#line 121 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
									_tmp31_ = m;
#line 121 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
#line 736 "AudioPlayerLibrary.c"
								}
							}
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_g_object_unref0 (m);
#line 741 "AudioPlayerLibrary.c"
						}
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_object_unref0 (_m_list);
#line 745 "AudioPlayerLibrary.c"
					}
				}
				__finally6:
				{
					GeeLinkedList* _tmp32_;
#line 115 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp32_ = self->priv->medias;
#line 115 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 755 "AudioPlayerLibrary.c"
				}
#line 115 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 115 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_free0 (parsed_search_string);
#line 115 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_free0 (parsed_search_string);
#line 763 "AudioPlayerLibrary.c"
					{
						GeeLinkedList* _tmp33_;
#line 102 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp33_ = self->priv->searched_medias;
#line 102 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						g_rec_mutex_unlock (&self->priv->__lock_searched_medias);
#line 770 "AudioPlayerLibrary.c"
					}
#line 115 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 115 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					g_clear_error (&_inner_error_);
#line 115 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					return;
#line 778 "AudioPlayerLibrary.c"
				}
			}
#line 102 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_free0 (parsed_search_string);
#line 783 "AudioPlayerLibrary.c"
		}
		__finally5:
		{
			GeeLinkedList* _tmp34_;
#line 102 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp34_ = self->priv->searched_medias;
#line 102 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_searched_medias);
#line 792 "AudioPlayerLibrary.c"
		}
#line 102 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 102 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 102 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_clear_error (&_inner_error_);
#line 102 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			return;
#line 802 "AudioPlayerLibrary.c"
		}
	}
#line 126 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_emit_by_name ((NoiseLibrary*) self, "search-finished");
#line 807 "AudioPlayerLibrary.c"
}


static GeeCollection*
noise_plugins_audio_player_library_real_get_search_result (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
	GeeCollection* result = NULL;
	GeeLinkedList* _tmp0_;
	GeeCollection* _tmp1_;
#line 129 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = self->priv->searched_medias;
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = _g_object_ref0 ((GeeCollection*) _tmp0_);
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = _tmp1_;
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 828 "AudioPlayerLibrary.c"
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 851 "AudioPlayerLibrary.c"
	} else {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 855 "AudioPlayerLibrary.c"
	}
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 861 "AudioPlayerLibrary.c"
	} else {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 865 "AudioPlayerLibrary.c"
	}
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 869 "AudioPlayerLibrary.c"
		gchar* _tmp2_;
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp2_;
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 877 "AudioPlayerLibrary.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		regex = _tmp6_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 905 "AudioPlayerLibrary.c"
				goto __catch7_g_regex_error;
			}
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			return NULL;
#line 914 "AudioPlayerLibrary.c"
		}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp8_ = regex;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 928 "AudioPlayerLibrary.c"
				goto __catch7_g_regex_error;
			}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			return NULL;
#line 939 "AudioPlayerLibrary.c"
		}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp10_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 953 "AudioPlayerLibrary.c"
	}
	goto __finally7;
	__catch7_g_regex_error:
	{
		GError* e = NULL;
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1429 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 967 "AudioPlayerLibrary.c"
	}
	__finally7:
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return NULL;
#line 978 "AudioPlayerLibrary.c"
	}
}


static void
noise_plugins_audio_player_library_real_add_media (NoiseLibrary* base,
                                                   NoiseMedia* m)
{
	NoisePluginsAudioPlayerLibrary * self;
	gchar* current_operation = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_ = NULL;
	NoisePluginsAudioPlayerDevice* _tmp12_;
	gchar* _tmp13_;
	NoiseLibrariesManager* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GFile* file = NULL;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GFile* _tmp25_;
	GFile* _tmp26_;
	GFile* destination_file = NULL;
	NoisePluginsAudioPlayerDevice* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GFile* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	GFile* _tmp35_;
	GFile* _tmp36_;
	GeeLinkedList* _tmp43_;
	GFile* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	GError * _inner_error_ = NULL;
#line 133 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 133 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (m != NULL);
#line 134 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (m == NULL) {
#line 135 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return;
#line 1040 "AudioPlayerLibrary.c"
	}
#line 137 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = g_strdup (_ ("Adding <b>$NAME</b> by <b>$ARTIST</b> to $DEVICE"));
#line 137 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	current_operation = _tmp0_;
#line 138 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = noise_media_get_title (m);
#line 138 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = _tmp2_;
#line 138 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = _tmp3_;
#line 138 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp1_ == NULL) {
#line 138 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp1_ = "";
#line 1056 "AudioPlayerLibrary.c"
	}
#line 138 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = current_operation;
#line 138 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp5_ = string_replace (_tmp4_, "$NAME", _tmp1_);
#line 138 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (current_operation);
#line 138 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	current_operation = _tmp5_;
#line 139 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp7_ = noise_media_get_artist (m);
#line 139 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp8_ = _tmp7_;
#line 139 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp6_ = _tmp8_;
#line 139 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp6_ == NULL) {
#line 139 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp6_ = "";
#line 1076 "AudioPlayerLibrary.c"
	}
#line 139 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp9_ = current_operation;
#line 139 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp10_ = string_replace (_tmp9_, "$ARTIST", _tmp6_);
#line 139 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (current_operation);
#line 139 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	current_operation = _tmp10_;
#line 140 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp12_ = self->priv->device;
#line 140 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp13_ = noise_device_getDisplayName ((NoiseDevice*) _tmp12_);
#line 140 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp11_ = _tmp13_;
#line 140 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp11_ == NULL) {
#line 1094 "AudioPlayerLibrary.c"
		gchar* _tmp14_;
#line 140 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp14_ = g_strdup ("");
#line 140 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (_tmp11_);
#line 140 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp11_ = _tmp14_;
#line 1102 "AudioPlayerLibrary.c"
	}
#line 140 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp15_ = noise_libraries_manager;
#line 140 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp16_ = current_operation;
#line 140 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp17_ = string_replace (_tmp16_, "$DEVICE", _tmp11_);
#line 140 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp15_->current_operation);
#line 140 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp15_->current_operation = _tmp17_;
#line 141 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp18_ = noise_media_get_title (m);
#line 141 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp19_ = _tmp18_;
#line 141 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp20_ = noise_media_get_artist (m);
#line 141 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp21_ = _tmp20_;
#line 141 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_debug ("AudioPlayerLibrary.vala:141: Adding media %s by %s\n", _tmp19_, _tmp21_);
#line 143 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp22_ = noise_media_get_uri (m);
#line 143 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp23_ = _tmp22_;
#line 143 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp24_ = _tmp23_;
#line 143 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp25_ = g_file_new_for_uri (_tmp24_);
#line 143 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp26_ = _tmp25_;
#line 143 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp24_);
#line 143 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	file = _tmp26_;
#line 144 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp27_ = self->priv->device;
#line 144 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp28_ = noise_plugins_audio_player_device_get_music_folder (_tmp27_);
#line 144 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp29_ = _tmp28_;
#line 144 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp30_ = file;
#line 144 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp31_ = g_file_get_basename (_tmp30_);
#line 144 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp32_ = _tmp31_;
#line 144 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp33_ = g_strconcat (_tmp29_, _tmp32_, NULL);
#line 144 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp34_ = _tmp33_;
#line 144 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp35_ = g_file_new_for_uri (_tmp34_);
#line 144 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp36_ = _tmp35_;
#line 144 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp34_);
#line 144 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp32_);
#line 144 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp29_);
#line 144 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	destination_file = _tmp36_;
#line 1166 "AudioPlayerLibrary.c"
	{
		GFile* _tmp37_;
		GFile* _tmp38_;
#line 147 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp37_ = file;
#line 147 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp38_ = destination_file;
#line 147 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_file_copy (_tmp37_, _tmp38_, G_FILE_COPY_ALL_METADATA, NULL, NULL, NULL, &_inner_error_);
#line 147 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1178 "AudioPlayerLibrary.c"
			goto __catch8_g_error;
		}
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp39_;
		const gchar* _tmp40_;
		GError* _tmp41_;
		const gchar* _tmp42_;
#line 146 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		err = _inner_error_;
#line 146 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_inner_error_ = NULL;
#line 149 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp39_ = noise_media_get_title (m);
#line 149 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp40_ = _tmp39_;
#line 149 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp41_ = err;
#line 149 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp42_ = _tmp41_->message;
#line 149 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_warning ("AudioPlayerLibrary.vala:149: Failed to copy track %s : %s\n", _tmp40_, _tmp42_);
#line 150 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_error_free0 (err);
#line 150 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (destination_file);
#line 150 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (file);
#line 150 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (_tmp11_);
#line 150 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (current_operation);
#line 150 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return;
#line 1216 "AudioPlayerLibrary.c"
	}
	__finally8:
#line 146 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 146 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (destination_file);
#line 146 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (file);
#line 146 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (_tmp11_);
#line 146 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (current_operation);
#line 146 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 146 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_clear_error (&_inner_error_);
#line 146 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return;
#line 1235 "AudioPlayerLibrary.c"
	}
#line 152 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp43_ = self->priv->imported_files;
#line 152 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp44_ = destination_file;
#line 152 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp45_ = g_file_get_uri (_tmp44_);
#line 152 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp46_ = _tmp45_;
#line 152 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp43_, _tmp46_);
#line 152 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp46_);
#line 133 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (destination_file);
#line 133 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (file);
#line 133 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp11_);
#line 133 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (current_operation);
#line 1257 "AudioPlayerLibrary.c"
}


static gboolean
_noise_libraries_manager_do_progress_notification_with_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = noise_libraries_manager_do_progress_notification_with_timeout ((NoiseLibrariesManager*) self);
#line 164 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 1268 "AudioPlayerLibrary.c"
}


static void
noise_plugins_audio_player_library_real_add_medias (NoiseLibrary* base,
                                                    GeeCollection* list)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseLibrariesManager* _tmp0_;
	NoisePluginsAudioPlayerDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	NoiseLibrariesManager* _tmp5_;
	gint sub_index = 0;
	GeeLinkedList* medias_to_sync = NULL;
	GeeLinkedList* _tmp6_;
	GeeLinkedList* _tmp7_;
	NoisePluginsAudioPlayerDevice* _tmp8_;
	GeeLinkedList* _tmp9_;
	GeeCollection* _tmp10_;
	GeeCollection* _tmp11_;
	GeeLinkedList* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint total_medias = 0;
	GeeLinkedList* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (list != NULL);
#line 156 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (noise_library_doing_file_operations ((NoiseLibrary*) self)) {
#line 157 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_warning ("AudioPlayerLibrary.vala:157: Tried to add when already syncing\n");
#line 158 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return;
#line 1309 "AudioPlayerLibrary.c"
	}
#line 161 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = noise_libraries_manager;
#line 161 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = self->priv->device;
#line 161 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = noise_device_getDisplayName ((NoiseDevice*) _tmp1_);
#line 161 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = _tmp2_;
#line 161 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = g_strdup_printf (_ ("Syncing <b>%s</b>…"), _tmp3_);
#line 161 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp0_->current_operation);
#line 161 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_->current_operation = _tmp4_;
#line 161 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp3_);
#line 163 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->is_doing_file_operations = TRUE;
#line 164 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp5_ = noise_libraries_manager;
#line 164 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _noise_libraries_manager_do_progress_notification_with_timeout_gsource_func, g_object_ref (_tmp5_), g_object_unref);
#line 165 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	sub_index = 0;
#line 167 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp6_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 167 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	medias_to_sync = _tmp6_;
#line 168 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp7_ = medias_to_sync;
#line 168 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp8_ = self->priv->device;
#line 168 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp9_ = self->priv->medias;
#line 168 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp10_ = noise_device_delete_doubles ((NoiseDevice*) _tmp8_, list, (GeeCollection*) _tmp9_);
#line 168 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp11_ = _tmp10_;
#line 168 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	gee_collection_add_all ((GeeCollection*) _tmp7_, _tmp11_);
#line 168 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (_tmp11_);
#line 169 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp12_ = medias_to_sync;
#line 169 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 169 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp14_ = _tmp13_;
#line 169 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_message ("AudioPlayerLibrary.vala:169: Found %d medias to add.", _tmp14_);
#line 170 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp15_ = medias_to_sync;
#line 170 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
#line 170 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp17_ = _tmp16_;
#line 170 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	total_medias = _tmp17_;
#line 172 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp18_ = total_medias;
#line 172 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp18_ > 0) {
#line 1373 "AudioPlayerLibrary.c"
		NoisePluginsAudioPlayerDevice* _tmp19_;
		GeeLinkedList* _tmp20_;
#line 173 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp19_ = self->priv->device;
#line 173 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp20_ = medias_to_sync;
#line 173 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (noise_device_will_fit ((NoiseDevice*) _tmp19_, (GeeCollection*) _tmp20_)) {
#line 1382 "AudioPlayerLibrary.c"
			GeeLinkedList* _tmp21_;
			NoiseGStreamerTagger* _tmp38_;
			GeeLinkedList* _tmp39_;
#line 174 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp21_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 174 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (self->priv->imported_files);
#line 174 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			self->priv->imported_files = _tmp21_;
#line 1392 "AudioPlayerLibrary.c"
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp22_;
				GeeLinkedList* _tmp23_;
				gint _m_size = 0;
				GeeLinkedList* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gint _m_index = 0;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp22_ = medias_to_sync;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp23_ = _g_object_ref0 (_tmp22_);
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_list = _tmp23_;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp24_ = _m_list;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp25_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp24_);
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp26_ = _tmp25_;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_size = _tmp26_;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_index = -1;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				while (TRUE) {
#line 1420 "AudioPlayerLibrary.c"
					gint _tmp27_;
					gint _tmp28_;
					gint _tmp29_;
					NoiseMedia* m = NULL;
					GeeLinkedList* _tmp30_;
					gint _tmp31_;
					gpointer _tmp32_;
					NoiseMedia* _tmp33_;
					gint _tmp34_;
					NoiseLibrariesManager* _tmp35_;
					gint _tmp36_;
					gint _tmp37_;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp27_ = _m_index;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_m_index = _tmp27_ + 1;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp28_ = _m_index;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp29_ = _m_size;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (!(_tmp28_ < _tmp29_)) {
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 1445 "AudioPlayerLibrary.c"
					}
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp30_ = _m_list;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp31_ = _m_index;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, _tmp31_);
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					m = (NoiseMedia*) _tmp32_;
#line 176 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp33_ = m;
#line 176 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					noise_library_add_media ((NoiseLibrary*) self, _tmp33_);
#line 177 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp34_ = sub_index;
#line 177 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					sub_index = _tmp34_ + 1;
#line 178 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp35_ = noise_libraries_manager;
#line 178 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp36_ = sub_index;
#line 178 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp37_ = total_medias;
#line 178 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp35_->progress = (gdouble) (_tmp36_ / _tmp37_);
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (m);
#line 1473 "AudioPlayerLibrary.c"
				}
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (_m_list);
#line 1477 "AudioPlayerLibrary.c"
			}
#line 180 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp38_ = self->tagger;
#line 180 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp39_ = self->priv->imported_files;
#line 180 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			noise_gstreamer_tagger_discoverer_import_media (_tmp38_, (GeeCollection*) _tmp39_);
#line 1485 "AudioPlayerLibrary.c"
		}
	}
#line 183 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (medias_to_sync);
#line 183 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return;
#line 1492 "AudioPlayerLibrary.c"
}


static NoiseMedia*
noise_plugins_audio_player_library_real_media_from_id (NoiseLibrary* base,
                                                       gint64 id)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseMedia* result = NULL;
	GError * _inner_error_ = NULL;
#line 186 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 1505 "AudioPlayerLibrary.c"
	{
		GeeLinkedList* _tmp0_;
#line 187 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp0_ = self->priv->medias;
#line 187 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_medias);
#line 1512 "AudioPlayerLibrary.c"
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp1_;
				GeeLinkedList* _tmp2_;
				gint _m_size = 0;
				GeeLinkedList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _m_index = 0;
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp1_ = self->priv->medias;
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp2_ = _g_object_ref0 (_tmp1_);
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_list = _tmp2_;
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp3_ = _m_list;
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp5_ = _tmp4_;
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_size = _tmp5_;
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_index = -1;
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				while (TRUE) {
#line 1541 "AudioPlayerLibrary.c"
					gint _tmp6_;
					gint _tmp7_;
					gint _tmp8_;
					NoiseMedia* m = NULL;
					GeeLinkedList* _tmp9_;
					gint _tmp10_;
					gpointer _tmp11_;
					NoiseMedia* _tmp12_;
					gint64 _tmp13_;
					gint64 _tmp14_;
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp6_ = _m_index;
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_m_index = _tmp6_ + 1;
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp7_ = _m_index;
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp8_ = _m_size;
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 1564 "AudioPlayerLibrary.c"
					}
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp9_ = _m_list;
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp10_ = _m_index;
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					m = (NoiseMedia*) _tmp11_;
#line 189 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp12_ = m;
#line 189 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp13_ = noise_media_get_rowid (_tmp12_);
#line 189 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp14_ = _tmp13_;
#line 189 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp14_ == id) {
#line 190 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						result = m;
#line 190 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_object_unref0 (_m_list);
#line 1586 "AudioPlayerLibrary.c"
						{
							GeeLinkedList* _tmp15_;
#line 187 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_tmp15_ = self->priv->medias;
#line 187 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 1593 "AudioPlayerLibrary.c"
						}
#line 190 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						return result;
#line 1597 "AudioPlayerLibrary.c"
					}
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (m);
#line 1601 "AudioPlayerLibrary.c"
				}
#line 188 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (_m_list);
#line 1605 "AudioPlayerLibrary.c"
			}
		}
		__finally9:
		{
			GeeLinkedList* _tmp16_;
#line 187 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp16_ = self->priv->medias;
#line 187 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 1615 "AudioPlayerLibrary.c"
		}
#line 187 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 187 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 187 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_clear_error (&_inner_error_);
#line 187 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			return NULL;
#line 1625 "AudioPlayerLibrary.c"
		}
	}
#line 194 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = NULL;
#line 194 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 1632 "AudioPlayerLibrary.c"
}


static GeeCollection*
noise_plugins_audio_player_library_real_medias_from_ids (NoiseLibrary* base,
                                                         GeeCollection* ids)
{
	NoisePluginsAudioPlayerLibrary * self;
	GeeCollection* result = NULL;
	GeeLinkedList* media_collection = NULL;
	GeeLinkedList* _tmp0_;
	GError * _inner_error_ = NULL;
#line 197 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 197 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_val_if_fail (ids != NULL, NULL);
#line 198 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 198 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	media_collection = _tmp0_;
#line 1653 "AudioPlayerLibrary.c"
	{
		GeeLinkedList* _tmp1_;
#line 200 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp1_ = self->priv->medias;
#line 200 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_medias);
#line 1660 "AudioPlayerLibrary.c"
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp2_;
				GeeLinkedList* _tmp3_;
				gint _m_size = 0;
				GeeLinkedList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _m_index = 0;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp2_ = self->priv->medias;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp3_ = _g_object_ref0 (_tmp2_);
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_list = _tmp3_;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp4_ = _m_list;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp6_ = _tmp5_;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_size = _tmp6_;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_index = -1;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				while (TRUE) {
#line 1689 "AudioPlayerLibrary.c"
					gint _tmp7_;
					gint _tmp8_;
					gint _tmp9_;
					NoiseMedia* m = NULL;
					GeeLinkedList* _tmp10_;
					gint _tmp11_;
					gpointer _tmp12_;
					NoiseMedia* _tmp13_;
					gint64 _tmp14_;
					gint64 _tmp15_;
					GeeLinkedList* _tmp18_;
					gint _tmp19_;
					gint _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp7_ = _m_index;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_m_index = _tmp7_ + 1;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp8_ = _m_index;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp9_ = _m_size;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (!(_tmp8_ < _tmp9_)) {
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 1717 "AudioPlayerLibrary.c"
					}
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp10_ = _m_list;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp11_ = _m_index;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _tmp11_);
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					m = (NoiseMedia*) _tmp12_;
#line 202 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp13_ = m;
#line 202 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp14_ = noise_media_get_rowid (_tmp13_);
#line 202 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp15_ = _tmp14_;
#line 202 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (gee_collection_contains (ids, &_tmp15_)) {
#line 1735 "AudioPlayerLibrary.c"
						GeeLinkedList* _tmp16_;
						NoiseMedia* _tmp17_;
#line 203 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp16_ = media_collection;
#line 203 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp17_ = m;
#line 203 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 1744 "AudioPlayerLibrary.c"
					}
#line 204 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp18_ = media_collection;
#line 204 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 204 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp20_ = _tmp19_;
#line 204 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp21_ = gee_collection_get_size (ids);
#line 204 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp22_ = _tmp21_;
#line 204 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp20_ == _tmp22_) {
#line 205 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_object_unref0 (m);
#line 205 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 1762 "AudioPlayerLibrary.c"
					}
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (m);
#line 1766 "AudioPlayerLibrary.c"
				}
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (_m_list);
#line 1770 "AudioPlayerLibrary.c"
			}
		}
		__finally10:
		{
			GeeLinkedList* _tmp23_;
#line 200 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp23_ = self->priv->medias;
#line 200 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 1780 "AudioPlayerLibrary.c"
		}
#line 200 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 200 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (media_collection);
#line 200 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 200 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_clear_error (&_inner_error_);
#line 200 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			return NULL;
#line 1792 "AudioPlayerLibrary.c"
		}
	}
#line 209 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = (GeeCollection*) media_collection;
#line 209 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 1799 "AudioPlayerLibrary.c"
}


static GeeCollection*
noise_plugins_audio_player_library_real_medias_from_uris (NoiseLibrary* base,
                                                          GeeCollection* uris)
{
	NoisePluginsAudioPlayerLibrary * self;
	GeeCollection* result = NULL;
	GeeLinkedList* media_collection = NULL;
	GeeLinkedList* _tmp0_;
	GError * _inner_error_ = NULL;
#line 212 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 212 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_val_if_fail (uris != NULL, NULL);
#line 213 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 213 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	media_collection = _tmp0_;
#line 1820 "AudioPlayerLibrary.c"
	{
		GeeLinkedList* _tmp1_;
#line 215 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp1_ = self->priv->medias;
#line 215 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_medias);
#line 1827 "AudioPlayerLibrary.c"
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp2_;
				GeeLinkedList* _tmp3_;
				gint _m_size = 0;
				GeeLinkedList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _m_index = 0;
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp2_ = self->priv->medias;
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp3_ = _g_object_ref0 (_tmp2_);
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_list = _tmp3_;
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp4_ = _m_list;
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp6_ = _tmp5_;
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_size = _tmp6_;
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_index = -1;
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				while (TRUE) {
#line 1856 "AudioPlayerLibrary.c"
					gint _tmp7_;
					gint _tmp8_;
					gint _tmp9_;
					NoiseMedia* m = NULL;
					GeeLinkedList* _tmp10_;
					gint _tmp11_;
					gpointer _tmp12_;
					NoiseMedia* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gboolean _tmp17_;
					GeeLinkedList* _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
					gint _tmp23_;
					gint _tmp24_;
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp7_ = _m_index;
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_m_index = _tmp7_ + 1;
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp8_ = _m_index;
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp9_ = _m_size;
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (!(_tmp8_ < _tmp9_)) {
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 1886 "AudioPlayerLibrary.c"
					}
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp10_ = _m_list;
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp11_ = _m_index;
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _tmp11_);
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					m = (NoiseMedia*) _tmp12_;
#line 217 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp13_ = m;
#line 217 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp14_ = noise_media_get_uri (_tmp13_);
#line 217 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp15_ = _tmp14_;
#line 217 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp16_ = _tmp15_;
#line 217 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp17_ = gee_collection_contains (uris, _tmp16_);
#line 217 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_free0 (_tmp16_);
#line 217 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp17_) {
#line 1910 "AudioPlayerLibrary.c"
						GeeLinkedList* _tmp18_;
						NoiseMedia* _tmp19_;
#line 218 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp18_ = media_collection;
#line 218 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp19_ = m;
#line 218 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
#line 1919 "AudioPlayerLibrary.c"
					}
#line 219 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp20_ = media_collection;
#line 219 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp21_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp20_);
#line 219 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp22_ = _tmp21_;
#line 219 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp23_ = gee_collection_get_size (uris);
#line 219 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp24_ = _tmp23_;
#line 219 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp22_ == _tmp24_) {
#line 220 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_object_unref0 (m);
#line 220 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 1937 "AudioPlayerLibrary.c"
					}
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (m);
#line 1941 "AudioPlayerLibrary.c"
				}
#line 216 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (_m_list);
#line 1945 "AudioPlayerLibrary.c"
			}
		}
		__finally11:
		{
			GeeLinkedList* _tmp25_;
#line 215 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp25_ = self->priv->medias;
#line 215 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 1955 "AudioPlayerLibrary.c"
		}
#line 215 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 215 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (media_collection);
#line 215 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 215 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_clear_error (&_inner_error_);
#line 215 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			return NULL;
#line 1967 "AudioPlayerLibrary.c"
		}
	}
#line 224 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = (GeeCollection*) media_collection;
#line 224 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 1974 "AudioPlayerLibrary.c"
}


static NoiseMedia*
noise_plugins_audio_player_library_real_find_media (NoiseLibrary* base,
                                                    NoiseMedia* to_find)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseMedia* result = NULL;
	NoiseMedia* found = NULL;
	GError * _inner_error_ = NULL;
#line 227 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 227 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_val_if_fail (to_find != NULL, NULL);
#line 228 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	found = NULL;
#line 1992 "AudioPlayerLibrary.c"
	{
		GeeLinkedList* _tmp0_;
#line 229 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp0_ = self->priv->medias;
#line 229 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_medias);
#line 1999 "AudioPlayerLibrary.c"
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp1_;
				GeeLinkedList* _tmp2_;
				gint _m_size = 0;
				GeeLinkedList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _m_index = 0;
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp1_ = self->priv->medias;
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp2_ = _g_object_ref0 (_tmp1_);
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_list = _tmp2_;
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp3_ = _m_list;
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp5_ = _tmp4_;
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_size = _tmp5_;
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_index = -1;
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				while (TRUE) {
#line 2028 "AudioPlayerLibrary.c"
					gint _tmp6_;
					gint _tmp7_;
					gint _tmp8_;
					NoiseMedia* m = NULL;
					GeeLinkedList* _tmp9_;
					gint _tmp10_;
					gpointer _tmp11_;
					gboolean _tmp12_ = FALSE;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					NoiseMedia* _tmp17_;
					const gchar* _tmp18_;
					const gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gboolean _tmp22_;
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp6_ = _m_index;
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_m_index = _tmp6_ + 1;
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp7_ = _m_index;
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp8_ = _m_size;
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 2059 "AudioPlayerLibrary.c"
					}
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp9_ = _m_list;
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp10_ = _m_index;
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					m = (NoiseMedia*) _tmp11_;
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp13_ = noise_media_get_title (to_find);
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp14_ = _tmp13_;
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp15_ = g_utf8_strdown (_tmp14_, (gssize) -1);
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp16_ = _tmp15_;
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp17_ = m;
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp18_ = noise_media_get_title (_tmp17_);
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp19_ = _tmp18_;
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp20_ = g_utf8_strdown (_tmp19_, (gssize) -1);
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp21_ = _tmp20_;
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp22_ = g_strcmp0 (_tmp16_, _tmp21_) == 0;
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_free0 (_tmp21_);
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_free0 (_tmp16_);
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp22_) {
#line 2095 "AudioPlayerLibrary.c"
						const gchar* _tmp23_;
						const gchar* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
						NoiseMedia* _tmp27_;
						const gchar* _tmp28_;
						const gchar* _tmp29_;
						gchar* _tmp30_;
						gchar* _tmp31_;
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp23_ = noise_media_get_artist (to_find);
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp24_ = _tmp23_;
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp25_ = g_utf8_strdown (_tmp24_, (gssize) -1);
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp26_ = _tmp25_;
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp27_ = m;
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp28_ = noise_media_get_artist (_tmp27_);
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp29_ = _tmp28_;
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp30_ = g_utf8_strdown (_tmp29_, (gssize) -1);
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp31_ = _tmp30_;
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp12_ = g_strcmp0 (_tmp26_, _tmp31_) == 0;
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_free0 (_tmp31_);
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_free0 (_tmp26_);
#line 2129 "AudioPlayerLibrary.c"
					} else {
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp12_ = FALSE;
#line 2133 "AudioPlayerLibrary.c"
					}
#line 231 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp12_) {
#line 2137 "AudioPlayerLibrary.c"
						NoiseMedia* _tmp32_;
						NoiseMedia* _tmp33_;
#line 232 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp32_ = m;
#line 232 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp33_ = _g_object_ref0 (_tmp32_);
#line 232 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_object_unref0 (found);
#line 232 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						found = _tmp33_;
#line 233 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_object_unref0 (m);
#line 233 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 2152 "AudioPlayerLibrary.c"
					}
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (m);
#line 2156 "AudioPlayerLibrary.c"
				}
#line 230 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (_m_list);
#line 2160 "AudioPlayerLibrary.c"
			}
		}
		__finally12:
		{
			GeeLinkedList* _tmp34_;
#line 229 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp34_ = self->priv->medias;
#line 229 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 2170 "AudioPlayerLibrary.c"
		}
#line 229 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 229 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (found);
#line 229 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 229 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_clear_error (&_inner_error_);
#line 229 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			return NULL;
#line 2182 "AudioPlayerLibrary.c"
		}
	}
#line 237 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = found;
#line 237 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 2189 "AudioPlayerLibrary.c"
}


static NoiseMedia*
noise_plugins_audio_player_library_real_media_from_file (NoiseLibrary* base,
                                                         GFile* file)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseMedia* result = NULL;
	GError * _inner_error_ = NULL;
#line 239 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 239 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 2204 "AudioPlayerLibrary.c"
	{
		GeeLinkedList* _tmp0_;
#line 240 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp0_ = self->priv->medias;
#line 240 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_medias);
#line 2211 "AudioPlayerLibrary.c"
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp1_;
				GeeLinkedList* _tmp2_;
				gint _m_size = 0;
				GeeLinkedList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _m_index = 0;
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp1_ = self->priv->medias;
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp2_ = _g_object_ref0 (_tmp1_);
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_list = _tmp2_;
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp3_ = _m_list;
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp5_ = _tmp4_;
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_size = _tmp5_;
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_index = -1;
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				while (TRUE) {
#line 2240 "AudioPlayerLibrary.c"
					gint _tmp6_;
					gint _tmp7_;
					gint _tmp8_;
					NoiseMedia* m = NULL;
					GeeLinkedList* _tmp9_;
					gint _tmp10_;
					gpointer _tmp11_;
					gboolean _tmp12_ = FALSE;
					NoiseMedia* _tmp13_;
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp6_ = _m_index;
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_m_index = _tmp6_ + 1;
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp7_ = _m_index;
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp8_ = _m_size;
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 2262 "AudioPlayerLibrary.c"
					}
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp9_ = _m_list;
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp10_ = _m_index;
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					m = (NoiseMedia*) _tmp11_;
#line 242 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp13_ = m;
#line 242 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp13_ != NULL) {
#line 2276 "AudioPlayerLibrary.c"
						NoiseMedia* _tmp14_;
						GFile* _tmp15_;
						GFile* _tmp16_;
#line 242 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp14_ = m;
#line 242 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp15_ = noise_media_get_file (_tmp14_);
#line 242 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp16_ = _tmp15_;
#line 242 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp12_ = g_file_equal (_tmp16_, file);
#line 2288 "AudioPlayerLibrary.c"
					} else {
#line 242 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp12_ = FALSE;
#line 2292 "AudioPlayerLibrary.c"
					}
#line 242 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp12_) {
#line 243 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						result = m;
#line 243 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_object_unref0 (_m_list);
#line 2300 "AudioPlayerLibrary.c"
						{
							GeeLinkedList* _tmp17_;
#line 240 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_tmp17_ = self->priv->medias;
#line 240 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 2307 "AudioPlayerLibrary.c"
						}
#line 243 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						return result;
#line 2311 "AudioPlayerLibrary.c"
					}
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (m);
#line 2315 "AudioPlayerLibrary.c"
				}
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (_m_list);
#line 2319 "AudioPlayerLibrary.c"
			}
		}
		__finally13:
		{
			GeeLinkedList* _tmp18_;
#line 240 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp18_ = self->priv->medias;
#line 240 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 2329 "AudioPlayerLibrary.c"
		}
#line 240 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 240 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 240 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_clear_error (&_inner_error_);
#line 240 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			return NULL;
#line 2339 "AudioPlayerLibrary.c"
		}
	}
#line 247 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = NULL;
#line 247 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 2346 "AudioPlayerLibrary.c"
}


static NoiseMedia*
noise_plugins_audio_player_library_real_media_from_uri (NoiseLibrary* base,
                                                        const gchar* uri)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseMedia* result = NULL;
	GError * _inner_error_ = NULL;
#line 249 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 249 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 2361 "AudioPlayerLibrary.c"
	{
		GeeLinkedList* _tmp0_;
#line 250 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp0_ = self->priv->medias;
#line 250 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_medias);
#line 2368 "AudioPlayerLibrary.c"
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp1_;
				GeeLinkedList* _tmp2_;
				gint _m_size = 0;
				GeeLinkedList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _m_index = 0;
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp1_ = self->priv->medias;
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp2_ = _g_object_ref0 (_tmp1_);
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_list = _tmp2_;
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp3_ = _m_list;
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp5_ = _tmp4_;
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_size = _tmp5_;
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_index = -1;
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				while (TRUE) {
#line 2397 "AudioPlayerLibrary.c"
					gint _tmp6_;
					gint _tmp7_;
					gint _tmp8_;
					NoiseMedia* m = NULL;
					GeeLinkedList* _tmp9_;
					gint _tmp10_;
					gpointer _tmp11_;
					gboolean _tmp12_ = FALSE;
					NoiseMedia* _tmp13_;
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp6_ = _m_index;
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_m_index = _tmp6_ + 1;
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp7_ = _m_index;
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp8_ = _m_size;
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 2419 "AudioPlayerLibrary.c"
					}
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp9_ = _m_list;
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp10_ = _m_index;
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					m = (NoiseMedia*) _tmp11_;
#line 252 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp13_ = m;
#line 252 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp13_ != NULL) {
#line 2433 "AudioPlayerLibrary.c"
						NoiseMedia* _tmp14_;
						gchar* _tmp15_;
						gchar* _tmp16_;
						gchar* _tmp17_;
#line 252 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp14_ = m;
#line 252 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp15_ = noise_media_get_uri (_tmp14_);
#line 252 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp16_ = _tmp15_;
#line 252 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp17_ = _tmp16_;
#line 252 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp12_ = g_strcmp0 (_tmp17_, uri) == 0;
#line 252 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_free0 (_tmp17_);
#line 2450 "AudioPlayerLibrary.c"
					} else {
#line 252 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp12_ = FALSE;
#line 2454 "AudioPlayerLibrary.c"
					}
#line 252 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp12_) {
#line 253 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						result = m;
#line 253 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_object_unref0 (_m_list);
#line 2462 "AudioPlayerLibrary.c"
						{
							GeeLinkedList* _tmp18_;
#line 250 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_tmp18_ = self->priv->medias;
#line 250 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 2469 "AudioPlayerLibrary.c"
						}
#line 253 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						return result;
#line 2473 "AudioPlayerLibrary.c"
					}
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (m);
#line 2477 "AudioPlayerLibrary.c"
				}
#line 251 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (_m_list);
#line 2481 "AudioPlayerLibrary.c"
			}
		}
		__finally14:
		{
			GeeLinkedList* _tmp19_;
#line 250 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp19_ = self->priv->medias;
#line 250 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 2491 "AudioPlayerLibrary.c"
		}
#line 250 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 250 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 250 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_clear_error (&_inner_error_);
#line 250 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			return NULL;
#line 2501 "AudioPlayerLibrary.c"
		}
	}
#line 257 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = NULL;
#line 257 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 2508 "AudioPlayerLibrary.c"
}


static void
noise_plugins_audio_player_library_real_update_media (NoiseLibrary* base,
                                                      NoiseMedia* s,
                                                      gboolean updateMeta,
                                                      gboolean record_time)
{
	NoisePluginsAudioPlayerLibrary * self;
#line 259 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 259 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (s != NULL);
#line 2523 "AudioPlayerLibrary.c"
}


static void
noise_plugins_audio_player_library_real_update_medias (NoiseLibrary* base,
                                                       GeeCollection* updates,
                                                       gboolean updateMeta,
                                                       gboolean record_time)
{
	NoisePluginsAudioPlayerLibrary * self;
#line 262 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 262 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (updates != NULL);
#line 2538 "AudioPlayerLibrary.c"
}


static void
noise_plugins_audio_player_library_real_remove_media (NoiseLibrary* base,
                                                      NoiseMedia* m,
                                                      gboolean trash)
{
	NoisePluginsAudioPlayerLibrary * self;
	gchar* current_operation = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_ = NULL;
	NoisePluginsAudioPlayerDevice* _tmp12_;
	gchar* _tmp13_;
	NoiseLibrariesManager* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gboolean _tmp21_;
	GError * _inner_error_ = NULL;
#line 265 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 265 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (m != NULL);
#line 266 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = g_strdup (_ ("Removing <b>$NAME</b> by <b>$ARTIST</b> from $DEVICE"));
#line 266 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	current_operation = _tmp0_;
#line 267 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = noise_media_get_title (m);
#line 267 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = _tmp2_;
#line 267 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = _tmp3_;
#line 267 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp1_ == NULL) {
#line 267 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp1_ = "";
#line 2589 "AudioPlayerLibrary.c"
	}
#line 267 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = current_operation;
#line 267 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp5_ = string_replace (_tmp4_, "$NAME", _tmp1_);
#line 267 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (current_operation);
#line 267 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	current_operation = _tmp5_;
#line 268 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp7_ = noise_media_get_artist (m);
#line 268 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp8_ = _tmp7_;
#line 268 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp6_ = _tmp8_;
#line 268 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp6_ == NULL) {
#line 268 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp6_ = "";
#line 2609 "AudioPlayerLibrary.c"
	}
#line 268 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp9_ = current_operation;
#line 268 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp10_ = string_replace (_tmp9_, "$ARTIST", _tmp6_);
#line 268 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (current_operation);
#line 268 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	current_operation = _tmp10_;
#line 269 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp12_ = self->priv->device;
#line 269 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp13_ = noise_device_getDisplayName ((NoiseDevice*) _tmp12_);
#line 269 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp11_ = _tmp13_;
#line 269 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp11_ == NULL) {
#line 2627 "AudioPlayerLibrary.c"
		gchar* _tmp14_;
#line 269 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp14_ = g_strdup ("");
#line 269 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (_tmp11_);
#line 269 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp11_ = _tmp14_;
#line 2635 "AudioPlayerLibrary.c"
	}
#line 269 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp15_ = noise_libraries_manager;
#line 269 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp16_ = current_operation;
#line 269 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp17_ = string_replace (_tmp16_, "$DEVICE", _tmp11_);
#line 269 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp15_->current_operation);
#line 269 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp15_->current_operation = _tmp17_;
#line 271 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp18_ = noise_media_get_uri (m);
#line 271 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp19_ = _tmp18_;
#line 271 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp20_ = _tmp19_;
#line 271 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp21_ = _tmp20_ != NULL;
#line 271 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp20_);
#line 271 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp21_) {
#line 2659 "AudioPlayerLibrary.c"
		GFile* file = NULL;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		GFile* _tmp25_;
		GFile* _tmp26_;
		GFile* _tmp27_;
#line 272 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp22_ = noise_media_get_uri (m);
#line 272 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp23_ = _tmp22_;
#line 272 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp24_ = _tmp23_;
#line 272 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp25_ = g_file_new_for_uri (_tmp24_);
#line 272 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp26_ = _tmp25_;
#line 272 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (_tmp24_);
#line 272 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		file = _tmp26_;
#line 274 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp27_ = file;
#line 274 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (g_file_query_exists (_tmp27_, NULL)) {
#line 2685 "AudioPlayerLibrary.c"
			GeeArrayList* media_list = NULL;
			GeeArrayList* _tmp28_;
			GeeArrayList* _tmp29_;
			GeeArrayList* _tmp30_;
			GeeLinkedList* _tmp31_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
#line 275 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp28_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 275 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			media_list = _tmp28_;
#line 276 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp29_ = media_list;
#line 276 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, m);
#line 277 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp30_ = media_list;
#line 277 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_signal_emit_by_name ((NoiseLibrary*) self, "media-removed", (GeeCollection*) _tmp30_);
#line 278 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp31_ = self->priv->medias;
#line 278 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp31_, m);
#line 2710 "AudioPlayerLibrary.c"
			{
				GFile* _tmp32_;
#line 280 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp32_ = file;
#line 280 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				g_file_delete (_tmp32_, NULL, &_inner_error_);
#line 280 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2719 "AudioPlayerLibrary.c"
					goto __catch15_g_error;
				}
			}
			goto __finally15;
			__catch15_g_error:
			{
				GError* err = NULL;
				gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
				GError* _tmp36_;
				const gchar* _tmp37_;
#line 279 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				err = _inner_error_;
#line 279 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_inner_error_ = NULL;
#line 282 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp33_ = noise_media_get_uri (m);
#line 282 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp34_ = _tmp33_;
#line 282 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp35_ = _tmp34_;
#line 282 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp36_ = err;
#line 282 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp37_ = _tmp36_->message;
#line 282 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				g_warning ("AudioPlayerLibrary.vala:282: Could not delete File at %s: %s", _tmp35_, _tmp37_);
#line 282 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_free0 (_tmp35_);
#line 283 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_error_free0 (err);
#line 283 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (media_list);
#line 283 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (file);
#line 283 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_free0 (_tmp11_);
#line 283 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_free0 (current_operation);
#line 283 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				return;
#line 2762 "AudioPlayerLibrary.c"
			}
			__finally15:
#line 279 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 279 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (media_list);
#line 279 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (file);
#line 279 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_free0 (_tmp11_);
#line 279 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_free0 (current_operation);
#line 279 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 279 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				g_clear_error (&_inner_error_);
#line 279 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				return;
#line 2781 "AudioPlayerLibrary.c"
			}
#line 285 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp38_ = noise_media_get_uri (m);
#line 285 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp39_ = _tmp38_;
#line 285 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp40_ = _tmp39_;
#line 285 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_debug ("AudioPlayerLibrary.vala:285: Successfully removed music file %s", _tmp40_);
#line 285 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_free0 (_tmp40_);
#line 274 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (media_list);
#line 2795 "AudioPlayerLibrary.c"
		} else {
			gchar* _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
#line 287 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp41_ = noise_media_get_uri (m);
#line 287 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp42_ = _tmp41_;
#line 287 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp43_ = _tmp42_;
#line 287 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_warning ("AudioPlayerLibrary.vala:287: File not found, could not delete File at " \
"%s. File may already be deleted", _tmp43_);
#line 287 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_free0 (_tmp43_);
#line 2810 "AudioPlayerLibrary.c"
		}
#line 271 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (file);
#line 2814 "AudioPlayerLibrary.c"
	}
#line 265 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp11_);
#line 265 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (current_operation);
#line 2820 "AudioPlayerLibrary.c"
}


static void
noise_plugins_audio_player_library_real_remove_medias (NoiseLibrary* base,
                                                       GeeCollection* list,
                                                       gboolean trash)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseLibrariesManager* _tmp0_;
	NoisePluginsAudioPlayerDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gint total = 0;
	gint _tmp5_;
	gint _tmp6_;
	NoiseLibrariesManager* _tmp7_;
	gint sub_index = 0;
	NoiseLibrariesManager* _tmp17_;
#line 291 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 291 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (list != NULL);
#line 292 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (noise_library_doing_file_operations ((NoiseLibrary*) self)) {
#line 293 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_warning ("AudioPlayerLibrary.vala:293: Tried to add when already syncing\n");
#line 294 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return;
#line 2851 "AudioPlayerLibrary.c"
	}
#line 297 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = noise_libraries_manager;
#line 297 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = self->priv->device;
#line 297 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = noise_device_getDisplayName ((NoiseDevice*) _tmp1_);
#line 297 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = _tmp2_;
#line 297 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = g_strdup_printf (_ ("Removing from <b>%s</b>…"), _tmp3_);
#line 297 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp0_->current_operation);
#line 297 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_->current_operation = _tmp4_;
#line 297 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp3_);
#line 299 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp5_ = gee_collection_get_size (list);
#line 299 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp6_ = _tmp5_;
#line 299 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	total = _tmp6_;
#line 300 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp7_ = noise_libraries_manager;
#line 300 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _noise_libraries_manager_do_progress_notification_with_timeout_gsource_func, g_object_ref (_tmp7_), g_object_unref);
#line 302 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	sub_index = 0;
#line 2881 "AudioPlayerLibrary.c"
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp8_;
#line 303 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp8_ = gee_iterable_iterator ((GeeIterable*) list);
#line 303 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_m_it = _tmp8_;
#line 303 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		while (TRUE) {
#line 2891 "AudioPlayerLibrary.c"
			GeeIterator* _tmp9_;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			NoiseMedia* _tmp12_;
			gint _tmp13_;
			NoiseLibrariesManager* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
#line 303 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp9_ = _m_it;
#line 303 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			if (!gee_iterator_next (_tmp9_)) {
#line 303 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				break;
#line 2907 "AudioPlayerLibrary.c"
			}
#line 303 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp10_ = _m_it;
#line 303 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 303 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			m = (NoiseMedia*) _tmp11_;
#line 304 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp12_ = m;
#line 304 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			noise_library_remove_media ((NoiseLibrary*) self, _tmp12_, TRUE);
#line 305 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp13_ = sub_index;
#line 305 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			sub_index = _tmp13_ + 1;
#line 306 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp14_ = noise_libraries_manager;
#line 306 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp15_ = sub_index;
#line 306 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp16_ = total;
#line 306 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp14_->progress = (gdouble) (_tmp15_ / _tmp16_);
#line 303 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (m);
#line 2933 "AudioPlayerLibrary.c"
		}
#line 303 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (_m_it);
#line 2937 "AudioPlayerLibrary.c"
	}
#line 308 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp17_ = noise_libraries_manager;
#line 308 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp17_->progress = (gdouble) 1;
#line 309 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_emit_by_name ((NoiseLibrary*) self, "file-operations-done");
#line 2945 "AudioPlayerLibrary.c"
}


static gboolean
noise_plugins_audio_player_library_real_support_smart_playlists (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
	gboolean result = FALSE;
#line 312 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 313 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = FALSE;
#line 313 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 2960 "AudioPlayerLibrary.c"
}


static void
noise_plugins_audio_player_library_real_add_smart_playlist (NoiseLibrary* base,
                                                            NoiseSmartPlaylist* p)
{
	NoisePluginsAudioPlayerLibrary * self;
#line 316 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 316 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (p != NULL);
#line 2973 "AudioPlayerLibrary.c"
}


static void
noise_plugins_audio_player_library_real_remove_smart_playlist (NoiseLibrary* base,
                                                               gint64 id)
{
	NoisePluginsAudioPlayerLibrary * self;
#line 319 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 2984 "AudioPlayerLibrary.c"
}


static NoiseSmartPlaylist*
noise_plugins_audio_player_library_real_smart_playlist_from_id (NoiseLibrary* base,
                                                                gint64 id)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseSmartPlaylist* result = NULL;
#line 322 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 323 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = NULL;
#line 323 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 3000 "AudioPlayerLibrary.c"
}


static NoiseSmartPlaylist*
noise_plugins_audio_player_library_real_smart_playlist_from_name (NoiseLibrary* base,
                                                                  const gchar* name)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseSmartPlaylist* result = NULL;
#line 325 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 325 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 326 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = NULL;
#line 326 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 3018 "AudioPlayerLibrary.c"
}


static gboolean
noise_plugins_audio_player_library_real_support_playlists (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
	gboolean result = FALSE;
#line 329 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 330 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = FALSE;
#line 330 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 3033 "AudioPlayerLibrary.c"
}


static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 333 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 333 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return _data1_;
#line 3044 "AudioPlayerLibrary.c"
}


static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 333 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 3055 "AudioPlayerLibrary.c"
		NoisePluginsAudioPlayerLibrary* self;
#line 333 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		self = _data1_->self;
#line 333 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (_data1_->p);
#line 333 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (self);
#line 333 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_slice_free (Block1Data, _data1_);
#line 3065 "AudioPlayerLibrary.c"
	}
}


static void
__lambda5_ (Block1Data* _data1_)
{
	NoisePluginsAudioPlayerLibrary* self;
#line 338 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = _data1_->self;
#line 338 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	noise_plugins_audio_player_library_keep_playlist_synchronized (self, _data1_->p);
#line 3078 "AudioPlayerLibrary.c"
}


static void
___lambda5__noise_playlist_media_added (NoisePlaylist* _sender,
                                        GeeCollection* media,
                                        gpointer self)
{
#line 338 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	__lambda5_ (self);
#line 3089 "AudioPlayerLibrary.c"
}


static void
__lambda6_ (Block1Data* _data1_)
{
	NoisePluginsAudioPlayerLibrary* self;
#line 339 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = _data1_->self;
#line 339 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	noise_plugins_audio_player_library_keep_playlist_synchronized (self, _data1_->p);
#line 3101 "AudioPlayerLibrary.c"
}


static void
___lambda6__noise_playlist_media_removed (NoisePlaylist* _sender,
                                          GeeCollection* media,
                                          gpointer self)
{
#line 339 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	__lambda6_ (self);
#line 3112 "AudioPlayerLibrary.c"
}


static void
__lambda7_ (Block1Data* _data1_,
            const gchar* old_name)
{
	NoisePluginsAudioPlayerLibrary* self;
#line 340 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = _data1_->self;
#line 340 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	noise_plugins_audio_player_library_remove_playlist_from_name (self, old_name);
#line 340 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	noise_plugins_audio_player_library_keep_playlist_synchronized (self, _data1_->p);
#line 3127 "AudioPlayerLibrary.c"
}


static void
___lambda7__noise_playlist_updated (NoisePlaylist* _sender,
                                    const gchar* old_name,
                                    gpointer self)
{
#line 340 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	__lambda7_ (self, old_name);
#line 3138 "AudioPlayerLibrary.c"
}


static void
noise_plugins_audio_player_library_real_add_playlist (NoiseLibrary* base,
                                                      NoiseStaticPlaylist* p)
{
	NoisePluginsAudioPlayerLibrary * self;
	Block1Data* _data1_;
	NoiseStaticPlaylist* _tmp0_;
	GeeLinkedList* _tmp1_;
#line 333 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 333 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (p != NULL);
#line 333 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 333 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_data1_->_ref_count_ = 1;
#line 333 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_data1_->self = g_object_ref (self);
#line 333 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = _g_object_ref0 (p);
#line 333 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (_data1_->p);
#line 333 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_data1_->p = _tmp0_;
#line 335 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = self->priv->playlists;
#line 335 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _data1_->p);
#line 336 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_emit_by_name ((NoiseLibrary*) self, "playlist-added", _data1_->p);
#line 337 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	noise_plugins_audio_player_library_keep_playlist_synchronized (self, _data1_->p);
#line 338 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_connect_data ((NoisePlaylist*) _data1_->p, "media-added", (GCallback) ___lambda5__noise_playlist_media_added, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 339 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_connect_data ((NoisePlaylist*) _data1_->p, "media-removed", (GCallback) ___lambda6__noise_playlist_media_removed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 340 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_connect_data ((NoisePlaylist*) _data1_->p, "updated", (GCallback) ___lambda7__noise_playlist_updated, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 333 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	block1_data_unref (_data1_);
#line 333 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_data1_ = NULL;
#line 3184 "AudioPlayerLibrary.c"
}


static void
noise_plugins_audio_player_library_real_remove_playlist (NoiseLibrary* base,
                                                         gint64 id)
{
	NoisePluginsAudioPlayerLibrary * self;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
#line 342 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 343 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = noise_library_get_playlists ((NoiseLibrary*) self);
#line 343 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = _tmp0_;
#line 343 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = gee_collection_get_size (_tmp1_);
#line 343 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = _tmp2_;
#line 343 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = id < ((gint64) _tmp3_);
#line 343 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (_tmp1_);
#line 343 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp4_) {
#line 3214 "AudioPlayerLibrary.c"
		GeeArrayList* array_v = NULL;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeLinkedList* _tmp7_;
#line 344 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp5_ = gee_array_list_new (NOISE_TYPE_STATIC_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 344 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		array_v = _tmp5_;
#line 345 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp6_ = array_v;
#line 345 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp7_ = self->priv->playlists;
#line 345 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		gee_array_list_add_all (_tmp6_, (GeeCollection*) _tmp7_);
#line 3229 "AudioPlayerLibrary.c"
		{
			GeeArrayList* _p_list = NULL;
			GeeArrayList* _tmp8_;
			GeeArrayList* _tmp9_;
			gint _p_size = 0;
			GeeArrayList* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gint _p_index = 0;
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp8_ = array_v;
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp9_ = _g_object_ref0 (_tmp8_);
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_p_list = _tmp9_;
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp10_ = _p_list;
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp10_);
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp12_ = _tmp11_;
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_p_size = _tmp12_;
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_p_index = -1;
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			while (TRUE) {
#line 3257 "AudioPlayerLibrary.c"
				gint _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				NoiseStaticPlaylist* p = NULL;
				GeeArrayList* _tmp16_;
				gint _tmp17_;
				gpointer _tmp18_;
				NoiseStaticPlaylist* _tmp19_;
				gint64 _tmp20_;
				gint64 _tmp21_;
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp13_ = _p_index;
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_p_index = _tmp13_ + 1;
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp14_ = _p_index;
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp15_ = _p_size;
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				if (!(_tmp14_ < _tmp15_)) {
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					break;
#line 3280 "AudioPlayerLibrary.c"
				}
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp16_ = _p_list;
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp17_ = _p_index;
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _tmp17_);
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				p = (NoiseStaticPlaylist*) _tmp18_;
#line 347 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp19_ = p;
#line 347 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp20_ = noise_playlist_get_rowid ((NoisePlaylist*) _tmp19_);
#line 347 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp21_ = _tmp20_;
#line 347 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				if (_tmp21_ == id) {
#line 3298 "AudioPlayerLibrary.c"
					NoiseStaticPlaylist* _tmp22_;
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					NoiseStaticPlaylist* _tmp25_;
					GeeLinkedList* _tmp26_;
					NoiseStaticPlaylist* _tmp27_;
#line 348 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp22_ = p;
#line 348 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp23_ = noise_playlist_get_name ((NoisePlaylist*) _tmp22_);
#line 348 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp24_ = _tmp23_;
#line 348 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					noise_plugins_audio_player_library_remove_playlist_from_name (self, _tmp24_);
#line 349 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp25_ = p;
#line 349 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					g_signal_emit_by_name ((NoiseLibrary*) self, "playlist-removed", _tmp25_);
#line 350 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp26_ = self->priv->playlists;
#line 350 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp27_ = p;
#line 350 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp26_, _tmp27_);
#line 351 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (p);
#line 351 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (_p_list);
#line 351 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (array_v);
#line 351 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					return;
#line 3331 "AudioPlayerLibrary.c"
				}
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (p);
#line 3335 "AudioPlayerLibrary.c"
			}
#line 346 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (_p_list);
#line 3339 "AudioPlayerLibrary.c"
		}
#line 343 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (array_v);
#line 3343 "AudioPlayerLibrary.c"
	}
}


static void
noise_plugins_audio_player_library_remove_playlist_from_name (NoisePluginsAudioPlayerLibrary* self,
                                                              const gchar* name)
{
	GFile* dest = NULL;
	NoisePluginsAudioPlayerDevice* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GError * _inner_error_ = NULL;
#line 357 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (self != NULL);
#line 357 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (name != NULL);
#line 358 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = self->priv->device;
#line 358 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = noise_plugins_audio_player_device_get_music_folder (_tmp0_);
#line 358 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = _tmp1_;
#line 358 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = string_replace (name, "/", "_");
#line 358 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = _tmp3_;
#line 358 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp5_ = g_strconcat (_tmp4_, ".m3u", NULL);
#line 358 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp6_ = _tmp5_;
#line 358 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp7_ = g_build_path ("/", _tmp2_, "Playlists", _tmp6_, NULL);
#line 358 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp8_ = _tmp7_;
#line 358 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp9_ = g_file_new_for_uri (_tmp8_);
#line 358 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp10_ = _tmp9_;
#line 358 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp8_);
#line 358 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp6_);
#line 358 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp4_);
#line 358 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp2_);
#line 358 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	dest = _tmp10_;
#line 3401 "AudioPlayerLibrary.c"
	{
		GFile* _tmp11_;
#line 361 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp11_ = dest;
#line 361 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (g_file_query_exists (_tmp11_, NULL)) {
#line 3408 "AudioPlayerLibrary.c"
			GFile* _tmp12_;
#line 362 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp12_ = dest;
#line 362 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_file_delete (_tmp12_, NULL, &_inner_error_);
#line 362 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3416 "AudioPlayerLibrary.c"
				goto __catch16_g_error;
			}
		}
	}
	goto __finally16;
	__catch16_g_error:
	{
		GError* err = NULL;
		GFile* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 359 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		err = _inner_error_;
#line 359 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_inner_error_ = NULL;
#line 366 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp13_ = dest;
#line 366 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp14_ = g_file_get_path (_tmp13_);
#line 366 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp15_ = _tmp14_;
#line 366 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp16_ = err;
#line 366 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp17_ = _tmp16_->message;
#line 366 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_warning ("AudioPlayerLibrary.vala:366: Could not remove playlist %s to file %s: " \
"%s", name, _tmp15_, _tmp17_);
#line 366 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (_tmp15_);
#line 359 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_error_free0 (err);
#line 3450 "AudioPlayerLibrary.c"
	}
	__finally16:
#line 359 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 359 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (dest);
#line 359 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 359 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_clear_error (&_inner_error_);
#line 359 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return;
#line 3463 "AudioPlayerLibrary.c"
	}
#line 357 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (dest);
#line 3467 "AudioPlayerLibrary.c"
}


static void
noise_plugins_audio_player_library_keep_playlist_synchronized (NoisePluginsAudioPlayerLibrary* self,
                                                               NoiseStaticPlaylist* p)
{
	gchar* content = NULL;
	NoisePluginsAudioPlayerDevice* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	NoisePluginsAudioPlayerDevice* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GFile* dest = NULL;
	NoisePluginsAudioPlayerDevice* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GFile* _tmp25_;
	GFile* _tmp26_;
	GError * _inner_error_ = NULL;
#line 370 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (self != NULL);
#line 370 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (p != NULL);
#line 371 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = self->priv->device;
#line 371 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = noise_device_get_uri ((NoiseDevice*) _tmp0_);
#line 371 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = _tmp1_;
#line 371 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = noise_playlists_utils_get_playlist_m3u_file ((NoisePlaylist*) p, _tmp2_);
#line 371 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = _tmp3_;
#line 371 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp2_);
#line 371 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	content = _tmp4_;
#line 372 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp5_ = content;
#line 372 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp6_ = self->priv->device;
#line 372 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp7_ = noise_device_get_uri ((NoiseDevice*) _tmp6_);
#line 372 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp8_ = _tmp7_;
#line 372 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp9_ = g_file_new_for_uri (_tmp8_);
#line 372 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp10_ = _tmp9_;
#line 372 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp11_ = g_file_get_path (_tmp10_);
#line 372 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp12_ = _tmp11_;
#line 372 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp13_ = string_replace (_tmp5_, _tmp12_, "");
#line 372 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (content);
#line 372 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	content = _tmp13_;
#line 372 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp12_);
#line 372 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (_tmp10_);
#line 372 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp8_);
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp14_ = self->priv->device;
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp15_ = noise_plugins_audio_player_device_get_music_folder (_tmp14_);
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp16_ = _tmp15_;
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp17_ = noise_playlist_get_name ((NoisePlaylist*) p);
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp18_ = _tmp17_;
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp19_ = string_replace (_tmp18_, "/", "_");
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp20_ = _tmp19_;
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp21_ = g_strconcat (_tmp20_, ".m3u", NULL);
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp22_ = _tmp21_;
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp23_ = g_build_path ("/", _tmp16_, "Playlists", _tmp22_, NULL);
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp24_ = _tmp23_;
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp25_ = g_file_new_for_uri (_tmp24_);
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp26_ = _tmp25_;
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp24_);
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp22_);
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp20_);
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp16_);
#line 374 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	dest = _tmp26_;
#line 3587 "AudioPlayerLibrary.c"
	{
		GFile* _tmp27_;
		GFileOutputStream* file_stream = NULL;
		GFile* _tmp29_;
		GFileOutputStream* _tmp30_;
		GDataOutputStream* data_stream = NULL;
		GFileOutputStream* _tmp31_;
		GDataOutputStream* _tmp32_;
		GDataOutputStream* _tmp33_;
		const gchar* _tmp34_;
#line 377 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp27_ = dest;
#line 377 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (g_file_query_exists (_tmp27_, NULL)) {
#line 3602 "AudioPlayerLibrary.c"
			GFile* _tmp28_;
#line 378 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp28_ = dest;
#line 378 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_file_delete (_tmp28_, NULL, &_inner_error_);
#line 378 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3610 "AudioPlayerLibrary.c"
				goto __catch17_g_error;
			}
		}
#line 381 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp29_ = dest;
#line 381 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp30_ = g_file_create (_tmp29_, G_FILE_CREATE_NONE, NULL, &_inner_error_);
#line 381 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		file_stream = _tmp30_;
#line 381 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3622 "AudioPlayerLibrary.c"
			goto __catch17_g_error;
		}
#line 384 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp31_ = file_stream;
#line 384 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp32_ = g_data_output_stream_new ((GOutputStream*) _tmp31_);
#line 384 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		data_stream = _tmp32_;
#line 385 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp33_ = data_stream;
#line 385 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp34_ = content;
#line 385 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_data_output_stream_put_string (_tmp33_, _tmp34_, NULL, &_inner_error_);
#line 385 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 385 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (data_stream);
#line 385 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (file_stream);
#line 3643 "AudioPlayerLibrary.c"
			goto __catch17_g_error;
		}
#line 375 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (data_stream);
#line 375 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (file_stream);
#line 3650 "AudioPlayerLibrary.c"
	}
	goto __finally17;
	__catch17_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		GFile* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		GError* _tmp40_;
		const gchar* _tmp41_;
#line 375 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		err = _inner_error_;
#line 375 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_inner_error_ = NULL;
#line 388 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp35_ = noise_playlist_get_name ((NoisePlaylist*) p);
#line 388 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp36_ = _tmp35_;
#line 388 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp37_ = dest;
#line 388 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp38_ = g_file_get_path (_tmp37_);
#line 388 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp39_ = _tmp38_;
#line 388 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp40_ = err;
#line 388 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp41_ = _tmp40_->message;
#line 388 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_warning ("AudioPlayerLibrary.vala:388: Could not save playlist %s to m3u file %s" \
": %s\n", _tmp36_, _tmp39_, _tmp41_);
#line 388 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (_tmp39_);
#line 375 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_error_free0 (err);
#line 3687 "AudioPlayerLibrary.c"
	}
	__finally17:
#line 375 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 375 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (dest);
#line 375 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (content);
#line 375 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 375 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_clear_error (&_inner_error_);
#line 375 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return;
#line 3702 "AudioPlayerLibrary.c"
	}
#line 370 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (dest);
#line 370 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (content);
#line 3708 "AudioPlayerLibrary.c"
}


static NoiseStaticPlaylist*
noise_plugins_audio_player_library_real_playlist_from_id (NoiseLibrary* base,
                                                          gint64 id)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseStaticPlaylist* result = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
#line 392 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 393 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = noise_library_get_playlists ((NoiseLibrary*) self);
#line 393 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = _tmp0_;
#line 393 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = gee_collection_get_size (_tmp1_);
#line 393 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = _tmp2_;
#line 393 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = id < ((gint64) _tmp3_);
#line 393 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (_tmp1_);
#line 393 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp4_) {
#line 3739 "AudioPlayerLibrary.c"
		GeeArrayList* array = NULL;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeCollection* _tmp7_;
		GeeCollection* _tmp8_;
#line 394 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp5_ = gee_array_list_new (NOISE_TYPE_STATIC_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 394 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		array = _tmp5_;
#line 395 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp6_ = array;
#line 395 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp7_ = noise_library_get_playlists ((NoiseLibrary*) self);
#line 395 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp8_ = _tmp7_;
#line 395 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		gee_array_list_add_all (_tmp6_, _tmp8_);
#line 395 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (_tmp8_);
#line 3759 "AudioPlayerLibrary.c"
		{
			GeeArrayList* _playlist_list = NULL;
			GeeArrayList* _tmp9_;
			GeeArrayList* _tmp10_;
			gint _playlist_size = 0;
			GeeArrayList* _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gint _playlist_index = 0;
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp9_ = array;
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp10_ = _g_object_ref0 (_tmp9_);
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_playlist_list = _tmp10_;
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp11_ = _playlist_list;
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp13_ = _tmp12_;
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_playlist_size = _tmp13_;
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_playlist_index = -1;
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			while (TRUE) {
#line 3787 "AudioPlayerLibrary.c"
				gint _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				NoiseStaticPlaylist* playlist = NULL;
				GeeArrayList* _tmp17_;
				gint _tmp18_;
				gpointer _tmp19_;
				NoiseStaticPlaylist* _tmp20_;
				gint64 _tmp21_;
				gint64 _tmp22_;
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp14_ = _playlist_index;
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_playlist_index = _tmp14_ + 1;
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp15_ = _playlist_index;
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp16_ = _playlist_size;
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				if (!(_tmp15_ < _tmp16_)) {
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					break;
#line 3810 "AudioPlayerLibrary.c"
				}
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp17_ = _playlist_list;
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp18_ = _playlist_index;
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, _tmp18_);
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				playlist = (NoiseStaticPlaylist*) _tmp19_;
#line 397 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp20_ = playlist;
#line 397 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp21_ = noise_playlist_get_rowid ((NoisePlaylist*) _tmp20_);
#line 397 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp22_ = _tmp21_;
#line 397 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				if (_tmp22_ == id) {
#line 398 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					result = playlist;
#line 398 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (_playlist_list);
#line 398 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (array);
#line 398 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					return result;
#line 3836 "AudioPlayerLibrary.c"
				}
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (playlist);
#line 3840 "AudioPlayerLibrary.c"
			}
#line 396 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (_playlist_list);
#line 3844 "AudioPlayerLibrary.c"
		}
#line 393 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (array);
#line 3848 "AudioPlayerLibrary.c"
	}
#line 401 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = NULL;
#line 401 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 3854 "AudioPlayerLibrary.c"
}


static NoiseStaticPlaylist*
noise_plugins_audio_player_library_real_playlist_from_name (NoiseLibrary* base,
                                                            const gchar* name)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseStaticPlaylist* result = NULL;
#line 403 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 403 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 3868 "AudioPlayerLibrary.c"
	{
		GeeIterator* _playlist_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 404 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp0_ = noise_library_get_playlists ((NoiseLibrary*) self);
#line 404 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp1_ = _tmp0_;
#line 404 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 404 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp3_ = _tmp2_;
#line 404 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (_tmp1_);
#line 404 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_playlist_it = _tmp3_;
#line 404 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		while (TRUE) {
#line 3889 "AudioPlayerLibrary.c"
			GeeIterator* _tmp4_;
			NoiseStaticPlaylist* playlist = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			NoiseStaticPlaylist* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
#line 404 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp4_ = _playlist_it;
#line 404 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 404 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				break;
#line 3903 "AudioPlayerLibrary.c"
			}
#line 404 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp5_ = _playlist_it;
#line 404 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 404 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			playlist = (NoiseStaticPlaylist*) _tmp6_;
#line 405 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp7_ = playlist;
#line 405 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp8_ = noise_playlist_get_name ((NoisePlaylist*) _tmp7_);
#line 405 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp9_ = _tmp8_;
#line 405 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			if (g_strcmp0 (_tmp9_, name) == 0) {
#line 406 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				result = playlist;
#line 406 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (_playlist_it);
#line 406 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				return result;
#line 3925 "AudioPlayerLibrary.c"
			}
#line 404 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (playlist);
#line 3929 "AudioPlayerLibrary.c"
		}
#line 404 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (_playlist_it);
#line 3933 "AudioPlayerLibrary.c"
	}
#line 409 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = NULL;
#line 409 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 3939 "AudioPlayerLibrary.c"
}


static gboolean
noise_plugins_audio_player_library_real_start_file_operations (NoiseLibrary* base,
                                                               const gchar* message)
{
	NoisePluginsAudioPlayerLibrary * self;
	gboolean result = FALSE;
#line 412 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 413 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (noise_library_doing_file_operations ((NoiseLibrary*) self)) {
#line 415 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		result = TRUE;
#line 415 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return result;
#line 3957 "AudioPlayerLibrary.c"
	} else {
#line 417 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		result = FALSE;
#line 417 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return result;
#line 3963 "AudioPlayerLibrary.c"
	}
}


static gboolean
noise_plugins_audio_player_library_real_doing_file_operations (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 419 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 420 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = self->priv->is_doing_file_operations;
#line 420 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = _tmp0_;
#line 420 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 3982 "AudioPlayerLibrary.c"
}


static void
noise_plugins_audio_player_library_real_finish_file_operations (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
#line 422 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (NoisePluginsAudioPlayerLibrary*) base;
#line 3992 "AudioPlayerLibrary.c"
}


static void
noise_plugins_audio_player_library_class_init (NoisePluginsAudioPlayerLibraryClass * klass)
{
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	noise_plugins_audio_player_library_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_type_class_add_private (klass, sizeof (NoisePluginsAudioPlayerLibraryPrivate));
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->initialize_library = (void (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_initialize_library;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->add_files_to_library = (void (*) (NoiseLibrary *, GeeCollection*)) noise_plugins_audio_player_library_real_add_files_to_library;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->get_medias = (GeeCollection* (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_get_medias;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->get_playlists = (GeeCollection* (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_get_playlists;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->get_smart_playlists = (GeeCollection* (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_get_smart_playlists;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->search_medias = (void (*) (NoiseLibrary *, const gchar*)) noise_plugins_audio_player_library_real_search_medias;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->get_search_result = (GeeCollection* (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_get_search_result;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->add_media = (void (*) (NoiseLibrary *, NoiseMedia*)) noise_plugins_audio_player_library_real_add_media;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->add_medias = (void (*) (NoiseLibrary *, GeeCollection*)) noise_plugins_audio_player_library_real_add_medias;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->media_from_id = (NoiseMedia* (*) (NoiseLibrary *, gint64)) noise_plugins_audio_player_library_real_media_from_id;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->medias_from_ids = (GeeCollection* (*) (NoiseLibrary *, GeeCollection*)) noise_plugins_audio_player_library_real_medias_from_ids;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->medias_from_uris = (GeeCollection* (*) (NoiseLibrary *, GeeCollection*)) noise_plugins_audio_player_library_real_medias_from_uris;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->find_media = (NoiseMedia* (*) (NoiseLibrary *, NoiseMedia*)) noise_plugins_audio_player_library_real_find_media;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->media_from_file = (NoiseMedia* (*) (NoiseLibrary *, GFile*)) noise_plugins_audio_player_library_real_media_from_file;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->media_from_uri = (NoiseMedia* (*) (NoiseLibrary *, const gchar*)) noise_plugins_audio_player_library_real_media_from_uri;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->update_media = (void (*) (NoiseLibrary *, NoiseMedia*, gboolean, gboolean)) noise_plugins_audio_player_library_real_update_media;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->update_medias = (void (*) (NoiseLibrary *, GeeCollection*, gboolean, gboolean)) noise_plugins_audio_player_library_real_update_medias;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->remove_media = (void (*) (NoiseLibrary *, NoiseMedia*, gboolean)) noise_plugins_audio_player_library_real_remove_media;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->remove_medias = (void (*) (NoiseLibrary *, GeeCollection*, gboolean)) noise_plugins_audio_player_library_real_remove_medias;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->support_smart_playlists = (gboolean (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_support_smart_playlists;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->add_smart_playlist = (void (*) (NoiseLibrary *, NoiseSmartPlaylist*)) noise_plugins_audio_player_library_real_add_smart_playlist;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->remove_smart_playlist = (void (*) (NoiseLibrary *, gint64)) noise_plugins_audio_player_library_real_remove_smart_playlist;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->smart_playlist_from_id = (NoiseSmartPlaylist* (*) (NoiseLibrary *, gint64)) noise_plugins_audio_player_library_real_smart_playlist_from_id;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->smart_playlist_from_name = (NoiseSmartPlaylist* (*) (NoiseLibrary *, const gchar*)) noise_plugins_audio_player_library_real_smart_playlist_from_name;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->support_playlists = (gboolean (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_support_playlists;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->add_playlist = (void (*) (NoiseLibrary *, NoiseStaticPlaylist*)) noise_plugins_audio_player_library_real_add_playlist;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->remove_playlist = (void (*) (NoiseLibrary *, gint64)) noise_plugins_audio_player_library_real_remove_playlist;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->playlist_from_id = (NoiseStaticPlaylist* (*) (NoiseLibrary *, gint64)) noise_plugins_audio_player_library_real_playlist_from_id;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->playlist_from_name = (NoiseStaticPlaylist* (*) (NoiseLibrary *, const gchar*)) noise_plugins_audio_player_library_real_playlist_from_name;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->start_file_operations = (gboolean (*) (NoiseLibrary *, const gchar*)) noise_plugins_audio_player_library_real_start_file_operations;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->doing_file_operations = (gboolean (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_doing_file_operations;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((NoiseLibraryClass *) klass)->finish_file_operations = (void (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_finish_file_operations;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_plugins_audio_player_library_finalize;
#line 4069 "AudioPlayerLibrary.c"
}


static void
noise_plugins_audio_player_library_instance_init (NoisePluginsAudioPlayerLibrary * self)
{
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv = NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_GET_PRIVATE (self);
#line 32 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_rec_mutex_init (&self->priv->__lock_medias);
#line 33 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_rec_mutex_init (&self->priv->__lock_searched_medias);
#line 35 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->operation_cancelled = FALSE;
#line 36 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->is_doing_file_operations = FALSE;
#line 37 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->queue_is_finished = FALSE;
#line 39 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->is_initialized = FALSE;
#line 40 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->medias_rowid = 0;
#line 41 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->playlists_rowid = 0;
#line 42 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->smartplaylists_rowid = 0;
#line 4096 "AudioPlayerLibrary.c"
}


static void
noise_plugins_audio_player_library_finalize (GObject * obj)
{
	NoisePluginsAudioPlayerLibrary * self;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibrary);
#line 31 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->device);
#line 32 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_rec_mutex_clear (&self->priv->__lock_medias);
#line 32 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->medias);
#line 33 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_rec_mutex_clear (&self->priv->__lock_searched_medias);
#line 33 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->searched_medias);
#line 34 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->playlists);
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->imported_files);
#line 44 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->tagger);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	G_OBJECT_CLASS (noise_plugins_audio_player_library_parent_class)->finalize (obj);
#line 4124 "AudioPlayerLibrary.c"
}


GType
noise_plugins_audio_player_library_get_type (void)
{
	return noise_plugins_audio_player_library_type_id;
}


GType
noise_plugins_audio_player_library_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NoisePluginsAudioPlayerLibraryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_plugins_audio_player_library_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePluginsAudioPlayerLibrary), 0, (GInstanceInitFunc) noise_plugins_audio_player_library_instance_init, NULL };
	noise_plugins_audio_player_library_type_id = g_type_module_register_type (module, NOISE_TYPE_LIBRARY, "NoisePluginsAudioPlayerLibrary", &g_define_type_info, 0);
	return noise_plugins_audio_player_library_type_id;
}



